gameplay = {}
gameplay.MoveEfficiencyLoss = 2.5
gameplay.RailmoveEfficiencyLoss = 10
gameplay.CaptureEfficiencyLoss = 2
gameplay.RiverBonus = 4
gameplay.PortBonus = 20
gameplay.TorpedoBonus = 10 --- homesupport defined in function AddPortSupply
gameplay.FirstStrikeBonus = 2
gameplay.RepairFull = 30
gameplay.RepairHalf = 20
gameplay.RepairNavalFull = 20
gameplay.RepairNavalHalf = 10
gameplay.RepairDreadnought = 10
gameplay.WinterEfficiencyPenalty = 10
gameplay.WinterCombatPenaltyAttacker = 0.5
gameplay.FreeUpkeep = 0
gameplay.retreatFailPenalty = 1.2
gameplay.AmmunitionCap = 90
gameplay.LabUpkeepCost = 1
gameplay.fortressAttackBonus = 1
gameplay.fortressDefenseBonus = 2
gameplay.amphibiousAttackMod = 1 --0.5
gameplay.amphibiousDefenseMod = 0.4 --0.5
scenario = {}

-- colonial faction id
COLONIAL = 23

--dofile "AI/ai.lua"
LogUi("POTZBLITZ MOD V12.0")
dofile "game/game_combat.lua"
dofile "game/game_move.lua"
dofile "game/game_victory_conditions.lua"

dofile("game/game_research.lua")
dofile("game/game_diplomacy.lua")
dofile("game/game_ammunition.lua")
dofile("game/game_railmoves.lua")
LogUi("2")
dofile("game/game_transportmoves.lua")
dofile("game/game_deployment.lua")
dofile("game/game_convoys.lua")
dofile("game/game_events.lua")
dofile("game/game_commanders.lua")
dofile("game/game_repair.lua")
LogUi("3")
dofile("game/game_resources.lua")
dofile("game/game_targetting.lua")
dofile("game/game_morale.lua")
dofile("game/game_supply.lua")
dofile("game/game_stats.lua")
dofile("game/game_territory.lua")
dofile("game/game_experience.lua")
dofile "technology.lua"
LogUi("4")
function turnCount(base, growth, target)
  return math.ceil(math.log(target / base) / math.log(1 + 1 / growth))
end

function GetHex(x, y)

  if x >= game.map.hexWidth or y >= game.map.hexHeight then
    return nil
  end

  if x < 0 or y < 0 then
    return nil
  end

  return game:GetHex(x, y)

end

function GetPlayer()
  return game.localPlayer
end

function GetScene()
  return GetPlayer().scene
end

function GetMap()
  return game.map
end

function GetUnitById(id)
  return game:GetUnitById(id)
end

function GameInit()

  Log("Initializing game")

  InitEvents()

  InitCommanders()

  InitDiplomacy()

  InitResearch()

  InitStats()

  InitAmmunition()

  InitRailmoves()

  InitTransportmoves()

  InitDeployment()

  InitResources()

  InitConvoys()

  InitMorale()

  InitSupply()

end

function GameTurnStart()
 
LogUi("----------GAMETURN START!") 

  if game.turn > 1 then

    -- Prevent neutral units from entrenching on DOW turn
    for faction in game:GetAllianceById(0).factions do
      for unit in faction.units do
        SetUnitAction(unit,-1)
      end
    end

    SetTurnDate()
local month = nil
if game.date.month == 1 then month = "JAN"
elseif game.date.month == 2 then 
month = "FEB"
elseif game.date.month == 3 then 
month = "MAR"
elseif game.date.month == 4 then 
month = "APR"
elseif game.date.month == 5 then 
month = "MAY"
elseif game.date.month == 6 then 
month = "JUN"
elseif game.date.month == 7 then 
month = "JUL"
elseif game.date.month == 8 then 
month = "AUG"
elseif game.date.month == 9 then 
month = "SEP"
elseif game.date.month == 10 then 
month = "OCT"
elseif game.date.month == 11 then 
month = "NOV"
elseif game.date.month == 12 then 
month = "DEC"
end


	
  end

  LogUi("----------GAMETURN CHECK2") 


  ChangeClimate()
  
    LogUi("----------GAMETURN CHECK3") 
  
  TriggerTurnEvents()
  
    LogUi("----------GAMETURN CHECK4") 

  ManageResearch()
  
    LogUi("----------GAMETURN CHECK5") 

  ManageDiplomacy()
  
    LogUi("----------GAMETURN CHECK6") 

  ResetDeployLimits()
  
    LogUi("----------GAMETURN CHECK7") 

  ResetRailmoves()
  
    LogUi("----------GAMETURN CHECK8") 

  TriggerTurnAfterEvents()
  
    LogUi("----------GAMETURN CHECK9") 

  NewDiplo()
  
      LogUi("----------GAMETURN CHECK 10 - END!!!!") 

end

function GameTurnEnd()
  LogUi("Turn ended: " .. game.turn)
end

function GamePhaseStart(alliance)
LogUi("=======================DIPLO SEQUENCE START============================")

-------------------------NIL CHECKS---------------------------------------------
for alliance in game.alliances do
	
    for faction in alliance.factions do
		for unit in faction.units do
			if unit.hex ~= nil and unit.type == Unit.NAVAL then
				if unit.luaData.endurance == nil then
					unit.luaData.endurance = 10
				LogUi("============================================================================================================================ ENDURANCE NIL checked!!!!!!!!!!!!!!1")

				end
				if unit.luaData.endurance <0 then
					unit.luaData.endurance = 0
					LogUi("============================================================================================================================ ENDURANCE LESS THAN ZERO checked!!!!!!!!!!!!!!1")

				end
			end
		if unit.hex ~= nil and (unit.luaData.experience == nil or unit.luaData.experience <0)  then
				LogUi("============================================================================================================================ EXP NIL checked!!!!!!!!!!!!!!1")
				unit.luaData.experience = 0
		end
		if unit.hex ~= nil and unit.luaData.efficiency == nil  then
			--	LogUi("============================================================================================================================ EFFICIENCY NIL checked!!!!!!!!!!!!!!1")
			--	LogUi("AT X/Y" .. unit.hex.x .. "/" .. unit.hex.y .. "/OWNER:" .. unit.faction.name .. "TYPE:" .. unit.prototype.name)
				unit.luaData.efficiency = 0
		end
		if unit.hex ~= nil and unit.luaData.efficiency <0  then
				LogUi("============================================================================================================================ EFFICIENCY BELOW ZERO checked!!!!!!!!!!!!!!1")
				LogUi("AT X/Y" .. unit.hex.x .. "/" .. unit.hex.y .. "/OWNER:" .. unit.faction.name .. "TYPE:" .. unit.prototype.name)
				unit.luaData.efficiency = 0
		end
		
		end		
	end
end	

----------------------------------------------
local impassable = game:GetFactionById(24)
--game.currentAlliance = alliance ---- is this workaround still needed?????????????
  if alliance.id == 0 then
 
 return
  end

LogUi("Phase start: " .. alliance.name)
AutoPassage()
MichelWarn()

if game.currentAlliance.id == player.alliance.id then
EventProb()
MusicPlayer():Stop()
MusicPlayer():ClearPlayList()
  
  if gameplay.winter == 0 and game.date.month > 4 and game.date.month < 10 then
  
  
				  local playListLength = 3
				 -- math.randomseed( os.time() )
				  local randomMusicStart = math.random(1, playListLength)
				  for i = 0, 2 do
					local trackId =  ((i + randomMusicStart)  % playListLength) + 1
					MusicPlayer():AddToPlayList("Summer" .. trackId)
				  end
				  MusicPlayer():SetLooping(true)
				  MusicPlayer():Play()
  elseif gameplay.winter == 0 or impassable.luaData.mud  == game.turn then
				local playListLength = 3
				 -- math.randomseed( os.time() )
				  local randomMusicStart = math.random(1, playListLength)
				  for i = 0, 2 do
					local trackId =  ((i + randomMusicStart)  % playListLength) + 1
					MusicPlayer():AddToPlayList("Rain" .. trackId)
				  end
				  MusicPlayer():SetLooping(true)
				  MusicPlayer():Play()
	elseif gameplay.winter == 1 then
			local playListLength = 2
				 -- math.randomseed( os.time() )
				  local randomMusicStart = math.random(1, playListLength)
				  for i = 0, 1 do
					local trackId =  ((i + randomMusicStart)  % playListLength) + 1
					MusicPlayer():AddToPlayList("Winter" .. trackId)
				  end
				  MusicPlayer():SetLooping(true)
				  MusicPlayer():Play()
  
  end
  end
  NeutralDOWs(alliance)
  
  
 -- local enemyAlliance = game:GetAllianceById(3 - game.currentAlliance.id)

  -- Clear LOS for water hexes adjacent to cities
  for faction in alliance.factions do
    for construction in faction.constructions do
      local hexes = game.map:GetHexesInRange(construction.hex, 1)

      for _, hex in pairs(hexes) do
        if hex.terrain.type == Terrain.WATER then
          alliance:AddVisibleHex(hex)
        end
      end
    end
end	
--------------------------------------

 if game.type == Game.TYPE_SINGLE then
	if game.currentAlliance.id ~= playerAlliance.id and game.currentAlliance.id ~= 0 then
		AIDiploCalc()
	end
 end

-------------------------------------
   
 -----SIGINT events:  1 enemy nation will be targeted 
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local luck = math.random(1,5)
LogUi("**************")
LogUi("**************")
LogUi("SIGINT PHASE")
LogUi("**************")
LogUi("**************")


local value = SigintResult(value, alliance)
--if game.type == Game.TYPE_SINGLE and game.currentAlliance.id ~= playerAlliance.id then
--LogUi("SIGINT TEST AI")
--local luck = math.random(3,5)
--end

if value ~= nil then  
local victimfaction = game:GetFactionById(value) 
	if victimfaction.luaData.isvictim ~= nil then
--	LogUi("SIGINT TRIGGER FOR:" .. victimfaction.name .. "/ VICTIMTURN =" .. victimfaction.luaData.isvictim)
	end
	if victimfaction ~= nil 
		and victimfaction.luaData.isvictim  == game.turn 
		and victimfaction.alliance.id ~= 0 then
	
			local zluck = math.random(1,4)
						if game.currentAlliance.id == 1   then
							
							if zluck == 1 then
								if GetTotalIntelCP(totalintel)  >= GetTotalIntelEnt(totalintel) then
									SetEvent("SigintEnt1", game.turn)
								else
									SetEvent("SigintEnt1", game.turn, nil, entente)
								end 		
							
							elseif zluck == 2 then
							
								if GetTotalIntelCP(totalintel)  >= GetTotalIntelEnt(totalintel) then
									SetEvent("SigintEnt2", game.turn)
								else
									SetEvent("SigintEnt2", game.turn, nil, entente)
								end 
							
							elseif zluck == 3 then
							
								if GetTotalIntelCP(totalintel)  >= GetTotalIntelEnt(totalintel) then
									SetEvent("SigintEnt3", game.turn)
								else
									SetEvent("SigintEnt3", game.turn, nil, entente)
								end 
							
							elseif zluck == 4 then
							if GetTotalIntelCP(totalintel)  >= GetTotalIntelEnt(totalintel) then
									SetEvent("SigintEnt4", game.turn)
								else
									SetEvent("SigintEnt4", game.turn, nil, entente)
								end 
							end
							
							
						elseif 	 game.currentAlliance.id == 2 then
							if zluck == 1 then
								if GetTotalIntelEnt(totalintel)  >= GetTotalIntelCP(totalintel) then								
									SetEvent("SigintCP1", game.turn)
								else
										SetEvent("SigintCP1", game.turn, nil, cp)
								end
							elseif zluck == 2 then
								if GetTotalIntelEnt(totalintel)  >= GetTotalIntelCP(totalintel) then								
									SetEvent("SigintCP2", game.turn)
								else
										SetEvent("SigintCP2", game.turn, nil, cp)
								end
							elseif zluck == 3 then
									if GetTotalIntelEnt(totalintel)  >= GetTotalIntelCP(totalintel) then								
									SetEvent("SigintCP3", game.turn)
								else
										SetEvent("SigintCP3", game.turn, nil, cp)
								end
							elseif zluck == 4 then
								if GetTotalIntelEnt(totalintel)  >= GetTotalIntelCP(totalintel) then								
									SetEvent("SigintCP4", game.turn)
								else
										SetEvent("SigintCP4", game.turn, nil, cp)
								end
							end
						
						
						end
----------------------TECH STEAL--------------------------------------------------------------
				if 	victimfaction.luaData.victimoutcome ~= nil 
					and  victimfaction.luaData.victimoutcome == 1 then -- steal tech from victimnation
					victimfaction.luaData.victimoutcome = 0
					local foeAlliance
					local ownalliance
					local success = 0 
					
							
					if game.currentAlliance.id == 1 then
						foeAlliance = game:GetAllianceById(2)
						ownalliance = game:GetAllianceById(1)
					elseif game.currentAlliance.id == 2 then
						foeAlliance = game:GetAllianceById(1)
						ownalliance = game:GetAllianceById(2)
					end
								
				
				for faction in ownalliance.factions do
					if success == 0 then
						
						local techsTable = GetAvailableTechs(faction, fakeTurn)
							-- Go through all these techs
							for _, techName in pairs(techsTable) do

							  -- Get tech's class
							  local techClass = data.newTechnologies[techName].class

							  -- Only progress if class has at least 1 lab
								if faction.luaData.labs[techClass] > 0 then
									if IsTechCompleted(techName, victimfaction) == true  and IsTechAvailable(techName, faction) == true and IsTechCompleted(techName, faction) ~= true then
											ApplyTechnology(faction, techName)
											success = 1
										--	LogUi("TECH STOLEN:" .. techName .. "/BY:" .. faction.name .. "/FROM:" .. victimfaction.name)
												if 	game.currentAlliance.id == player.alliance.id and player.alliance.id == 1  then
													PopupMessage("Entente spies have procured TECHNOLOGY BLUEPRINTS from " .. victimfaction.name .. " about " .. techName)
												elseif game.currentAlliance.id == player.alliance.id and player.alliance.id == 2 then
													PopupMessage("Central Powers spies have procured TECHNOLOGY BLUEPRINTS from " .. victimfaction.name .. " about " .. techName)
												end
											
											break
									end
								end
							end
					end
				end	
				if success == 0 then
					victimfaction.luaData.victimoutcome = math.random(2,5)
				end
				
				end
--------------------------NAVAL CODE-----------------------------------------------------------
			if 	victimfaction.luaData.victimoutcome ~= nil
					and game.date.year >= 1915
					and  victimfaction.luaData.victimoutcome == 2 
					and (victimfaction.id == 0 
						or victimfaction.id == 1 
						or victimfaction.id == 2 
						or victimfaction.id == 3 
						or (victimfaction.id == 4 and game.date.year <= 1915) 
						or victimfaction.id == 8) then -- naval code broken
							victimfaction.luaData.victimoutcome = 0 
												
						if game.currentAlliance.id == 1 
							and game.currentAlliance.id == player.alliance.id then
								
								if ("LuckyHit") +6 < game.turn	then
									PutinEnt("LuckyHit")
								end	
							PopupMessage("Entente code breakers have managed to decipher the NAVAL CIPHER used by " .. victimfaction.name)
						elseif game.currentAlliance.id == 2 
							and game.currentAlliance.id == player.alliance.id then 
								
									if GetEvent("LuckyHit") +6 < game.turn	then
										PutinCP("LuckyHit")
									end
							PopupMessage("Central Powers code breakers have managed to decipher the NAVAL CIPHER used by " .. victimfaction.name)
						end
						
						victimfaction.luaData.navalcodebroken = game.turn	
							for unit in victimfaction.units do
								if unit.hex ~= nil
									and unit.type == Unit.NAVAL then
										if unit.luaData.experience == nil then
											unit.luaData.experience = 0
										end
										local chance = unit.luaData.experience
										
										if unit.commander ~= nil then
											chance = chance *2
										end
										if unit.prototype.name == "submarine" then
											chance = chance *3
										end
										if math.random(1,1000) > chance then
											unit.luaData.navalcodebroken = game.turn
										end
								end
								
							end			
											
									
						if victimfaction.id == 1 then
							cp.luaData.entminesspot = game.turn
						elseif victimfaction.id == 2 then
							entente.luaData.cpminesspot = game.turn
								if GetEvent("SubAttack") >0  then
									PutinEnt("Lusitania")
								end
						end	
					
				elseif victimfaction.luaData.victimoutcome ~= nil  then
					 victimfaction.luaData.victimoutcome = (math.random(3,5))
				
				end		
----------------------ARMY CODE---------------------------------------------------------------	
				if	victimfaction.luaData.victimoutcome ~= nil
					and game.date.year >= 1915
					and  victimfaction.luaData.victimoutcome == 3 then 
					victimfaction.luaData.victimoutcome = 0 -- land code broken 
						--	LogUi("ARMY CODE BROKEN")
								if game.currentAlliance.id == 1 
									and game.currentAlliance.id == player.alliance.id then
									PopupMessage("Entente code breakers have managed to decipher the ARMY CIPHER used by " .. victimfaction.name)
									
								elseif game.currentAlliance.id == 2 
									and game.currentAlliance.id == player.alliance.id then
									PopupMessage("Central Powers code breakers have managed to decipher the ARMY CIPHER used by " .. victimfaction.name)
								end
								
							victimfaction.luaData.codebroken = game.turn
								for unit in victimfaction.units do
									if unit.hex ~= nil
										and unit.type == Unit.LAND
										and unit.prototype.name ~= "smallgarrison"	then
											if unit.luaData.experience == nil then
												unit.luaData.experience = 0
											end
											local chance = unit.luaData.experience
												if unit.commander ~= nil then
													chance = chance * 1.5
												end
												local spotter = 0
												local hex = unit.hex
												local hexes = game.map:GetHexesInRange(hex, 4)
													for _, ahex in pairs(hexes) do
														if ahex.unit ~= nil  
															and ahex.unit.alliance.id == 2 then
																spotter = 1
																break	
														end	
													end
												if spotter == 0 then
													chance = chance + 900	
												end	
												if math.random(1,1000) > chance then
													unit.luaData.codebroken = game.turn
												end
									end
								end
				elseif victimfaction.luaData.victimoutcome ~= nil  then
					 
					 victimfaction.luaData.victimoutcome = (math.random(4,5))
				
				end			
----------------------INFILTRATE--------------------------------				
				if victimfaction.luaData.victimoutcome ~= nil 
					and  victimfaction.luaData.victimoutcome == 4 then 
					victimfaction.luaData.victimoutcome = 0  -- spy events added/bonus DP
									--		LogUi("SPY EVENT")

					if game.currentAlliance.id == 2 then
						PopupMessage("CENTRAL POWERS SPIES INFILTRATE ENTENTE COMMAND STRUCTURE!")

								if GetEvent("Spy") == 0 and game.date.year >= 1915 then
										PutinCP("Spy")
								end
								if victimfaction.alliance.id == 1 then
									entente.luaData.infiltrated = 1
									cp.luaData.intel[victimfaction.id] = cp.luaData.intel[victimfaction.id] + game.turn 
								
								local bonusDP = math.ceil(math.sqrt(game.turn))
								if bonusDP < math.ceil(math.sqrt(entente.luaData.DP)) then
									bonusDP = math.ceil(math.sqrt(entente.luaData.DP))
								end		
																
								if game.date.year <= 1915 then	
										cp.luaData.DP = cp.luaData.DP + bonusDP
									elseif game.date.year == 1916 then
										cp.luaData.DP = cp.luaData.DP + bonusDP
									elseif game.date.year == 1917 then
										cp.luaData.DP = cp.luaData.DP + bonusDP
									elseif game.date.year == 1918 then
										cp.luaData.DP = cp.luaData.DP + bonusDP
								end	
							end		
								
					elseif 	game.currentAlliance.id == 1 then
							PopupMessage("ENTENTE SPIES INFILTRATE CENTRAL POWERS COMMAND STRUCTURE!")
							if GetEvent("Spy2") == 0 and game.date.year >= 1915 then
									PutinEnt("Spy2")
							elseif 	GetEvent("Spy2") ~= 0
									and GetEvent("Spy3") == 0 
									and game.date.year >= 1915 then
									PutinEnt("Spy3")
							end		
							if victimfaction.alliance.id == 2 then
								cp.luaData.infiltrated = 1
								entente.luaData.intel[victimfaction.id] = entente.luaData.intel[victimfaction.id] + game.turn 
								
								local bonusDP = math.ceil(math.sqrt(game.turn))
								if bonusDP < math.ceil(math.sqrt(cp.luaData.DP)) then
									bonusDP = math.ceil(math.sqrt(cp.luaData.DP))
								end		
								
								if game.date.year <= 1915 then	
											entente.luaData.DP = entente.luaData.DP + bonusDP 
								elseif game.date.year == 1916 then
											entente.luaData.DP = entente.luaData.DP + bonusDP
								elseif game.date.year == 1917 then
											entente.luaData.DP = entente.luaData.DP + bonusDP
								elseif game.date.year == 1918 then
											entente.luaData.DP = entente.luaData.DP + bonusDP
								end	
							end		
					end
				end
----------------------SABOTAGE--------------------------------			
	if victimfaction.luaData.victimoutcome ~= nil 
		and  victimfaction.luaData.victimoutcome == 5 then 
				victimfaction.luaData.victimoutcome = 0 -- sabotage
										

				if victimfaction.pp >=20 then				
					victimfaction:ConsumeProductionPoints(math.floor(victimfaction.pp/2))
				end
				if victimfaction.am >=10 then	
					victimfaction:ConsumeAmmo(math.ceil(victimfaction.am/2))
				end
				
				if victimfaction.luaData.factories ~= nil then
				
					if victimfaction.luaData.factories >= 10 then
						victimfaction.luaData.factories = victimfaction.luaData.factories - 1
					end	
				end
				
				if victimfaction.morale >= 50  then
					ChangeFactionMorale(victimfaction, - 10)
				end
				if victimfaction.luaData.collaps ~= nil then
						if victimfaction.alliance.id == 1 then
							entente.luaData.socialists = entente.luaData.socialists +1	
						elseif victimfaction.alliance.id == 2 then
							cp.luaData.socialists = cp.luaData.socialists +1		
						end		
				
						if victimfaction.alliance.id == 1 and entente.luaData.socialists > victimfaction.luaData.collaps then
							victimfaction.luaData.collaps = victimfaction.luaData.collaps +1
						elseif victimfaction.alliance.id == 2 and cp.luaData.socialists > victimfaction.luaData.collaps  then
							victimfaction.luaData.collaps = victimfaction.luaData.collaps +1
						end		
				end
						
					if game.currentAlliance.id == player.alliance.id then
						PopupMessage("Widespread Socialist defeatism and industrial sabotage suffered by " .. victimfaction.name .. ". Arms and ammunition factories incapacitated and stockpiles destroyed!")
						sfx = LoadSample("inter.wav")
						PlaySample(sfx)
					end
	end
------------------------------------------------------		
			
------------------------------------------------------		
				
					
						
					
						
					
					
					
			
	end 
end 
--LogUi("CHECK1")
	
--[[  local serbia = game:GetFactionById(7)
for unit in serbia.units do
							if unit.hex ~= nil and unit.type == Unit.NAVAL then
								playerAlliance:AddVisibleHex(unit.hex)
								--View:AddEffect(unit.hex, "radius_red")
							SetAiImage("select_100",unit.hex)
							entente.luaData.spotted = game.turn
							end
						end
	]]					
			
 --------------------WORKED!
 --[[ 
  if game.turn == 1 then
	for hex in serbia.hexes do
		playerAlliance:AddVisibleHex(hex)
	end
  end
  
  if game.turn == 3 then
  for hex in serbia.hexes do
		playerAlliance:AddVisibleHex(hex)
	end
  end
 ]] 

 ----------------------------
--LogUi("CHECK2")
  

  ResetTransportmoves()
--LogUi("CHECK3")
  SupplyEffects(alliance)
--LogUi("CHECK4")
  if game.turn > 1 then

  

    --FIXME: remove if game.currentAlliance works in MP replay
   -- game.currentAlliance = alliance

    gameplay.advanceHex = nil
    gameplay.advanceUnit = nil

    MoraleCalculation()
LogUi("MORALE CALC DONE")	
	if game.turn >3 then
    VictoryConditions()
	end
    UnlockCommanders(alliance)
LogUi("UNLOCK COMMANDERS DONE")
    TransportSickness(alliance)
--LogUi("CHECK7")
    EfficiencyRecovery(alliance)
--LogUi("CHECK8")
    if alliance.id ~= 0 then
      UnitEntrenchment(alliance)
    end
--LogUi("CHECK9")
    ManageConvoys(alliance)
LogUi("MANAGECONVOYSDONE")
  else

    if alliance.id ~= startingAlliance then
LogUi("CHECK11")
      ManageConvoys(alliance)
--LogUi("CHECK12")
  else
--LogUi("CHECK13")
      -- Convoys dont auto move in first turn, so take away their mp
      for faction in alliance.factions do
        for unit in faction.units do
          if unit.prototype.name == "convoy" then
            unit.mp = 0
          end
        end
      end
LogUi("CHECK14")
    end

  end
		local counter = 0
		for faction in alliance.factions do
			counter = counter +1
		end
		if counter >0 then	
			ui.resourcesPanel:Refresh()
		end
LogUi("======================DIPLO SEQUENCE END: ALL DIPLO DONE!=================================")
								

end

function CoastalCityLOS(alliance)

  for faction in alliance.factions do
    for construction in faction.constructions do
      if construction.type ~= Construction.TYPE_PORT then
        local hexes = game.map:GetHexesInRange(construction.hex, 1)
        for _, hex in pairs(hexes) do
          if hex.terrain.type == Terrain.WATER then
            alliance:AddVisibleHex(hex)
            --print("hex revealed")
          end
        end
      end
    end
  end

end

function GamePhaseEnd(alliance)
LogUi("----------GAMEPHASE END START")
  if alliance.id == 1 then
    FillGaps(game:GetAllianceById(2))
  elseif alliance.id == 2 then
    FillGaps(game:GetAllianceById(1))
  end

  ManageFinances(alliance)

  if playerAlliance.id == game.currentAlliance.id then
    ui.disableControls = true
  end

  LogUi("Phase end: " .. alliance.name)
  
  if alliance.id ~= 0 then
	if alliance.luaData.DP >= 20 and game.date.year == 1915 then 
		alliance.luaData.DP = math.floor(alliance.luaData.DP * 1.1)
	
	elseif alliance.luaData.DP >= 20 and game.date.year == 1916 then 
		alliance.luaData.DP = math.floor(alliance.luaData.DP * 1.25)
	
	elseif alliance.luaData.DP >= 20 and game.date.year == 1917 then
		alliance.luaData.DP = math.floor(alliance.luaData.DP * 1.33) 
	
	elseif alliance.luaData.DP >= 20 and game.date.year == 1918 then
		alliance.luaData.DP = math.floor(alliance.luaData.DP * 1.5)
	
	
	end
  end
  LogUi("-----------GAMEPHASE END END")
	
end





-- Change climate from warm to cold and back
function ChangeClimate()
 local impassable = game:GetFactionById(24)
 
 
 
if  game.turn == 12 and impassable.luaData.winterfourteen == 6
	or (game.date.year == 1915 and game.date.month == 11 and impassable.luaData.winterfifteen == 6)	
	or (game.date.year == 1916 and game.date.month == 11 and impassable.luaData.wintersixteen == 6)	
	or (game.date.year == 1917 and game.date.month == 11 and impassable.luaData.winterseventeen == 6)	
	or (game.date.year == 1918 and game.date.month == 11 and impassable.luaData.wintereighteen == 6) then
					if impassable.luaData.winter == 0 then
						GetPlayer().scene:LoadMap("map_winter")
						gameplay.winter = 1
						impassable.luaData.winter = 1
						AddToReportQueue(playerAlliance, "report_winter", "icon_winter")
					end
end
if 	(game.date.month >= 12  --- month!
			or game.date.month <= 2) 
		and impassable.luaData.winter == 0   then -- normal winter starts in december 
					GetPlayer().scene:LoadMap("map_winter")
					gameplay.winter = 1
					impassable.luaData.winter = 1
					AddToReportQueue(playerAlliance, "report_winter", "icon_winter")

end
if game.date.month == 3  			-- normal spring starts in march
			and ((game.date.year == 1915 and impassable.luaData.springfifteen >= 2)
				or (game.date.year == 1916 and impassable.luaData.springsixteen >= 2)
				or (game.date.year == 1917 and impassable.luaData.springseventeen >= 2)
				or (game.date.year == 1918 and impassable.luaData.springeighteen >= 2)) then				
							GetPlayer().scene:LoadMap("map")
							gameplay.winter = 0
							impassable.luaData.winter = 0
							AddToReportQueue(playerAlliance, "report_summer", "icon_winter")
	
end
if (game.date.month >= 4 and game.date.month <= 10) 
	and impassable.luaData.winter == 1 then -- after long winter: spring in april
					GetPlayer().scene:LoadMap("map")
					gameplay.winter = 0
					impassable.luaData.winter = 0
				   AddToReportQueue(playerAlliance, "report_summer", "icon_winter")
end
------------------------


end


-------------------------------------------------------
 





-- if hex.climate < climate then its winter there
function GetClimate()
local impassable = game:GetFactionById(24)

  if impassable.luaData.winter == 1 then --(impassable.luaData.winter ~= nil and impassable.luaData.winter == 1) or (gameplay.winter ~= nil and gameplay.winter == 1) then
    return 9
  else
    return 0
  end
end


-- Units that stay in transport lose efficiency
function TransportSickness(alliance)

  for faction in alliance.factions do
    for unit in faction.units do

      if unit.prototype.name == "transport" then

        for cargo in unit.cargo.units do
          DamageEfficiency(cargo, 10)
          unit.efficiency = cargo.efficiency
			if (unit.alliance.id == player.alliance.id 
				and unit.hex ~= nil 
				and unit.efficiency == 0 
				and unit.luaData.endurance ~= nil 
				and unit.luaData.endurance < 1)  then
				cargo:Damage(10)
				unit:Damage(10)
			end
		  break
        end

      end

    end
  end

end

-- Efficiency recovery for idle units
function EfficiencyRecovery(alliance)
  for faction in alliance.factions do
    for unit in faction.units do
      UnitEfficiencyRecovery(unit)
    end
  end
end

function UnitEfficiencyRecovery(unit)
  if unit.alive and unit.state ~= Unit.STATE_EMBARKED and unit.supply > 0 and unit.hex.terrain.type ~= Terrain.WATER then
    if UnitCanRecoverEfficiency(unit) then
      unit.efficiency = unit.efficiency + GetUnitEfficiencyRecoveryIncrease(unit)
    end
  end
end

function NEWUnitCanRecoverEfficiency(unit,hex,nextTurn)
  if hex == nil then
    hex = unit.hex
  end
  if unit.hex ~= nil
		and unit.alive 
		and unit.state ~= Unit.STATE_EMBARKED 
		and unit.supply > 0 
		and hex.terrain.type ~= Terrain.WATER 
		and ((nextTurn == true and unit.hex.id == hex.id) 
				or UnitWasIdle(unit)) then
				return true
  else
    return false
  end
end

function UnitCanRecoverEfficiency(unit,hex,nextTurn)
  if hex == nil then
    hex = unit.hex
  end
  if unit.hex ~= nil then
    return unit.alive and unit.state ~= Unit.STATE_EMBARKED and unit.supply > 0 and hex.terrain.type ~= Terrain.WATER and ((nextTurn == true and unit.hex.id == hex.id) or UnitWasIdle(unit))
  else
    return false
  end
end



function GetUnitEfficiencyRecoveryIncrease(unit)
  local recovery
  if unit.supply == 2 then
    recovery = 50
  elseif unit.supply == 1 then
    recovery = 30
  else
    recovery = 0
  end
  if unit.type == Unit.NAVAL and unit.luaData.endurance ~=  nil then
	unit.luaData.quality = unit.luaData.endurance
  end
  
  if recovery > unit.luaData.quality - unit.efficiency then
    recovery = unit.luaData.quality - unit.efficiency
  end
  
  -----RUSSIA SUPPLY CRISIS
  if recovery >0 
	and unit.faction.id == 4 
	and GetEvent("RussiaSupplyCrisis") >0 and GetEvent("RussiaSupplyCrisisEnd") == 0  
	and unit.hex ~= nil 
	and unit.type == Unit.LAND	
	and (unit.hex.construction == nil or (unit.hex.construction ~= nil and unit.supply < 2))
	and unit.efficiency >= 30
	and ((math.random(1,100) > unit.efficiency - game.turn)  
			or (unit.faction.id == 4 
				and (unit.hex.originalFaction.id == 2 
					or unit.hex.originalFaction.id == 3)  
				and math.random(1,100) > unit.efficiency - game.turn *2)) then
				recovery = -30
  end
  ----SERBS IN AUSTRIA
  if recovery >0 
	and unit.faction.id == 7   
	and unit.hex ~= nil 
	and unit.type == Unit.LAND 
	and unit.hex.construction == nil 
	and unit.hex.originalFaction.id == 3
	and unit.efficiency >= 20 
	and math.random(1,100) > unit.efficiency  then
				recovery = -20
  end
    if recovery >0 
	and (player.alliance.id == 1 and game.type == Game.TYPE_SINGLE)
	and unit.faction.id == 4 
	and GetEvent("RussiaSupplyCrisisEnd") >0	
	and unit.hex ~= nil 
	and unit.type == Unit.LAND 
	and unit.hex.construction == nil 
	and unit.hex.originalFaction.id == 2
	and unit.efficiency >= 20   then
				recovery = -20
  end
  
  if unit.luaData.endurance ~= nil and unit.luaData.endurance <= 0 and unit.type == Unit.NAVAL then
		recovery = 0
  end
  
  return recovery
end

-- Automatic hex entrenchment for idle units
-- Units with half supply cannot go above level 2
-- Units with no supply cannot improve entrenchment
function UnitEntrenchment(alliance)
  for faction in alliance.factions do
    for unit in faction.units do
      if UnitCanEntrench(unit) 
	  and (unit.luaData.mud == nil or unit.luaData.mud == 0) then
	  
		if unit.faction.id == 4 
			and GetEvent("RussiaSupplyCrisis") >0 
			and GetEvent("RussiaSupplyCrisisEnd") == 0 then
				if unit.hex.entrench >1 then
					unit.hex.entrench = unit.hex.entrench -1
				end		
		else
			unit.hex.entrench = unit.hex.entrench + 1
		end
	  end
    end
  end
end

function UnitCanEntrench(unit,hex,nextTurn)
  if hex == nil then
    hex = unit.hex
  end
  if unit.alive 
	and unit.hex ~= nil 
	and unit.type ~= Unit.NAVAL 
	and unit.type ~= Unit.AIR
	and ((nextTurn == true and unit.hex.id == hex.id) or unit.luaData.noEntrenchTurn ~= game.turn -1) then
    if hex ~= nil and hex.entrench < unit.faction.luaData.entrenchMax then
      if unit.supply == 2 or (unit.supply == 1 and hex.entrench < 2) then
        return true
      end
    end
  end
  return false
end

-- Check if hex has river in certain direction
function HasRiver(hex, direction)
  if hex.rivers < 1 or hex.rivers == 255 then
    return false
  end
  if hasbit(hex.rivers, bit(direction+1)) == true then
    return true
  else
    return false
  end
end


function GameUnitCreated(unit)
  -- initialize unit here
  --unit.luaData.someValue = unit.id * 666

  unit.luaData.quality = 100

  unit.luaData.unitTechs = {}
  if game ~= nil then
    unit.luaData.repaired = game.turn
    unit.luaData.upgraded = game.turn
  else
    unit.luaData.repaired = 0
    unit.luaData.upgraded = 0
  end
  SetUnitAction(unit)

  --Log("Unit created. Id=" .. unit.id)
end

function GameFactionHexAdded(faction, hex)

  -- Damage entrenchment on capture
  if hex.entrench > 2 then
    hex.entrench = hex.entrench - 1
  end

  -- Efficiency loss for captor
  if hex.unit ~= nil then
    if gameplay.advanceUnit == nil or gameplay.advanceUnit.id ~= hex.unit.id then
      DamageEfficiency(hex.unit, gameplay.CaptureEfficiencyLoss)
    end
  end
end

function GameFactionHexRemoved(faction, hex)

end

function SetUnitAction(unit)
  if game ~= nil then
    local phase = 0
    if game.currentAlliance ~= nil and startingAlliance ~= game.currentAlliance.id then
      phase = 1
    end
    unit.luaData.lastAction = game.turn * 10 + phase
    unit.luaData.lastActionTurn = game.turn
  else
    unit.luaData.lastAction = 10
    unit.luaData.lastActionTurn = - 1
  end
  if unit.luaData.lastActionId == nil then
    unit.luaData.lastActionId = 1
  else
    unit.luaData.lastActionId = unit.luaData.lastActionId + 1
  end
end

function UnitNoEntrenchTurn(unit)
  if game ~= nil then
    unit.luaData.noEntrenchTurn = game.turn
  else
    unit.luaData.noEntrenchTurn = 1
  end
end


function Ishexinv(x,y) --- is hexinvisible for enemy? true == yes, is invisible

local hex = GetHex(x,y)
local enemyinrange = 0
local invisi  = true	
	local adjacentHexes = game.map:GetHexesInRange(hex, 7)
		for _, enemyhex in pairs(adjacentHexes) do
			LogUi("RANGE 7 CHECK AT: " .. enemyhex.x .. "/" .. enemyhex.y)
			
				if enemyhex.unit ~= nil 
				and enemyhex.unit.alliance.id ~= 0
				    and enemyhex.unit.alliance.id ~= game.currentAlliance.id
					and enemyhex.unit.prototype.name == "zeppelin" then
						enemyinrange = 1
						LogUi("SPOTTED ENEMY AT HEX: " .. enemyhex.x .. "/" .. enemyhex.y)
						LogUi("UNIT FACTION IS: " .. enemyhex.unit.faction.name .. "/ TYPE IS: " .. enemyhex.unit.prototype.name)
					break
				end
		end
		local adjacentHexes = game.map:GetHexesInRange(hex, 6)	
		for _, enemyhex in pairs(adjacentHexes) do
		LogUi("RANGE 6 CHECK AT: " .. enemyhex.x .. "/" .. enemyhex.y)
				if enemyhex.unit ~= nil 
				and enemyhex.unit.alliance.id ~= 0
				    and enemyhex.unit.alliance.id ~= game.currentAlliance.id
					and enemyhex.unit.prototype.name == "bomber" then		
						enemyinrange = 1
						LogUi("SPOTTED ENEMY AT HEX: " .. enemyhex.x .. "/" .. enemyhex.y)
					break
				end
		end		

	local adjacentHexes = game.map:GetHexesInRange(hex, 4)			
		for _, enemyhex in pairs(adjacentHexes) do
		LogUi("RANGE 4 CHECK AT: " .. enemyhex.x .. "/" .. enemyhex.y)
				if enemyhex.unit ~= nil 
				and enemyhex.unit.alliance.id ~= 0
				    and enemyhex.unit.alliance.id ~= game.currentAlliance.id
					and enemyhex.unit.prototype.name == "fighter" then 
					LogUi("SPOTTED ENEMY AT HEX: " .. enemyhex.x .. "/" .. enemyhex.y)	
						LogUi("UNIT FACTION IS: " .. enemyhex.unit.faction.name .. "/ TYPE IS: " .. enemyhex.unit.prototype.name)
					
					enemyinrange = 1
					break
				end
		end
	local adjacentHexes = game.map:GetHexesInRange(hex, 3)					
		for _, enemyhex in pairs(adjacentHexes) do
		LogUi("RANGE 3 CHECK AT: " .. enemyhex.x .. "/" .. enemyhex.y)
				if enemyhex.unit ~= nil 
					and enemyhex.unit.alliance.id ~= 0
				    and enemyhex.unit.alliance.id ~= game.currentAlliance.id
						and (enemyhex.unit.prototype.name == "arabcavalry"
							or (enemyhex.unit.prototype.name == "lightcruiser"
							    and hex.terrain.type == Terrain.WATER)
							or (enemyhex.unit.prototype.name == "battlecruiser"
								and hex.terrain.type == Terrain.WATER)
							or (enemyhex.unit.prototype.name == "submarine")
									and hex.terrain.type == Terrain.WATER) then
					enemyinrange = 1
					LogUi("SPOTTED ENEMY AT HEX: " .. enemyhex.x .. "/" .. enemyhex.y)
					LogUi("UNIT FACTION IS: " .. enemyhex.unit.faction.name .. "/ TYPE IS: " .. enemyhex.unit.prototype.name)

					break
				end
		end		
			local adjacentHexes = game.map:GetHexesInRange(hex, 2)					
		for _, enemyhex in pairs(adjacentHexes) do
		LogUi("RANGE 2 CHECK AT: " .. enemyhex.x .. "/" .. enemyhex.y)
				if enemyhex.unit ~= nil 
						and enemyhex.unit.alliance.id ~= 0 
						and enemyhex.unit.alliance.id ~= game.currentAlliance.id
						and (enemyhex.unit.prototype.name == "cavalry"
							or enemyhex.unit.prototype.name == "armouredcruiser"
							or enemyhex.unit.prototype.name == "armouredcar") then
					enemyinrange = 1
					LogUi("SPOTTED ENEMY AT HEX: " .. enemyhex.x .. "/" .. enemyhex.y)
					LogUi("UNIT FACTION IS: " .. enemyhex.unit.faction.name .. "/ TYPE IS: " .. enemyhex.unit.prototype.name)

					break
				end
		end
		local adjacentHexes = game.map:GetHexesInRange(hex, 1)					
		for _, enemyhex in pairs(adjacentHexes) do
		LogUi("RANGE 1 CHECK AT: " .. enemyhex.x .. "/" .. enemyhex.y)
				if (enemyhex.unit ~= nil 
					and enemyhex.unit.alliance.id ~= 0				
				    and enemyhex.unit.alliance.id ~= game.currentAlliance.id)
					or (enemyhex.alliance ~= nil
						and enemyhex.alliance.id ~= 0
						and enemyhex.alliance.id ~= game.currentAlliance.id 
						and enemyhex.construction ~= nil)	then
					enemyinrange = 1
					LogUi("SPOTTED ENEMY AT HEX: " .. enemyhex.x .. "/" .. enemyhex.y)
					LogUi("UNIT FACTION IS: " .. enemyhex.unit.faction.name .. "/ TYPE IS: " .. enemyhex.unit.prototype.name)

					break
				end
		end	
		if (hex.unit ~= nil and hex.unit.alliance.id ~= game.currentAlliance.id)
				or (hex.alliance ~= nil
						and hex.alliance.id ~= game.currentAlliance.id 
						and hex.construction ~= nil) then
						LogUi("SPOTTED ENEMY AT HEX: " .. hex.x .. "/" .. hex.y)
			enemyinrange = 1 
		end
--------------------------
--------------------------		
if enemyinrange == 1 then
	invisi = false
end
----------------
return invisi
end


--[[ Has unit done action last turn
function UnitWasIdle(unit)
  if math.floor(unit.luaData.lastAction / 10) < game.turn - 1 then
    return true
  else
    return false
  end
end--]]

function UnitWasIdle(unit)
  if  unit.luaData.lastActionTurn == nil or unit.luaData.lastActionTurn < GetTurnForMostRecentCompletePhase(unit.alliance) then
    return true
  end
  return false
end

-- Has unit done action during current phase
function UnitIsIdle(unit)
  local turn = 0
  if startingAlliance ~= unit.faction.alliance.id and unit.faction.alliance.id ~= game.currentAlliance.id then
    turn = 1
  end
  if unit.luaData.lastAction < (game.turn - turn) * 10 + turn then
    return true
  else
    return false
  end
end

function GetTurnForMostRecentCompletePhase(alliance)
  if game.currentAlliance.id == alliance.id then
    return game.turn - 1
  else
    if alliance.id == startingAlliance then
      return game.turn
    else
      return game.turn - 1
    end
  end
end

function ErrorCheckConstructions()
  for faction in game.factions do
    for construction in faction.constructions do
      if construction.type ~= Construction.TYPE_PORT then
        if construction.hex.originalFaction == nil then
          print("warning: " .. construction.name .. " has no originalFaction")
        else
          if construction.hex.originalFaction.id ~= faction.id then
            print("warning: " .. construction.name .. " belongs to wrong faction")
          end
        end
      end
    end
  end
end



function EasterEgg_RedBaron(unit)
  if unit.prototype.name == "fighter" and unit.level == 4 and unit.commander ~= nil and unit.commander.id == 21 then
    unit:Upgrade()
  end
end




function GetDirection(x1, y1, x2, y2)
  local direction
  if(x1 > x2) then
    if(y1 == y2) then
      if(x1%2 == 0) then
        direction = 4
      else
        direction = 5
      end
    else
      if(x1%2 == 0) then
        direction = 5
      else
        direction = 4
      end
    end
  elseif (x1 < x2) then
    if(y1 == y2) then
      if(x1%2 == 0) then
        direction = 2
      else
        direction = 1
      end
    else
      if(x1%2 == 0) then
        direction = 1
      else
        direction = 2
      end
    end
  elseif (x1 == x2) then
    if(y1 > y2) then
      direction = 0
    else
      direction = 3
    end
  end
  return direction
end

function GetAdjacent(x, y, direction)
  local x2,y2,hex
  if direction < 0 then
    direction = direction + 6
  elseif direction > 5 then
    direction = direction - 6
  end

  if direction == 0 then
    x2 = x
    y2 = y - 1
  elseif direction == 1 then
    x2 = x + 1
    if(x%2 == 0) then
      y2 = y-1
    else
      y2 = y
    end
  elseif direction == 2 then
    x2 = x + 1
    if(x%2 == 0) then
      y2 = y
    else
      y2 = y+1
    end
  elseif direction == 3 then
    x2 = x
    y2 = y + 1
  elseif direction == 4 then
    x2 = x - 1
    if(x%2 == 0) then
      y2 = y
    else
      y2 = y+1
    end
  elseif direction == 5 then
    x2 = x - 1
    if(x%2 == 0) then
      y2 = y-1
    else
      y2 = y
    end
  end

  return GetHex(x2, y2)
end

function RepairStats()

		
	for faction in game.factions do	
	
		---CASUALTIES-----
		
		if faction.luaData.statsCasualties["ground"] ~= nil then
			faction.luaData.groundlosses = faction.luaData.statsCasualties["ground"]
		
		elseif faction.luaData.statsCasualties["ground"] == nil then
				faction.luaData.statsCasualties["ground"] = faction.luaData.groundlosses
		end
		
		if faction.luaData.statsCasualties["naval"] ~= nil then
			faction.luaData.navallosses	= faction.luaData.statsCasualties["naval"]
		
		elseif faction.luaData.statsCasualties["naval"] == nil then
				faction.luaData.statsCasualties["naval"] = faction.luaData.navallosses
		end
		
		if faction.luaData.statsCasualties["air"] ~= nil then
			faction.luaData.airlosses = faction.luaData.statsCasualties["air"]
		
		elseif faction.luaData.statsCasualties["air"] == nil then
			faction.luaData.statsCasualties["air"] = faction.luaData.airlosses
		end	
		
		
		---KILLS-----
		
		if faction.luaData.statsKills["ground"] ~= nil then
			faction.luaData.groundkills	=  faction.luaData.statsKills["ground"] == nil 
		
		elseif faction.luaData.statsKills["ground"] == nil then
				faction.luaData.statsKills["ground"] = faction.luaData.groundkills
		end
		
		if faction.luaData.statsKills["naval"] ~= nil then
				faction.luaData.navalkills = faction.luaData.statsKills["naval"] 
		
		elseif faction.luaData.statsKills["naval"] == nil then
				faction.luaData.statsKills["naval"] = faction.luaData.navalkills
		end
		
		if faction.luaData.statsKills["air"] ~= nil then
				faction.luaData.airkills = faction.luaData.statsKills["air"]	
		
		elseif faction.luaData.statsKills["air"] == nil then
			 faction.luaData.statsKills["air"] = faction.luaData.airkills
		
		end		
	end

end

function MatchType() --- type is defined by player alliance

if game.type == Game.TYPE_SINGLE and player.alliance.id == 1 then
	return 1
end
if game.type == Game.TYPE_SINGLE and player.alliance.id == 2 then
	return 2
end

if game.type == Game.TYPE_PBEM then
	return 3
end


end 


