function SimulateCombat(attackers,defender,defenderHex,attackerHexes,movesAssigned,aiPlayer,preDefenderDamage,preDefenderEfficiencyDrop,preAttackersDamage,preAttackersEfficiencyDrops)--,attackerEffiencies)
  local defenderClone = {}
  local attackerClone = {}
   ui.resourcesPanel:Refresh()
  --defenderClone.id = defender.id
  --defenderClone.name = defender.name
  defenderClone.faction = defender.faction
  defenderClone.alliance = defender.alliance
  defenderClone.type = defender.type
  defenderClone.supply = defender.supply
  if preDefenderDamage ~= nil then
    defenderClone.hp = math.min(100,math.max(0,defender.hp - preDefenderDamage))
  else
    defenderClone.hp = defender.hp
  end
  local initHP = defenderClone.hp
  if preDefenderEfficiencyDrop ~= nil then
    defenderClone.efficiency = math.min(100,math.max(0,defender.efficiency - preDefenderEfficiencyDrop))
  else
    defenderClone.efficiency = defender.efficiency
  end 
  local initEfficiency = defenderClone.efficiency
  defenderClone.prototype = defender.prototype
  defenderClone.commander = defender.commander
  defenderClone.luaData = defender.luaData

  if defenderHex == nil then
    defenderClone.hex = defender.hex
  else
    defenderClone.hex = defenderHex
  end
  defenderClone.efficiency = aiPlayer:getPostMoveEfficiency(defenderClone,defenderClone.hex)

  local attackersDamage = {}
  local attackersEfficiencyDrop = {}
  local historicDefenderDamage = {}
  local historicDefenderEfficiencyDrop = {}
  local damage,attackerDamage,defenderDamage,attackerEfficiency, defenderEfficiency, defenderEfficiencyDrop


  for i,attacker in ipairs(attackers) do
    attackerClone = {}
    attackerClone.id = attacker.id
    attackerClone.name = attacker.name
    attackerClone.faction = attacker.faction
    attackerClone.alliance = attacker.alliance
    attackerClone.type = attacker.type
    attackerClone.supply = attacker.supply
    if preAttackersDamage ~= nil and preAttackersDamage[attacker.id] ~= nil then
      attackerClone.hp = math.min(100,math.max(0,attacker.hp - preAttackersDamage[attacker.id]))
    else
      attackerClone.hp = attacker.hp
    end
    attackerClone.prototype = attacker.prototype
    attackerClone.commander = attacker.commander
    attackerClone.luaData = attacker.luaData
    attackerClone.stats = attacker.stats
    attackerClone.cargo = attacker.cargo

    if attackerHexes ~= nil and attackerHexes[attacker.id] ~= nil then
      attackerClone.hex = attackerHexes[attacker.id]
    elseif movesAssigned ~= nil and movesAssigned[attacker.id] ~= nil and attacker.mp > 0 then
      attackerClone.hex = movesAssigned[attacker.id]
    else
      attackerClone.hex = attacker.hex
    end
    attackerClone.efficiency = aiPlayer:getPostMoveEfficiency(attacker,attackerClone.hex)

    if preAttackersEfficiencyDrops ~= nil and preAttackersEfficiencyDrops[attacker.id] ~= nil then
      attackerClone.efficiency = math.min(100,math.max(0,attackerClone.efficiency - preAttackersEfficiencyDrops[attacker.id]))
    end

    damage = CalculateDamage(attackerClone,defenderClone,true)
    attackerDamage,defenderDamage = damage[1]*10,damage[2]*10
    attackersDamage[attacker.id] = attackerDamage
    defenderClone.hp = defenderClone.hp - defenderDamage

    historicDefenderDamage[i] = defenderDamage

    attackerEfficiency, defenderEfficiency = CalculateEfficiency(attackerClone,defenderClone,attackerDamage,defenderDamage)
    attackersEfficiencyDrop[attacker.id] = attackerClone.efficiency - attackerEfficiency
    historicDefenderEfficiencyDrop[i] = defenderClone.efficiency - defenderEfficiency
    defenderClone.efficiency = defenderEfficiency

    if defenderClone.hp <= 0 then
      defenderDamage = initHP
      defenderEfficiencyDrop = defender.efficiency - defenderClone.efficiency
      return  attackersDamage, defenderDamage, historicDefenderDamage, attackersEfficiencyDrop, defenderEfficiencyDrop, historicDefenderEfficiencyDrop
    end


    -- Note, need to add predictions for if the unit will retreat!
  end

  defenderDamage = initHP - defenderClone.hp
  defenderEfficiencyDrop = initEfficiency - defenderClone.efficiency

  return attackersDamage, defenderDamage, historicDefenderDamage, attackersEfficiencyDrop, defenderEfficiencyDrop
end

function ResolveCombat(attacker, defender)
--LogUi("ResolveCombat START")	

  if attacker.alliance.id ~= playerAlliance.id then
    showAttack(attacker.hex,defender.hex,MoveLogType.Attack)
  end

  local hex = defender.hex
  ui.attackerHex = attacker.hex

  local attackerLosses = 0
  local defenderLosses = 0

  -- Clear advance hex
  if gameplay.advanceUnit ~= nil then
    gameplay.advanceUnit = nil
    gameplay.advanceHex = nil
  end

  local defenderCity
  local targetIsUnit = false
  if defender.prototype ~= nil then
    targetIsUnit = true
    if hex.construction ~= nil then
      defenderCity = hex.construction
    end
  else
    defenderCity = defender
  end

  -- Ammo Consumption --
  if attacker.type ~= Unit.NAVAL or defender.type ~= Unit.NAVAL then
    attacker.faction:ConsumeAmmo(GetUnitAmmoRequirement(attacker))

    if attacker.alliance.id == playerAlliance.id then
      ui.resourcesPanel:Refresh()
    end

  end

  -- Intercept logic
  InterceptCheck(attacker, hex)

  -- Check if defender is unit and not construction
  if defender.prototype ~= nil then

    local damage = CalculateDamage(attacker, defender, false)
    
	attackerLosses = attackerLosses + damage[1]
    defenderLosses = defenderLosses + damage[2]
    local retreat = damage[3]
	
    -- Damage unit hp
    attacker:Damage(attackerLosses)
    defender:Damage(defenderLosses)

    -- If unit is in transport, also damage transport
    if attacker.carrier ~= nil then
      attacker.carrier:Damage(attackerLosses)
    end
    if defender.carrier ~= nil then
      defender.carrier:Damage(defenderLosses)
    end

    -- If unit is transport, also damage cargo
    if defender.cargo ~= nil then
      for cargo in defender.cargo.units do
        cargo:Damage(defenderLosses)
        -- Update kill/casualty stats
        defender.faction.luaData.statsCasualties[cargo.prototype.lua.class] = defender.faction.luaData.statsCasualties[cargo.prototype.lua.class] + defenderLosses
        attacker.faction.luaData.statsKills[cargo.prototype.lua.class] = attacker.faction.luaData.statsKills[cargo.prototype.lua.class] + defenderLosses
        break
      end
    else
      -- Update kill/casualty stats
	  
		if attacker.type == defender.type then
		attacker.faction.luaData.statsKills[defender.prototype.lua.class] = attacker.faction.luaData.statsKills[defender.prototype.lua.class] + defenderLosses
		defender.faction.luaData.statsCasualties[defender.prototype.lua.class] = defender.faction.luaData.statsCasualties[defender.prototype.lua.class] + defenderLosses	  
		end
	  
		if defender.prototype.lua.class == "convoy" then
			defender.faction.luaData.statsCasualties["naval"] = defender.faction.luaData.statsCasualties["naval"] + defenderLosses
		--	attacker.faction.luaData.statsKills["naval"] = attacker.faction.luaData.statsKills["naval"] + defenderLosses
		end
    end
	if attacker.cargo ~= nil then
		  for cargo in attacker.cargo.units do
			cargo:Damage(attackerLosses)
			-- Update kill/casualty stats
			attacker.faction.luaData.statsCasualties[cargo.prototype.lua.class] = attacker.faction.luaData.statsCasualties[cargo.prototype.lua.class] + attackerLosses
			defender.faction.luaData.statsKills[cargo.prototype.lua.class] = defender.faction.luaData.statsKills[cargo.prototype.lua.class] + attackerLosses
			break
		  end
    else
      -- Update kill/casualty stats
	  	 if attacker.type == defender.type then

			attacker.faction.luaData.statsCasualties[attacker.prototype.lua.class] = attacker.faction.luaData.statsCasualties[attacker.prototype.lua.class] + attackerLosses
			defender.faction.luaData.statsKills[attacker.prototype.lua.class] = defender.faction.luaData.statsKills[attacker.prototype.lua.class] + attackerLosses
		end
	  end

    -- Damage unit construction
    --StrategicAttack(attacker, hex)

    AfterCombat(attacker,defender,attackerLosses,defenderLosses,retreat,hex)

    SetUnitAction(defender)

  end

  -- Check if there is city that will (also) be damaged
  if defenderCity ~= nil then
	
	
		local prod = 0
		
			prod = GetConstructionProduction(hex.construction) *5	
			--LogUi("PROD:" .. prod)	
			
			if defenderCity.type == Construction.TYPE_FORTRESS then
				prod = prod + 50
			end
			
		
		
		
	if GetStat(attacker, "stratattack") ~= nil then
	  local damage = StrategicAttack(attacker, defenderCity)
      if not targetIsUnit then
        attackerLosses = damage[1]
        defenderLosses = damage[2]
      end
	
	elseif attacker.type == Unit.LAND then
	--	LogUi("------------------------------------------------DFL:" .. defenderLosses) 
		if defenderLosses >= 10 then      --- V6 this is new!!!!
		CollateralDamage(defenderCity, 10)
		end
    
	end
	
	
			--------BRITAIN REACTS TO GERMAN NAVY BOMBARDING FRANCE-----------
      		if attacker.type == Unit.NAVAL then
				   local britain = game:GetFactionById(1)

					if attacker.faction.id == 2 
						and GetEvent("DOWbritain") == 0 
						and defender.hex ~= nil 
						and defender.hex.construction ~= nil 
						and defender.hex.originalFaction ~= nil
						and defender.hex.originalFaction.id == 0 then 
						
							if britain.luaData.alignment <= 99.7 then 
								ChangeFactionAlignment(game:GetFactionById(1), britain.alliance, 0.3)

							elseif britain.luaData.alignment > 100 then
								britain.luaData.alignment = 100					
							end
					end
					
				if defender.prototype ~= nil and defender.type == Unit.LAND and defender.luaData.experience ~= nil then
								local battery = prod * (1 + (0.25 * GetUnitExperienceLevel(defender)))
									--		LogUi("PROD" .. prod)
											if GetEvent("CoastalDefense") == game.turn then
											
												if defender.commander ~= nil then
													battery = battery * 0.5
												else
													battery = battery * 0.3
												end
											end
											if defender.faction.am <1 then
												battery = battery * 0.5
											end
											
											if GetEvent("CoastalDefense") == game.turn and attacker.commander ~= nil then
												battery = battery * 0.65
											end
											LogUi("COASTAL BATTERY" .. battery)
						if battery > attacker.luaData.experience then 
							SetEvent("CoastalDefense", game.turn)
									
									if attacker.luaData.endurance ~= nil then
											attacker.luaData.endurance = attacker.luaData.endurance -1
									else 
										attacker.luaData.endurance = 9	
									
									end
									
									if attacker.commander == nil then
										attacker:Damage(10)
											if defender.faction.am > 1 then
												defender.faction:ConsumeAmmo(1)
											end
									else
										attacker:Damage(5)
											if defender.faction.am > 1 then	
													defender.faction:ConsumeAmmo(1)
											end
									end	
						end
						
				end
			end			
	
  end

  -- Reveal hex player just attacked
  attacker.alliance:AddVisibleHex(hex)

  -- Attack animations --
  -----------------------
   
  AttackAnimation(attacker, defender)
  AttackSound(attacker, defender)

  SetUnitAction(attacker)
  UnitNoEntrenchTurn(attacker)
--[[  
	if attackerLosses ~= nil
	and attackerLosses >= 0 then
	ui.attackerDamage = attackerLosses
	  
	end
	if defenderLosses ~= nil
	and defenderLosses >= 0 then
	  ui.defenderDamage = defenderLosses

	end]]
  

 ui.attackerDamage = attackerLosses --- UNTIL BUG IS FOUND
 ui.defenderDamage = defenderLosses

  attacker.luaData.repaired = game.turn
  attacker.luaData.upgraded = game.turn

--	if attacker ~= nil and attacker.luaData.experience ~= nil and defender ~= nil and defender.prototype.name ~= "convoy" and defender.prototype.name ~= "transport" then
--		ExperienceAssign(attacker, defender, defenderLosses, attackerLosses)
--	 end
--	if defender ~= nil and defender.luaData.experience ~= nil then 
--		ExperienceAssign(defender, attacker, attackerLosses, defenderLosses)
--	end
	
	
	
	
  TriggerCombatEvents(attacker, defender, hex)
--LogUi("ResolveCombat END")	
  end


function CalculateDamage(attacker, defender, simulate)
--LogUi("CALC DAMAGE START")
 local entente = game:GetAllianceById(1)
   local cp = game:GetAllianceById(2)
  local attackerHex = attacker.hex
  local hex = defender.hex


  -- Amphibious Attack --
  -----------------------

  local amphibious = 0
  if attacker.cargo ~= nil then
    amphibious = 1
    for cargo in attacker.cargo.units do
      attacker = cargo
      break
    end
  end

  -- Attack Direction --
  ----------------------

  -- get defender coords, get attacker coords
  -- compare positions
  --defender.attdir = defender.attdir + 2^GetDirection(attacker.hex.x,attacker.hex.y,defender.hex.x,defender.hex.y)
  --dir = {0,0,0,0,0,0}

  -- Get attack directions
  --value = defender.attdir
  --for j=0,5 do
  --  i = 5-j
  --  if(value >= 2^i) then
  --    dir[i+1] = 1
  --    value = value - 2^i
  --    printLog("Attack from: " .. i)
  --  end
  --end
  -- Check if outflanked
  --for i=0,5 do
  --  j = (i + 3) % 6
  --  -- if attacked from 2 opposing directions:
  --  if(dir[i+1] == 1 and dir[j+1] == 1) then
  --    printLog("Outflank attack!")
  --    break
  --  end
  --end


  --if defender has "garrison" defined, use its stats in ground attack
  local defenderPrototype
  if defender.prototype.lua.defenseType ~= nil then
    defenderPrototype = GetPrototypeByName(defender.prototype.lua.defenseType)
  else
    defenderPrototype = defender.prototype.lua
  end


  -- Attack & Defense --
  ----------------------

  local aAttack = 0
  local aDefense = 0
  local dAttack = 0
  local dDefense = 0

  local aCommander = GetNearbyCommander(attacker)
  local dCommander = GetNearbyCommander(defender)

  local defenseType

  if attacker.prototype.lua.type == defenderPrototype.type and attacker.prototype.lua.class ~= "artillery" then
    aDefense = GetStat(attacker, "basedefense") + GetCommanderBonus(aCommander, "basedefense")
    dDefense = GetStat(defender, "basedefense", defenderPrototype) + GetCommanderBonus(dCommander, "basedefense")
    defenseType = "base"
  else
    aDefense = GetStat(attacker, "highdefense") + GetCommanderBonus(aCommander, "highdefense")
    dDefense = GetStat(defender, "highdefense", defenderPrototype) + GetCommanderBonus(dCommander, "highdefense")
    defenseType = "high"
  end

  --Log(attacker.prototype.name)
  --Log(defender.prototype.name)

  if defenderPrototype.type == "land" then
    aAttack = GetStat(attacker, "groundattack") + GetCommanderBonus(aCommander, "groundattack")
    if defender.prototype.name == "armour" then
      local bonus = GetStat(attacker, "armourattack")
      if bonus ~= nil then
        aAttack = aAttack + bonus
      end
    end
  elseif defenderPrototype.type == "air" then
    aAttack = GetStat(attacker, "airattack") + GetCommanderBonus(aCommander, "airattack")
  elseif defender.prototype.name == "submarine" then
    aAttack = GetStat(attacker, "subattack")
    -- Check if it has sub attack before applying bonus
    if aAttack ~= nil then
      GetCommanderBonus(dCommander, "subattack")
    end
  else
    aAttack = GetStat(attacker, "navalattack") + GetCommanderBonus(aCommander, "navalattack")
  end

  local bombardAttack = false
  if attacker.prototype.lua.class ~= "artillery" then
    if attacker.type == Unit.LAND then
      dAttack = GetStat(defender, "groundattack", defenderPrototype) + GetCommanderBonus(dCommander, "groundattack")
      if attacker.prototype.name == "armour" then
        local bonus = GetStat(defender, "armourattack")
        if bonus ~= nil then
          dAttack = dAttack + bonus
        end
      end
    elseif attacker.type == Unit.AIR then
      dAttack = GetStat(defender, "airattack", defenderPrototype) + GetCommanderBonus(dCommander, "airattack")
    elseif attacker.prototype.name == "submarine" then
      dAttack = GetStat(defender, "subattack", defenderPrototype)
      -- Check if it has sub attack before applying bonus
      if dAttack ~= nil then
        GetCommanderBonus(dCommander, "subattack")
      end
    else
      dAttack = GetStat(defender, "navalattack", defenderPrototype)
      -- Check if it has naval attack before applying bonus
      if dAttack ~= nil then
        GetCommanderBonus(dCommander, "navalattack")
      end
      if defender.type ~= Unit.NAVAL then
		bombardAttack = true
      end
    end
  else
    bombardAttack = true
  end

  if aAttack == nil then
    aAttack = 0
  end
  if dAttack == nil then
    dAttack = 0
  end


  -- Amphibious Penalty --
  ------------------------

  if amphibious == 1 then
    aAttack = aAttack * gameplay.amphibiousAttackMod
    aDefense = aDefense * gameplay.amphibiousDefenseMod
  end


  -- First Strike Bonus --
  -------------------------

  if not simulate
  and attacker.prototype.lua.firstStrike == 1 
  and defender.prototype.name ~= "submarine" 
  and defender.type  == Unit.NAVAL  then
    aAttack = aAttack + gameplay.FirstStrikeBonus
	    if defender.luaData.endurance == nil and defender.type == Unit.NAVAL then
			defender.luaData.endurance = 9

		end
	end


  -- Subs vs convoys and transports
 if not simulate then
	if attacker.prototype.name == "submarine" 
	and (defender.prototype.name == "convoy" or defender.prototype.name == "transport")  then
		aAttack = aAttack + (GetUnitTechCount(attacker, attacker.faction))
			if game.type == Game.TYPE_PBEM or (game.type == Game.TYPE_SINGLE and attacker.alliance.id ~= player.alliance.id) then
					--aAttack = aAttack + (0.5 * GetUnitTechCount(attacker, attacker.faction))
						if game.type == Game.TYPE_SINGLE and player.alliance.id == 1 and game.date.year >= 1916 then
								aAttack = aAttack + (1 * GetUnitTechCount(attacker, attacker.faction))	
						end
			end	
	end
  end
  
  -- Verdun
  if GetEvent("Falkenhayn2") > 0 
	and (GetEvent("VerdunCaptured") == 0 
	and not simulate 
	and GetEvent("VerdunDefended") == 0) then
		if attacker.faction.id == 2 
			and defender.faction.id == 0 
			and (attacker.type == Unit.LAND and defender.type == Unit.LAND) then
			aAttack = aAttack + 1
		
		elseif attacker.faction.id == 2 
			and defender.faction.id == 4
			and attacker.range == 1	
			and attacker.type == Unit.LAND 
			and defender.type == Unit.LAND 
			and aAttack > 2 then
				if aAttack >2 then
					aAttack = aAttack - 2
				end
		
		elseif attacker.faction.id == 4 
			and defender.faction.id == 2 
			and attacker.type == Unit.LAND 
			and defender.type == Unit.LAND then
				if dDefense >1 then
					dDefense = dDefense +1
				end
		end
		
  end
 
 -- capital ship ammo consumption
if not simulate 
	and attacker.alliance.id == player.alliance.id 
	and attacker.type == Unit.NAVAL 
	and defender.type == Unit.NAVAL 
	and attacker.prototype.name  ~= "submarine" 
	and attacker.prototype.name  ~= "lightcruiser" 
	and attacker.prototype.name  ~= "armouredcruiser" 
	and defender.prototype.name ~= "submarine" then
   
	if attacker.faction.am >= 1 then
		attacker.faction:ConsumeAmmo(1)
	
	elseif attacker.faction.am < 1 then
		aAttack = aAttack * 0.5
	end
 	ui.resourcesPanel:Refresh()
									
 end

-- endurance 
 local lucky = math.random(1,10)
if (attacker.luaData.endurance ~= nil 
	and defender.luaData.endurance ~= nil ) 
	and not simulate 
	and (attacker.alliance.id == player.alliance.id 
		or (attacker.alliance.id ~= player.alliance.id 
			and game.type == Game.TYPE_SINGLE 
			and lucky >= attacker.luaData.endurance)) 
	and attacker.type == Unit.NAVAL 
	and defender.type == Unit.NAVAL   then
		if attacker.luaData.endurance ~= nil then
			if attacker.luaData.endurance >= 1 then
				if attacker.commander == nil then
					attacker.luaData.endurance = attacker.luaData.endurance - 1	
				else 	
					attacker.luaData.endurance = attacker.luaData.endurance - (0.5 * math.random(1,2)) 
				end					
					
			end
		else
				attacker.luaData.endurance = 9
		end
		if defender.luaData.endurance ~= nil then
				if defender.commander == nil then
					defender.luaData.endurance = defender.luaData.endurance - 1			
				else 	
					defender.luaData.endurance = defender.luaData.endurance -  (0.5 * math.random(1,2)) 
				end		
		else
				defender.luaData.endurance = 9
		end
end

 local blucky = math.random(1,15)
 local clucky = math.random(1,15)


	if (attacker.alliance.id == player.alliance.id 
	or defender.alliance.id == player.alliance.id) 
	and not simulate 
	and attacker.type == Unit.NAVAL 
	and defender.type == Unit.NAVAL 
	and defender.prototype.name ~= "convoy" 
	and defender.prototype.name ~= "transport" then
		if attacker.alive and defender.alive then
			if attacker.luaData.endurance == nil and attacker.type == Unit.NAVAL then
			attacker.luaData.endurance = 10
			end
			if defender.luaData.endurance == nil and defender.type == Unit.NAVAL then
			defender.luaData.endurance = 10
			end
			
			if not HasHomeSupport(attacker.faction.alliance, attacker.hex) 
				and attacker.alliance.id == player.alliance.id 
					and blucky >= attacker.luaData.endurance then
				if attacker.luaData.endurance >= 1 then
					attacker.luaData.endurance = attacker.luaData.endurance - 1
				end
			end
			
			if not HasHomeSupport(defender.faction.alliance, defender.hex) 
				and defender.alliance.id == player.alliance.id 
				and clucky >= defender.luaData.endurance then
				if defender.luaData.endurance >= 1 then
					defender.luaData.endurance = defender.luaData.endurance - 1
				end
			end
		end
	else
	end		

----CADORNA---------------------------------------------------------
	local italy = game:GetFactionById(8)
	if GetEvent("ReplaceCadorna") == 0 
		and italy.alliance.id ~= 0 then
	if not simulate 
		and attacker.prototype.name == "infantry" 
		and attacker.faction.id == 8 then
			italy.luaData.cadornacharge = italy.luaData.cadornacharge + math.floor(math.sqrt(game.turn))
	end
	if not simulate 
		and attacker.prototype.name == "garrison" 
		and attacker.faction.id == 8 then
			italy.luaData.cadornacharge = italy.luaData.cadornacharge + (math.floor(math.sqrt(game.turn)) * 0.5)
	end
	if not simulate 
		and attacker.prototype.name == "cavalry" 
		and attacker.faction.id == 8 then
			italy.luaData.cadornacharge = italy.luaData.cadornacharge + (math.floor(math.sqrt(game.turn)) * 0.5)
	end

	end



--- HORSE MASSACRE ------------------------
 

    if attacker.prototype.name == "cavalry" 
	and GetEvent("WarHorses") >0  
	and not simulate 
	and defender.alive
	and ((defender.prototype.name == "infantry" 
			or defender.prototype.name == "garrison") 
	and HasUnitTech(defender, "industrial_warfare") == true) 	then
				aAttack = aAttack - 3
				aDefense = aDefense - 3
				if aAttack < 1 then
					aAttack = 1
				end
				if aDefense < 1 then
					aDefense = 1
				end	
	
	end

	if ((attacker.prototype.name == "infantry" or attacker.prototype.name == "garrison" ) 
		and not simulate 
		and defender.alive
		and HasUnitTech(defender, "industrial_warfare") == true) 
		and GetEvent("WarHorses") >0  
		and defender.prototype.name == "cavalry"  then
				dAttack = dAttack - 3
				dDefense = dDefense - 3
				if dAttack < 1 then
					dAttack = 1
				end
				if dDefense < 1 then
					dDefense = 1
				end	
	
	end

------- RSC------
  local russia = game:GetFactionById(4)
 
	if GetEvent("RussiaSupplyCrisis") >0 
	and GetEvent("RussiaSupplyCrisisEnd") == 0 
	and player.alliance.id == 1 
	and game.type == Game.TYPE_SINGLE then 
		if attacker.alliance.id == 2 
			and attacker.range == 1
			and defender.faction.id == 4 
			and attacker.type == Unit.LAND 
			and defender.type == Unit.LAND  then 
			if defender.faction.id == 4 
				and defender.hex ~= nil 
				and russia.morale >= 65 then --and (defender.hex.originalFaction.id == 2 or defender.hex.originalFaction.id == 3) then
				aAttack = aAttack + 2
			end
			--else
			--	aAttack = aAttack + 1
			--end
		end
	end

----- GORLICE -------
local impassable = game:GetFactionById(24)

if not simulate 
	and GetEvent("Gorlice") >0 
	and impassable.luaData.winter == 0 then 
		if attacker.alliance.id == 2 
			and attacker.range == 1
			and defender.alive
			and defender.faction.id == 4 
			and attacker.type == Unit.LAND 
			and defender.type == Unit.LAND  then 
		
				if defender.hex ~= nil then 
					if defender.hex.originalFaction ~= nil 
						and (defender.hex.originalFaction.id == 2 or defender.hex.originalFaction.id == 3) then	
						aAttack = aAttack + 10
					elseif defender.hex.originalFaction ~= nil 
						and defender.hex.originalFaction.id == 4 then
							if GetEvent("RussiaSupplyCrisis") == 0 then
								aAttack = aAttack + 4
							else
								aAttack = aAttack + 2
							end
					end
				end
		end
elseif GetEvent("Gorlice") >0 
	and impassable.luaData.winter == 1 then
	SetEvent("Gorlice", -1)
		
end	
-----BRUSSILOW----------
if not simulate 
	and GetEvent("Brussilow") >0 
		and GetEvent("Brussilow") +4 >= game.turn then 
		if attacker.alliance.id == 4
			and attacker.range == 1
			and defender.alive
			and (defender.faction.id == 2 
				or defender.faction.id == 3)
			and attacker.type == Unit.LAND 
			and defender.type == Unit.LAND  then 
						aAttack = aAttack + 5 - (GetEvent("Brussilow") - game.turn)
		end
end		

----------------------	
	
-- czechs, croats and hungarians in AH reject to fight	
	
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)
local italy = game:GetFactionById(8)
local serbia = game:GetFactionById(7)
local romania = game:GetFactionById(18)


if attacker.faction.id == 3 and not simulate and austria.luaData.czechs >1 and defender.faction.id == 4 and GetEvent("FranzJosef") == 0 and attacker.type == Unit.LAND and (attacker.prototype.name == "infantry" or attacker.prototype.name == "cavalry" or attacker.prototype.name == "garrison") and defender.type == Unit.LAND and GetEvent("Masaryk") == 0 then
aAttack = aAttack - (austria.luaData.czechs * 0.5)
	if aAttack < 1 then
	aAttack = 1
	end
	
	if austria.mp >250 then
	austria:ConsumeManpower(math.ceil(austria.luaData.czechs * 0.5))
	end
	
elseif attacker.faction.id == 3 and not simulate and austria.luaData.czechs >0  and (GetEvent("FranzJosef") >0 or GetEvent("Masaryk") >0) and attacker.type == Unit.LAND and (attacker.prototype.name == "infantry" or attacker.prototype.name == "cavalry" or attacker.prototype.name == "garrison") and defender.type == Unit.LAND  then
aAttack = aAttack - (austria.luaData.czechs * 0.5)
	if aAttack < 1 then
	aAttack = 1
	end
	if austria.mp >250 then
	austria:ConsumeManpower(math.ceil(austria.luaData.czechs *0.5))
	end
end
 --croats benefit from borojevic
if attacker.faction.id == 3 and not simulate  and (attacker.commander ~= nil and attacker.commander.id ~= 59) and austria.luaData.croats >3 and (defender.faction.id == 8 or defender.faction.id == 7)  and GetEvent("FranzJosef") == 0 and attacker.type == Unit.LAND and (attacker.prototype.name == "infantry" or attacker.prototype.name == "cavalry" or attacker.prototype.name == "garrison") and defender.type == Unit.LAND then
aAttack = aAttack - (austria.luaData.croats *0.5)
	if aAttack < 1 then
	aAttack = 1
	end
		if austria.mp >250 then
		austria:ConsumeManpower((math.ceil(austria.luaData.croats *0.5)))
		end
elseif attacker.faction.id == 3 and not simulate and (attacker.commander ~= nil and attacker.commander.id ~= 59) and austria.luaData.croats >2  and GetEvent("FranzJosef") >0 and attacker.type == Unit.LAND and (attacker.prototype.name == "infantry" or attacker.prototype.name == "cavalry" or attacker.prototype.name == "garrison") and defender.type == Unit.LAND then
aAttack = aAttack - (austria.luaData.croats * 0.5)
		if aAttack < 1 then
			aAttack = 1
		end
		if austria.mp >250 then
		austria:ConsumeManpower((math.ceil(austria.luaData.croats * 0.5)))
		end
end

if attacker.faction.id == 3 and not simulate and austria.luaData.hungarians >5 and (attacker.commander ~= nil and attacker.commander.id ~= 95) and (defender.faction.id == 18 or defender.faction.id == 8)  and GetEvent("FranzJosef") == 0 and attacker.type == Unit.LAND and (attacker.prototype.name == "infantry" or attacker.prototype.name == "cavalry" or attacker.prototype.name == "garrison") and defender.type == Unit.LAND then
aAttack = aAttack - (austria.luaData.hungarians * 0.5)
		if aAttack < 1 then
			aAttack = 1
			end
		if austria.mp >250 then
		austria:ConsumeManpower(math.ceil(austria.luaData.hungarians * 0.5))
		end
elseif attacker.faction.id == 3 and not simulate and austria.luaData.hungarians >3  and GetEvent("FranzJosef") >0 and attacker.type == Unit.LAND and (attacker.prototype.name == "infantry" or attacker.prototype.name == "cavalry" or attacker.prototype.name == "garrison") and defender.type == Unit.LAND then
aAttack = aAttack - (austria.luaData.hungarians)
	if aAttack < 1 then
		aAttack = 1
	end
		if austria.mp >250 then
		austria:ConsumeManpower(math.ceil(austria.luaData.hungarians * 0.5))
		end
end
      ui.resourcesPanel:Refresh()


-- Belgrade
local romania = game:GetFactionById(18)
local bulgaria = game:GetFactionById(19)
local serbia = game:GetFactionById(7)
local belgrade = game:GetHex(109,38)
local bonus = GetEvent("DOWbulgaria")

if (bulgaria.alliance.id == 2 or romania.alliance.id == 2) and serbia.alliance.id == 1 and belgrade.alliance.id == 1 and game.type == Game.TYPE_SINGLE and playerAlliance.id == 1 then

if attacker.alliance.id == 2 and defender.hex == belgrade.hex then
aAttack = aAttack + (bonus * 0.2)
 if  GetEvent("SerbiaMoral") >0 then
 aAttack = aAttack + (bonus * 0.2)

 end
end 

end

--------RUSSIA--------------------

local russia = game:GetFactionById(4)
local germany = game:GetFactionById(2)


if Game.TYPE_SINGLE  
	and player.alliance.id ==1 
	and (attacker.faction.id == 3 and defender.faction.id == 4) 
	and GetEvent("AustriaInvasion") == 0 then
	
	if GetEvent("BattleKrasnik") >0 then
		aAttack = aAttack + 2
	else
		aAttack = aAttack + 1
	end	
end
if Game.TYPE_SINGLE  
	and player.alliance.id ==1 
	and (attacker.faction.id == 2 
	and defender.faction.id == 4) 
	and GetEvent("Tannenberg") <= 0 
	and game.date.year == 1914 then
	
		if GetEvent("Moltke") <= 0 then
		
	
			aAttack = aAttack + 2
			
		else
			aAttack = aAttack + 1
		end	
end

local germany = game:GetFactionById(2)

if game.date.year == 1914 
	and russia.luaData.steamroller ~= -1 
	and GetEvent("Tannenberg") == 0 then

	if  not simulate and attacker.faction.id == 4 
		and (defender.faction.id == 2  or defender.faction.id == 3) 
		and (attacker.type == Unit.LAND and defender.type == Unit.LAND) then
								
													
							if GetEvent("RussiaSurprise") <= 0 then
									if attacker.faction.id == 4 and attacker.commander ~= nil then --- has commander
										russia.luaData.steamroller = russia.luaData.steamroller + 0.5
									elseif (game.type == Game.TYPE_PBEM 
											or (game.type == Game.TYPE_SINGLE and player.alliance.id ==2) ) then 
												russia.luaData.steamroller = russia.luaData.steamroller + 0.35
									elseif game.type == Game.TYPE_SINGLE  
										and player.alliance.id ==1 
										and attacker.faction.id == 4  then
										russia.luaData.steamroller = russia.luaData.steamroller + 0.25
									
									
									end
						
									
							elseif 	GetEvent("RussiaSurprise") > 0 then
									if attacker.faction.id == 4 and attacker.commander ~= nil then
										russia.luaData.steamroller = russia.luaData.steamroller +1 -- has commander
									elseif attacker.faction.id == 4  then
										russia.luaData.steamroller = russia.luaData.steamroller + 0.5 --- no commander
									end
							end
					--	if game.type == Game.TYPE_PBEM or (game.type == Game.TYPE_SINGLE and player.alliance.id == 2) then
							if attacker.faction.id == 4 then
								aAttack = aAttack + russia.luaData.steamroller 
							end
							if attacker.faction.id == 4  and defender.faction.id == 3 then
								aAttack = aAttack + russia.luaData.steamroller 
							end
					--	end
						
						---- general francois 
						if GetEvent("Francois") ==  0 
							and germany.luaData.commanders[17].unlocked == 0 
							and germany.luaData.commanders[97].unlocked == 0 then
										
										if game.type == Game.TYPE_PBEM then
											germany.luaData.francoisluck = germany.luaData.francoisluck * 1.25
										end
										if GetEvent("Redeploy") >0 then
											germany.luaData.francoisluck = germany.luaData.francoisluck * 0.5
										end
										
									if germany.luaData.francoisluck < russia.luaData.steamroller and defender.faction.id == 2 then
												local koenigsberg = game:GetHex(112,17)
											--	local thorn = game:GetHex(110,21)

												local hexes = game.map:GetHexesInRange(koenigsberg, 3)
												
													for _, hex in pairs(hexes) do
														if hex.unit ~= nil 
															and hex.unit.faction.id == 2 
															and koenigsberg.alliance.id == 2 
															and (hex.unit.prototype.name == "infantry" 
																	or hex.unit.prototype.name == "cavalry") 
																--	or hex.unit.prototype.name == "garrison") 
															and hex.unit.commander == nil 
															and hex.unit.hp >= 70 then
																	local unit = hex.unit
																	AttachCommanderToUnit(97, unit.hex.x, unit.hex.y)
																	germany.luaData.francois = 1																	
																--	if game.currentAlliance.id == player.alliance.id and player.alliance.id == 2 then
																	PopupMessage("German General Von Francois has disobeyed orders to retreat, instead preparing for a ferocious counter attack on Russian forces in East Prussia!")
																--	end
																	SetEvent("Francois", -1)
																	break
																	
														end				
													end


								
									end
								end			
	end
end

--GermanCounterAttackinEastPrussia
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local warsaw = game:GetHex(112,23)
local germany = game:GetFactionById(2)
local russia = game:GetFactionById(4)
local timeleft = 0

--if cp.luaData.sigint[russia.id]  - entente.luaData.sigint[russia.id]  >0 then
--								
--end

if germany.luaData.funk >0  
	and not simulate 
	and game.date.year == 1914  then 
	if attacker.faction.id == 2 
			and defender.faction.id == 4 
			and (attacker.type == Unit.LAND and defender.type == Unit.LAND)  
			and cp.luaData.sigint[russia.id] > entente.luaData.sigint[russia.id] then			
			if cp.luaData.intel[russia.id] > entente.luaData.intel[russia.id] then	
				----------------
				if not simulate then
				local attackbonus = math.ceil((cp.luaData.intel[russia.id] - entente.luaData.intel[russia.id])/2)
					if attackbonus >3 then
						attackbonus = 3
					end	
					aAttack = aAttack + attackbonus
					  local luck = math.random(1,4)
							  if luck == 1 then
							local sfx = {}
								sfx = LoadSample("Radio.wav")
								PlaySample(sfx)
							elseif luck == 2 then
									 sfx = LoadSample("interference1.wav")
								PlaySample(sfx)
							elseif luck == 3 then
									 sfx = LoadSample("interference2.wav")
								PlaySample(sfx)	
								
							elseif luck == 4 then
								 sfx = LoadSample("morse.wav")
								PlaySample(sfx)
							end	
					LogUi("********* RUSSIAN CODE! BONUS WAS " .. attackbonus)
				end	
			end		
			germany.luaData.funk = germany.luaData.funk - (0.1 * math.random(1,10))
			if germany.luaData.funk <= 0 then
				PopupMessage("RUSSIAN ARMY CIPHER HAS CHANGED!")
				germany.luaData.funk = -1
				cp.luaData.intel[russia.id] = math.floor(cp.luaData.intel[russia.id] * 0.65)
			--	LogUi("********* RUSSIAN CODE END!****")
			end						
	end								
end	
----------------------- hoffmann
if cp.luaData.hoffmann > 0 then
	if  (game.type == Game.TYPE_SINGLE 
			and player.alliance.id == 2)
		or game.type == Game.TYPE_PBEM then
			if not simulate  then
				if attacker.alliance.id == player.alliance.id then
					if attacker.faction.id == 2 
						and defender.faction.id == 4 
						and attacker.type == Unit.LAND 
						and defender.type == Unit.LAND then
							aAttack = aAttack + (math.random(game.turn, game.turn *2)) 
							LogUi("HOFFMANNATTACK WAS: " .. aAttack)
							cp.luaData.hoffmann = 0	
					end
				end		
			end	
	elseif game.type == Game.TYPE_SINGLE 
			and player.alliance.id == 1 then 
				if attacker.faction.id == 2 
					and defender.faction.id == 4 
					and attacker.type == Unit.LAND 
					and defender.type == Unit.LAND then
						aAttack = aAttack + game.turn 
						LogUi("HOFFMANNATTACK WAS: " .. aAttack)
							local hoffmanluck = math.random(1,6)
							if hoffmanluck <= cp.luaData.hoffmann  then 						
								cp.luaData.hoffmann = 0 
							else
							cp.luaData.hoffmann = cp.luaData.hoffmann +1
						end
			end
	end		
end	
-----------------------------


--German initial attack in france
--- Moltke
local calais = GetHex(82, 26)
local reims = GetHex(85, 28)
local amiens = GetHex(82, 28)	


if GetEvent("Moltke") == 0  
	and (GetEvent("OffensiveEnds") == 0 
---	and not simulate 
--	and ((game.type == Game.TYPE_PBEM) 
--			or (attacker.alliance.id == 2 and player.alliance.id == 1 and game.type == Game.TYPE_SINGLE)) 
	and GetEvent("Stalemate") == 0 
	and GetEvent("FranceDefended") ==0) 
	and gameplay.winter == 0 
	and game.date.year == 1914 then
		if attacker.faction.id == 2 
			and attacker.type == Unit.LAND 
			and defender.type == Unit.LAND 					
			and attacker.range == 1		
			and ((defender.faction.id == 0
				or defender.faction.id == 1 	
				or defender.faction.id == 6)	
					and (defender.hex.originalFaction.id == 0 
						or defender.hex.originalFaction.id == 6) 
					and defender.hex.construction == nil) then

							if  game.type == Game.TYPE_SINGLE 
								and player.alliance.id == 1 
								and (GetEvent("PlanXVII") >0 
								or GetEvent("UltimatumBelgium2") >0)  then		
									if  GetEvent("Attaque") == 0 then
										aAttack = aAttack +  math.random(4,5)
									
									elseif 	reims.alliance.id == 1
										and calais.alliance.id == 1
										and amiens.alliance.id == 1 then
											aAttack = aAttack +  math.random(3,4)

									elseif GetEvent("ParisEvac") == 0	then
											aAttack = aAttack +  math.random(0,3)
										
									end
							end
			
		--[[	if game.type == Game.TYPE_SINGLE
				and player.alliance.id == 2 
				and (GetEvent("PlanXVII") >0 
					or GetEvent("UltimatumBelgium2") >0) then
					if  GetEvent("Attaque") == 0 then
						aAttack = aAttack + 2
					else
						aAttack = aAttack + 1
					end
			end]]
			
		--[[	if game.type == Game.TYPE_PBEM 
				 and (GetEvent("PlanXVII") >0 
					  or GetEvent("UltimatumBelgium2") >0) then 
					if  GetEvent("Attaque") == 0 then
						aAttack = aAttack + 1
					end	
			end]]
			
		end				
	end	
---Rupprecht
if  not simulate
	and GetEvent("Rupprecht") >0  
	and attacker.faction.id == 2 
	and (defender.faction.id == 0 or defender.faction.id == 1 or defender.faction.id == 17)  
	and (attacker.type == Unit.LAND 
	and defender.type == Unit.LAND) then	
	
		if GetEvent("Rupprecht") >0 
			and game.turn == 3 
			and player.alliance.id == 1 
			and game.type == Game.TYPE_SINGLE then
			aAttack = aAttack + 5
		end	

		if GetEvent("Rupprecht") >0 
			and not simulate 
			and game.type == Game.TYPE_SINGLE 
			and player.alliance.id == 1 
			and (game.turn == 4 or game.turn == 5) then
									aAttack = aAttack + 4

		end	
		if GetEvent("Rupprecht") >0 
			and not simulate 
			and (game.turn == 6 or game.turn == 7) 
				and game.type == Game.TYPE_SINGLE 
				and player.alliance.id == 1 then
									aAttack = aAttack + 3
		end	
end	
	
---army code broken	
if not simulate
and attacker.luaData.codebroken ~= nil 
and attacker.luaData.codebroken >0 
and attacker.luaData.codebroken + 3 >= game.turn then
	if (attacker.prototype.name == "infantry" 
		or attacker.prototype.name == "garrison" 
		or attacker.prototype.name == "cavalry") and attacker.type == Unit.LAND then
			if attacker.luaData.codebroken == game.turn then
				aAttack = aAttack - 5
			elseif attacker.luaData.codebroken +1 == game.turn then
					aAttack = aAttack - 3
			elseif attacker.luaData.codebroken +2 == game.turn then
					aAttack = aAttack - 1
			end
			
			if aAttack < 1 then
				aAttack = 1
			end
	end
end
if not simulate 
and defender.luaData.codebroken ~= nil 
and defender.luaData.codebroken >0 
and defender.luaData.codebroken + 3 >= game.turn then
	if (defender.prototype.name == "infantry" 
		or defender.prototype.name == "garrison" 
		or defender.prototype.name == "cavalry") and defender.type == Unit.LAND then
			
			if defender.luaData.codebroken == game.turn then
				aAttack = aAttack +5
			--	LogUi("SUCCESS!")
			elseif defender.luaData.codebroken +1 == game.turn then
					aAttack = aAttack +3
			elseif defender.luaData.codebroken +2 == game.turn then
					aAttack = aAttack +1
			end

	end
end
--- naval code broken	
if not simulate 
	and attacker.luaData.navalcodebroken ~= nil 
	and attacker.luaData.navalcodebroken >0 
	and attacker.luaData.navalcodebroken + 3 >= game.turn then
	if attacker.type == Unit.NAVAL and defender.type == Unit.NAVAL then
			if attacker.luaData.navalcodebroken == game.turn then
				aAttack = aAttack - 3
			elseif attacker.luaData.navalcodebroken +1 == game.turn then
					aAttack = aAttack - 2
			elseif attacker.luaData.navalcodebroken +2 == game.turn then
					aAttack = aAttack - 1
			end
			
			if aAttack < 1 then
				aAttack = 1
			end
	end
end
if 	not simulate 
	and defender.luaData.navalcodebroken ~= nil 
	and defender.luaData.navalcodebroken >0 
	and defender.luaData.navalcodebroken + 3 >= game.turn then
	if attacker.type == Unit.NAVAL and defender.type == Unit.NAVAL then
			if defender.faction.luaData.navalcodebroken == game.turn then
				aAttack = aAttack +3
			elseif defender.faction.luaData.navalcodebroken +1 == game.turn then
					aAttack = aAttack +2
			elseif defender.faction.luaData.navalcodebroken +2 == game.turn then
					aAttack = aAttack +1
			end

	end
end


	

-- French human waves
----OUTRANCE----
local france = game:GetFactionById(0)
if not simulate 
	and GetEvent("Attaque") == 0
	and GetEvent("BarbedWire") == 0
	and GetEvent("Outrance") >0
	and attacker.alive
	and (attacker.type == Unit.LAND and defender.type == Unit.LAND)
	and attacker.range == 1
	and attacker.faction.id == 0 
	and defender.faction.id == 2 	then
		--	LogUi("WHOA!")
			aAttack = aAttack + 3							
			france:ConsumeManpower(math.random(1,6))
			france.luaData.eventMorale = france.luaData.eventMorale +1
			ui.resourcesPanel:Refresh()									
								
	
end	
---ATTAQUE----
 if not simulate
 and GetEvent("Attaque") > 0   
 and GetEvent("Moltke") == 0 
 and GetEvent("OnLesAura") == 0 
 and GetEvent("DemonstrationFrance") == 0 
 and GetEvent("OffensiveEnds") == 0 
 and GetEvent("Stalemate") == 0 
 and GetEvent("FranceDefended") == 0
 and game.date.year == 1914 then
		if attacker.faction.id == 0 
			and defender.faction.id == 2 
			and (attacker.type == Unit.LAND and defender.type == Unit.LAND) then
				aAttack = aAttack + 3
				aDefense = aDefense +1
				if GetEvent("Schlieffen") >0 then
					france.luaData.eventMorale = france.luaData.eventMorale +1
					ui.resourcesPanel:Refresh()
				end
				if not simulate then
					france:ConsumeManpower(3)
					france.luaData.statsCasualties["ground"] = france.luaData.statsCasualties["ground"] + 5	
						if france.alliance.id == player.alliance.id then
							ui.resourcesPanel:Refresh()
						end
				end
		end				
	end

 if not simulate 
	and GetEvent("OnLesAura") > 0
	and GetEvent("OffensiveEnds") == 0 
	and GetEvent("Stalemate") == 0 
	and GetEvent("FranceDefended") == 0															
	and game.date.year == 1914 then
				  		if attacker.faction.id == 0 
						and defender.faction.id == 2 
						and (attacker.type == Unit.LAND and defender.type == Unit.LAND) 
						and attacker.range == 1 then
							aAttack = aAttack + 3
							dDefense = dDefense  +3	
							france.luaData.eventMorale = france.luaData.eventMorale +1
							ui.resourcesPanel:Refresh()
						end				
	end

-- Jihad
if  not simulate 
	and GetEvent("Jihad") >0 
	and GetEvent("TurkeyDeserts") == 0  then
	
		if attacker.faction.id == 5  
			and attacker.range == 1 
			and (attacker.type == Unit.LAND and defender.type == Unit.LAND) then
				aAttack = aAttack +2
				aDefense = aDefense +2
			end
end

----Turkey crumbles----
local turkey = game:GetFactionById(5)

if  not simulate  
	and GetEvent("TurkeyDeserts") > 0  then
	
		if attacker.faction.id == 5  
			and attacker.range == 1 
			and (attacker.type == Unit.LAND 
				and defender.type == Unit.LAND) then
				aAttack = aAttack - math.random(0, math.ceil(math.sqrt(turkey.luaData.collaps)))
				aDefense = aDefense - math.random(0, math.ceil(math.sqrt(turkey.luaData.collaps)))
		
				if aAttack <0 then
					aAttack = 0
				end
				if aDefense <0 then
					aDefense = 0
				end
				
		end
			
end


	
--- moralebonus

if not simulate 
	and attacker.faction.luaData.charge ~= nil
	and attacker.faction.luaData.charge == game.turn 
	and attacker.range == 1 
	and (attacker.type == Unit.LAND and defender.type == Unit.LAND)  then
	
			aAttack = aAttack +5
			LogUi("BANG!")	
end
if not simulate 
	and attacker.faction.luaData.chargetwo ~= nil
	and attacker.faction.luaData.chargetwo == game.turn 
	and attacker.range == 1 
	and (attacker.type == Unit.LAND and defender.type == Unit.LAND)  then
		
		--	aAttack = aAttack +1
			LogUi("BOING!")	
		
end
	
 -- Somme
 
if  not simulate
	and GetEvent("Somme") > 0 
	and (GetEvent("SommeEnds") == 0 or GetEvent("SommeEnds2") == 0) then  
  		if attacker.faction.id == 1
			and attacker.range == 1
			and defender.faction.id == 2 
			and (attacker.type == Unit.LAND and defender.type == Unit.LAND) and not simulate then
			aAttack = aAttack + 1
		end
  
  end
 
  -- capital or obsolete ships vs subs malus
  
	if not simulate 
		and (attacker.prototype.name == "dreadnought" 
			or attacker.prototype.name == "pre-dreadnought" 
			or attacker.prototype.name == "battlecruiser" 
			or attacker.prototype.name == "armouredcruiser") 
		and (defender.prototype.name == "submarine")  then
		aAttack = aAttack * 0.5
	end

	local germany = game:GetFactionById(2)

-- malus for blockaded Germans in NORTH SEA in SP
  if not simulate 
	and attacker.faction.id == 2 
	and attacker.type == Unit.NAVAL 
	and defender.type == Unit.NAVAL 
	and attacker.hex.region == 1 
	and defender.faction.id == 1  
	and attacker.prototype.name ~= "submarine" 
	and defender.prototype.name ~= "submarine" 
	and germany.luaData.blockaded == 1 
	and player.alliance.id == 2 
	and game.type == Game.TYPE_SINGLE then
    aAttack = aAttack  - 1
		if aAttack < 1 then
			aAttack = 1
		end
  end
  

--obsolete weaponry 
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
if not simulate then
if germany.luaData.techbehind == 1 and attacker.faction.id == 2 then
	germany:ConsumeManpower(math.random(0,3))
	ui.resourcesPanel:Refresh()
end
if germany.luaData.techbehind == 1 and defender.faction.id == 2 then
	germany:ConsumeManpower(math.random(0,3))
	ui.resourcesPanel:Refresh()
end
if austria.luaData.techbehind == 1 and attacker.faction.id == 3 then
	austria:ConsumeManpower(math.random(0,3))
	ui.resourcesPanel:Refresh()
end
if austria.luaData.techbehind == 1 and defender.faction.id == 3 then
	austria:ConsumeManpower(math.random(0,3))
	ui.resourcesPanel:Refresh()
end  
end

  -- First tank attack --
  -----------------------

  if not simulate then
    if GetEvent("TankAttack") == game.turn then
      if attacker.prototype.name == "armour" then
        aAttack = aAttack + 5
        aDefense = aDefense  + 5
      end
      if defender.prototype.name == "armour" then
        if dAttack > 0 then
          dAttack = dAttack +  3
        end
        dDefense = dDefense  + 3
      end
    end
  end
  
  ---First gas attack --
  if not simulate then
    if GetEvent("GasAttack") == 0 then
	--LogUi("1st GAS ATTACK!")
      if attacker.prototype.name == "artillery" 
		and HasUnitTech(attacker, "chlorine_gas")
		and HasUnitTech(attacker, "specialised_shell_types") then
			if gameplay.winter == 0 then
				aAttack = aAttack + 5
			else
				aAttack = aAttack + 2
			end
        ---aDefense = aDefense + 2
      end
   
    end
  end

  -- Gas & gasmask hack --
  ------------------------
--assault
  local gasEffect = 0
  if attacker.prototype.name == "artillery" and HasUnitTech(attacker, "chlorine_gas") then
    if HasUnitTech(attacker, "mustard_gas") then
      gasEffect = 2
    elseif HasUnitTech(attacker, "phosgene_gas") then
      gasEffect = 2
    else
      gasEffect = 1
    end
	if HasUnitTech(attacker, "specialised_shell_types")  then
	 -- gasEffect = gasEffect + 1
    end
	if HasUnitTech(attacker, "creeping_barrage")  then
	 -- gasEffect = gasEffect +1
    end
	if gameplay.winter == 1 or GetEvent("Storm") == game.turn then
		
			gasEffect = gasEffect * 0.65
		
	end

    if HasUnitTech(defender, "filter_respirator_mask") then
      gasEffect = gasEffect * 0.35
    elseif HasUnitTech(defender, "cotton_pad_mask") then
      gasEffect = gasEffect * 0.65
    end
  end

  --- ground units overrunning air units----
  
  if attacker.type == Unit.LAND
	and defender.type == Unit.AIR then
		aAttack = aAttack * 3
		--LogUi("HUSSA!")
		
  end	
  
  
  
  -- River Bonus --
  -----------------

  if attacker.stats.range == 1 and HasRiver(defender.hex, defender.hex:GetDirection(attackerHex)) == true then
    dDefense = dDefense + gameplay.RiverBonus
  end


  -- Terrain bonus --
  -------------------------

  if attacker.type ~= Unit.AIR and not bombardAttack then
    aDefense = aDefense + hex.terrain.attack
    dDefense = dDefense + hex.terrain.defense
  end


  -- Port Bonus --
  ----------------

  if attacker.type == Unit.NAVAL and defender.type == Unit.NAVAL then
    if HasHomeSupport(attacker.faction.alliance, defender.hex) and attacker.prototype.name ~= "submarine" then
      aAttack = aAttack + gameplay.TorpedoBonus
    end
    if HasPortSupport(defender.faction.alliance, defender.hex) then
      dAttack = dAttack + gameplay.PortBonus
      dDefense = dDefense + gameplay.PortBonus
    elseif HasHomeSupport(defender.faction.alliance, defender.hex) and attacker.prototype.name ~= "submarine" and defender.prototype.name ~= "transport" and defender.prototype.name ~= "convoy" then
      dAttack = dAttack + gameplay.TorpedoBonus
    end
  end

  ------ lucky hit on BBs BCs  ------
  --------------------------------------
  
 if not simulate 
	and (attacker.prototype.name == "dreadnought" 
		or attacker.prototype.name == "battlecruiser"
		or attacker.prototype.name == "pre-dreadnought") 
	and (defender.prototype.name == "dreadnought" 
			or defender.prototype.name == "battlecruiser" 
			or defender.prototype.name == "pre-dreadnought") then
-----	
--if not HasHomeSupport(defender.faction.alliance, defender.hex) 
--	and not HasPortSupport(defender.faction.alliance, defender.hex)	then
if defender.prototype.name == "dreadnought" 
	--	and defender.commander == nil
		and not HasHomeSupport(defender.faction.alliance, defender.hex) 
		and not HasPortSupport(defender.faction.alliance, defender.hex)
		and ( 	
				(attacker.alliance.id == 2 and cp.luaData.luckyhit == 1) 
				or  (attacker.alliance.id == 1 and entente.luaData.luckyhit == 1)) then
			aAttack = aAttack  + math.floor(math.sqrt(game.turn))
			SetEvent("LuckyHit", game.turn)
			if attacker.alliance.id == 1 and entente.luaData.luckyhit == 1 then
				entente.luaData.luckyhit = 0
			elseif attacker.alliance.id == 2 and cp.luaData.luckyhit == 1 then
				cp.luaData.luckyhit = 0
			end
			
elseif defender.prototype.name == "battlecruiser" 
	--	and defender.commander == nil
		and not HasHomeSupport(defender.faction.alliance, defender.hex) 
		and not HasPortSupport(defender.faction.alliance, defender.hex)
		and (
		(attacker.alliance.id == 2 and cp.luaData.luckyhit == 1) 
		or  (attacker.alliance.id == 1 and entente.luaData.luckyhit == 1)) then
			aAttack = aAttack + math.random(1,6) + math.random(1,6) + math.random(1,6)
						SetEvent("LuckyHit", game.turn)

			if attacker.alliance.id == 1 and entente.luaData.luckyhit == 1 then
				entente.luaData.luckyhit = 0
			elseif attacker.alliance.id == 2 and cp.luaData.luckyhit == 1 then
				cp.luaData.luckyhit = 0
			end
elseif defender.prototype.name == "pre-dreadnought" 
	--	and defender.commander == nil
		and not HasHomeSupport(defender.faction.alliance, defender.hex) 
		and not HasPortSupport(defender.faction.alliance, defender.hex)
		and (
			(attacker.alliance.id == 2 and cp.luaData.luckyhit == 1) 
			or  (attacker.alliance.id == 1 and entente.luaData.luckyhit == 1)) then
			aAttack = aAttack  + math.random(1,6) + math.random(1,6) + math.random(1,6)
						SetEvent("LuckyHit", game.turn)

			if attacker.alliance.id == 1 and entente.luaData.luckyhit == 1 then
				entente.luaData.luckyhit = 0
			elseif attacker.alliance.id == 2 and cp.luaData.luckyhit == 1 then
				cp.luaData.luckyhit = 0
			end
		
		
elseif attacker.prototype.name == "dreadnought" 
	--	and attacker.commander == nil
		and not HasHomeSupport(attacker.faction.alliance, attacker.hex) 
		and not HasPortSupport(attacker.faction.alliance, attacker.hex)
		and ((defender.alliance.id == 2 and cp.luaData.luckyhit == 1) 
			or  (defender.alliance.id == 1 and entente.luaData.luckyhit == 1)) then
			dDefense = dDefense  + math.random(1,6) + math.random(1,6) + math.random(1,6)
						SetEvent("LuckyHit", game.turn)

			if defender.alliance.id == 1 and entente.luaData.luckyhit == 1 then
				entente.luaData.luckyhit = 0
			elseif defender.alliance.id == 2 and cp.luaData.luckyhit == 1 then
				cp.luaData.luckyhit = 0
			end
	elseif attacker.prototype.name == "battlecruiser" 
	--	and attacker.commander == nil
		and not HasHomeSupport(attacker.faction.alliance, attacker.hex) 
		and not HasPortSupport(attacker.faction.alliance, attacker.hex)
		and ((defender.alliance.id == 2 and cp.luaData.luckyhit == 1) 
			or  (defender.alliance.id == 1 and entente.luaData.luckyhit == 1)) then
			dDefense = dDefense + math.random(1,6) + math.random(1,6) + math.random(1,6)
						SetEvent("LuckyHit", game.turn)

			if defender.alliance.id == 1 and entente.luaData.luckyhit == 1 then
				entente.luaData.luckyhit = 0
			elseif defender.alliance.id == 2 and cp.luaData.luckyhit == 1 then
				cp.luaData.luckyhit = 0
			end
	elseif attacker.prototype.name == "pre-dreadnought" 
	--	and attacker.commander == nil
		and not HasHomeSupport(attacker.faction.alliance, attacker.hex) 
		and not HasPortSupport(attacker.faction.alliance, attacker.hex)
		and ((defender.alliance.id == 2 and cp.luaData.luckyhit == 1) 
			or  (defender.alliance.id == 1 and entente.luaData.luckyhit == 1)) then
			dDefense = dDefense + math.random(1,6) + math.random(1,6) + math.random(1,6)
						SetEvent("LuckyHit", game.turn)

			if defender.alliance.id == 1 and entente.luaData.luckyhit == 1 then
				entente.luaData.luckyhit = 0
			elseif defender.alliance.id == 2 and cp.luaData.luckyhit == 1 then
				cp.luaData.luckyhit = 0
			end
	
--  end
 end 
-------  
end
  -- Assault & Entrenchment bonus --
  ----------------------------------

  if defender.prototype.lua.class == "ground" and defender.prototype.lua.noEntrench ~= 1 then
    local assault = 0
    if attacker.prototype.lua.stats.assault ~= nil then
      assault = GetStat(attacker, "assault")
    elseif attacker.prototype.lua.stats.bombard ~= nil then
      assault = GetStat(attacker, "bombard")
    end
    if gasEffect > 0 then
      assault = assault + gasEffect
    end
    fortification = GetStatEntrenchment(defender) - assault
    if fortification > 0 then
      dDefense = dDefense + fortification
    end
  end

  
  --- mud
local impassable = game:GetFactionById(24)

if not simulate 
	and (impassable.luaData.mud  == game.turn 
	and attacker.luaData.mud ~= nil 
	and attacker.luaData.mud == game.turn
	and attacker.hex.construction == nil) then
--LogUi("~~~~~~~~~~MUD~~~~~~~~~~~~~~~~~~")
aAttack = aAttack * 0.25
aDefense = aDefense * 0.5
DamageEfficiency(attacker, 20)
end
if not simulate 
	and (impassable.luaData.mud == game.turn 
	and defender.luaData.mud ~= nil  
	and defender.luaData.mud == game.turn
	and defender.hex.construction == nil) then
		DamageEfficiency(defender, 10)
		dAttack = dAttack * 0.5
		dDefense = dDefense * 1.25
end

  -- Fortress bonuses --
local france = game:GetFactionById(0)

  ----------------------
  if defender.hex.construction ~= nil then
    if defender.hex.construction.type == Construction.TYPE_FORTRESS then
      if dAttack > 0 then
        dAttack = dAttack + gameplay.fortressAttackBonus
      end
      if defenseType == "base" then
        dDefense = dDefense + gameplay.fortressDefenseBonus
			local verdun = game:GetHex(87, 29)
			if defender.hex == verdun 
				and attacker.range == 1 
				and defender.supply == 2
				and verdun.alliance.id == 1
				and GetEvent("VerdunOne") >0
				and GetEvent("VerdunTrigger") == 0 then
					if (game.type == Game.TYPE_SINGLE 
						and attacker.alliance.id == playerAlliance.id
						and playerAlliance.id == 2) 
						or game.type == Game.TYPE_PBEM then
							if not simulate then	
								dDefense = dDefense +10
								dAttack = dAttack +10
								
							end
					elseif attacker.alliance.id == player.alliance.id
							and not simulate then
							dDefense = dDefense +10
							dAttack = dAttack +10

					elseif attacker.alliance.id ~= player.alliance.id 
						and simulate then
						dDefense = dDefense +10
						
					end
				 
			end
      end
    end
  end


  -- Winter attack malus for ATTACKER!
  -------------------
  local impassable = game:GetFactionById(24)
  if attacker.type == Unit.LAND 
	and attacker.prototype.name ~= "artillery" 
	and defender.type == Unit.LAND 
	and attacker.range == 1 
	and attacker.hex ~= nil 
	and defender.hex ~= nil then
  --  LogUi("AT:" .. attacker.hex.x .. "/" .. attacker.hex.y)
 --	LogUi("DEF:" .. defender.hex.y .. "/" .. defender.hex.y)
	if gameplay.winter == 1 then
--	LogUi("Winter!")
--	LogUi("PENALTY" .. gameplay.WinterCombatPenaltyAttacker)
--LogUi("IMPA:" .. impassable.luaData.winter)
	if GetClimate() > attacker.hex.climate then
		if attacker.hex.y <= 51 then
			aAttack = aAttack * gameplay.WinterCombatPenaltyAttacker
		end
	end
	end
end
  
 --experience
local attexbonus = 1
local defexbonus = 1

 if GetUnitExperienceLevel(attacker) ~= nil then
 if GetUnitExperienceLevel(attacker) == 0 then
	attexbonus = 1
 elseif GetUnitExperienceLevel(attacker) == 1 then
	attexbonus = 1.1
 elseif GetUnitExperienceLevel(attacker) == 2 then
	attexbonus = 1.2
 elseif GetUnitExperienceLevel(attacker) == 3 then
	attexbonus = 1.3
 end
 aAttack = aAttack * attexbonus
 aDefense = aDefense * attexbonus
end

 if GetUnitExperienceLevel(defender) ~= nil then
 if GetUnitExperienceLevel(defender) == 0 then
 defexbonus = 1
 elseif GetUnitExperienceLevel(defender) == 1 then
 defexbonus = 1.1
 elseif GetUnitExperienceLevel(defender) == 2 then
 defexbonus = 1.2
 elseif GetUnitExperienceLevel(defender) == 3 then
 defexbonus = 1.3
 end

 dAttack = dAttack * defexbonus
 dDefense = dDefense * defexbonus 
end  
  

---naval bombardment nerf
  if not simulate
	and attacker.type == Unit.NAVAL 
	and defender.type ~= Unit.NAVAL  then
		aAttack = aAttack  * 0.35
  end

---- SUBs and Storm weather ------  
if not simulate then
	if GetEvent("Storm") == game.turn 
		and attacker.prototype.name == "submarine" then
		aAttack = aAttack *0.5
	end
	if GetEvent("Storm") == game.turn 
		and attacker.prototype.name == "lightcruiser" 
		and defender.prototype.name == "submarine" then
		aAttack = aAttack *0.35
	end

----subs vs lightcruisers------------
	 if attacker.prototype.name == "submarine" 
		and defender.prototype.name == "lightcruiser" 
		and HasUnitTech(defender,"passive_hydrophone") == true then
			aAttack = aAttack *0.65
	 
	 elseif attacker.prototype.name == "submarine" 
		and defender.prototype.name == "lightcruiser" 
		and HasUnitTech(defender,"depth_charge_projector") == true then
			aAttack = aAttack *0.75
		
	 elseif attacker.prototype.name == "submarine" 
		and defender.prototype.name == "lightcruiser" 
		and HasUnitTech(defender,"depth_charge") == true then
		aAttack = aAttack *0.85
	
	end
end

	
	
  

  -- Efficiency & strength effects --
  -----------------------------------

  local hpA_mod = math.sqrt(attacker.hp) / 10
  local hpD_mod = math.sqrt(defender.hp) / 10
  
  if attacker.efficiency <0 then
	attacker.efficiency = 0
  end	
  if defender.efficiency <0 then
	defender.efficiency = 0
  end

  local effA_mod = math.sqrt(attacker.efficiency) / 10
  local effD_mod = math.sqrt(defender.efficiency) / 10

  local aAttackOrig = aAttack
  local dAttackOrig = dAttack

  aAttack = (hpA_mod * aAttack * 0.3) + (effA_mod * hpA_mod * aAttack * 0.7)
  dAttack = (hpD_mod * dAttack * 0.3) + (effD_mod * hpD_mod * dAttack * 0.7)

  aDefense = (hpA_mod * aDefense *0.3) + (effA_mod * hpA_mod * aDefense * 0.7)
  if defenseType == "base" then
    dDefense = (hpD_mod * dDefense *0.3) + (effD_mod * hpD_mod * dDefense * 0.7)
  end

  local aDamMod = math.sqrt(aAttack*100/(aAttackOrig+5)) / 10
  local dDamMod = math.sqrt(dAttack*100/(dAttackOrig+5)) / 10


  
  
  
  -- Supply Effect --
  -------------------

  if attacker.supply == 1 then
    aAttack = aAttack * 0.5
    aDefense = aDefense * 0.7
  elseif attacker.supply == 0 then
    aAttack = aAttack * 0.05
    aDefense = aDefense * 0.1
  end
  if defender.supply == 1 then
    dAttack = dAttack * 0.5
    dDefense = dDefense * 0.7
  elseif defender.supply == 0 then
    dAttack = dAttack * 0.05
    dDefense = dDefense * 0.1
  end

  -- Damage calculation --
  ------------------------

  local maxDamage = 100
  local damageMod = 10

  --local attackMod = (aAttack/5)/math.sqrt(1+math.pow(aAttack/5,2))
  local aDamage = (aAttack - dDefense) / damageMod
  local dLosses = math.floor((aDamage/math.sqrt(1+math.pow(aDamage,2))+1) /2 * maxDamage * aDamMod, 1)

  --local attackMod = (dAttack/5)/math.sqrt(1+math.pow(dAttack/5,2))
  local dDamage = (dAttack - aDefense) / damageMod
  local aLosses = math.floor((dDamage/math.sqrt(1+math.pow(dDamage,2))+1) /2 * maxDamage * dDamMod, 1)


  -- Counter Battery Fire --
  --------------------------

  local counterBatAmmoReq = 5
  local counterBatModifier = 5
  local counterammo = 0
  if attacker.prototype.name == "artillery" and defender.faction.am >= counterBatAmmoReq then
    local adjacentHexes = game.map:GetHexesInRange(hex, 1)
    for i,adjacent in pairs(adjacentHexes) do
      if attacker.alliance:IsVisible(adjacent) or not simulate then
        if adjacent.unit ~= nil and adjacent.unit.faction.alliance.id == defender.faction.alliance.id then
          local counterattack = GetStat(adjacent.unit, "counterattack")
          if counterattack ~= nil and counterattack > 0 then
			counterammo = counterattack
            aLosses = aLosses + counterattack * counterBatModifier * adjacent.unit.hp * adjacent.unit.efficiency / 10000
            if not simulate then
              attacker.alliance:AddVisibleHex(adjacent)
              defender.faction:ConsumeAmmo(counterammo)
              View:AddEffect(attackerHex, "attack_heavy")
            end
            break
          end
        end
      end
    end
  end


  -- Air units attacks less effective vs weak ground targets --
  -------------------------------------------------------------

  if attacker.type == Unit.AIR and defender.type ~= Unit.AIR then
    dLosses = dLosses * defender.hp * defender.efficiency / 10000
  end



  -- Randomisation --
  -------------------

  if simulate == false then
    if not bombardAttack and dAttack > 0 then
      local rand = math.floor(game.random:Next(-10,10))
      if aLosses + rand <= 0 then
        attacker.efficiency = attacker.efficiency - aLosses / 2
      end
      aLosses = aLosses + rand
      if aLosses < 0 then
        aLosses = 0
      elseif aLosses > 100 then
        aLosses = 100
      end
    end
    if dAttack > 0 then
      local rand = math.floor(game.random:Next(-10,10))
      if dLosses + rand <= 0 then
        defender.efficiency = defender.efficiency - dLosses / 2
      end
      dLosses = dLosses + rand
      if dLosses < 0 then
        dLosses = 0
      elseif dLosses > 100 then
        dLosses = 100
      end
    end
  end


 -- Retreat logic --
  -------------------

  -- Normal unit retreats after taking damage higher than 50% of its current hp
  -- And damage ... > 30% of its current hp
  -- Then damage = damage - (damage - 50% hp) / 3 ( = 2/3rd the damage of whats higher than 50%)

  -- Quick Retreat unit retreats after 30% casualties
  -- Then damage = damage - (damage - 30% hp) / 2 ( = half the damage of whats higher than 50%)

  -- PursuitBonus attacker will do x% more damage when defender retreats
  -- Then damage = damage - (damage - 50% hp) / 4 ( = quarter of the damage of whats higher than 50%)

  -- Attacker losses = losses defender prevented * (original defLosses / attLosses)

  local retreat = -1
  local preventedLosses = 0
  local navalretreat = 0
  local escape = 0
	
	if defender.luaData.endurance == nil and defender.type == Unit.NAVAL then
		defender.luaData.endurance = 9
	end
	
	if defender.type == Unit.NAVAL and defender.commander ~= nil and ((GetUnitExperienceLevel(defender)) >= (GetUnitExperienceLevel(attacker)) ) then
			navalretreat = 1
	end	
	
	if defender.type == Unit.NAVAL and defender.prototype.lua.quickRetreat == 1 then
			navalretreat = 1
	end

  if simulate == false 
	and attacker.stats.range == 1 
	and defender.supply > 0 
	and aLosses < attacker.hp  then -- and defender.supply > 0 and aLosses < attacker.hp then
				
									
				if defender.prototype.lua.quickRetreat == nil 
					or  (defender.type == Unit.NAVAL and navalretreat == 0 ) then
										  if hex.construction == nil and dLosses >= defender.hp / 2 then
											retreat = GetRetreatHex(defender, attackerHex:GetDirection(defender.hex), attacker)
														if retreat ~= -1   then
														  preventedLosses = (dLosses - defender.hp / 2) / 3
														  --aLosses = aLosses - preventedLosses * (dLosses / aLosses)
																  if attacker.prototype.lua.pursuitBonus ~= nil then
																	dLosses = dLosses - preventedLosses * 0.7
																  else
																	dLosses = dLosses - preventedLosses
																  end
														else
														  -- additional losses
																dLosses = dLosses * gameplay.retreatFailPenalty
																  if dLosses > 100 then
																	dLosses = 100
																  end
														end
										  end
				elseif  (defender.alive and defender.type == Unit.NAVAL and navalretreat == 1 ) then
							
					--		LogUi("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
							
							
							if attacker.alive and attacker.commander ~= nil then
								escape = escape - GetUnitExperienceLevel(attacker)
							end
							
							if defender.alive and defender.commander ~= nil then
								escape = escape + GetUnitExperienceLevel(defender)
							end
							
							if attacker.alive and attacker.prototype.name == "lightcruiser" then
								escape = escape -2
							end
							if defender.alive and defender.prototype.name == "lightcruiser" then
								escape = escape +2
							end
							
							if attacker.alive and HasUnitTech(attacker, "razzle_dazzle_camouflage")  then
								escape = escape -1
							end
							
							if defender.alive and HasUnitTech(defender, "razzle_dazzle_camouflage")  then
								escape = escape +1
							end
							
							if attacker.alive and HasUnitTech(attacker, "passive_hydrophone")  then
								escape = escape -2
							end
							if attacker.alive 
								and attacker.luaData.experience ~= nil 
								and defender.alive 
								and defender.luaData.experience ~= nil 
								and attacker.luaData.experience > defender.luaData.experience then
								escape = escape - GetUnitExperienceLevel(attacker)
							end
							
							if attacker.alive 
								and attacker.luaData.experience ~= nil 
								and defender.alive and defender.luaData.experience ~= nil 
								and attacker.luaData.experience <= defender.luaData.experience then
								escape = escape + GetUnitExperienceLevel(defender)
							end
						
							if gameplay.winter == 1 then
								escape = escape +1
							end
							
							if defender.alive and defender.type == Unit.NAVAL 
								and attacker.alive 
								and attacker.type == Unit.NAVAL 
								and attacker.luaData.endurance ~= nil 
								and defender.luaData.endurance ~= nil 
								and  attacker.luaData.endurance >= defender.luaData.endurance then
								escape = escape -1
							else
								escape = escape +1
							end
							
							if defender.alive and GetEvent("Storm") == game.turn 
							and defender.type == Unit.NAVAL then
								escape = escape +3
							end
						--	LogUi("ESCAPE" .. escape)	
				--  LogUi("RETREAT LOGIC START")
							  if dLosses >= defender.hp * 30 / 100  and escape >0 then --and not (attacker.prototype.name == "lightcruiser" and defender.prototype.name == "submarine" ) then --30
							--	LogUi("ESCAPE:" .. escape)
								retreat = GetRetreatHex(defender, attackerHex:GetDirection(defender.hex), attacker)
													if retreat ~= -1 then
													  preventedLosses = (dLosses - defender.hp * 25 / 100) / 2 --30
													  --aLosses = aLosses - preventedLosses * (dLosses / aLosses)
													  dLosses = dLosses - preventedLosses
													else
													  -- additional losses
													  dLosses = dLosses * gameplay.retreatFailPenalty
													  if dLosses > 100 then
														dLosses = 100
													  end
													end
							  end
				else
						--	LogUi("BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB")
							if dLosses >= defender.hp * 30 / 100 then
									retreat = GetRetreatHex(defender, attackerHex:GetDirection(defender.hex), attacker)
									if retreat ~= -1 then
									  preventedLosses = (dLosses - defender.hp * 30 / 100) / 2
									  --aLosses = aLosses - preventedLosses * (dLosses / aLosses)
									  dLosses = dLosses - preventedLosses
									else
									  -- additional losses
									  dLosses = dLosses * gameplay.retreatFailPenalty
									  if dLosses > 100 then
										dLosses = 100
									  end
									end
							end
				end
    dLosses = math.floor(dLosses)
    aLosses = math.floor(aLosses)
  end

  -- Simulated damage is shown in double digits, not triple
  if simulate == true then
    aLosses = aLosses / 10
    dLosses = dLosses / 10
  end
  
  -------- EXPERIENCE --------------
  if simulate == false then
	  if attacker ~= nil 
		and attacker.luaData.experience ~= nil 
		and defender.prototype ~= nil 
		and (defender.prototype.name ~= "convoy" or attacker.prototype.name == "submarine") 
		and (defender.prototype.name ~= "transport" or attacker.prototype.name == "submarine") then
			ExperienceAssign(attacker, defender, dLosses, aLosses)
		 end
		if defender ~= nil 
		and defender.prototype ~= nil 
		and defender.luaData.experience ~= nil then 
			ExperienceAssign(defender, attacker, aLosses, dLosses)
		end
  end		
 -------------------------------------------------- 
  
-- LogUi("RETREAT LOGIC END")
--LogUi("CALC DAMAGE END")
	
  if aLosses == nil then
	PopupMessage("!!!SCRIPTING ERROR!!!;aLosses IS NIL!!!")
	 aLosses = 0	
  elseif aLosses == math.huge or aLosses == -math.huge then
	PopupMessage("!!!SCRIPTING ERROR!!!;aLosses is HUGE!!!")
	 aLosses = 0	
  elseif aLosses ~= aLosses then
	PopupMessage("!!!SCRIPTING ERROR!!!;aLosses is NAN!!!")
	  aLosses = 0		
  end
  if dLosses == nil then
	PopupMessage("!!!SCRIPTING ERROR!!!;dLosses IS NIL!!!")
	 dLosses = 0	
  elseif dLosses == math.huge or  dLosses == -math.huge then
	PopupMessage("!!!SCRIPTING ERROR!!!;dLosses is HUGE!!!")
	 dLosses = 0	
  elseif dLosses ~= dLosses then
	PopupMessage("!!!SCRIPTING ERROR!!!;dLosses is NAN!!!")
	 dLosses = 0	
  end

  
	
  return {aLosses, dLosses, retreat}

end


function StrategicAttack(attacker, construction)
  local damage = math.floor(attacker.prototype.lua.stats.stratattack * attacker.hp / 100 * attacker.efficiency / 100)

  if damage > construction.efficency then
    damage = construction.efficency
  end

  construction:SetEfficency(construction.efficency - damage)

  --DestructionMoraleEffect(attacker, damage)

  return {0, damage, 0}
end


function CollateralDamage(construction, damage)
  if damage > construction.efficency then
    damage = construction.efficency
  end

  construction:SetEfficency(construction.efficency - damage)
end



----------------------------------------------------------

function AfterCombat(attacker,defender,attackerLosses,defenderLosses,retreat,defenderHex)
--LogUi("AFTERCOMBAT START")

  -- Amphibious Attack --
  -----------------------

  local transport
  if attacker.cargo ~= nil then
    transport = attacker
    for cargo in attacker.cargo.units do
      attacker = cargo
      break
    end
  end


  -- Efficiency Drop --
  ---------------------

  attacker.efficiency, defender.efficiency = CalculateEfficiency(attacker,defender,attackerLosses,defenderLosses)


  -- Winter effect --
  -------------------
local winterlucka = math.random(1,200)
local winterluckb = math.random(1,200)
  if defender.type ~= Unit.NAVAL and attacker.range == 1 then
    if GetClimate() > defenderHex.climate then
      if attacker.alive and attacker.hex ~= nil and attacker.hex.y <= 51 then
	  DamageEfficiency(attacker, gameplay.WinterEfficiencyPenalty)
	  end	
	  if defender.alive and defender.hex.y <= 51 then 
	  DamageEfficiency(defender, (gameplay.WinterEfficiencyPenalty * 0.5))
	  end
	end
  end

--- Heat effect  
if attacker.hex ~= nil 
	and attacker.alive 
	and (attacker.hex.terrain.name == "dunes" or attacker.hex.terrain.name == "desert") 
	and attacker.hex.construction == nil 
	and attacker.prototype.name ~= "arabcavalry" 
		and attacker.prototype.name ~= "arabinfantry" 
		and attacker.prototype.name ~= "arabgarrison" then
	if (attacker.alliance.id == 2 and winterlucka > attacker.luaData.experience) 
	or (attacker.alliance.id == 1 and GetEvent("Pipeline") == 0) then		
	  DamageEfficiency(attacker, gameplay.WinterEfficiencyPenalty)
	--  LogUi("DESERT FIGHTING!")
	end
end  

if defender.alive 
	and (defender.hex.terrain.name == "dunes" 
			or defender.hex.terrain.name == "desert") 
	and defender.hex.construction == nil 
	and defender.prototype.name ~= "arabcavalry" 
	and defender.prototype.name ~= "arabinfantry" 
	and defender.prototype.name ~= "arabgarrison" then
	  if (defender.alliance.id == 2 
			and winterluckb > defender.luaData.experience) 
		or (defender.alliance.id == 1 
			and GetEvent("Pipeline") == 0) then		
		DamageEfficiency(defender, gameplay.WinterEfficiencyPenalty)
	--	LogUi("DESERT FIGHTING2!")
	--	LogUi("NAME:" .. defender.prototype.name)
	--	LogUi("TERRAIN:" .. defender.hex.terrain.name)

	  end	
end	  




  -- Entrenchment damage --
  -------------------------

--~   if attacker.prototype.name == "artillery" then
--~     if defenderHex.entrench > 1 then
--~       if HasUnitTech(attacker, "specialised_shell_types") then
--~         defenderHex.entrench = defenderHex.entrench - 1
--~       end
--~     end
--~   end


  -- National Morale Loss --
  --------------------------

  --CombatMoraleEffect(attacker, defender, attackerLosses, defenderLosses, retreat)

  


  -- Retreat --
  -------------

  gameplay.retreat = false
  if retreat ~= -1 and defender.alive then

    -- Advance option
    if attacker.range == 1 and attacker.type == Unit.LAND then
      gameplay.advanceHex = defender.hex
      if transport == nil then
        gameplay.advanceUnit = attacker
      else
        gameplay.advanceUnit = transport
      end
    end

    GetPlayer():WarpUnit(defender, retreat)

    if game.type == Game.TYPE_SINGLE and currentAIPlayer ~= nil then
      currentAIPlayer:incEnemyMoveCounter()
    end
    gameplay.retreat = true
  end

  if not defender.alive then
    if game.type == Game.TYPE_SINGLE and currentAIPlayer ~= nil then
      currentAIPlayer:incEnemyMoveCounter()
    end
    if attacker.range == 1 and attacker.type == Unit.LAND then
      gameplay.advanceHex = defender.previousHex
      if transport == nil then
        gameplay.advanceUnit = attacker
      else
        gameplay.advanceUnit = transport
      end
    end
  end

  -- Wounded Commander --
  -----------------------

 if attacker.hp <= 0 
	and attacker.type ~= Unit.AIR 
	and attacker.commander ~= nil 
	and attacker.type == defender.type then

		WoundCommander(attacker.commander)

elseif attacker.type == Unit.AIR  
	and defender.type == Unit.AIR 
	and attacker.commander ~= nil then ------AIR ACE ATTACKING
	
		local airaceattackerbonus = 0
		local airacedefenderbonus = 0
		
		
		if attacker.alive 
			and attacker.commander ~= nil then
			local commander = attacker.commander		
			 airaceattackerbonus = (data.commanders[commander.id+1].stats["airattack"]) 
			for i = (airaceattackerbonus),0,-1 do
				 airaceattackerbonus =  airaceattackerbonus + math.random(0,10)
			end
		end	
		if defender.alive 
			and defender.commander ~= nil then
			local commander = defender.commander		
			 airacedefenderbonus = (data.commanders[commander.id+1].stats["airattack"]) 
			for i = (airacedefenderbonus),0,-1 do
				 airacedefenderbonus =  airacedefenderbonus + math.random(0,10)
			end
		end	
	
	airaceattackerbonus =  airaceattackerbonus + (attacker.hp *  (1 + (0.1 * GetUnitTechCount(attacker, attacker.faction))) * (1 + (0.2 * GetUnitExperienceLevel(attacker))))
	airacedefenderbonus =  airacedefenderbonus + (defender.hp *  (1 + (0.1 * GetUnitTechCount(defender, defender.faction))) * (1 + (0.2 * GetUnitExperienceLevel(defender))))
	
	local luck =  math.random(1,100)
	local chance = airacedefenderbonus - airaceattackerbonus 	
	local divident = math.random(1, (GetUnitExperienceLevel(defender)+1))
				
				LogUi("DOGFIGHT: ATTACKERSTRENGTH/DEFENDERSTRENGTH" .. airaceattackerbonus .. "/" ..  airacedefenderbonus)
			
				 		
				LogUi("ATTACKER KILLED CHANCE/ROLL:" .. chance .. "/" .. luck)
				if luck < chance   then
					LogUi("DOGFIGHT ATTACKER WOUNDED!!!")
					WoundCommander(attacker.commander)
				end
				if defender.alive and defender.luaData.experience ~= nil then
					defender.luaData.experience = defender.luaData.experience + (airaceattackerbonus / divident)
				end		
	
	
 end
 
 if defender.hp <= 0  
		and defender.type ~= Unit.AIR 
		and defender.commander ~= nil 
		and defender.type == attacker.type then
			WoundCommander(defender.commander)
			
elseif defender.type == Unit.AIR 
		and attacker.type == Unit.AIR 
		and defender.commander ~= nil then ---- AIR ACE DEFENDING
			local airaceattackerbonus = 0
			local airacedefenderbonus = 0
			
			if attacker.alive 
				and attacker.commander ~= nil then
				local commander = attacker.commander		
				 airaceattackerbonus = (data.commanders[commander.id+1].stats["airattack"]) 
				for i = (airaceattackerbonus),0,-1 do
					 airaceattackerbonus =  airaceattackerbonus + math.random(5,10)
				end
			end	
			if defender.alive 
				and defender.commander ~= nil then
				local commander = defender.commander		
				 airacedefenderbonus = (data.commanders[commander.id+1].stats["airattack"]) 
				for i = (airacedefenderbonus),0,-1 do
					 airacedefenderbonus =  airacedefenderbonus + math.random(5,10)
				end
			end	
			
			
			
			airaceattackerbonus = math.random(1,100) + (attacker.hp *  (1 + (0.1 * GetUnitTechCount(attacker, attacker.faction))) * (1 + (0.2 * GetUnitExperienceLevel(attacker))))
			airacedefenderbonus = math.random(1,100) + (defender.hp *  (1 + (0.1 * GetUnitTechCount(defender, defender.faction))) * (1 + (0.2 * GetUnitExperienceLevel(defender))))
			
			local luck =  math.random(1,100)
			local dividentb = math.random(1, (GetUnitExperienceLevel(defender)+1))			
			local chance = airaceattackerbonus - airacedefenderbonus 	
			LogUi("DOGFIGHT: ATTACKERSTRENGTH/DEFENDERSTRENGTH" .. airaceattackerbonus .. "/" ..  airacedefenderbonus)	 		
			LogUi("DEFENDER KILLED CHANCE/ROLL:" .. chance .. "/" .. luck)
				if luck < chance   then
					LogUi("DOGFIGHT DEFENDER WOUNDED!!!")
					WoundCommander(defender.commander)
				end
				if attacker.alive 
					and attacker.luaData.experience ~= nil then
						attacker.luaData.experience = attacker.luaData.experience + (airacedefenderbonus / dividentb)
				end		

	
	
 end
 
--LogUi("AFTERCOMBAT END")
end


function GetRetreatHex(unit, dir, attacker)
--LogUi("GETRETREATHEX START")
  if unit.id == 406 then
    local te = 0
  end

	if unit.luaData.experience == nil then
		unit.luaData.experience = 0
	end	
  		
  local retreatHexes = {}
  retreatHexes[0] = GetAdjacent(unit.hex.x, unit.hex.y, dir)
  retreatHexes[1] = GetAdjacent(unit.hex.x, unit.hex.y, dir-1)
  retreatHexes[2] = GetAdjacent(unit.hex.x, unit.hex.y, dir+1)
  retreatHexes[3] = GetAdjacent(unit.hex.x, unit.hex.y, dir-2)
  retreatHexes[4] = GetAdjacent(unit.hex.x, unit.hex.y, dir+2)
 
  local secondBest = 0
  local secondBestHex
  local eAlliance = game:GetAllianceById(3 - unit.faction.alliance.id)

  for _, targetHex in pairs(retreatHexes) do
    if targetHex ~= nil 
	and (targetHex.unit == nil or not targetHex.unit.alive) 
	and (targetHex.terrain.type ~= Terrain.WATER and unit.type == Unit.LAND) 
	and targetHex.faction.alliance.id == unit.faction.alliance.id 
	and IsTerrainValidForUnit(targetHex, unit) then
					  if not IsNextToEnemy(eAlliance, targetHex) then
						return targetHex
					  elseif secondBest == 0 then
						secondBestHex = targetHex
						if not IsNextToEnemy(eAlliance, targetHex, true, attacker) then
						  secondBest = 2
						else
						  secondBest = 1
						end
					  elseif secondBest == 1 then
						if not IsNextToEnemy(eAlliance, targetHex, true, attacker) then
						  secondBest = 2
						  secondBestHex = targetHex
						end
					  end
  --------------------------------------------------  
	elseif targetHex ~= nil 
	and (targetHex.unit == nil or not targetHex.unit.alive) 
	and (targetHex.terrain.type == Terrain.WATER and unit.type == Unit.NAVAL) 
	and (unit.prototype.lua.quickRetreat ~= nil or unit.commander ~= nil) 
	and (targetHex.terrain.type == Terrain.WATER 
		or (targetHex.construction ~= nil 
			and targetHex.construction.type == Construction.TYPE_PORT 
			and targetHex.construction.city.hex.faction.alliance.id == unit.alliance.id)) 
--	and IsTerrainValidForUnit(targetHex, unit) 
	and (unit.luaData.experience * unit.hp * unit.efficiency >= 100000) then
			local ergebnis = unit.luaData.experience 
			local ergebnistwo =  unit.hp
					--	LogUi("EVADE ROLL:" .. ergebnis .. "/" .. ergebnistwo)
					if unit.luaData.endurance == nil and unit.type == Unit.NAVAL then
						unit.luaData.endurance = 10
					elseif unit.luaData.endurance ~= nil and unit.luaData.endurance >= 1  and unit.type == Unit.NAVAL then
						unit.luaData.endurance = unit.luaData.endurance  -1		
					end
		
					if not IsNextToEnemy(eAlliance, targetHex) then
						return targetHex
					elseif secondBest == 0 then
						secondBestHex = targetHex
						if not IsNextToEnemy(eAlliance, targetHex, true, attacker) then
							secondBest = 2
						else
							secondBest = 1
						end
				  elseif secondBest == 1 then
						if not IsNextToEnemy(eAlliance, targetHex, true, attacker) then
							secondBest = 2
							secondBestHex = targetHex
						end
				  end
	
	end
  end
  if secondBestHex ~= nil then
    return secondBestHex
  end
  return -1
end

function IsNextToEnemy(enemyAlliance, hex, checkAP, attacker)
  for neighbour in hex.neighbours do
    if neighbour.unit ~= nil and neighbour.unit.alliance.id == enemyAlliance.id then
      if checkAP ~= true or (neighbour.unit.ap > 0 and neighbour.unit.id ~= attacker.id) then
        return true
      end
    end
  end
  return false
end


function CalculateEfficiency(attacker,defender,attackerLosses,defenderLosses)
local impassable = game:GetFactionById(24)

-- shock
  -- Defender
  local defenderEfficiency = defender.efficiency - math.floor(defenderLosses / 6 + attackerLosses / 20)
  if attacker.type ~= Unit.AIR or defender.type ~= Unit.AIR then
    local shock = GetStat(attacker, "shock")

    -- Gas & gasmask hack for shock
    if attacker.prototype.name == "artillery" and HasUnitTech(attacker, "chlorine_gas") then
      local gasEffect = 0
      if HasUnitTech(attacker, "mustard_gas") then
        gasEffect = 3
      elseif HasUnitTech(attacker, "phosgene_gas") then
        gasEffect = 2
      else
        gasEffect = 1
      end
      if HasUnitTech(attacker, "specialised_shell_types")  then
			--gasEffect = gasEffect +1
	  end
	  if HasUnitTech(attacker, "creeping_barrage")  then
		 --gasEffect = gasEffect +1
	  end
	  if impassable.luaData.winter == 1
		or impassable.luaData.mud == game.turn
		or GetEvent("Storm") == game.turn then
			gasEffect = gasEffect * 0.5
	 end

	  if HasUnitTech(defender, "filter_respirator_mask")  then
        
		if  HasUnitTech(attacker, "mustard_gas") == true then
			gasEffect = gasEffect * 0.5
		
		elseif HasUnitTech(attacker, "mustard_gas")  ~= true then
			gasEffect = gasEffect * 0.25	
		end
      
	  elseif HasUnitTech(defender, "cotton_pad_mask") then
			gasEffect = gasEffect * 0.65
      end

      if shock == nil then
        shock = gasEffect
      else
        shock = shock + gasEffect
      end
    end


    -- Air units attacks less effective vs weak ground targets --
    if attacker.type == Unit.AIR and defender.type ~= Unit.AIR then
      shock = shock * defender.hp / 100
    end

    if shock ~= nil then
      local shockMultiplier = 5
    -- LogUi("eff: " .. defender.prototype.name .. " " .. math.floor(shock * shockMultiplier * attacker.hp * attacker.efficiency / 10000))
      
	  defenderEfficiency = defenderEfficiency - math.floor(shock * shockMultiplier * attacker.hp * attacker.efficiency / 10000)
     -- LogUi("eff: " .. defender.prototype.name .. " " .. math.floor(shock * shockMultiplier * attacker.hp * attacker.efficiency / 10000))
		
	end
  end
  if defenderEfficiency < 0 then
    defenderEfficiency = 0
  end
  local verdun = game:GetHex(87, 29)
  local france = game:GetFactionById(0)


  

  -- Attacker
  local attackEfficiencyDrop = 0
  local attackerEfficiency = attacker.efficiency - attackEfficiencyDrop - math.floor(attackerLosses / 6 + defenderLosses / 20)
  if attackerEfficiency < 0 then
    attackerEfficiency = 0
  end
 ui.resourcesPanel:Refresh()
  return attackerEfficiency, defenderEfficiency
end



-- Play an attack animation over attacker & defender
-- Based on unit type & weapon
function AttackAnimation(attacker, defender)
--LogUi("ATTACK ANIM START")
  local hex

  if defender.alive then
    hex = defender.hex
  else
    hex = defender.previousHex
  end

  -- No attack anim for unarmed fighter
   --- > did  work :
	if attacker.type == Unit.AIR and (attacker.prototype.name == "fighter") and defender ~= nil and defender.hex ~= nil then
	 local hexes = game.map:GetHexesInRange(defender.hex, 1)
			  for _, hex in pairs(hexes) do
			 -- LogUi("CHECKFIGHTER!")
				local luck = math.random(1,6)
				if gameplay.winter == 1 then
					luck = luck -2
				elseif game.date.month <= 4 or game.date.month >= 10 then
					luck = luck - 1
				end
				if GetEvent("Storm") == game.turn then
						luck = luck -2
				end	
				if attacker.commander ~= nil then
					luck = luck + 1
				end
				
			   if GetUnitExperienceLevel(attacker) + luck >= 5 then
				--	LogUi("SPOT:" GetUnitExperienceLevel(attacker) + luck)
					attacker.faction.alliance:AddVisibleHex(hex)
				end	
				--LogUi("SPOT:" .. GetUnitExperienceLevel(attacker) + luck)

			 end   
	end
 if attacker.prototype.name == "fighter" and GetUnitTechCount(attacker) == 1 then
  
	return
 end
 
  -- Defender explosion
  -- use Lua random gen so that optional sfx/gfx won't change combat calculation result
  local rand = math.random(0, 2)
  if defender.type == Unit.LAND then
		if attacker.prototype.weapon == "heavy" then
		  View:AddEffect(hex, "attack_heavy")
		end
		if attacker.prototype.weapon == "light" then
		  View:AddEffect(hex, "attack_light")
		end
  else
    View:AddEffect(hex, "attack_heavy")
  end

  if defender.type == Unit.NAVAL then
    View:AddEffect(hex, "attack_water")
  end

  if defender.type == Unit.AIR then
    View:AddEffect(hex, "attack_air")
  end

	if attacker.type == Unit.AIR and (attacker.prototype.name == "zeppelin") and defender ~= nil and defender.hex ~= nil then
	 local hexes = game.map:GetHexesInRange(defender.hex, 2)
			  for _, hex in pairs(hexes) do
		--	  LogUi("CHECKZEP!")
			 local luck = math.random(1,6)
				if gameplay.winter == 1 then
					luck = luck - 2
				elseif game.date.month <= 4 or game.date.month >= 10 then
					luck = luck - -1
				end
				if GetEvent("Storm") == game.turn then
						luck = luck -1
				end	
				if attacker.commander ~= nil then
					luck = luck + 2
				end
			--	LogUi("LUCK:" .. luck)
			--	LogUi("ZEPTECH:" .. GetUnitTechCount(attacker, attacker.faction))
			   if (GetUnitTechCount(attacker, attacker.faction) +1) + luck >= 6 then
					attacker.faction.alliance:AddVisibleHex(hex)
			   end
			 end   
	end
 -- LogUi("ATTACK ANIM END")
end



sounds = {}

function AttackSound(unit, defunit)

local impassable = game:GetFactionById(24)
local dierollsounda = math.random(1,6)
local dierollsoundb = math.random(1,6)
local dierollsoundc = math.random(1,1000)

    local sfx = {}
    local i
    local counter = 0
    local soundType = "_attack_"
    -- No attack sound for unarmed fighter
    if unit.prototype.name == "fighter" and GetUnitTechCount(unit) == 1 then
      soundType = "_move_"
    end


    for i=0, 23 do
      if engine:FileExists("sound", unit.prototype.name .. soundType .. (i+1) .. ".wav") then
        sfx[i] = LoadSample(unit.prototype.name .. soundType .. (i+1) .. ".wav")
        counter = counter + 1
      else
        break
      end
    end

    if counter > 0 then
      PlaySample(sfx[math.random(0, (counter - 1))])
    end


if dierollsounda > impassable.luaData.artysound  and unit.prototype.name == "artillery" then
  local sfx = LoadSample("faintartillery.wav")
	PlaySample(sfx)
	impassable.luaData.artysound = impassable.luaData.artysound +1

elseif impassable.luaData.artysound ~= -1 then
	impassable.luaData.artysound =  impassable.luaData.artysound +1
end
if  dierollsoundb  < impassable.luaData.artysound and impassable.luaData.artysound ~= -1 then
impassable.luaData.artysound  = -1
MusicPlayer():Stop()
MusicPlayer():ClearPlayList() 
	if gameplay.winter == 0 then
		MusicPlayer():AddToPlayList("battleloopsummer")			
		MusicPlayer():SetLooping(true)
		MusicPlayer():Play()
	elseif gameplay.winter ==1 then
		MusicPlayer():AddToPlayList("battleloopwinter")			
		MusicPlayer():SetLooping(true)
		MusicPlayer():Play()
	end
end	
local soundluck = math.random(1,100)
if HasUnitTech(unit, "assault_tactics") == true 
	and unit.type == Unit.LAND
	and soundluck >= 75 then
local sfx = LoadSample("assault.wav")
	PlaySample(sfx)

elseif HasUnitTech(unit, "flamethrower") == true 
	and unit.type == Unit.LAND
	and soundluck >= 75 then
local sfx = LoadSample("flamer.wav")
	PlaySample(sfx)
end

if unit.prototype.name == "artillery"
	and (HasUnitTech(unit, "chlorine_gas")
		or HasUnitTech(unit, "phosgene_gas")
		or HasUnitTech(unit, "mustard_gas"))then
	local luck = math.random(1,12)
	if luck == 1 then
		  PlaySample(LoadSample("gas1.wav"))	  
	elseif luck == 2 then
		  PlaySample(LoadSample("gas2.wav"))
	elseif luck == 3 then
		  PlaySample(LoadSample("gas3.wav"))	 
	elseif luck == 4 then
		  PlaySample(LoadSample("gas4.wav"))	 
	elseif luck == 5 then
		  PlaySample(LoadSample("gas5.wav"))	 
	elseif luck == 6 then
		  PlaySample(LoadSample("gas6.wav"))
	
	end
	if defunit ~= nil then
		if HasUnitTech(defunit, "filter_respirator_mask") then 
			local luck = math.random(1,100)
			if luck  >= 85 then
			  PlaySample(LoadSample("gasmask1.wav"))
			elseif luck <= 15 then
			  PlaySample(LoadSample("gasmask2.wav"))
			end
		end
	end
		  
	
	
end	

local aluck = math.random(1,100)
local bluck = math.random(1,100)
if unit.luaData.experience ~= nil 
	and (unit.prototype.name == "infantry" 
		or unit.prototype.name == "garrison" 
		or unit.prototype.name == "cavalry") 
	and dierollsoundc < unit.luaData.experience 
	and aluck  <=  unit.efficiency 
	and bluck <= unit.hp then
	if unit.commander ~= nil then
		local luck = math.random(1,11) 

			if luck == 1 then
				local sfx = LoadSample("charge4.wav")
				PlaySample(sfx)
			elseif luck == 2 then
				local sfx = LoadSample("charge5.wav")
				PlaySample(sfx)
			elseif luck == 3  then
				local sfx = LoadSample("charge6.wav")
				PlaySample(sfx)
			elseif luck == 4  then
				local sfx = LoadSample("charge7.wav")
				PlaySample(sfx)
			elseif luck == 5  then
				local sfx = LoadSample("charge8.wav")
				PlaySample(sfx)
			elseif luck == 6  then
				local sfx = LoadSample("charge9.wav")
				PlaySample(sfx)	
			elseif luck == 7  then
				local sfx = LoadSample("charge10.wav")
				PlaySample(sfx)
			elseif luck == 8  then
				local sfx = LoadSample("charge11.wav")
				PlaySample(sfx)	
			elseif luck == 9  then
				local sfx = LoadSample("charge12.wav")
				PlaySample(sfx)	
			elseif luck == 10  then
				local sfx = LoadSample("charge13.wav")
				PlaySample(sfx)	
			elseif luck == 11  then
				local sfx = LoadSample("charge14.wav")
				PlaySample(sfx)		
				
			end
end
local luck = math.random(1,3) 

	if luck == 1 then
		local sfx = LoadSample("charge1.wav")
		PlaySample(sfx)
	elseif luck == 2 then
		local sfx = LoadSample("charge2.wav")
		PlaySample(sfx)
	elseif luck == 3  then
		local sfx = LoadSample("charge3.wav")
		PlaySample(sfx)
	end
		


end
end

function GetStat(unit, stat, prototype)

  -- if no different prototype is given, use unit base prototype
  if prototype == nil then
    prototype = unit.prototype.lua
  end

  local value = prototype.stats[stat]

  -- transporters have no techs
  if unit.luaData.unitTechs ~= nil then
    -- Run through techs
    local i = 0
    local techName
    while unit.luaData.unitTechs[i+1] ~= nil do
      techName = unit.luaData.unitTechs[i+1]
      if IsTechValidForUnit(techName, unit) == true then
        if data.newTechnologies[techName].stats ~= nil and data.newTechnologies[techName].stats[stat] ~= nil then
          value = value + data.newTechnologies[techName].stats[stat]
        end
      end
      i = i + 1
    end
  end

  return value
end

function GetProductionStat(faction, unit, stat)

  local value = unit.prototype.lua.stats[stat]

  -- Run through techs
  for techName, _ in pairs(data.newTechnologies) do
    if faction.luaData.researchComplete[techName] ~= 0 then
      if IsTechValidForUnit(techName, unit) == true then
        if data.newTechnologies[techName].stats ~= nil and data.newTechnologies[techName].stats[stat] ~= nil then
          value = value + data.newTechnologies[techName].stats[stat]
        end
      end
    end
  end

  return value
end


function GetStatEntrenchment(unit)
  local entrenchment = unit.hex.terrain.entrench * unit.hex.entrench

  if unit.hex.construction ~= nil then
    if unit.hex.construction.type == Construction.TYPE_FORTRESS then
      entrenchment = entrenchment + 10
    end
  end

  local maxEntrenchment = 18
  if entrenchment > maxEntrenchment then
    entrenchment = maxEntrenchment
  end

  return entrenchment
end


function GetPrototypeByName(name)
  for i, v in pairs(data.units) do
    if data.units[i].name == name then
      return data.units[i]
    end
  end
end

function IsConstructionValidTarget(unit, hex)
  if hex.construction ~= nil and hex.terrain.type ~= Terrain.WATER then
    if hex.faction.alliance.id ~= unit.faction.alliance.id and hex.faction.alliance.id ~= 0 then
      if hex.unit == nil or hex.unit.alive == false or unit.faction.alliance:IsVisible(hex) == false then
        if hex:Distance(unit.hex) < unit.prototype:GetLevelStats(unit.level).range then
          return true
        end
      end
    end
  end
  return false
end

function InterceptCheck(attacker, hex)

  local defender = hex.unit
  
  		local airaceattackerbonus = 0
		local airaceinterceptbonus = 0
		
		local lucka = math.random(1,100)
		local luckb = math.random(1,100)
		local luckc = math.random(1,100)
		
				--------FOR EXP GAIN ---------------- 
		local dividenta = math.random(1, (GetUnitExperienceLevel(attacker)+1)) +1
		local dividentb = 0
		local dividentc = 0


  -- Check if attack can be intercepted
  if attacker.type == Unit.AIR and (defender == nil or defender.type ~= Unit.AIR) then
		
    -- find interceptor
    local interceptor
    local interceptorHexes = game.map:GetHexesInRange(hex, 4)
    for _,interceptorHex in pairs(interceptorHexes) do
      local unit = interceptorHex.unit
      if unit ~= nil 
      and unit.alive 
      and unit.prototype.name == "fighter" 
      and (hex.faction == nil or unit.faction.alliance.id == hex.faction.alliance.id)
      and GetStat(unit, "airattack") > 0 and unit.hp >= 60 
      and unit.efficiency >= 60
      and unit.luaData.intercepted ~= game.turn then -- and unit.ap > 0 then
        interceptor = unit
        unit.luaData.intercepted = game.turn
        break
      end
    end

    -- find escort if there is interceptor & attacker is bomber/zep
    local escort
    if interceptor ~= nil and GetStat(attacker, "stratattack") ~= nil then
      local escortHexes = game.map:GetHexesInRange(hex, 4)
      for _,escortHex in pairs(escortHexes) do
      local unit = escortHex.unit
      if unit ~= nil 
		and unit.alive 
		and unit.prototype.name == "fighter" 
		and unit.faction.alliance.id == attacker.faction.alliance.id 
		and GetStat(unit, "airattack") > 0 
		and unit.hp >= 60 and unit.efficiency >= 60 
		and unit.ap > 0 then
			escort = unit
        break
      end
      end
    end

if interceptor ~= nil then
		dividentb = math.random(1, (GetUnitExperienceLevel(interceptor)+1)) +1
		
		if attacker.alive 
			and attacker.commander ~= nil then
			local commander = attacker.commander		
			 airaceattackerbonus = (data.commanders[commander.id+1].stats["airattack"]) 
			for i = (airaceattackerbonus),0,-1 do
				 airaceattackerbonus =  airaceattackerbonus + math.random(0,10)
			end
		end	
		if interceptor.alive 
			and interceptor.commander ~= nil then
			local commander = interceptor.commander		
			 airaceinterceptbonus = (data.commanders[commander.id+1].stats["airattack"]) 
			for i = (airaceinterceptbonus),0,-1 do
				 airaceinterceptbonus =  airaceinterceptbonus + math.random(0,10)
			end
		end	
		
		airaceattackerbonus = airaceattackerbonus + (attacker.hp *  (1 + (0.1 * GetUnitTechCount(attacker, attacker.faction))) * (1 + (0.2 * GetUnitExperienceLevel(attacker))))
		airaceinterceptbonus = airaceinterceptbonus + (interceptor.hp *  (1 + (0.1 * GetUnitTechCount(interceptor, interceptor.faction))) * (1 + (0.2 * GetUnitExperienceLevel(interceptor))))
     
		LogUi("AIR ATTACKBONUS: " .. airaceattackerbonus)
		LogUi("AIR INTERCEPTBONUS: " .. airaceinterceptbonus)

	 -- Reveil interceptor
		attacker.faction.alliance:AddVisibleHex(interceptor.hex)

 if escort ~= nil then
		dividentc = math.random(1, (GetUnitExperienceLevel(escort)+1)) +1
		LogUi("ESCORTING FROM:" .. escort.hex.x .. "/" .. escort.hex.y)
        -- fight between interceptor & escort
        local airaceescortbonus = 0
		local damage = CalculateDamage(escort, interceptor, false)
		
		
        if escort.alive 
			and escort.commander ~= nil then
			local commander = escort.commander		
			 airaceescortbonus = (data.commanders[commander.id+1].stats["airattack"]) 
			for i = (airaceescortbonus),0,-1 do
				 airaceescortbonus =  airaceescortbonus + math.random(0,10)
			end
		end	
		
		airaceescortbonus = airaceescortbonus + (escort.hp *  (1 + (0.2 * GetUnitTechCount(escort, escort.faction))) * (1 + (0.2 * GetUnitExperienceLevel(escort))))
		LogUi("AIR ESCORTBONUS: " .. airaceescortbonus)
		

		if escort.alive 
			and escort.type == Unit.AIR  
			and escort.commander ~= nil 
			and luckb <  (airaceinterceptbonus ) - (airaceattackerbonus + airaceescortbonus)  then 
			WoundCommander(escort.commander)
			LogUi("ESCORTING ACE WOUNDED")
			local avalue = (airaceinterceptbonus ) - (airaceattackerbonus + airaceescortbonus)
			LogUi("Chance in % was: " .. avalue .. "/ROLL WAS: " .. luckb)
			if interceptor.alive and interceptor.luaData.experience ~= nil then
				interceptor.luaData.experience = interceptor.luaData.experience + (airaceescortbonus / dividentb)
			end
		end
		
		if interceptor.alive 
			and attacker.type == Unit.AIR 
			and interceptor.type == Unit.AIR  
			and interceptor.commander ~= nil 
			and luckc <  (airaceattackerbonus + airaceescortbonus ) - (airaceinterceptbonus )  then 
			WoundCommander(interceptor.commander)
			LogUi("INTERCEPTING ACE WOUNDED")
			local avalue = (airaceattackerbonus + airaceescortbonus ) - (airaceinterceptbonus )
			LogUi("Chance in % was: " .. avalue .. "/ROLL WAS: " .. luckc)
			
			if escort.alive and escort.luaData.experience ~= nil then
					escort.luaData.experience = escort.luaData.experience + (airaceinterceptbonus / dividentc) 
			end
		end
		
		TriggerCombatEvents(escort, interceptor)

        -- Reveil escorts
        interceptor.alliance:AddVisibleHex(escort.hex)
	
        ----------- Damage unit hp -----------------------
        
		----------AIRKILLS-----------
		escort:Damage(damage[1])
		escort.faction.luaData.statsCasualties["air"] = escort.faction.luaData.statsCasualties["air"] + damage[1]
		interceptor.faction.luaData.statsKills["air"] = interceptor.faction.luaData.statsKills["air"] + damage[1]
		
        interceptor:Damage(damage[2])
		escort.faction.luaData.statsKills["air"] = escort.faction.luaData.statsKills["air"] + damage[2]
		interceptor.faction.luaData.statsCasualties["air"] = interceptor.faction.luaData.statsCasualties["air"] + damage[2]
        
		AttackAnimation(escort, interceptor)
        AttackAnimation(interceptor, escort)
        AttackSound(escort)

        interceptor.ap = 0
        escort.ap = 0
		
		
  else
	   -----------------------------------------	
       ---- fight between interceptor & bomber--
	   -------------------------------------------
        local damage = CalculateDamage(interceptor, attacker, false)

        TriggerCombatEvents(interceptor, attacker)
		
		if attacker.alive 
			and (attacker.luaData.experience == nil or attacker.luaData.experience == 0) then
			attacker.luaData.experience = 1
		end
		if interceptor.alive 
			and (interceptor.luaData.experience == nil or interceptor.luaData.experience == 0) then
			interceptor.luaData.experience = 1
		end
		
        -- Reveil interceptor
        attacker.faction.alliance:AddVisibleHex(interceptor.hex)
			
		
		if attacker.alive and attacker.type == Unit.AIR  
			and attacker.commander ~= nil 
			and lucka < (airaceinterceptbonus ) - (airaceattackerbonus) then -- (math.random(1,6) + math.random(1,6))  then
			WoundCommander(attacker.commander)
			LogUi("ATTACKER ACE WOUNDED")
			local avalue = airaceinterceptbonus  - airaceattackerbonus
			LogUi("Chance in % was: " .. avalue .. "/ROLL WAS: " .. lucka)
			if interceptor.alive and interceptor.luaData.experience ~= nil then
				interceptor.luaData.experience = interceptor.luaData.experience + (airaceattackerbonus / dividentb) 
			end
		end		
		
		if interceptor.alive 
			and attacker.type == Unit.AIR and interceptor.type == Unit.AIR  
			and interceptor.commander ~= nil 
			and luckb <  (airaceattackerbonus) - (airaceinterceptbonus )  then --(math.random(1,6) + math.random(1,6))  then
			WoundCommander(interceptor.commander)
			LogUi("INTERCEPT ACE WOUNDED")
			local avalue = airaceattackerbonus  - airaceinterceptbonus
			LogUi("Chance in % was: " .. avalue .. "/ROLL WAS: " .. luckb)
				if attacker.alive and attacker.luaData.experience ~= nil then
					attacker.luaData.experience = attacker.luaData.experience + (airaceinterceptbonus / dividenta)
				end
		end
		
		 -- Damage unit hp
		
		----------AIRKILLS2-----------
			interceptor:Damage(damage[1])
			interceptor.faction.luaData.statsCasualties["air"] = interceptor.faction.luaData.statsCasualties["air"] + damage[1]
			attacker.faction.luaData.statsKills["air"] = attacker.faction.luaData.statsKills["air"] + damage[1]
		   
			attacker:Damage(damage[2])
			interceptor.faction.luaData.statsKills["air"] = interceptor.faction.luaData.statsKills["air"] + damage[2]
			attacker.faction.luaData.statsCasualties["air"] = attacker.faction.luaData.statsCasualties["air"] + damage[2]

			AttackAnimation(interceptor, attacker)
			AttackAnimation(attacker, interceptor)
			AttackSound(interceptor)

			interceptor.ap = 0

		end
	  
    end

  end

end

function HasHomeSupport(alliance, hex)
  local portSupportRange = 2

  local hexes = game.map:GetHexesInRange(hex, portSupportRange)

  for _, portHex in pairs(hexes) do
    if portHex.construction ~= nil 
		and portHex.construction.type == Construction.TYPE_PORT 
		and portHex.construction.city.hex.originalFaction.alliance.id == alliance.id 
		and portHex.construction.city.hex.faction.alliance.id == alliance.id then
			return true
    end
  end

  return false
end

function EnemyWaters(alliance, hex)
  local portSupportRange = 1

  local hexes = game.map:GetHexesInRange(hex, portSupportRange)

  for _, portHex in pairs(hexes) do
    if portHex.construction ~= nil and portHex.construction.type == Construction.TYPE_PORT and portHex.construction.city.hex.originalFaction.alliance.id ~= alliance.id and portHex.construction.city.hex.faction.alliance.id ~= alliance.id then
      return true
    end
  end

  return false
end



function HasPortSupport(alliance, hex)
  if hex.construction ~= nil and hex.construction.type == Construction.TYPE_PORT and hex.construction.city.hex.faction.alliance.id == alliance.id then
    return true
  end

  return false
end

function DamageEfficiency(unit, damage)
if unit ~= nil then 
 unit.efficiency = unit.efficiency - damage
	if unit.efficiency < 0 then
		unit.efficiency = 0
	end
	if unit.efficiency > 100 then
		unit.efficiency = 100
	end
end
end


function GetEnemyAlliance(alliance)
  return game:GetAllianceById(3 - alliance.id)
end
