function InitCommanders()

  local id, faction, alive
  local i = 1

  while data.commanders[i] ~= nil do

    id = data.commanders[i].id
    faction = game:GetFactionById(data.commanders[i].faction)
	alive = data.commanders[i].alive

    -- Init commanders table
    if faction ~= nil then
      if faction.luaData.commanders == nil then
        faction.luaData.commanders = {}
      end

      faction.luaData.commanders[id] = {}
      faction.luaData.commanders[id].turns = 0
      faction.luaData.commanders[id].unlocked = 0
      faction.luaData.commanders[id].type = data.commanders[i].type
      faction.luaData.commanders[id].alive = data.commanders[i].alive
    
	end

    i = i + 1

  end

end


function DecreaseFactionCommanderRequirement(factionId, req, class, amount)
  local faction = game:GetFactionById(factionId)
  if faction.luaData.commanderRequirements == nil then
    faction.luaData.commanderRequirements = {}
  end
  if faction.luaData.commanderRequirements[req] == nil then
    faction.luaData.commanderRequirements[req] = {}
  end
  faction.luaData.commanderRequirements[req][class] = amount
end

function GetFactionCommanderRequirementReduction(factionId, req, class)
  local faction = game:GetFactionById(factionId)
  if faction.luaData.commanderRequirements == nil or faction.luaData.commanderRequirements[req] == nil or faction.luaData.commanderRequirements[req][class] == nil then
    return 0
  else
  --  LogUi("return " .. faction.luaData.commanderRequirements[req][class])
    return faction.luaData.commanderRequirements[req][class]
  end
end

function UnlockCommanders(alliance)
       local france  = game:GetFactionById(0)

  for faction in alliance.factions do
    if faction.luaData.commanders ~= nil then
      for i, commander in pairs(faction.luaData.commanders) do
        if commander.unlocked == 0 then
          if CommanderConditionsCheck(faction, i)[0] == true then
            commander.unlocked = game.turn
							
          	if  france.luaData.commanders[0].unlocked == game.turn -- new
				
				and GetEvent("Attaque") == 0 
				and GetEvent("FrenchTrench") <= 0 
				and GetEvent("Michel") <= 0 
				and france.luaData.joffreattack == 0 then
				Discard("Outrance")
				if game.currentAlliance.id == player.alliance.id and player.alliance.id == 1 then 
					PopupMessage("FROM FRENCH ARMY HQ: GENERAL JOFFRE HAS GIVEN OUT ORDERS TO THE FRENCH ARMY FOR AN ALL-OUT COUNTER ATTACK ON THE ENEMY!")
				end
					
				Discard("FrenchTrench")
				SetEvent("FrenchTrench",-1)
				Discard("Michel")
				SetEvent("Michel", -1)
				france.luaData.joffreattack = 1
				end ----- end new
		  
		  end
        elseif commander.turns > 0 then
          commander.turns = commander.turns - 1
        end
      end
    end
  end
end

function CommanderConditionsCheck(faction, commander)
  local conditions = {}
  local conditionCounter = 1

  local i = commander + 1

  -- Ignore "removed" commanders
  if data.commanders[i].conditions.removed then
    conditions[0] = false
    return conditions
  end

  -- All conditions true
  conditions[0] = true

  -- Condition: Kills
  if data.commanders[i].conditions.kills ~= nil then
    local reduction = GetFactionCommanderRequirementReduction(faction.id, "kills", data.commanders[i].conditions.kills[2])
    if faction.luaData.statsKills[data.commanders[i].conditions.kills[2]] / 10 >= data.commanders[i].conditions.kills[1] - reduction then
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

  -- Condition: Casualties
  if data.commanders[i].conditions.casualties ~= nil then
    local reduction = GetFactionCommanderRequirementReduction(faction.id, "casualties", data.commanders[i].conditions.kills[2])
    if faction.luaData.statsCasualties[data.commanders[i].conditions.casualties[2]] / 10 >= data.commanders[i].conditions.casualties[1] - reduction then
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

  -- Condition: Research
  if data.commanders[i].conditions.researched ~= nil then
    if faction.luaData.researchComplete[data.commanders[i].conditions.researched] > 0 then
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

  -- Condition: War
  if data.commanders[i].conditions.war ~= nil then
    local alliance = game:GetFactionById(data.commanders[i].conditions.war).alliance
    if faction.alliance.id ~= alliance.id and alliance.id ~= 0 then
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

  -- Condition: Ally
  if data.commanders[i].conditions.ally ~= nil then
    local alliance = game:GetFactionById(data.commanders[i].conditions.ally).alliance
    if faction.alliance.id == alliance.id and alliance.id ~= 0 then
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

  -- Condition: Year
  if data.commanders[i].conditions.year ~= nil then
   if game.date.year >= data.commanders[i].conditions.year then
   
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

   --Condition: month
  if data.commanders[i].conditions.month ~= nil then
   if game.date.month >= data.commanders[i].conditions.month then
   
      conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end
  
  
  
  
  
  -- Condition: Unlocked
  if data.commanders[i].conditions.unlocked ~= nil then												
    local unlocked = GetCommanderByName(data.commanders[i].conditions.unlocked)
    --if faction.luaData.commanders[unlocked] and faction.luaData.commanders[unlocked].unit ~= nil and faction.luaData.commanders[id].alive ~= nil then
         if faction.luaData.commanders[unlocked] and faction.luaData.commanders[unlocked].unit ~= nil then --and faction.luaData.commanders[alive] ~= nil then

	 conditions[conditionCounter] = true
    else
      conditions[conditionCounter] = false
      conditions[0] = false
    end
    conditionCounter = conditionCounter + 1
  end

  
  
  return conditions
end


-- Add commander to production queue
function AddCommander(id, faction)

  local i = 1

  while data.commanders[i] ~= nil do

    if data.commanders[i].id == id and faction.luaData.commanders[id].alive ~= nil then

      faction = game:GetFactionById(data.commanders[i].faction)

      faction.luaData.commanders[id].unlocked = game.turn
					
      return true

    end

    i = i + 1

  end
end


function GetCommanderByName(name)

  local i = 1

  while data.commanders[i] ~= nil do
    if data.commanders[i].name == name then
      return data.commanders[i].id
    end
    i = i + 1
  end

  return false
end


--
function CommanderCompatible(commander, unit)
  if unit.faction.id == data.commanders[commander+1].faction and unit.commander == nil then
    if data.commanders[commander+1].type == "land" and unit.prototype.lua.class == "ground" then
      return true
    end
    if data.commanders[commander+1].type == "air" and unit.prototype.lua.class == "air" then
      return true
    end
    if data.commanders[commander+1].type == "naval" and unit.prototype.lua.class == "naval" and GetStat(unit, "navalattack") ~= nil then
      return true
    end
  end
  return false
end


-- Attach commander to unit
function AttachCommanderToUnit(commander, unit, y, source)
--LogUi("ATTACH COMMANDER START")
  if source == nil and game.turn == -1 then
    source = "init"
  end

  -- Ability to attach commander to unit at (x,y) coords
  if y ~= nil then
    local hex = GetHex(unit, y)
    -- if there is unit and its part of the commander's faction
    if hex.unit ~= nil and hex.unit.faction.luaData.commanders[commander] ~= nil then
      unit = hex.unit
      unit.faction.luaData.commanders[commander].unlocked = 1
--~       print("unlocked")
    else
      print("failed to attach commander " .. commander)
	  LogUi("ATTACH COMMANDER ERROR")

      return false
    end
  end
-------------------------
  if unit ~= nil 
	and unit.commander == nil 
	and unit.faction.luaData.commanders[commander] ~= nil 
	and unit.faction.luaData.commanders[commander].unlocked ~= 0 
	and unit.faction.luaData.commanders[commander].unit == nil then
		if source == "ai" or source == "init" then
		unit:AttachCommander(commander)
    
		else
			if unit.type == Unit.NAVAL 
				and unit.alliance.id == player.alliance.id 
				and unit.hex.construction == nil then --and unit.hex.construction.type ~= Construction.TYPE_PORT  then
							PopupMessage("admiralnoattach")
							return false
			else
				GetPlayer():AttachCommander(unit, commander)
			end
		end
		
    unit.faction.luaData.commanders[commander].unit = unit.id
    MoveCommander(unit)
    EasterEgg_RedBaron(unit)
----	LogUi("ATTACH COMMANDER END")

    return true
  else
    LogUi("failed to attach commander " .. commander .. unit.hex.x .. "/" .. unit.hex.y)
	LogUi("ATTACH COMMANDER ERROR!")

    return false
  end
end
	


--[[
  if unit ~= nil and unit.commander == nil and unit.faction.luaData.commanders[commander] ~= nil and unit.faction.luaData.commanders[commander].unlocked ~= 0 and unit.faction.luaData.commanders[commander].unit == nil then
    if source == "ai" or source == "init" then
      unit:AttachCommander(commander)
    else
      GetPlayer():AttachCommander(unit, commander)
    end
    unit.faction.luaData.commanders[commander].unit = unit.id
    MoveCommander(unit)
    EasterEgg_RedBaron(unit)
    return true
  else
    print("failed to attach commander " .. commander)
    return false
  end
end
	
end]]


function MarkCommanderRange(unit, commander)
  if commander == nil then
    commander = unit.commander.id
  end

  local validHexes = {}
  local range = data.commanders[commander+1].range
  for x = -range, range do
    for y = -range, range do
      if unit.hex.x + x >= 0 and unit.hex.x + x <= xSize and unit.hex.y + y >=0 and unit.hex.y + y <= ySize then
        local hex = GetHex(unit.hex.x + x, unit.hex.y + y)
        if unit.hex:Distance(hex) <= range and hex.id ~= unit.hex.id then
          table.insert(validHexes, hex)
          --View:AddEffect(hex, "commander_range_" .. unit.alliance.id)
        end
      end
    end
  end
  --View:AddEffect(hex, "commander_range_" .. unit.alliance.id)
  GetScene():AddActionImages(validHexes, "commander_range_" .. unit.alliance.id)
end


function GetNearbyCommander(unit)
  local range = 4

  -- Transported units dont show commander
  if unit.hex == nil then
    return nil
  end

  -- If unit has its own commander, look no further
  if unit.commander ~= nil then
    return unit.commander
  end

  for x = -range, range do
    for y = -range, range do
      if unit.hex.x + x >= 0 and unit.hex.x + x <= xSize and unit.hex.y + y >=0 and unit.hex.y + y <= ySize then
        local hex = GetHex(unit.hex.x + x, unit.hex.y + y)
        if hex ~= nil and hex.unit ~= nil then
          if hex.unit.faction.id == unit.faction.id 
			and hex.unit.commander ~= nil 
			and CommanderCompatible(hex.unit.commander.id, unit) then
            if unit.hex:Distance(hex) <= data.commanders[hex.unit.commander.id+1].range then
              --unit.commanderInfluence = hex.unit.commander
              return hex.unit.commander
            end
          end
        end
      end
    end
  end

  return nil
end

function GetCommanderBonus(commander, stat)
  if commander ~= nil then
    local bonus = 0
    if data.commanders[commander.id+1].stats ~= nil then
      bonus = data.commanders[commander.id+1].stats[stat]
    end
    if bonus ~= nil then
      return bonus
    end
  end
  return 0
end


function DetachCommanderFromUnit(unit, commander, forceDetach, source)
  local faction = game:GetFactionById(data.commanders[commander.id+1].faction)
  -- Only if parent unit is in full supply
  if unit.supply == 2 or forceDetach == true then
    --unit:DetachCommander()
    if source == "ai" then
				unit:DetachCommander()
    else
				if unit.type == Unit.NAVAL 
					and unit.alliance.id == player.alliance.id 
					and unit.hex.construction == nil then
							PopupMessage("admiralnodetach")
											return false
			
				elseif unit.mp == 0
					and unit.alliance.id == player.alliance.id then
					PopupMessage("This commander has already given a movement order this turn. He cannot be removed until next turn.")
							return false				
							
				elseif unit.ap == 0 
					and unit.alliance.id == player.alliance.id then
					PopupMessage("This commander has already conducted an attack this turn. He cannot be removed until next turn.")
							return false	

				elseif unit.prototype.name == "infantry"
					and unit.alliance.id == player.alliance.id 
					and commander.id == 116	then
						PopupMessage("Trotsky must always stay with the Red Train.")
							return false
				
				elseif commander.id == 78 
						and unit.alliance.id == player.alliance.id  then
						PopupMessage("General Samsonov has given an oath to Tsar Nicolas to either lead his troops to victory or die with them.")
							return false
				
				else		
						GetPlayer():DetachCommander(unit)
				end
	end

    faction.luaData.commanders[commander.id].unit = nil
    faction.luaData.commanders[commander.id].turns = 2
  end
end

--
--
function WoundCommander(commander, recoverTime)
LogUi("COMMANDER WOUND ROUTINE")
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)
local turkey = game:GetFactionById(5)
local italy = game:GetFactionById(8)

local luck = math.random(1,6)
local bluck = math.random(1,6)
local chance = math.random(3,4)

local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local faction = game:GetFactionById(data.commanders[commander.id+1].faction)

 -- LogUi("Commander was:" .. faction.luaData.commanders[commander.id].type  .. "NAME:" .. faction.luaData.commanders[commander.id+1].id)
local range = data.commanders[commander.id+1].range
local name = data.commanders[commander.id+1].name

LogUi("RANGE:" .. range)
LogUi("NAME:" ..name)
LogUi("KILL ROLL WAS: " .. luck)

 if luck >= (range + chance) 
	or faction.luaData.commanders[commander.id].type  == "naval"  
	or  commander.id == 78 
	or commander.id == 86	
	or commander.id == 92	then 

	if faction.luaData.commanders[commander.id].type  == "air" then
			local unit = GetUnitById(faction.luaData.commanders[commander.id].unit)

			unit:DetachCommander()
			LogUi("AIR ACE KILLED!")
	end
	if faction.luaData.commanders[commander.id].type  == "land" then
		  
		  if math.random(1,6) >= 5 then
		  sfx = LoadSample("bullet.wav")
				PlaySample(sfx)
		  end
	end
 
--table.remove(faction.luaData.commanders[commander.id])  

for i,v in pairs(faction.luaData.commanders) do
--for i = #tab, 1, -1 do
--local v = tab[i]
	if(v == faction.luaData.commanders[commander.id]) then
		LogUi("REMOVED:" .. commander.name)
		table.remove(faction.luaData.commanders[commander.id])  
			--LogUi("REMOVED commander:" .. faction.luaData.commanders[commander.id])
			--tab[i] = nil
		end
end


  
  if faction.id == 0 then
        local france = game:GetFactionById(0)
        ChangeFactionMorale(france, - france.luaData.deadcommander)
		france.luaData.deadcommander = france.luaData.deadcommander +1
		cp.luaData.DP = cp.luaData.DP + france.luaData.deadcommander
		
		SetEvent("CommanderDeathFrance", game.turn)
		sfx = LoadSample("commanderdeath.wav")
		PlaySample(sfx)	


  elseif  faction.id == 1 then
  local britain = game:GetFactionById(1)
        ChangeFactionMorale(britain, - britain.luaData.deadcommander)
		britain.luaData.deadcommander = britain.luaData.deadcommander +1
		cp.luaData.DP = cp.luaData.DP + britain.luaData.deadcommander
  
  SetEvent("CommanderDeathBritain", game.turn)
  			 	sfx = LoadSample("commanderdeath.wav")
				PlaySample(sfx)	

  
  elseif  faction.id == 2 then
  local germany = game:GetFactionById(2)
        ChangeFactionMorale(germany, - germany.luaData.deadcommander)
		germany.luaData.deadcommander = germany.luaData.deadcommander +1
		
  
		if commander.id == 51 and GetEvent("Moltke") == 0 and game.date.year == 1914 then
			SetEvent("Moltke", game.turn)
		
		elseif commander.id == 96 then
				germany.luaData.eventMorale = germany.luaData.eventMorale - germany.luaData.collaps
			
			
		else 
			SetEvent("CommanderDeathGermany", game.turn)
			sfx = LoadSample("commanderdeath.wav")
			PlaySample(sfx)	

			entente.luaData.DP = entente.luaData.DP + germany.luaData.deadcommander
		end 
  
  elseif faction.id == 3 then
  local austria = game:GetFactionById(3)
        ChangeFactionMorale(austria, - austria.luaData.deadcommander)
		austria.luaData.deadcommander = austria.luaData.deadcommander +1
		
		if commander.id == 91 and GetEvent("AustriaInvasion") >0 and GetEvent("AuffenbergDismissed") == 0 then
			SetEvent("AuffenbergDismissed", game.turn)
		
		elseif commander.id == 63 and GetEvent("DOWpersia") == 0 then
			SetEvent("ColmarDeath", game.turn)
		
		elseif commander.id == 94 and GetEvent("AustriaInvasion") >0 and GetEvent("BrudermannDismissed") == 0 then
			SetEvent("BrudermannDismissed", game.turn)
		else
				SetEvent("CommanderDeathAustria", game.turn)
				sfx = LoadSample("commanderdeath.wav")
				PlaySample(sfx)	

				austria.luaData.deadcommander = austria.luaData.deadcommander +1
				entente.luaData.DP = entente.luaData.DP + austria.luaData.deadcommander
		end
		
  elseif faction.id == 4 then
	local russia = game:GetFactionById(4)
	
		if commander.id == 33 then
			russia.luaData.kolchakkill = 1
		elseif commander.id == 30 then			
			russia.luaData.yudenichkill = 1
		elseif commander.id ==  103 then
			russia.luaData.kornilovkill = 1
		end
		
        if russia.alliance.id == player.alliance.id and game.type == Game.TYPE_SINGLE then
			ChangeFactionMorale(russia, - math.random(1,6))
		else
			ChangeFactionMorale(russia, - russia.luaData.deadcommander)
		end
		
		if commander.id == 78 and GetEvent("Samsonov") == 0 
			and GetEvent("Tannenberg") >0 then
				SetEvent("Samsonov", game.turn)
				russia.luaData.samso = 1

			
		else 
			SetEvent("CommanderDeathRussia", game.turn)
			 	sfx = LoadSample("commanderdeath.wav")
				PlaySample(sfx)	
				russia.luaData.deadcommander = russia.luaData.deadcommander +1
				cp.luaData.DP = cp.luaData.DP + russia.luaData.deadcommander
		end 
 
  elseif faction.id == 5 then
  local turkey = game:GetFactionById(5)
        ChangeFactionMorale(turkey, - turkey.luaData.deadcommander)
		turkey.luaData.deadcommander = turkey.luaData.deadcommander +1

				SetEvent("CommanderDeathTurkey", game.turn)
  			 	sfx = LoadSample("commanderdeath.wav")
				PlaySample(sfx)	

				entente.luaData.DP = entente.luaData.DP + turkey.luaData.deadcommander
 
  elseif faction.id == 6 then
		if commander.id == 86  then
				SetEvent("AlbertFlee", game.turn)
		end
	
  elseif faction.id == 8 then
  local italy = game:GetFactionById(8)
        ChangeFactionMorale(italy, - italy.luaData.deadcommander)
		SetEvent("CommanderDeathItaly", game.turn)
  			 	sfx = LoadSample("commanderdeath.wav")
				PlaySample(sfx)	
				if commander.id == 88 
					and (GetEvent("ItalyCharge") >0 or GetEvent("ItalyChargeEnt") >0)
					and italy.luaData.collaps >=4	then
					italy.luaData.cadornadead = 1
					Discard("ReplaceCadorna")
						if 	italy.luaData.commanders[101].unlocked == 0 then
							italy.luaData.commanders[101].unlocked = game.turn
						end

				end

  		italy.luaData.deadcommander = italy.luaData.deadcommander +1
		  cp.luaData.DP = cp.luaData.DP + italy.luaData.deadcommander

  
  else 
  SetEvent("CommanderDeath", game.turn)
  end
 --------------------- if not dead
 
 else
	if faction.luaData.commanders[commander.id].type  == "air" and faction.luaData.commanders[commander.id].unit ~= nil then
			local unit = GetUnitById(faction.luaData.commanders[commander.id].unit)
			 if  unit.alliance.id == playerAlliance.id then
				PopupMessage("commander_wounded")
			 end
			unit:DetachCommander()
			LogUi("wounded!")
	end
	
  if recoverTime == nil then
    recoverTime = 3
  end
  faction.luaData.commanders[commander.id].unit = nil
  faction.luaData.commanders[commander.id].turns = math.random(recoverTime, recoverTime + 2)
end
ui.resourcesPanel:Refresh()
LogUi("COMMANDER WOUND ROUTINE FINISHED!")
end


--
function KaiserCommander(commander, recoverTime)
  local faction = game:GetFactionById(data.commanders[commander.id+1].faction)
  if recoverTime == nil then
    recoverTime = 2
  end
  faction.luaData.commanders[commander.id].unit = nil
  faction.luaData.commanders[commander.id].turns = 2
end

function ReprimandCommander(commander, recoverTime)
  local faction = game:GetFactionById(data.commanders[commander.id+1].faction)
  if recoverTime == nil then
    recoverTime = 2
  end
  faction.luaData.commanders[commander.id].unit = nil
  faction.luaData.commanders[commander.id].turns = 2
end


function SendOffCommander(commander, recoverTime)
  local faction = game:GetFactionById(data.commanders[commander.id+1].faction)
  if recoverTime == nil then
    recoverTime = 1
  end
  faction.luaData.commanders[commander.id].unit = nil
  faction.luaData.commanders[commander.id].turns = 1
end

