

function InitConvoys()
  for faction in game.factions do
    faction.luaData.convoys = {}
  end
end

function FactionBlockaded(faction)
  if faction.luaData.blockaded == 1 then
    return true
  end
  return false
end 

function ManageConvoys(alliance)
local entente = game:GetAllianceById(1)
local cp = game:GetAllianceById(2)
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local sweden = game:GetFactionById(11)
local norway = game:GetFactionById(20)
local impassable = game:GetFactionById(24)
local russia = game:GetFactionById(4)

  -- Convoys only spawn for factions at war
  -- AND still have capitals left = can still produce units
  if alliance.id ~= 0 then
    for faction in alliance.factions do
      if game.turn > 1  
	  and (faction.luaData.capitals > 0 or IsNewFaction(faction) == true) then
        -- Spawn convoys at intervals
        for _, convoy in pairs(faction.luaData.convoys) do
          if not FactionBlockaded(faction) or convoy.blockadable == 0 then
            if game.turn % convoy.interval == 0 and game.turn > convoy.spawnturn then
              convoy.spawnturn = game.turn + math.random(0,2)
            end

            if game.turn == convoy.spawnturn then

              -- Dont spawn in arabian gulf if it's blocked
              if GetHex(convoy.x, convoy.y).region ~= 7 or (GetHex(130, 66).faction.alliance.id == 1 and GetHex(130, 67).faction.alliance.id == 1 and GetHex(130, 68).faction.alliance.id == 1) then
                local hex = ConvoySpawn(faction, convoy.x, convoy.y, 0, convoy.cargo)
              else
                convoy.spawnturn = convoy.spawnturn + 1
              end

            end
          end
        end
      end
    end
  end

  -- Manage existing convoys
  gameplay.convoys = {}
  for faction in alliance.factions do
    for unit in faction.units do
      if unit.alive and unit.prototype.name == "convoy" then
        -- If convoy is in national port
        local arrived = false
        local hexes = game.map:GetHexesInRange(unit.hex, 1)
        for _, hex in pairs(hexes) do
          if hex.construction ~= nil 
			and hex.construction.isPort 
			and hex.construction.city.hex.faction.id == faction.id 
			and hex.construction.city.hex.originalFaction.id == faction.id 
			and hex.y < 45 then
            
				arrived = true
            
			if alliance.id == playerAlliance.id then
              --PopupInfoDialog("convoy_finished", unit.hex.x, unit.hex.y)
              ui.resourcesPanel:Refresh()
            end
            local factor = impassable.luaData.convoyfactor
			local entfactor = entente.luaData.convoyfactor
			local gfactor = cp.luaData.convoyfactor
			
			------GERMANY----------------
			if faction.id == 2 
				and sweden.alliance.id == 0
				and norway.alliance.id == 0
				and factor < gfactor then	
				factor = gfactor
				
				if germany.luaData.blockaded == 0 
					and norway.alliance.id == 0
					and norway.luaData.alignment < 25 then
					factor = factor + 0.1
				end
				if  sweden.luaData.alignment < 25 
					and sweden.alliance.id == 0 then
					factor = factor + 0.1
				end
				if factor > 1 then
					factor = 1
				end
			end

			-----------FRANCE and BRITAIN-------------
			if  (faction.id == 0 or faction.id == 1) 
				and player.alliance.id == 2 
				and game.type == Game.TYPE_SINGLE then -- BONUS for ENT in SP vs ENT AI
				if factor < entfactor then
					factor = entfactor
				end
			
			elseif 	(faction.id == 0 or faction.id == 1) 
				and ((player.alliance.id == 1 and game.type == Game.TYPE_SINGLE) 
						or game.type == Game.TYPE_PBEM) then -- MALUS for ENT in MP or SP vs CP AI
				if factor > entfactor then
					factor = entfactor
				end
			end
			
			if GetEvent("DOWbrazil") >0 and (faction.id == 0 or faction.id == 1) then
				factor = factor + 0.1
				if factor >1 then
					entfactor = 1
				end
				entente.luaData.DP = entente.luaData.DP + math.random(1,3)
			end
		---------------PRODUSCTION BONUS------------------	
			local cargobonus = unit.hp *factor
			LogUi("$$$$$$$$$$$$$$$$$$$$ CONVOY BONUS $$$$$$$$$$$$$$$$$$$$:" .. cargobonus)
			faction:ConsumeProductionPoints(-(unit.hp * factor))
            faction:ConsumeManpower(-unit.hp * 0.2)
			impassable.luaData.convoyfactor = 0.1 * (math.random(1,10))
-------------------GERMANY----------------------------------------------
			if faction.id == 2 then
				cp.luaData.convoyfactor = 0.1 * math.random(1,10)
				if germany.morale < 50  and germany.luaData.collaps >0 then
					ChangeFactionMorale(germany, math.random(0, germany.luaData.collaps)) -- test
				end
			
				if unit.hp >= 70 then
					germany:ConsumeAmmo(- 3)
				elseif unit.hp <= 30 then
					germany:ConsumeAmmo(- 1)
				else
					germany:ConsumeAmmo(- 2)
				end
				ui.resourcesPanel:Refresh()
				cp.luaData.DP = cp.luaData.DP + math.random(1, (math.ceil(math.sqrt(game.turn))))
			end
-----------------------FRANCE---------------------------------------------
			if faction.id == 0 and france.luaData.collaps < 10 then
				entente.luaData.convoyfactor = 0.1 * math.random(1,10)
			
				if france.morale < 50 then
					ChangeFactionMorale(france, math.random(1,(10 - (france.luaData.collaps)))) -- test
					france:ConsumeManpower(- (math.random(10,20)))
				end		  

				LogUi("+++ A CONVOY HAS REACHED FRANCE! +++")
				france.luaData.convoysarrived = france.luaData.convoysarrived +1
				entente.luaData.DP = entente.luaData.DP + math.random(1, math.ceil(math.sqrt(game.turn /2)))
			end
-----------------------BRITAIN----------------------------------------------
		if faction.id == 1 then
				entente.luaData.convoyfactor = 0.1 * math.random(1,10)
			 	britain.luaData.convoysarrived = britain.luaData.convoysarrived +1
				LogUi("+++ A CONVOY HAS REACHED ENGLAND! +++")

				if britain.luaData.britishsupply > 0 
					and britain.morale < 90 
					and GetEvent("Rationing") >0  then
					ChangeFactionMorale(britain, math.random((britain.luaData.britishsupply), (britain.luaData.britishsupply *2))) -- test
					entente.luaData.DP = entente.luaData.DP + math.random(1, math.ceil(math.sqrt(game.turn /2)))
				end
				
				
			if britain.luaData.britishsupply <= 4 then
				if GetEvent("MurmanConvoys") >0 
					and GetEvent("RussiaSupplyCrisisEnd") == 0 
					and russia.alliance.id == 1 then
						if math.random(1,100) >= 50  -- only 50% chance for +1 supply
							and math.random(1,100) <= unit.hp then
								britain.luaData.britishsupply = britain.luaData.britishsupply + 1
						end
				elseif math.random(1,100) <= unit.hp then
						britain.luaData.britishsupply = britain.luaData.britishsupply + 1
				end
			end
					
			if  russia.alliance.id == 1 
				and GetEvent("Surrenderfrance") >0 
				and GetEvent("MurmanConvoys") >0 
				and britain.luaData.britishsupply >0 
				and (gameplay.winter == 0 
					or (gameplay.winter == 1 and math.random(1,100) < game.turn)) then
					local abonus = math.floor(math.sqrt(game.turn))
					local bbonus = math.ceil(math.sqrt(game.turn) * (britain.luaData.britishsupply +1))
						russia:ConsumeManpower(- (math.random(abonus, bbonus)))
						ChangeFactionMorale(russia, (math.random(1,6)))
			end
		end
			
----- disband convoys -------			
            unit:Kill()
			ui.resourcesPanel:Refresh()

            break
          end
        end
        if not arrived then
          -- Move convoy automatically
          -- For player only! AI should do the same in AI scripts
          if alliance.id == playerAlliance.id then
            table.insert(gameplay.convoys, unit)
          end
        end
      end
    end
  end

  -- Convoy movement
  if not GetGameOver() then
    ui.disableControls = false
		if alliance.id == playerAlliance.id then
		  ui.mainPanel.blockingPanel:Popup("convoy")
		  GoToNextConvoy(gameplay.convoys)
		end
  else
    ui.disableControls = true
  end

end


function MoveNextConvoy(convoys)

  if #convoys > 0 then

    local convoy = convoys[1]

    -- Kill off convoy that's stuck in arabian gulf
    if convoy.hex.region == 7 then
      if GetHex(130, 66).faction.alliance.id ~= 1 or GetHex(130, 67).faction.alliance.id ~= 1 or GetHex(130, 68).faction.alliance.id ~= 1 then
        convoy:Damage(35)
      end
    end

    if convoy.alive then
      local destination = FindNearestConvoyPort(convoy)
      if destination ~= nil then
        --convoy.mp = math.ceil(convoy.mp * math.random(8,10) / 10)
        GetPlayer():MoveUnit(convoy, destination)
        LookAtWrapper(convoy.hex)
      end
    end

  end

  table.remove(convoys, 1)
end

function GoToNextConvoy(convoys)
  if #convoys > 0 then
    local convoy = convoys[1]
    LookAtWrapper(convoy.hex)

    engine:ScheduleTask(1000, function() MoveNextConvoy(convoys) end)
    engine:ScheduleTask(3000, function() GoToNextConvoy(convoys) end)
  elseif game.currentAlliance.id == playerAlliance.id then

    -- Turn report
    ui.mainPanel.blockingPanel:Hide()

    if game.turn > 1 or game.currentAlliance.id ~= startingAlliance then
      ui.newsPaper:Refresh(0)
      ui.turn_report:Show()
      ui.messageQue:ShowNext()
    else
      -- Advice messages
      AdviceTurnStart()
    end

    -- Activate for auto end turn
    --engine:ScheduleTask(1000, EndTurnProcess)
  end
end

function DefineConvoy(faction, x, y, cargo, interval, spawnturn, blockadable)
  if blockadable == nil then
    blockadable = 0
  end

  faction = game:GetFactionById(faction)

  local convoy =
  {
    unit = -1,
    x = x,
    y = y,
    cargo = cargo,
    interval = interval,
    spawnturn = spawnturn,
    blockadable = blockadable
  }
  table.insert(faction.luaData.convoys, convoy)
end

function ConvoySpawn(faction, x, y, facing, resources)
  local succes = false

  -- Check if hex OR adjacent hex is unoccupied
  local hex = GetHex(x, y)
  if hex.unit == nil then
    succes = true
  else
    for i = 0, 5 do
      hex = GetAdjacent(x, y, i)
      if hex ~= nil then
        if hex.unit == nil and hex.terrain.type == Terrain.WATER then
          succes = true
          break
        end
      end
    end
  end

  if succes then
	
    SpawnUnit(11, faction, x, y, facing, resources)

    return hex
  else
    return -1
  end
end

function FindNearestConvoyPort(unit)

  local distance = 100000
  local hex
  for construction in unit.faction.constructions do
    if construction.hex.x > 32 
		and construction.hex.y < 45 
		and construction.type == Construction.TYPE_PORT 
		and construction.city.hex.originalFaction.id == unit.faction.id then
      
	  local newDistance = unit.hex:Distance(construction.hex)
      if distance > newDistance then
        hex = construction.hex
        distance = newDistance
      end
    end
  end
  return hex

end
