function OnUnitNotMoved(unit)
  print("unit was blocked" .. unit.id)
  if unit.hex ~= nil and playerAlliance:IsVisible(unit.hex) then
    MoveSound(unit, 0)

    if unit.alliance.id ~= playerAlliance.id and unit.hex ~= nil then
      followTurn(unit.hex)
    end

    if unit.alive and unit.faction.alliance.id == playerAlliance.id and game.currentAlliance.id == playerAlliance.id and not ui.disableControls then
      ui.SelectHex(unit.hex)
    end
  end
end

function undoSave(name, undo, table)
  undo:Set(name, table[name])
end

function OnUnitMoved(unit, from, moveType, path, undo)
local germany = game:GetFactionById(2)
local impassable = game:GetFactionById(24)

local to = path[#path]

  if to ~= nil 
		and unit.alliance.id ~= playerAlliance.id 
			or (moveType == 3 
				and from.faction ~= nil 
				and from.faction.alliance.id ~= playerAlliance.id) then
    if unit.visible then
      if moveType == 2 then
        showMovement(from,to,MoveLogType.Swap,path)
      elseif moveType == 3 and unit.ap == 0 and unit.range == 1 then
        showAttack(from,to,MoveLogType.Advance,path)
      elseif moveType == 1 then
        showMovement(from,to,MoveLogType.Rail,path)
      else
        showMovement(from,to,nil,path)
      end
    end
  end

  undo:SetBool("railMove", moveType == 1)
  -- Consume Railroad move
  if moveType == 1 then
    undoSave("railmovesCurrent", undo, unit.faction.luaData)
    
	if from.faction ~= nil then
	--	LogUi("FROM:" .. from.faction.id)
	end
	--LogUi("TO: " .. unit.hex.originalFaction.id) 
    if GetEvent("RhineBridges") >0 
	--	and germany.luaData.bridgeok == 1
		and unit.alliance.id == 2
		and from.faction.id ~= nil
		and (from.faction.id == 2
				or from.faction.id == 3)
		and (unit.hex.originalFaction.id == 6
			or unit.hex.originalFaction.id == 0) then
	else
		UseRailmove(unit.faction)
	end
	if unit.faction.alliance.id == playerAlliance.id then
      ui.resourcesPanel:Refresh()
    end

    undoSave("repaired", undo, unit.luaData)
    undoSave("upgraded", undo, unit.luaData)
    
    -- Can't upgrade/repair after railmove
    unit.luaData.repaired = game.turn
    unit.luaData.upgraded = game.turn
  end

  undo:SetInt("ap", unit.ap)
  -- Railroad moves OR Artillery & Air lose ability to attack
  if not CanUnitAttackAfterMove(unit) or (moveType == 1 and unit.prototype.lua.chassis ~= "rail") then
    unit.ap = 0
  end

  -- When unit has moved
  if (from ~= nil) then
    -- Clear advance hex
    if gameplay.advanceUnit ~= nil and gameplay.advanceUnit.faction.alliance.id == unit.faction.alliance.id then
      undo:SetInt("gameplay.advanceUnit", gameplay.advanceUnit.id)
      undo:SetInt("gameplay.advanceHexX", gameplay.advanceHex.x)
      undo:SetInt("gameplay.advanceHexY", gameplay.advanceHex.y)
      gameplay.advanceUnit = nil
      gameplay.advanceHex = nil
    end

    if unit.visible and (to ~= nil and playerAlliance:IsVisible(to)) or playerAlliance:IsVisible(from) then
      MoveSound(unit, moveType)
    end
	if unit.type == Unit.NAVAL and unit.luaData.endurance == nil then
		unit.luaData.endurance = 10
	end
	  if  unit.type == Unit.NAVAL 
			and unit.luaData.endurance ~= nil 
			and unit.luaData.endurance >= 1 then
				local subtest  = math.random(1,15)
				if unit.commander ~= nil then
					local commander = unit.commander
					local range = data.commanders[commander.id+1].range
					subtest = subtest - math.random(0, range)
				end
				LogUi("SUBTEST:" .. subtest)
				if subtest  >= unit.luaData.endurance 
					or (impassable.luaData.winter == 1 
						and unit.prototype.name ~= "submarine")  	then
							unit.luaData.endurance = unit.luaData.endurance - 1
				end
	  end	
  end

  --MoveCommander(unit, from)

  --MoveConvoy(unit)

  -- Should be move to UI OnUnitMoved!
  if unit.alive and unit.faction.alliance.id == playerAlliance.id and game.currentAlliance.id == playerAlliance.id and not ui.disableControls then
    if ui.swappedHex == nil then
      ui.SelectHex(unit.hex)
    else
      ui.SelectHex(ui.swappedHex)
    end
    RefreshUnitStats(unit, "stats_panel", 1)
  end

  if unit.alive then
    undo:SetInt("efficiency", unit.efficiency)
    DamageEfficiency(unit, GetMoveEfficiencyLoss(unit, to, moveType == 1))

    undoSave("lastAction", undo, unit.luaData)
    undoSave("lastActionTurn", undo, unit.luaData)
    undoSave("lastActionId", undo, unit.luaData)
    SetUnitAction(unit)
    
    UnitNoEntrenchTurn(unit)

    AdviceMove(unit)

    TriggerMoveEvents(unit)
  end
  
end

function undoLoad(name, undo, table)
  table[name] = undo:Get(name)
end

function OnUnitMoveUndo(unit, undo)
 -- LogUi("Move UNDO unit#" .. tostring(unit.id))
  
  if undo:GetBool("railMove") then
    undoLoad("railmovesCurrent", undo, unit.faction.luaData)
    undoLoad("repaired", undo, unit.luaData)
    undoLoad("upgraded", undo, unit.luaData)

  end
  
  unit.ap = undo:GetInt("ap")
  
  if undo:Has("gameplay.advanceUnit") then
    gameplay.advanceUnit = GetUnitById(undo:GetInt("gameplay.advanceUnit"))
    local ax = undo:GetInt("gameplay.advanceHexX")
    local ay = undo:GetInt("gameplay.advanceHexY")
    gameplay.advanceHex = GetHex(ax, ay)
  end
  
  if unit.alive then
    unit.efficicncy = undo:GetInt("efficiency")

    undoLoad("lastAction", undo, unit.luaData)
    undoLoad("lastActionTurn", undo, unit.luaData)
    undoLoad("lastActionId", undo, unit.luaData)
  end
  
  GetPlayer():DeselectUnit()
 
end

function MoveCommander(unit, from)

  if unit.commander ~= nil then
    local range = data.commanders[unit.commander.id+1].range

    -- Clear previously affected units
    if from ~= nil then
      for x = -range, range do
        for y = -range, range do
          local hex = GetHex(from.x + x, from.y + y)
          if hex ~= nil and hex.unit ~= nil and hex.unit.alive then
            if unit.commanderInfluence == unit.commander.id then
              --unit.commanderInfluence = nil
            end
          end
        end
      end
    end

    -- Affect units now in range
    for x = -range, range do
      for y = -range, range do
        local hex = GetHex(unit.hex.x + x, unit.hex.y + y)
        if hex ~= nil and hex.unit ~= nil and hex.unit.alive then
          if hex.unit.faction.id == unit.faction.id then
            if unit.hex:Distance(hex) <= range then
              unit.commanderInfluence = unit.commander.id
            end
          end
        end
      end
    end

  end

end


-- Play movement sound
function MoveSound(unit, moveType)
  local sfx = {}
  local counter = 0
if unit.commander ~= nil then
	if unit.prototype.name ~= "infantry" 
		and unit.prototype.name ~= "garrison"	then
	
	
		if math.random(1,100) >= 51 then
			sfx = LoadSample("interference1.wav")
			PlaySample(sfx)
		else
					sfx = LoadSample("interference2.wav")
			PlaySample(sfx)
		end
	
	else
			sfx = LoadSample("landcommander.wav")
			PlaySample(sfx)
	
	end
	end
	if unit.prototype.name == "infantry" 
			and unit.faction.id == 1 
			and math.random(1,10) == 10 
			and unit.hex.y < 40 then
				if math.random(1,100) >= 51 then
					sfx = LoadSample("bagpipes1.wav")
					PlaySample(sfx)
				else
					sfx = LoadSample("bagpipes2.wav")
					PlaySample(sfx)
				end
	
	end
	
  if moveType ~= 1 then
	
    local i
    for i=0,3 do
      if engine:FileExists("sound", unit.prototype.name .. "_move_" .. (i+1) .. ".wav") then
        sfx[i] = LoadSample(unit.prototype.name .. "_move_" .. (i+1) .. ".wav")
        counter = counter + 1
      else
        break
      end
    end
  end
  if moveType == 1 then
    local i
    for i=0,5 do
      sfx[i] = LoadSample("train_move_" .. (i+1) .. ".wav")
      counter = counter + 1
    end
  end

  if counter > 0 then
    PlaySample(sfx[math.random(0, (counter - 1))])
  end
end

-- Check if convoy reaches port
function MoveConvoy(unit)

  if unit.alive and unit.hex.construction ~= nil and unit.prototype.name == "convoy" then
    if unit.hex.construction.type == Construction.TYPE_PORT then
      unit.faction:ConsumeProductionPoints(-unit.hp)
      unit:Kill()
      unit:Damage(unit.hp)
    end
  end

end

function CanUnitAttackAfterMove(unit) -- chance for mudded units to at least move away
local impassable = game:GetFactionById(24)

  if unit.prototype.lua.class == "air" 
	or unit.prototype.lua.class == "artillery" 
	or unit.prototype.name == "transport" 
	or (impassable.luaData.mud == game.turn 
		and unit.luaData.mud ~= nil 
		and unit.luaData.mud == game.turn) then
    return false
  else
    return true
  end
end

-- Have to pass actual embark function because it differs between AI and player(UI)
function EmbarkUnit(unit, hex, embarkFunc)
  embarkFunc(unit, hex)
  local result = unit.state == Unit.STATE_EMBARKED

  if result ~= false then
    local cargoHp = unit.hp
    if cargoHp ~= hex.unit.hp then
      hex.unit:Damage(hex.unit.hp - cargoHp)
    end

    UseTransportmove(unit.faction)

    -- Sound effect
    if playerAlliance:IsVisible(hex) then
      PlaySample(sEmbark)
    end
  end

  return result
end

-- Have to pass actual disembark function because it differs between AI and player(UI)
function DisembarkUnit(unit, hex, disembarkFunc)
local usa = game:GetFactionById(10)

  
  disembarkFunc(unit, hex)
  local result = unit.state ~= Unit.STATE_EMBARKED

  if result then
    hex.unit.ap = 0

    -- Sound effect
    if playerAlliance:IsVisible(hex) then
      PlaySample(sDisembark)
    end
  end
	if GetEvent("BefTwo") == 0 then
		BefTwo(hex)
	end
	if GetEvent("ArmyOrient") == 0 then
		ArmyOrient(hex)
	end

	if GetEvent("USALanded") == 0 and usa.alliance.id == 1 then
		USALanded(hex)
	end
	
  return result
end


function IsTerrainValidForUnit(hex, unit)
  for _, chassis in pairs(data.chassis) do
    if chassis.name == unit.prototype.lua.chassis  then
      
	  if unit.prototype.lua.levels[1].mp >= chassis.costs[hex.terrain.name]  then
        if unit.prototype.lua.chassis ~= "rail" or hex.hasRailroad then
          return true
        end
      end
      return false
    end
  end
end

function GetMoveEfficiencyLoss(unit, hex, railMove)
local wesel = game:GetHex(90, 25)  
local mainz = game:GetHex(91, 28)
local Metz = game:GetHex(89, 29)
local germany = game:GetFactionById(2)

  
  if hex == nil then
    hex = unit.hex
  end

  local loss = 0

  if railMove and unit.alliance.id == player.alliance.id then
    -- Efficiency loss
    if GetEvent("RhineBridges") >0 
		and GetEvent("RhineBridges") + germany.luaData.bridges  <= game.turn
		and wesel.alliance.id == 2 
		and mainz.alliance.id == 2
		and Metz.alliance.id == 2
		and unit.alliance.id == 2
		and unit.hex.originalFaction.id == 6 then
		
	loss = 0

	else	
		loss = gameplay.RailmoveEfficiencyLoss
	end
	--LogUi("X:" .. hex.x .. "/Y:" .. hex.y)
  else

    -- Land and Air units lose efficiency from movement
    if unit.type ~= Unit.NAVAL then
     loss = gameplay.MoveEfficiencyLoss

      -- Winter effect
      if hex ~= nil and GetClimate() > hex.climate and hex.y <= 51 then --and (unit.alliance.id == player.alliance.id or (game.type == Game.TYPE_SINGLE and unit.alliance.id ~= player.alliance.id and unit.faction.id ~=4 ) ) then
        loss = loss + gameplay.WinterEfficiencyPenalty
	--	LogUi("COLD!")
      end
	
		--- Desert/Dunes effect
		
					if hex ~= nil 
						and hex.terrain.name == "dunes" 
						and hex.construction == nil
						and unit.prototype.name ~= "arabcavalry" 
						and unit.prototype.name ~= "arabinfantry" 
						and unit.prototype.name ~= "arabgarrison" then
								if unit.luaData.experience == nil then
									unit.luaData.experience = 0
								end
								
								if (unit.alliance.id == 2 and math.random(1,200) > unit.luaData.experience) 
								 or (unit.alliance.id == 1 and GetEvent("Pipeline") == 0) then		
									loss = loss + math.random(2,3) * 10
									
									if (hex.alliance.id == unit.alliance.id) or gameplay.winter == 1 then
										local thirst = 1 + (0.1 * math.random(1,10))
										loss = loss / thirst
									--	LogUi("NOT THIRSTY!")
									end
								end
					end
					if hex ~= nil 
						and hex.terrain.name == "desert" 
						and hex.construction == nil
						and unit.prototype.name ~= "arabcavalry" 
						and unit.prototype.name ~= "arabinfantry" 
						and unit.prototype.name ~= "arabgarrison" then
									if unit.luaData.experience == nil then
										unit.luaData.experience = 0
									end
									
									if (unit.alliance.id == 2 and math.random(1,200) > unit.luaData.experience) 
										or (unit.alliance.id == 1 and GetEvent("Pipeline") == 0) then		
											loss = loss + math.random(1,2) * 10
											--LogUi("DESERT THIRSTY!")
												if (hex.alliance.id == unit.alliance.id) or gameplay.winter == 1 then
													local thirst = 1 + (0.1 * math.random(1,10))
													loss = loss / thirst
												--	LogUi("NOT THIRSTY!")
												end
									
									
									end
					end
	
	end
  end

  return loss
end
