gameplay.repairDiscountFactor = 0.2

function CanRepairUnit(unit)

  if unit.prototype.name == "transport" or unit.prototype.name == "convoy" or unit.faction.alliance.id ~= game.currentAlliance.id then
    return false
  end

  if unit.alive and (unit.prototype.name ~= "smallgarrison" and unit.hp < 91 or (unit.prototype.name == "smallgarrison" and unit.hp <= 40)) and unit.luaData.repaired < game.turn and unit.supply > 0 then
    if unit.type == Unit.NAVAL then
      -- Naval units can only be repaired in port
      if unit.hex.construction ~= nil and unit.hex.construction.city.hex.faction.alliance.id == unit.alliance.id then
        return true
      end
    else
      return true
    end
  end
  return false

end

function RepairUnit(unit)
  local PPcost, MPcost = GetRepairCost(unit)

  local repairValue = GetRepairPoints(unit)
  local repairPoints = GetRepairPoints(unit)
  if repairValue == 0 then
    -- can't repair no supply unit
    return false
  end

  if (unit.faction.pp >= PPcost or (unit.alliance.id ~= 0 and unit.alliance.id ~=  player.alliance.id and game.type == Game.TYPE_SINGLE)) and unit.faction.mp >= MPcost then
    if unit:Repair(repairValue) then
			if unit.alliance.id ~= 0 
				and unit.alliance.id ~=  player.alliance.id 
				and game.type == Game.TYPE_SINGLE 
				and unit.efficiency ~= nil 
				and unit.efficiency <= 80 then
					DamageEfficiency(unit, -20)
			end
      unit.faction:ConsumeProductionPoints(PPcost)
      unit.faction:ConsumeManpower(MPcost)
      unit.luaData.repaired = game.turn
	 -- LogUi("MOIN!")
		ExperienceRepair(unit, repairPoints)
      return true
    end
  end

  return false
end

function GetRepairCost(unit)
  local britain = game:GetFactionById(1)
  local pointsRepaired= GetRepairPoints(unit)

  local PPcost = math.ceil(unit.prototype.costPP * (pointsRepaired) / 100 * gameplay.repairDiscountFactor)
  local MPcost = math.ceil(unit.prototype.costMP * (pointsRepaired) / 100)

  -- Repairing half supply doubles cost
  if unit.supply == 1 then
    PPcost = PPcost * 2
    MPcost = MPcost * 2
  end
  if unit.hex ~= nil then
	if (unit.hex.terrain.name == "mountain" 
		or unit.hex.terrain.name == "dunes") 
		and unit.hex.originalFaction.alliance.id ~= unit.alliance.id 
		and unit.commander == nil  then
			PPcost = PPcost * 1.5
	end
	if (unit.hex.terrain.name == "swamp" 
			or unit.hex.terrain.name == "desert" 
			or unit.hex.terrain.name == "difficult") 
		and unit.hex.originalFaction.alliance.id ~= unit.alliance.id 
		and unit.commander == nil then
			PPcost = PPcost * 1.25
	end
  end
  
	if (unit.prototype.name == "arabinfantry"
		or unit.prototype.name == "arabcavalry" 
		or unit.prototype.name == "arabgarrison")
		and unit.alliance.id == 2 then
			PPcost = 0
			MPcost = 0
	end
	if unit.prototype.name == "infantry" 
		and unit.faction.id == 1
		and GetEvent("PalsBattalions") == 0 then
		MPcost = MPcost *3
	end		
	
  return PPcost, MPcost
end

function GetRepairPoints(unit, moved)

  if moved == nil then
    moved = unit.mp == 0
  end

  local repairValue
  if unit.supply == 2 and unit.mp > 0 then
    repairValue = gameplay.RepairFull

    if unit.prototype.name == "dreadnought" 
	   or unit.prototype.name == "battlecruiser" then
	 --  or unit.prototype.name == "armour" 	then
      repairValue = gameplay.RepairDreadnought
    end
  elseif unit.supply >= 1 then
    repairValue = gameplay.RepairHalf
    if unit.prototype.name == "dreadnought" 
		or unit.prototype.name == "battlecruiser"	then
      repairValue = gameplay.RepairDreadnought
    end
  else
    return 0
  end

  local pointsRepaired = 100 - unit.hp
	if repairValue + unit.hp > 100  then
	repairValue = 100 - unit.hp
	end
	if unit.prototype.name == "submarine" then
		repairValue = 100
	end

  return repairValue

end
