gameplay.researchSpeed = 10
gameplay.researchBoost = 15

function InitResearch()

  -- Tech stuff
  for faction in game.factions do

    faction.luaData.focusPoints = 2

    faction.luaData.researchUnlocked = {}  -- Is tech unlocked
    faction.luaData.researchProgress = {}  -- Current progress on tech research
    faction.luaData.researchComplete = {}  -- Is tech completed true/false

    for techName, _ in pairs(data.newTechnologies) do
      faction.luaData.researchUnlocked[techName] = 0
      faction.luaData.researchProgress[techName] = 0
      faction.luaData.researchComplete[techName] = 0
    end

    local unitTypes =
    {
      "garrison",
      "infantry",
      "cavalry",
      "artillery",
      "railgun",
      "armouredcar",
      "armouredtrain",
      "armour",
      "fighter",
      "bomber",
      "zeppelin",
      "armouredcruiser",
      "lightcruiser",
      "pre-dreadnought",
      "dreadnought",
      "submarine",
	  "battlecruiser"
    }

--~     faction.luaData.unitLevel = {}
--~     for _, unittype in pairs(unitTypes) do
--~       faction.luaData.unitLevel[unittype] = 1
--~     end

    faction.luaData.labs = {}
    faction.luaData.labs["ground"] = 0
    faction.luaData.labs["artillery"] = 0
    faction.luaData.labs["air"] = 0
    faction.luaData.labs["naval"] = 0
    faction.luaData.labs["armour"] = 0
    faction.luaData.currentTech = {}
    faction.luaData.currentTech["ground"] = -1
    faction.luaData.currentTech["artillery"] = -1
    faction.luaData.currentTech["air"] = -1
    faction.luaData.currentTech["naval"] = -1
    faction.luaData.currentTech["armour"] = -1

    faction.luaData.factionTechs = {}
  end

  SetUnitStartingLevels()

  --PrintTechInfo()

end

function PrintTechInfo()

  local function LocalGetDate(turns)
          local days = 0
          if turns >= 5 then
            days = 4 * 7 + (turns - 4) * 14
          else
            days = turns * 7
          end

          local day = game.date.day
          local month = game.date.month
          local year = game.date.year
          if game.date.year == 1914 then
             day = 23
             month = 7
             year = 1914
          end

          local months = {
            "jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec"
          }

          while true do
            if month == 2 then
              daysInMonth = 28
            elseif month <= 7 then
              if month % 2 == 0 then
                daysInMonth = 30
              else
                daysInMonth = 31
              end
            else
              if month % 2 == 0 then
                daysInMonth = 31
              else
                daysInMonth = 30
              end
            end
            if day + days <= daysInMonth then
              day = day + days
              break
            else
              days = days + day - daysInMonth
              day = 0
              month = month + 1
              if month == 13 then
                month = 1
                year = year + 1
              end
            end
          end

          local date = "" .. day .. "/"..months[month].."/"..year
          return date
        end

  local techLines = {}

  --for techClass, _ in pairs(data.techLines) do
techClass = "air"
   -- LogUi(" ")
   -- LogUi(" ")
   -- LogUi("*** CATEGORY ".. techClass .. " ***")
    for i, techLine in pairs(data.techLines[techClass]) do
     -- LogUi(" ")
     -- LogUi("  LINE ".. i .. " ----------")
      local previousTech = nil
      local timeTotal = 0
      for k, techName in pairs(techLine) do
        if k ~= "event" then

       --   LogUi(" ")
        --  LogUi("   TECH "..techName)

          timeTotal = timeTotal + data.newTechnologies[techName].time
          --LogUi("      Turns: " .. turns)

          for labs = 1, 6 do

        --   local labIncrement = ((labs-1)/3)/math.sqrt(1+math.pow((labs-1)/3,2))*3
           local labIncrement = ((labs-1)/2)/math.sqrt(1+math.pow((labs-1)/3,2)) *5
            
			local totalIncrement = gameplay.researchSpeed + labIncrement

            local turns = math.ceil(timeTotal / totalIncrement)

            local boost = totalIncrement * 20 / 100
            local turnsBoosted = math.ceil(timeTotal / (totalIncrement + boost))

            LogUi("      "..labs.." Labs: " .. LocalGetDate(turns) .. " (" .. turns ..  ") " .. LocalGetDate(turnsBoosted) .. " (" .. turnsBoosted ..  ") ")
          end

--~           timeTotal = timeTotal + data.newTechnologies[techName].time
--~           turns = timeTotal / (gameplay.researchSpeed + boost)
--~           LogUi("      Boosted Turns: " .. turns)

--~           LogUi("      Boosted Date: " .. LocalGetDate(timeTotal / gameplay.researchSpeed))

          if previousTech ~= nil then
            data.newTechnologies[techName].requirement = previousTech
          end
          previousTech = techName
        end
      end
    end
  --end
  LogUi(" ")
  LogUi(" ")
end

function CreateExtraTechInfo()
  -- Create additional info for techs
  local techLines = {}
  for techClass, _ in pairs(data.techLines) do
    for i, techLine in pairs(data.techLines[techClass]) do
      local previousTech = nil
      for k, techName in pairs(techLine) do
        if k ~= "event" then
          data.newTechnologies[techName].tier = k
          data.newTechnologies[techName].line = techLine
          data.newTechnologies[techName].class = techClass
          if previousTech ~= nil then
            data.newTechnologies[techName].requirement = previousTech
          end
          previousTech = techName
        end
      end
    end
  end
end


-- Lab boost function graph:
-- (x/4)/sqrt(1+(x/4)^2)*8
-- http://fooplot.com/#W3sidHlwZSI6MCwiZXEiOiIoeC80KS9zcXJ0KDErKHgvNCleMikqOCIsImNvbG9yIjoiIzAwMDAwMCJ9LHsidHlwZSI6MTAwMCwid2luZG93IjpbIjAiLCIxMiIsIjAiLCI4Il19XQ--
function ManageResearch(force, fakeTurn)
  if game.turn > 1 or force then

    local techCategories = {"ground", "artillery", "air", "naval", "armour"}
    local techName
    for alliance in game.alliances do
      for faction in alliance.factions do

        -- Randomised progress every 5 (was 10) turns
           if game.turn % 5 == 0 or game.turn == 2 then ----------        if game.turn % 10 == 0 or game.turn == 2 then
          for _, techClass in pairs(techCategories) do
--~           if IsTechCategoryAvailable(category, faction) then
            if GetCategoryTechlineCount(faction, techClass) > 0 then

              local  randomTech = 1
              if GetCategoryTechlineCount(faction, techClass) > 1 then
                local randomTech = math.random(1, GetCategoryTechlineCount(faction, techClass))
              end
              local techCount = 0
              local techName
              for i, techLine in pairs(data.techLines[techClass]) do
                for _, t in pairs(techLine) do
                  if IsTechAvailable(t, faction) then
                    techCount = techCount + 1
                    techName = t
                    break
                  end
                end
                if techCount > 0 and techCount == randomTech then
                  faction.luaData.researchProgress[techName] = faction.luaData.researchProgress[techName] + 1
--~                   LogUi(faction.name .. ": Random progress tech " .. techName)
                  break
                end
              end
            end
--~           end
          end
        end

        -- Amount of focux points used counter
        local focusPointsUsed = 0

        -- Get list of techs faction can currently research
        local techsTable = GetAvailableTechs(faction, fakeTurn)

        -- Go through all these techs
        for _, techName in pairs(techsTable) do

          -- Get tech's class
          local techClass = data.newTechnologies[techName].class

          -- Only progress if class has at least 1 lab
          if faction.luaData.labs[techClass] > 0 then

            local totalIncrement = GetTechIncrement(faction, techName)

            if faction.luaData.currentTech[techClass] == techName then
              focusPointsUsed = focusPointsUsed + 1
            end

            faction.luaData.researchProgress[techName] = faction.luaData.researchProgress[techName] + totalIncrement

          end

        end

        -- check for completion
        for _, techName in pairs(techsTable) do
          if faction.luaData.researchProgress[techName] >= data.newTechnologies[techName].time then
            ApplyTechnology(faction, techName)
          end
        end

        for _, techClass in pairs(techCategories) do
          -- Clear current tech
          if faction.luaData.currentTech[techClass] ~= -1 and faction.luaData.researchComplete[faction.luaData.currentTech[techClass]] ~= 0 then
            faction.luaData.currentTech[techClass] = -1
            faction.luaData.focusPoints = faction.luaData.focusPoints + 1
            focusPointsUsed = focusPointsUsed - 1
          end

          -- Unfocus remaining tech in category is it is now the last one there
          if GetCategoryTechlineCount(faction, techClass) == 1 then
            if faction.luaData.currentTech[techClass] ~= -1 then
              faction.luaData.currentTech[techClass] = -1
              faction.luaData.focusPoints = faction.luaData.focusPoints + 1
              focusPointsUsed = focusPointsUsed - 1
            end
          end
        end

        -- return unused focus points
        if game.date.month % 6 == 0 then
          faction.luaData.focusPoints = GetTotalLabs(faction) / 2 + 2 - focusPointsUsed
        end

      end
    end

  end
end

function GetTechIncrement(faction, techName)

  local techClass = data.newTechnologies[techName].class

  -- Research speed bonus starts from 2 labs, 0 at 1 lab
  local labs = faction.luaData.labs[techClass] - 1

  -- Lab research speed bonus calculation
  --FIXME: should not be "labs - 1" AGAIN here, but change requires resetting of all tech times
 -- local labIncrement = ((labs-1)/3)/math.sqrt(1+math.pow((labs-1)/3,2))*3
 local labIncrement = ((labs-1)/2)/math.sqrt(1+math.pow((labs-1)/3,2)) *3
          
  
  -- Total progress of tech this turn
  local totalIncrement = gameplay.researchSpeed + labIncrement

  -- If there currently is a focused tech in this tech class
  if faction.luaData.currentTech[techClass] ~= -1 then

    -- If the current tech is the focused techn speed bonus
    if faction.luaData.currentTech[techClass] == techName then

      -- 20% increase
      local boost = totalIncrement * 20 / 100

      totalIncrement = totalIncrement + boost

    -- If another tech is focused, speed is slowed down
    else

      local loss
      -- This should never happen cos if there is only 1 tech left than there cant be another thats being focused
      if GetCategoryTechlineCount(faction, techClass) == 1 then
        loss = 0
      else
        loss = (totalIncrement * 20 / 100) / (GetCategoryTechlineCount(faction, techClass) - 1)
      end

      totalIncrement = totalIncrement - loss

    end

  end

  return totalIncrement
end

-- Set unit starting levels, based on "level" value in units.lua
function SetUnitStartingLevels()
  for alliance in game.alliances do
    for faction in alliance.factions do
      faction.luaData.unitLevel = {}
      for _, protoInfo in ipairs(faction.unit_prototypes) do
        prototype = game:GetUnitPrototype(protoInfo.prototype)
        if prototype.lua.level ~= nil then
          --print("set armour level to " .. prototype.lua.level)
          --faction:UnlockUnitLevel(2, prototype.lua.level)
          faction.luaData.unitLevel[prototype.name] = 0
        else
          faction.luaData.unitLevel[prototype.name] = 1
        end
      end
    end
  end
end

function ApplyTechnology(faction, techName)
  -- cancel if already unlocked
  if faction.luaData.researchProgress[techName] == data.newTechnologies[techName].time then
    return false
  end
  faction.luaData.researchProgress[techName] = data.newTechnologies[techName].time

  if game.turn > 0 then
    faction.luaData.researchComplete[techName] = game.turn
  else
    faction.luaData.researchComplete[techName] = 1
  end
  --faction.luaData.researchPurchased[techName] = 1
  -- Increase unit level
  if data.newTechnologies[techName].level == true then
    local j = 1
    while data.newTechnologies[techName].unitTypes[j] ~= nil do
      local unit = data.newTechnologies[techName].unitTypes[j]
      -- Check if faction has this unit type
      if faction.luaData.unitLevel[unit] ~= nil then
        faction.luaData.unitLevel[unit] = faction.luaData.unitLevel[unit] + 1
        faction:UnlockUnitLevel(game:GetUnitPrototype(unit).id, faction.luaData.unitLevel[unit])
      end
      j = j + 1
    end
  end
  faction.luaData.factionTechs[#faction.luaData.factionTechs+1] = techName

  -- Faction related techs
  if data.newTechnologies[techName].stats ~= nil then
    if data.newTechnologies[techName].stats["entrenchment"] ~= nil then
      faction.maxEntrenchment = data.newTechnologies[techName].stats["entrenchment"]
      faction.luaData.entrenchMax = faction.maxEntrenchment
    end
  end
end

function IsTechCompleted(techName, faction)
  for _, tech in pairs(faction.luaData.factionTechs) do
    if tech == techName then
      return true
    end
  end
  return false
end

function IsTechLineAvailable(techLine)
  if techLine.event ~= nil and GetEvent(techLine.event) == 0 then
    return false
  else
    return true
  end
end

function IsTechAvailable(techName, faction)
  if data.newTechnologies[techName] == nil then
    return false
  end

  local event = data.newTechnologies[techName].line.event
  if event ~= nil and GetEvent(event) == 0 then
    return false
  end
  if faction.luaData.researchComplete[techName] ~= 0 then
    return false
  end
  if data.newTechnologies[techName].requirement ~= nil then
    if faction.luaData.researchComplete[data.newTechnologies[techName].requirement] == 0 then
      return false
    end
  end
  return true
end

function IsTechCategoryAvailable(category, faction, fakeTurn)
  local turn = fakeTurn
  if fakeTurn == nil then
    turn = game.turn
  end
  if faction ~= nil and data.factions[faction.id+1].research[category] ~= 1 then
    return false
  end
  if scenario.techCategoriesUnlocked == nil or scenario.techCategoriesUnlocked[category] <= turn then
    return true
  else
    return false
  end
end

function GetAvailableTechs(faction, fakeTurn)

  local techsTable = {}
  for techClass, _ in pairs(data.techLines) do
    if IsTechCategoryAvailable(techClass, faction, fakeTurn) then
      for i, techLine in pairs(data.techLines[techClass]) do
        if techLine.event == nil or GetEvent(techLine.event) ~= 0 then
          for _, techName in pairs(techLine) do
            if IsTechAvailable(techName, faction) then
              table.insert(techsTable, techName)
              break
            end
          end
        end
      end
    end
  end

  return techsTable
end

function GetTechLine(techName)
  return data.newTechnologies[techName].line
end


function GetResearchBudget(faction)
  local budget = 0
  local i = 0
  while data.newTechnologies[i+1] ~= nil do
    if faction.luaData.researchComplete[i] == 0 then
      --budget = budget + faction.luaData.researchBudget[i] * data.newTechnologies[i+1].cost
    end
    i = i + 1
  end
  return budget
end

function GetResearchUpkeep(faction)
  if faction.luaData.labsforfree == nil then
	faction.luaData.labsforfree = 0
  end
  
  cost = 0
  if not CanFactionProduce(faction) then
    return 0
  end
  if scenario.techCategoriesUnlocked ~= nil then
    for category, turn in pairs(scenario.techCategoriesUnlocked) do
      if game.turn >= turn then
        cost = ((GetTotalLabs(faction) -faction.luaData.labsforfree) *  (GetTotalLabs(faction) +1)) /2   
      end
    end
  else
    cost = ((GetTotalLabs(faction) - faction.luaData.labsforfree) *  (GetTotalLabs(faction) +1)) /2                                    -- gameplay.LabUpkeepCost
	

 end
 if cost < 0 then
		cost = 0
	end
  return cost
end

function BuildLab(faction, techClass, free)
  cost = GetLabCost(faction)
  if faction.pp >= cost or free then
    faction:ConsumeProductionPoints(cost)
    faction.luaData.labs[techClass] = faction.luaData.labs[techClass] + 1

    -- Add focus point for every 2 labs
    if GetTotalLabs(faction) % 2 == 0 then
      faction.luaData.focusPoints = faction.luaData.focusPoints + 1
    end
    return true
  else
    return false
  end
end


function SellLab(faction, techClass)
  if faction.luaData.labs[techClass] > 0 then
    cost = GetLabCost(faction, GetTotalLabs(faction) - 1) / 2

    faction:ConsumeProductionPoints(-cost)

    -- Remove focus point for every 2 labs
    if GetTotalLabs(faction) % 2 == 0 and faction.luaData.focusPoints > 0 then
      faction.luaData.focusPoints = faction.luaData.focusPoints - 1
    end

    faction.luaData.labs[techClass] = faction.luaData.labs[techClass] - 1

    return true
  else
    return false
  end
end

function ResearchTechnology(faction, techName)
  --faction.luaData.researchPurchased[techId] = 1
  local techClass = data.newTechnologies[techName].class
  if IsTechAvailable(techName, faction) and GetCategoryTechlineCount(faction, techClass) > 1 and faction.luaData.focusPoints > 0 and faction.luaData.currentTech[techClass] ~= techName then
    faction.luaData.currentTech[techClass] = techName
    faction.luaData.focusPoints = faction.luaData.focusPoints - 1
    return true
  else
    return false
  end
end

function GetCategoryTechlineCount(faction, techClass)
  local count = 0

  for i, techLine in pairs(data.techLines[techClass]) do
    if techLine.event == nil or GetEvent(techLine.event) ~= 0 then
      for _, techName in pairs(techLine) do
        if IsTechAvailable(techName, faction) then
          count = count + 1
        end
      end
    end
  end
  return count
end

function UnfocusTechnology(faction, techName)
  if faction.luaData.focusPoints > 0 and faction.luaData.currentTech[techClass] ~= -1 then
    local techClass = data.newTechnologies[techName].class
    faction.luaData.currentTech[techClass] = -1
    faction.luaData.focusPoints = faction.luaData.focusPoints - 1
    return true
  else
    return false
  end
end

function SetLabs(factionId, group1, group2, group3, group4, group5)
  local faction = game:GetFactionById(factionId)
  faction.luaData.labs["ground"] = group1
  faction.luaData.labs["artillery"] = group2
  faction.luaData.labs["air"] = group3
  faction.luaData.labs["naval"] = group4
  faction.luaData.labs["armour"] = group5
end

function GetLabCost(faction, labcount) -- cost to buy NEW lab
  if labcount == nil then
    labcount = GetTotalLabs(faction)
  end
  return (0 + 3 * labcount)
end

function GetTotalLabs(faction)
  local totalLabs = faction.luaData.labs["ground"]
  if scenario.techCategoriesUnlocked["artillery"] <= game.turn then
	totalLabs = totalLabs + faction.luaData.labs["artillery"]
  end
  if scenario.techCategoriesUnlocked["naval"] <= game.turn then
	totalLabs = totalLabs + faction.luaData.labs["naval"]
  end
  if scenario.techCategoriesUnlocked["air"] <= game.turn then
	totalLabs = totalLabs + faction.luaData.labs["air"]
  end
  if scenario.techCategoriesUnlocked["armour"] <= game.turn then
	totalLabs = totalLabs + faction.luaData.labs["armour"]
  end
  
  
  
  
 -- + faction.luaData.labs["artillery"]
 -- + faction.luaData.labs["air"]
 -- + faction.luaData.labs["naval"]
 -- + faction.luaData.labs["armour"]
  return (totalLabs)
end

-- Unlock technology for faction
function UnlockTechnology(factionId, techName)
  faction = game:GetFactionById(factionId)
  ApplyTechnology(faction, techName)
end

-- Progress technology for faction (in %)
function ProgressTechnology(factionId, techName, progress)
  faction = game:GetFactionById(factionId)
  faction.luaData.researchProgress[techName] = data.newTechnologies[techName].time * progress / 100
  if progress == 100 then
    ApplyTechnology(faction, techName)
  end
end

function UnitSetTechs(unit, techsTable)
  unit.luaData.unitTechs = techsTable
end


-- Returns time to complete
-- If time takes longer than 5 turns it will return -1
function GetTechTime(faction, techName)

  local increment = GetTechIncrement(faction, techName)

  if increment > 0 then
    local time = math.ceil((data.newTechnologies[techName].time - faction.luaData.researchProgress[techName]) / increment)
    if time <= 50 then
      return time
    else
      return -1
    end
  else
    return -1
  end

end

function UnitCanUpgrade(unit)
  local j = 0
  local k = 0
  local hasTech, techName
  local upgrade_cost = 0

  if unit.luaData.upgraded == game.turn or unit.supply < 2 or unit.faction.alliance.id ~= game.currentAlliance.id or unit.prototype.name == "transport" or unit.prototype.name == "convoy" then
    return 0
  end

  -- Naval units can only be upgraded in national port
  if unit.type == Unit.NAVAL then
    if unit.alive and unit.hex ~= nil then
      if unit.hex.construction == nil or unit.hex.construction.city.hex.faction.id ~= unit.faction.id then
        return 0
      end
    end
  end

  -- go through faction techs
  for _, techName in pairs(unit.faction.luaData.factionTechs) do
    -- go through unit techs
    hasTech = false
    j = 1
    while unit.luaData.unitTechs[j] ~= nil do
      -- Check if unit already has tech
      if unit.luaData.unitTechs[j] == techName then
        hasTech = true
        break
      end
      j = j + 1
    end
    -- If not then check if tech affects this unit type
    k = 1
    if not hasTech then
      while data.newTechnologies[techName].unitTypes[k] ~= nil do
        if data.newTechnologies[techName].unitTypes[k] == unit.prototype.name then
          upgrade_cost = upgrade_cost + data.newTechnologies[techName].cost
        end
        k = k + 1
      end
    end
  end
  return upgrade_cost
end

function UnitCanUpgradeDetailed(unit)
  local j = 0
  local k = 0
  local hasTech, techName
  local upgrade_cost = 0

  if unit.luaData.upgraded == game.turn or unit.supply < 2 or unit.faction.alliance.id ~= game.currentAlliance.id then
    return 0
  end

  -- Naval units can only be upgraded in port
  if unit.type == Unit.NAVAL then
    if unit.alive and unit.hex ~= nil then
      if unit.hex.construction == nil or unit.hex.construction.city.hex.faction.id ~= unit.faction.id then
        return 0
      end
    end
  end

  local improvements = {}

  -- go through faction techs
  for _, techName in pairs(unit.faction.luaData.factionTechs) do
    -- go through unit techs
    hasTech = false
    j = 1
    while unit.luaData.unitTechs[j] ~= nil do
      -- Check if unit already has tech
      if unit.luaData.unitTechs[j] == techName then
        hasTech = true
        break
      end
      j = j + 1
    end
    -- If not then check if tech affects this unit type
    k = 1
    if not hasTech then
      while data.newTechnologies[techName].unitTypes[k] ~= nil do
        if data.newTechnologies[techName].unitTypes[k] == unit.prototype.name then
          upgrade_cost = upgrade_cost + data.newTechnologies[techName].cost
          if data.newTechnologies[techName].stats ~= nil then
            for statName, value in pairs(data.newTechnologies[techName].stats) do
              if improvements[statName] == nil then
                improvements[statName] = value
              else
                improvements[statName] = improvements[statName] + value
              end
            end
          end
        end
        k = k + 1
      end
    end
  end
  return upgrade_cost, improvements
end

function UpgradeUnit(unit)
--LogUi("upgrade start")
  local check = UnitCanUpgrade(unit)
  if check > 0 and check <= unit.faction.pp then
    unit.faction:ConsumeProductionPoints(check)
    unit.mp = 0
    unit.ap = 0
    unit.luaData.upgraded = game.turn
    UpdateUnit(unit)
    return true
  else
    return false
  end
 -- LogUi("upgrade end")
end

-- Apply all current techs to the unit
function UpdateUnit(unit, techs)
--LogUi("update start")
  -- copy unit techs
  if techs == nil then
    unit.luaData.unitTechs = utils.deepcopy(unit.faction.luaData.factionTechs)
  else
    unit.luaData.unitTechs = utils.deepcopy(techs)
  end

  --FIXME: unit must use icon at time of purchase, not latest one
  -- If faction has the unit type
  if unit.faction.luaData.unitLevel[unit.prototype.name] ~= nil then
    while unit.level < unit.faction.luaData.unitLevel[unit.prototype.name] do
      unit:Upgrade()
      EasterEgg_RedBaron(unit)
    end
  end
 -- LogUi("update end")
end

-- Pass (unit) OR (unitname, faction)
function GetUnitTechCount(unit, faction)

  local level = 1

  if faction == nil then
    local i = 0
    local techName
    while unit.luaData.unitTechs[i+1] ~= nil do
      techName = unit.luaData.unitTechs[i+1]
      if IsTechValidForUnit(techName, unit) == true then
        if data.newTechnologies[techName].stats ~= nil and data.newTechnologies[techName].stats["entrenchment"] == nil then
          --print("unit has technology " .. techName)
          level = level + 1
        end
      end
      i = i + 1
    end
  else
    for _, techName in pairs(faction.luaData.factionTechs) do
      if data.newTechnologies[techName].stats ~= nil then
        local k = 1
        while data.newTechnologies[techName].unitTypes[k] ~= nil do
          if data.newTechnologies[techName].unitTypes[k] == unit then
            level = level + 1
            break
          end
          k = k + 1
        end
      end
    end
  end

  return level
end

function HasUnitTech(unit, techName)

	if unit.alive then
	  -- Check if unit has it
	  i = 1
	  while unit.luaData.unitTechs[i] ~= nil do
		-- Check if unit already has tech
		if unit.luaData.unitTechs[i] == techName then
		  return true
		end
		i = i + 1
	  end
	 
	end 

  return false
end

function IsTechValidForUnit(techName, unit)
  local i = 1
  while data.newTechnologies[techName].unitTypes[i] ~= nil do
    if data.newTechnologies[techName].unitTypes[i] == string.lower(unit.prototype.name) then
      return true
    end
    i = i + 1
  end
  return false
end


function PrintTechUnlockDates()
  local turn = 1
  local year = 1914
  repeat
--~     for faction in game.factions do
--~     if faction.id == 0 then
      ManageResearch(true, turn)

--~     if faction.id == 0 then
      -- Increase lab count for specific factions
--~       if faction.id == 0 then
--~         faction.luaData.labs["ground"] = faction.luaData.labs["ground"] + 1
--~       end

      -- Print state at scenario start turns
      if turn == 21 or turn == 43 or turn == 72 or turn == 97 then
        year = year + 1
        LogUi("")
        LogUi("YEAR " .. year)
        LogUi("")
        LogUi("-- Automated Tech Generation")
        for faction in game.factions do
          LogUi("")
          LogUi("-- " .. faction.name)
          for techClass, _ in pairs(data.techLines) do
            for i, techLine in pairs(data.techLines[techClass]) do
              for k, techName in pairs(techLine) do
                if faction.luaData.researchProgress[techName] ~= nil then
                  local state = faction.luaData.researchProgress[techName] * 100 / data.newTechnologies[techName].time
                  if state > 0 then
                    if state == 100 then
                      LogUi("UnlockTechnology(" .. faction.id .. ", \"" .. techName .. "\")") -- .. faction.luaData.researchProgress[techName] .. " / " .. data.newTechnologies[techName].time)
                    else
                      LogUi("ProgressTechnology(" .. faction.id .. ", \"" .. techName .. "\", " .. math.floor(state) .. ")")
                    end
                  end
                end
              end
            end
          end
        end

        -- Print labs
        LogUi("")
        LogUi("")
        LogUi("-- Automated Lab Generation")
        for faction in game.factions do
          LogUi("SetLabs(" .. faction.id .. ", " .. faction.luaData.labs["ground"] .. ", " .. faction.luaData.labs["artillery"] .. ", "  .. faction.luaData.labs["air"] .. ", "  .. faction.luaData.labs["naval"] .. ", "  .. faction.luaData.labs["armour"] .. ")")
        end
      end
--~     end
--~     end
    turn = turn + 1
  until turn == 180
end
