gameplay.portSupplyDistance = 25

function InitSupply()
  for alliance in game.alliances do
    if alliance.id ~= 0 then
      alliance.luaData.portSupply = {}
      alliance.luaData.portHome = {}
      for faction in alliance.factions do
        SetPortSupplyFaction(faction)
      end
    end
  end
end

-- Lower unit efficiency based on its supply state
function SupplyEffects(alliance)
local verdun = game:GetHex(87, 29)

  for faction in game.factions do
    for unit in faction.units do

      -- Naval units always full supply
      if unit.type ~= Unit.NAVAL then

        if unit.hex ~= nil then
          SetUnitMovePenalty(unit)
		  NoAttack(unit)

          if unit.supply == 0 then
            -- Damage unit during enemy phase start
            if game.currentAlliance.id == 3 - unit.alliance.id then
              unit:Damage(10)
              if unit.hp <= 0 and unit.commander ~= nil then
                WoundCommander(unit.commander, (math.random(6,36)))
                if unit.faction.alliance.id == playerAlliance.id then
                  PopupCommanderCapturedMessageOnTurnReport()
                  --PopupMessage("commander_captured")
                end
              end
            end
          end
        end

      else
			
        -- Naval unit supply
        if alliance.id == faction.alliance.id then
          if unit.hex ~= nil and unit.alive and unit.prototype.name ~= "convoy" and unit.prototype.name ~= "transport" then
            -- Get distance to nearest port
            local inSupply = false
            local hexes = game.map:GetHexesInRange(unit.hex, gameplay.portSupplyDistance)
            for _, hex in pairs(hexes) do
              if hex.construction ~= nil and hex.construction.type == Construction.TYPE_PORT and hex.construction.city.hex.faction.alliance.id == faction.alliance.id then
                inSupply = true
                break
              end
            end
            if not inSupply then
              -- out of supply
				DamageEfficiency(unit, 30)
				if unit.luaData.endurance ~= nil and unit.luaData.endurance >= 1 then
					unit.luaData.endurance = unit.luaData.endurance -1
				end
			else
					if unit.luaData.endurance == nil then
						unit.efficiency = unit.efficiency + 30
						if unit.efficiency >100 then
							unit.efficiency = 100
						end
					end
					if unit.luaData.endurance ~= nil and unit.luaData.endurance >0 and math.random(1,10) <= unit.luaData.endurance then
						unit.efficiency = unit.efficiency + ((unit.luaData.endurance /2) * 10 )
						if unit.efficiency >100 then
							unit.efficiency = 100
						end
					elseif unit.luaData.endurance ~=nil and unit.luaData.endurance >0 and math.random(1,10) > unit.luaData.endurance and unit.efficiency >10 then
							DamageEfficiency(unit, 10)
					
					end					
					if unit.efficiency > 100 then
						unit.efficiency = 100
					end
            end
          end
        end

      end

    end
  end

end

function SetUnitMovePenalty(unit)
  local impassable = game:GetFactionById(24)
  local russia = game:GetFactionById(4)
  local france = game:GetFactionById(0)
  local germany = game:GetFactionById(2)
  local italy = game:GetFactionById(8)
  local belgium = game:GetFactionById(6)

  local antwerp = GetHex(85, 24)	
  local counter = 0
  if unit.type ~= Unit.NAVAL then
    
	
	if unit.supply == 1 then
      -- Lower movement points
      unit.mp = math.floor(unit.prototype:GetLevelStats(1).mp * 2 / 3)
    elseif unit.supply == 0 then
      -- Lower movement points
      unit.mp = 3
    elseif unit.type == Unit.LAND 
		and unit.hex ~= nil
		and unit.hex.construction == nil
		and unit.luaData.mud ~= nil 
		and unit.luaData.mud == game.turn 
		and impassable.luaData.mud == game.turn then
		unit.mp = 0
	end
------------ GERMAN ATTACK THROUGH BELGIUM -----------------	
	if  GetEvent("DOWgermany") == game.turn 
		and unit.faction.id == 0 
		and unit.type == Unit.LAND 
		and unit.prototype.name ~= "smallgarrison"
		and unit.hex.y < 40 then

			local luck = math.random(1,100)
			if (GetEvent("Schlieffen") >0 
				or GetEvent("PlanXVII") >0) 
							
				and GetEvent("Michel") <= 0 
				and GetEvent("InvadeBelgium") <= 0
				and GetEvent("Redeploy") <= 0 
				and luck >= 35			then
					unit.mp = 0	
					counter = counter +1	
			elseif GetEvent("Redeploy") >0 
				and luck >=50 then
					unit.mp = 0	
					counter = counter +1	
				end
		if counter >0 then
	--	PopupMessage("GERMAN SURPRISE ATTACK!!! " .. counter .. " French units unable to move!")
		end
	end
----------ANTWERP GARRISON------
if GetEvent("AntwerpCaptured") == 0 
	and player.alliance.id == 2 
	and game.type == Game.TYPE_SINGLE
	and antwerp.unit ~= nil
	and antwerp.unit.faction.id == belgium.id then
		antwerp.unit.mp = 0
end	
	
-----------VERDUN IN SP VS ENTENTE AI-----------------------
local verdun = game:GetHex(87, 29)
if verdun.alliance.id == 1 
	and player.alliance.id == 2 and game.type == Game.TYPE_SINGLE
	and verdun.unit ~= nil
	and unit.hex ~= nil
	and unit.hex.x == 87
	and unit.hex.y == 29
	and unit.prototype.name == "infantry"
	and unit.efficiency >= 50
	and unit.hp >= 80 then
		unit.mp = 0
end	
-------SINAI DESERT---------------------------
if unit.hex ~= nil 
			and (unit.hex.terrain.name == "desert" or unit.hex.terrain.name == "dunes" )
			and impassable.luaData.winter == 0
			and unit.hex.construction == nil
			and unit.prototype.name ~= "arabcavalry" 
			and unit.prototype.name ~= "arabinfantry" 
			and unit.prototype.name ~= "arabgarrison" then
							if unit.luaData.experience == nil then
								unit.luaData.experience = 0
							end
							if player.alliance.id == 1 and game.type == Game.TYPE_SINGLE 
								and  unit.hex.x >= 131 
								and unit.hex.x <= 133 
								and unit.hex.y >= 66 
								and unit.hex.y <= 71  
								and unit.alliance.id == 1 
								and GetEvent("Pipeline") == 0 
								and math.random(1,100) > unit.efficiency  	then																		
										unit.mp = 0
									
							elseif player.alliance.id == 2 and game.type == Game.TYPE_SINGLE 
								and  unit.hex.x >= 131 
								and unit.hex.x <= 133 
								and unit.hex.y >= 66 
								and unit.hex.y <= 71  
								and unit.alliance.id == 2
								and unit.commander == nil
								and game.date.year >= 1915
								and unit.efficiency >0								
								and math.random(1,200) > unit.luaData.experience  then																		
									
										unit.mp = 0
	
							
							elseif game.type == Game.TYPE_PBEM
								and playerAlliance.id == 1 
								and  unit.hex.x >= 131 
								and unit.hex.x <= 133 
								and unit.hex.y >= 66 
								and unit.hex.y <= 71  
								and unit.alliance.id == 1 
								and GetEvent("Pipeline") == 0 
								and unit.efficiency >0
								and math.random(1,100) > unit.efficiency  	then																		
										unit.mp = 0
							
							elseif game.type == Game.TYPE_PBEM 
								and playerAlliance.id == 2 
								and  unit.hex.x >= 131 
								and unit.hex.x <= 133 
								and unit.hex.y >= 66 
								and unit.hex.y <= 71  
								and unit.alliance.id == 2 
								and unit.commander == nil
								and unit.efficiency >0
								and math.random(1,100) > unit.efficiency  	then																		
										unit.mp = 0
							
							
							end
end
						
	
		
-------------RUSSIA SUPPLY CRISIS----------------------	
 
  if GetEvent("RussiaSupplyCrisis") >0 
	and GetEvent("RussiaSupplyCrisisEnd") == 0 
	and unit.hex ~= nil 
	and unit.type == Unit.LAND 
	and ((unit.faction.id == 4 
			and unit.hex.originalFaction.id == 4
			and unit.hex.construction == nil
			and Game.TYPE_SINGLE 
			and player.alliance.id == 1 
			and unit.commander == nil
			and math.random(1,100) > unit.efficiency + game.turn)  
			or 
			(unit.faction.id == 4 
			and unit.hex.construction == nil
			and unit.commander == nil
			and math.random(1,100) > unit.efficiency - game.turn)
			and (unit.hex.originalFaction.id == 2 
					or unit.hex.originalFaction.id == 3)  
			)  then
	
	
--	unit.mp = 0
  
  end
  
 ----------------EAST PRUSSIA------------------------------ 
  
  if player.alliance.id == 1 
	and game.type == Game.TYPE_SINGLE
	and unit.faction.id == 2
	and unit.type == Unit.LAND 
	and GetEvent("DOWgermany") >0
	and game.date.year == 1914
	and unit.hex ~= nil
	and unit.hex.x >= 109
	and  GetEvent("AllEast") <= 0
	and GetEvent("DOWrussia") == 0 
	and game.turn <= germany.luaData.eastwait
	and germany.luaData.francois == 0
										then
						
						unit.mp = 0
	end	
------------------GALICIA-----------------------------------
	
	if MatchType() == 1 --  player is Entente
		and unit.faction.id == 3
		and unit.type == Unit.LAND 
		and game.date.year == 1914
		and unit.hex ~= nil
		and (unit.hex.y <= 29 or unit.prototype.name == "fighter")
		and unit.commander ~= nil 
		and  GetEvent("AllEast") <= 0
		and GetEvent("SerbsinAustria") <= 0
		and GetEvent("DOWrussia") == 0 then
						
					unit.mp = 0
	end				
		
  
 
  
 ------------STOP ENTENTE MASS DEPLOYMENT TO ITALY------------------------------------------------------------------ 
 
 if player.alliance.id == 2 
	and game.type == Game.TYPE_SINGLE
	and unit.hex ~= nil
	and (unit.faction.id == 0 or unit.faction.id == 1)
	and unit.type == Unit.LAND 
	and italy.alliance.id == 1 
	and unit.hex.originalFaction.id == 0
	and ((unit.prototype.name == "garrison" and unit.hp >= 90)
		or (unit.prototype.name == "garrison" and unit.hp >= 70 and unit.hex.entrench >0)
		or unit.prototype.name == "cavalry"
		or unit.prototype.name == "artillery"
		or unit.prototype.name == "armour"
		or (unit.prototype.name == "infantry" and unit.hp >= 70)) then
	
		local paris = game:GetHex(82,30)
		local dijon = game:GetHex(86, 33)
		local reims = game:GetHex(85,28)
		local amiens = game:GetHex(82, 28)
		local rouen = game:GetHex(80, 28)
		local toul = game:GetHex(87,31)
		

			if unit.hex == paris
				or unit.hex == dijon
				or unit.hex == reims
				or unit.hex == amiens 
				or unit.hex == rouen 
				or unit.hex == toul then
					unit.mp = 0
			end	
			local rangecheck = 2
			if unit.hex == paris then
				rangecheck = 3
			end	
			
			local hexes = game.map:GetHexesInRange(unit.hex, rangecheck)
				for _, ahex in pairs(hexes) do
					if 	ahex.unit ~= nil
						and ahex.unit.alliance.id == 2 
						and ahex.unit.type == Unit.LAND then
							unit.mp = 0
					end	
				end	
	end	
-----------------MORE SPECIAL CASES HERE---------------------------------
end	
    
   -----------NAVAL -----------------------------------
if unit.type == Unit.NAVAL then

 --------baltic ice ------------------
	if unit.faction.id == 4 
		and gameplay.winter == 1 
		and GetEvent("Russianports") +4 >= game.turn 
		and ((unit.hex.x == 117
				and unit.hex.y == 13)
			or (unit.hex.x == 118 
				and unit.hex.y == 9)
			or (unit.hex.x == 120 
				and unit.hex.y == 8)
			or (unit.hex.x == 124 
				and unit.hex.y == 8))then
			unit.mp = 0	
	end
	
---------- prevent german bc suicide attack
	LogUi("SUPTEST1")
  if unit.faction.id == 2 
	and (player.alliance.id == 1 and game.type == Game.TYPE_SINGLE ) then
			LogUi("SUPTEST2")
		if game.turn <= 10 then
				LogUi("SUPTEST3")
				
					if unit.prototype.name == "battlecruiser" 	
					and unit.hex ~= nil
					and ((unit.hex.x == 94
							and unit.hex.y == 19)
						or (unit.hex.x == 92 
								and unit.hex.y == 19))then
									LogUi("SUPTEST4")
						unit.mp = 0
				end	
		end
	end

end
end




function NoAttack(unit)
  
	if GetEvent("FrenchMutiny") == game.turn then
	  if unit.type == Unit.LAND 
		and unit.hex ~= nil 
		and unit.faction.id == 0 
		and unit.hp >= 50 
		and unit.efficiency >= 50 then
		local hexes = game.map:GetHexesInRange(unit.hex, 1)
			for _, hex in pairs(hexes) do
				if hex.unit ~= nil and hex.unit.faction.id == 2 then
						unit.ap = 0
						break
				end	
			end	
		end
	end
	
	if GetEvent("RussiaSupplyCrisis") >0 
		and GetEvent("RussiaSupplyCrisisEnd") == 0 
		and unit.hex ~= nil 
		and unit.type == Unit.LAND 
		and unit.faction.id == 4 
		and unit.commander == nil
		and unit.hex.construction == nil
		and (math.random(1,100) > unit.efficiency  
			or (unit.hex.originalFaction.id == 2 or unit.hex.originalFaction.id == 3)) then
		--unit.ap = 0
	end
	
end




function AddPortSupply(alliance, hex)
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)

  local hexes = game.map:GetHexesInRange(hex, gameplay.portSupplyDistance)

  for _, hex in pairs(hexes) do
    if alliance.luaData.portSupply[hex.id] ~= nil then
      alliance.luaData.portSupply[hex.id] = alliance.luaData.portSupply[hex.id] + 1
    else
      alliance.luaData.portSupply[hex.id] = 1
    end
  end

  if hex.construction.city.hex.originalFaction.id == hex.construction.city.hex.faction.id then
    hexes = game.map:GetHexesInRange(hex, 1) -- torpedobonus range
			-------------------------
			   
			
			-------------------------
			
    for _, hex in pairs(hexes) do
      if alliance.luaData.portHome[hex.id] ~= nil then
        alliance.luaData.portHome[hex.id] = alliance.luaData.portHome[hex.id] + 1
      else
        alliance.luaData.portHome[hex.id] = 1
      end
    end
  end
end

function RemovePortSupply(alliance, hex)

  -- Don't bother with neutral alliance
  if alliance.id == 0 then
    return
  end

  local hexes = game.map:GetHexesInRange(hex, gameplay.portSupplyDistance)

  for _, hex in pairs(hexes) do
    alliance.luaData.portSupply[hex.id] = alliance.luaData.portSupply[hex.id] - 1
  end

  if hex.construction.city.hex.originalFaction.id ~= hex.construction.city.hex.faction.id then
    hexes = game.map:GetHexesInRange(hex, 2)

    for _, hex in pairs(hexes) do
      if alliance.luaData.portHome[hex.id] ~= nil then
        alliance.luaData.portHome[hex.id] = alliance.luaData.portHome[hex.id] - 1
      else
        alliance.luaData.portHome[hex.id] = 1
      end
    end
  end
end

function SetPortSupplyFaction(faction)
  for construction in faction.constructions do
    if construction.type == Construction.TYPE_PORT then
      AddPortSupply(faction.alliance, construction.hex)
    end
  end
end
