function InitTransportmoves()
  for faction in game.factions do
    SetFactionTransportmoves(faction, 0)
  end
end

function SetFactionTransportmoves(faction, amount)

  if type(faction) == "number" then
    faction = game:GetFactionById(faction)
  end

  faction.luaData.transportmovesCurrent = amount
  faction.luaData.transportmovesMax = amount

  ResetFactionTransportmoves(faction)
end

function GetFactionTransportmoves(faction)
  return(faction.luaData.transportmovesCurrent)
end




function GetFactionMaxTransportmoves(faction)
  return(faction.luaData.transportmovesMax)
end

function AddFactionTransportmoves(faction, amount)
  faction.luaData.transportmovesCurrent = faction.luaData.transportmovesCurrent + amount
end

function PurchaseFactionTransportmoves(faction)
  local cost = GetTransportmovesIncrementCost(GetFactionMaxTransportmoves(faction))
  if faction.pp >= cost then
   faction:ConsumeProductionPoints(cost)
	faction.luaData.transportmovesMax = faction.luaData.transportmovesMax + 1
    AddFactionTransportmoves(faction, 1)
    		if playerAlliance.luaData.transportsound == 0 then
					sfx = LoadSample("transportsound.wav")
					PlaySample(sfx)
					playerAlliance.luaData.transportsound = 1
				end
	return true
  else
    return false
  end
end

function GetTransportmovesIncrementCost(currentAmount)
  local cost = (currentAmount + 2) * 20
  return cost
end

function ResetTransportmoves()
  for faction in game.factions do
    ResetFactionTransportmoves(faction)
  end
end

function ResetFactionTransportmoves(faction)
  local transportCount = 0
  for unit in faction.units do
    if unit.isCarrier and unit.alive then
      transportCount = transportCount + 1
    end
  end
  faction.luaData.transportmovesCurrent = faction.luaData.transportmovesMax - transportCount
end

function UseTransportmove(faction)
  faction.luaData.transportmovesCurrent = faction.luaData.transportmovesCurrent - 1
  if faction.alliance.id == playerAlliance.id then
    ui.resourcesPanel:Refresh()
  end
end
