function GameCheckVictory()
  return GetWinner(); --return id of a winner (alliance)
end

function VC_Germany()
  local germany = game:GetFactionById(2)
  if (GetEvent("Surrendergermany") >0 or germany.luaData.collaps >= 10) then --and game.date.year > 1914 then
    return game:GetAllianceById(1)
  else
    return game:GetAllianceById(2)
  end
end

function VC_Austria()
  local austria = game:GetFactionById(3)
  if (GetEvent("Surrenderaustria") >0 or austria.luaData.collaps >= 10) then
    return game:GetAllianceById(1)
  else
    return game:GetAllianceById(2)
  end
end

function VC_France()
  local france = game:GetFactionById(0)
  if (GetEvent("Surrenderfrance") >0 or france.luaData.collaps >= 10) and game.date.year >= 1914 then
    return game:GetAllianceById(2)
  else
    return game:GetAllianceById(1)
  end
end

function VC_Britain()
  local britain = game:GetFactionById(1)
  if (GetEvent("Surrenderbritain") >0 or britain.luaData.collaps >= 10) and game.date.year >= 1914 then
    return game:GetAllianceById(2)
  else
    return game:GetAllianceById(1)
  end
end

function VC_Russia()
  local russia = game:GetFactionById(4)
  if (GetEvent("Surrenderrussia") >0 or russia.luaData.collaps >= 10) and game.date.year >= 1914 then
    return game:GetAllianceById(2)
  else
    return game:GetAllianceById(1)
  end
end

-- Terminal condition: achieving this ends game
function oldTC_DefeatAll()
  for alliance in game.alliances do
    if alliance.numFactions == 0 and game.date.year > 1914 then   --------------------------------1
      return game:GetAllianceById(3 - alliance.id)
    end
  end
  return 0
end

function TC_DefeatAll()

for alliance in game.alliances do
local counter = 0	
		for faction in alliance.factions do
			if faction.luaData.collaps ~= nil and faction.luaData.collaps >= 10 then
				counter = counter +1 
			end	
		end
		if (alliance.numFactions == 0  or counter > (alliance.numFactions /2)) 
				and game.date.year > 1914 then   --------------------------------1
			  return game:GetAllianceById(3 - alliance.id)
		end
end	
  return 0
end


						



-- Terminal condition: achieving this ends game
function TC_Deadline()
local russia = game:GetFactionById(4)
local impassable = game:GetFactionById(24)
local whites = game:GetFactionById(26)
local bolshevik = game:GetFactionById(27)
local value = 1919

	if whites.alliance.id == 1 
		and bolshevik.alliance.id == 2  then
		value = 1922
	end
	if game.date.year == value then
		return 1
	else
		return 0
  end
end

-- Terminal condition: achieving this ends game
function TC_NoCities()
  for alliance in game.alliances do
    local hasCities = false
    if alliance.id ~= 0 then
      for faction in alliance.factions do
        for construction in faction.constructions do
          hasCities = true
        end
      end
      if not hasCities and game.date.year > 1914 then ----------------------------- 2
        return game:GetAllianceById(3 - alliance.id)
      end
    end
  end
  return 0
end


gameplay.victoryConditions =
{
  {
    condition = VC_Germany,
    stars = 3,
  },
  {
    condition = VC_Austria,
    stars = 2,
  },
  {
    condition = VC_France,
    stars = 2,
  },
  {
    condition = VC_Britain,
    stars = 2,
  },
  {
    condition = VC_Russia,
    stars = 1,
  },
  {
    condition = TC_DefeatAll,
    stars = 1,
  },
  {
    condition = TC_Deadline,
    stars = 1,
  },
  {
    condition = TC_NoCities,
    stars = 1,
  },
}


function VictoryConditions(next)
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)

  -- check if VC are met next turn (for MP only!)
  if next == "next" then
    SetTurnDate()
  end

  -- Check all VCs
  -- If any terminal ones are achieved, end game
  if TC_DefeatAll() ~= 0 
	or TC_Deadline() ~= 0 
	or TC_NoCities() ~= 0 
	or ((GetEvent("Surrenderfrance") >0 or france.luaData.collaps >= 10)
			and (GetEvent("Surrenderbritain") >0 or britain.luaData.collaps >= 10)
			and (GetEvent("Surrenderrussia") >0 or russia.luaData.collaps >= 10))
	or ((GetEvent("Surrenderaustria") >0 or austria.luaData.collaps >= 10)
			and (GetEvent("Surrendergermany") >0 or germany.luaData.collaps >= 10)) then
	
    local total = 5
    local stars = 0
    for i = 1, total do
      if gameplay.victoryConditions[i].condition().id == playerAlliance.id then
        stars = stars + gameplay.victoryConditions[i].stars
      end
    end

    DeclareVictory(stars)

    return true
  end

  return false
end

function OldDeclareVictory(stars) --- for backup purposes

  local maxStars = 11
  if stars > math.floor(maxStars / 2) then
    PopupFinal("victory_type_" .. stars, "event_victory", "victory_"  .. playerAlliance.id .. "_text")
    SetGameOver(playerAlliance.id)
  elseif stars < math.floor(maxStars / 2) then
    PopupFinal("victory_type_" .. stars, "event_defeat", "defeat_"  .. playerAlliance.id .. "_text")
    SetGameOver(GetEnemyAlliance(playerAlliance).id)
  else
    PopupFinal("victory_type_" .. stars, "event_draw", "draw_text")
    SetGameOver(0)
  end

end


function DeclareVictory(stars)
local cp =  game:GetAllianceById(2)
local entente =  game:GetAllianceById(1)
local neutrals =  game:GetAllianceById(0)
local neutral =  game:GetAllianceById(0)

-------------------------------------------------------
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)
local turkey = game:GetFactionById(5)
local belgium = game:GetFactionById(6)
local serbia = game:GetFactionById(7)
local italy = game:GetFactionById(8)
local netherlands = game:GetFactionById(9)
local usa = game:GetFactionById(10)
local sweden = game:GetFactionById(11)
local denmark = game:GetFactionById(12)
local finland = game:GetFactionById(13)
local greece = game:GetFactionById(14)
local spain = game:GetFactionById(15)
local portugal = game:GetFactionById(16)
local switzerland = game:GetFactionById(17)
local romania = game:GetFactionById(18)
local bulgaria = game:GetFactionById(19)
local norway = game:GetFactionById(20)
local persia = game:GetFactionById(22)
local arabia = game:GetFactionById(21)
local whites = game:GetFactionById(26)
local bolshevik = game:GetFactionById(27)
local impassable = game:GetFactionById(24)


    
if stars >= 6 then
	
	-----------------------
	-----ENTENTE-----------
	-----------------------
	if playerAlliance.id == 1 then
	
			if france.alliance.id == 1 
			   and britain.alliance.id == 1
			   and (russia.alliance.id == 1 and russia.luaData.collaps < 10)
			---------------------------------------------------------- F B R  AxGx
			   and (germany.alliance.id == 0 or germany.luaData.collaps >= 10)
			   and (austria.alliance.id == 0 or austria.luaData.collaps >= 10) then
				stars = 10
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				if france.morale <= britain.morale then
					PlaySample(LoadSample("entwin2.wav"))
				else 
					PlaySample(LoadSample("entwin1.wav"))			
				end
			------------------------------------------------------------  F B AxGx
			elseif 	france.alliance.id == 1 
			   and britain.alliance.id == 1
			   and (russia.alliance.id == 0 or russia.luaData.collaps >= 10)
			
			   and (germany.alliance.id == 0 or germany.luaData.collaps >= 10)
			   and (austria.alliance.id == 0 or austria.luaData.collaps >= 10) then
			   stars = 9
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				PlaySample(LoadSample("entwin1.wav"))			
					
			 -------------------------------------------------------------  B R I/U AxGx		   
			 elseif (france.alliance.id == 0 or france.luaData.collaps >= 10) 
			   and britain.alliance.id == 1
			   and russia.alliance.id == 1 
			   and (italy.alliance.id == 1 or usa.alliance.id == 1) 
			
			   and (germany.alliance.id == 0 or germany.luaData.collaps >= 10)
			   and (austria.alliance.id == 0 or austria.luaData.collaps >= 10) then
			   stars = 8
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				PlaySample(LoadSample("entwin2.wav"))
			
			 ------------------------------------------------------------- F B R/I AxGx 		   
			 elseif france.alliance.id == 1 
			   and britain.alliance.id == 1
			   and ((russia.alliance.id == 1 and russia.luaData.collaps < 10) or (italy.alliance.id == 1 and italy.luaData.collaps < 10))  
			
			   and (germany.alliance.id == 0 or germany.luaData.collaps >= 10)
			   and (austria.alliance.id == 2 or austria.alliance.id == 0 or austria.luaData.collaps >= 10) then
			   stars = 8
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				if france.morale <= britain.morale then
					PlaySample(LoadSample("entwin2.wav"))
				else 
					PlaySample(LoadSample("entwin1.wav"))			
				end
											
			 ---------------------------------------------------F B R I U    Ax----------  		   
			 elseif france.alliance.id == 1 
			   and britain.alliance.id == 1
			   and russia.alliance.id == 1 
			   and italy.alliance.id == 1 
			   and usa.alliance.id == 1
			
			   and germany.alliance.id == 2 
			   and (austria.alliance.id == 0 or austria.luaData.collaps >= 10) then
			   stars = 8
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				if france.morale <= britain.morale then
					PlaySample(LoadSample("entwin2.wav"))
				else 
					PlaySample(LoadSample("entwin1.wav"))			
				end
								
			-----------------------------------------------F B I U       Gx--------------  			
	
			 elseif france.alliance.id == 1
			   and britain.alliance.id == 1
			   and (russia.alliance.id == 0 or russia.luaData.collaps >= 10) 
			   and (italy.alliance.id == 1 or usa.alliance.id == 1)
			  
			   and (germany.alliance.id == 0 or germany.luaData.collaps >= 10)
			   and austria.alliance.id == 2 then
			   stars = 7
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				PlaySample(LoadSample("entwin1.wav"))			
				GetHighScore(stars)
			 --------------------------------------------------------B U R/I    Gx-----  		
			 elseif (france.alliance.id == 1 and france.luaData.collaps < 10) 
			   and britain.alliance.id == 1
			   and usa.alliance.id == 1
			   and (russia.alliance.id == 1 or italy.alliance.id == 1) 
			   	
			 
			   and (germany.alliance.id == 0 or germany.luaData.collaps >= 10)
			   and (austria.alliance.id == 2 or austria.alliance.id == 0 or austria.luaData.collaps >= 10) then
			   stars = 7
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				PlaySample(LoadSample("entwin2.wav"))
						
				
			-----------------------------------------------FBRI Ax/Gx----- ---------  
			elseif ((france.alliance.id == 1 
					and britain.alliance.id == 1
					and usa.alliance.id == 0
					and russia.alliance.id == 1
					and italy.alliance.id == 1)
			----------------------------------------------FRUI Ax/Gx
				or (france.alliance.id == 1 
					and (britain.alliance.id == 0 or britain.luaData.collaps >= 10)
					and usa.alliance.id == 1					
					and russia.alliance.id == 1
					and italy.alliance.id == 1)
				----------------------------------------BRUI Ax/Gx
				or ((france.alliance.id == 0 or france.luaData.collaps >= 10) 
					and britain.alliance.id == 1
					and usa.alliance.id == 1					
					and russia.alliance.id == 1
					and italy.alliance.id == 1)  
				--------------------------------------- FBUI Ax/Gx--
				or ((russia.alliance.id == 0 or russia.luaData.collaps >= 10) 
					and britain.alliance.id == 1
					and usa.alliance.id == 1					
					and france.alliance.id == 1
					and italy.alliance.id == 1))  
			 -------------------------------------------------------------  
			   and (((germany.alliance.id == 0 or germany.luaData.collaps >= 10) and austria.alliance.id == 2) 
					or (germany.alliance.id == 2 and (austria.alliance.id == 0 or austria.luaData.collaps >= 10))) then
			   stars = 7
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)
				if france.alliance.id == 1 then
					PlaySample(LoadSample("entwin1.wav"))
				elseif britain.alliance.id == 1 then
					PlaySample(LoadSample("entwin2.wav"))			
				
				else
					
				end		
			
			else
				stars = 6	
				PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				GetHighScore(stars)	
				if france.alliance.id == 1 then
					PlaySample(LoadSample("entwin1.wav"))
				elseif britain.alliance.id == 1 then
					PlaySample(LoadSample("entwin2.wav"))			
				
				else
					
				end		

					
			end		
		
		------------------------
		-----CENTRAL POWERS-----
		------------------------
			
	elseif playerAlliance.id == 2 then
			
			-------------------------------------------------------------  AG FxBxRx

			if germany.alliance.id == 2
				and austria.alliance.id == 2
				
				and (france.alliance.id == 0 or france.luaData.collaps >= 10)
				and (britain.alliance.id == 0 or britain.luaData.collaps >= 10)
				and (russia.alliance.id == 0 or russia.luaData.collaps >= 10) then
				
				stars = 10
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				PlaySample(LoadSample("cpwin1.wav"))
				GetHighScore(stars)	
				
			-------------------------------------------------------------  AG Fx,Bx/Rx
			elseif germany.alliance.id == 2
				and austria.alliance.id == 2
				
				and (france.alliance.id == 0 or france.luaData.collaps >= 10)
				and ((britain.alliance.id == 0 or britain.luaData.collaps >= 10)
						or (russia.alliance.id == 0 or russia.luaData.collaps >= 10)) then
				
				stars = 9
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)	
				PlaySample(LoadSample("cpwin1.wav"))
				GetHighScore(stars)		

			-------------------------------------------------------------  AG F, Bx,Rx
			elseif germany.alliance.id == 2
				and austria.alliance.id == 2
				
				and france.alliance.id == 1
				and (britain.alliance.id == 0 or britain.luaData.collaps >= 10)
				and (russia.alliance.id == 0 or russia.luaData.collaps >= 10) then
				
				stars = 8
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				PlaySample(LoadSample("cpwin1.wav"))			
				GetHighScore(stars)	
			--------------------------------------------------------------- AG F, Bx/Fx
			elseif germany.alliance.id == 2
				and austria.alliance.id == 2
				
				and france.alliance.id == 1
				and ((britain.alliance.id == 0 or britain.luaData.collaps >= 10)
				 or 	(russia.alliance.id == 0 or russia.luaData.collaps >= 10)) then
				
				stars = 7
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)
				PlaySample(LoadSample("cpwin1.wav"))			
				GetHighScore(stars)				

			-------------------------------------------------------------  G  Fx,Bx,Rx 	 	
			elseif germany.alliance.id == 2
				and (austria.alliance.id == 0 or austria.luaData.collaps >= 10)
				
				and (france.alliance.id == 0 or france.luaData.collaps >= 10)
				and (britain.alliance.id == 0 or britain.luaData.collaps >= 10)
				and (russia.alliance.id == 0 or russia.luaData.collaps >= 10)then
				
				stars = 8
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)	
				 PlaySample(LoadSample("cpwin2.wav"))			
				GetHighScore(stars)	
			 -------------------------------------------------------------  G  Fx,Bx/Rx
			elseif germany.alliance.id == 2
				and (austria.alliance.id == 0 or austria.luaData.collaps >= 10)
				
				and (france.alliance.id == 0 or france.luaData.collaps >= 10)
				and	((britain.alliance.id == 0 or britain.luaData.collaps >= 10)
						or (russia.alliance.id == 0 or russia.luaData.collaps >= 10)) then
				
				stars = 7
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)	
				PlaySample(LoadSample("cpwin2.wav"))			
				GetHighScore(stars)	

			 -------------------------------------------------------------  
			else
				
				stars = 6
				PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
				SetGameOver(playerAlliance.id)	
				 PlaySample(LoadSample("cpwin2.wav"))
				GetHighScore(stars)		

			end
		end			
	
elseif stars <= 5 then

	if playerAlliance.id == 1 then
			
    		PopupFinal("victory_type_" .. stars, "event_entvictory_" .. stars, "entvictory_"  .. stars .. "_text")
			SetGameOver(GetEnemyAlliance(playerAlliance).id)
			PlaySample(LoadSample("lost.wav"))
			GetHighScore(stars)				 
			
	elseif 	playerAlliance.id == 2 then	
			
			if stars <= 2 then
				if cp.luaData.socialists >= 10 
					and GetEvent("OctoberRevolution") >0 then
					--and GetEvent("KaiserAbdicate") <= 0 then
							stars = 1
					
				elseif 	cp.luaData.socialists >=7  
						or GetEvent("KaiserAbdicate") >0 then
							stars = 0
				else
							stars = 2
				end	
			end
	
	
			PopupFinal("victory_type_" .. stars, "event_cpvictory_" .. stars, "cpvictory_"  .. stars .. "_text")
			SetGameOver(GetEnemyAlliance(playerAlliance).id)
			PlaySample(LoadSample("cploss.wav"))
			GetHighScore(stars)
		
	end
end

end

function GetHighScore(stars)
local cp =  game:GetAllianceById(2)
local entente =  game:GetAllianceById(1)

local endscore = stars * 1000
LogUi("ENDSCORE#1" .. endscore)
local bonus = 0
local endrank = "THE UNKNOWN SOLDIER"
for faction in playerAlliance.factions do

		if faction.id == 0 then
			bonus = bonus - (faction.luaData.collaps * 100)
		end
		if faction.id == 1 then
			bonus = bonus - (faction.luaData.collaps * 100)
		end
		if faction.id == 2 then
			bonus = bonus - (faction.luaData.collaps * 100)
		end
		if faction.id == 3 then
			bonus = bonus - (faction.luaData.collaps * 100)
		end
		if faction.id == 4 then
			bonus = bonus - (faction.luaData.collaps * 100)
		end

end		
		endscore = endscore + bonus
		LogUi("ENDSCORE#2" .. endscore)

		if playerAlliance.id == 1 then
			endscore = endscore + (entente.luaData.DP * 5)
		elseif playerAlliance.id == 2 then
			endscore = endscore + (cp.luaData.DP * 5)
		end
		LogUi("ENDSCORE#3" .. endscore)
		LogUi("ENDSCORE#4" .. endscore)

	
if playerAlliance.id == 1 then
if endscore >= 10000 then
		endrank = "PHILIPPE PETAIN"
   
	elseif endscore >9500 then
		endrank = "ALEXEJ BRUSSILOW"	
		
	elseif endscore >9000 then
		endrank = "FERDINAND FOCH"	

	elseif endscore >8500 then
		endrank = "EDMUND ALLENBY"
		
	elseif endscore >8000 then
		endrank = "RADOMIR PUTNIK"	
	
	elseif endscore >7500 then
		endrank = "FREDERICK CAVAN"	
	
	elseif endscore >7000 then
		endrank = "JOSEPH JOFFRE"
		
	elseif endscore >6500 then
		endrank = "PAVEL PLEHWE"
	
	elseif endscore >6000 then
		endrank = "EMMANUEL AOSTA"
		
	elseif endscore >5500 then
		endrank = "KING ALBERT OF BELGIUM"	
	
	elseif endscore >5000 then
		endrank = "NIKOLAJ YUDENICH"
	
	elseif endscore >4500 then
		endrank = "SIR JOHN FRENCH"
		
	elseif endscore >4000 then
		endrank = "PAUL SARRAIL"

	elseif endscore >3500 then
		endrank = "IAN HAMILTON"

	elseif endscore >3000 then
		endrank = "SIR DOUGLAS HAIG"
	
	elseif endscore >2500 then
		endrank = "ROBERT NIVELLE"

	elseif endscore >2000 then
		endrank = "CHARLES TOWNSHEND"

	elseif endscore >1500 then
		endrank = "ALEXEI EVERT"

	elseif endscore >1000 then
		endrank = "ALEXANDER SAMSONOV"

	elseif endscore >=500 then
		endrank = "LUIGI CADORNA"

	elseif endscore < 500 then
		endrank = "PAUL VON RENNENKAMPFF"		
	
	end	
end
if playerAlliance.id == 2 then
	if endscore >= 10000 then
		endrank = "MAX HOFFMANN"
   
	elseif endscore >9500 then
		endrank = "AUGUST VON MACKENSEN"	
		
	elseif endscore >9000 then
		endrank = "OSKAR VON HUTIER"	

	elseif endscore >8500 then
		endrank = "ERICH LUDENDORFF"
		
	elseif endscore >8000 then
		endrank = "HERRMAN VON EICHHORN"	
	
	elseif endscore >7500 then
		endrank = "SVETOZAR BOROJEVIC"	
	
	elseif endscore >7000 then
		endrank = "MUSTAFA KEMAL"
		
	elseif endscore >6500 then
		endrank = "LIEMANN VON SANDERS"
	
	elseif endscore >6000 then
		endrank = "HERRMANN VON FRANCOIS"
		
	elseif endscore >5500 then
		endrank = "EDUARD VON BOEHM-ERMOLLI"	
	
	elseif endscore >5000 then
		endrank = "PAUL VON HINDENBURG"
	
	elseif endscore >4500 then
		endrank = "RUPPRECHT VON BAYERN"
		
	elseif endscore >4000 then
		endrank = "KRONPRINZ WILHELM"

	elseif endscore >3500 then
		endrank = "MAX VON HAUSEN"

	elseif endscore >3000 then
		endrank = "KARL VON BUELOW"
	
	elseif endscore >2500 then
		endrank = "ERICH VON FALKENHAYN"

	elseif endscore >2000 then
		endrank = "HELMUTH VON MOLTKE"

	elseif endscore >1500 then
		endrank = "ALEXANDER VON KLUCK"

	elseif endscore >1000 then
		endrank = "CONRAD VON HOETZENDORF"

	elseif endscore >=500 then
		endrank = "MAXIMILLIAN VON PRITTWITZ"

	elseif endscore < 500 then
		endrank = "OSKAR POTIOREK"		
	
	end	

end
	PopupScorebox("YOUR FINAL SCORE IS: " .. endscore .. ";;YOUR PLACE IN HISTORY IS: " .. endrank)  


end

function GetGameOver()
  if game:GetAllianceById(0).luaData.gameOver ~= nil then
    return true
  else
    return false
  end
end

function GetWinner()
  if game:GetAllianceById(0).luaData.gameOver ~= nil then
    return game:GetAllianceById(0).luaData.gameOver
  else
    return -1
  end
end

function SetGameOver(allianceId)
  game:GetAllianceById(0).luaData.gameOver = allianceId
end
