function AdviceValid(advice)
  if GetUserInt("tutorial_" .. advice, 0) ~= 1 then
    return true
  else
    return false
  end
end

function AdviceClose(advice)
  SetUserInt("tutorial_" .. advice, 1)
end


function AdviceTurnStart()

  -- Cancel if tutorial is switched off
  if settings.tutorial == 0 then
    return
  end

  if game.currentAlliance.id == playerAlliance.id then
    if game.turn == 2 then
      -- Advice popup: city PP layer
      if AdviceValid("showproduction") then
        ui.advicePanel:AddAdvice("showproduction")
        AdviceClose("showproduction")
      end
    end

    -- Advice about the Russian DOW
    if game.turn == 5 then
      if playerAlliance.id == 2 then
        if AdviceValid("russia") then
          ui.advicePanel:AddAdvice("russia")
          AdviceClose("russia")
        end
      end
    end

--~     -- Advice about the invasion of belgium
--~     if game.turn == 3 then
--~       if playerAlliance.id == 2 then
--~         if settings.tutorial["belgium"] ~= 1 then
--~           ui.advicePanel:AddAdvice("belgium", "belgium", 1, 1)
--~           settings.tutorial["belgium"] = 1
--~         end
--~       end
--~     end

--~     -- Advice about the invasion of belgium
--~     if game.turn == 9 then
--~       if playerAlliance.id == 2 then
--~         if settings.tutorial["belgium"] ~= 1 then
--~           ui.advicePanel:AddAdvice("belgium", "belgium", 1, 1)
--~           settings.tutorial["belgium"] = 1
--~         end
--~       end
--~     end
  end

end

function AdviceUnit(unit)

  -- Cancel if tutorial is switched off
  if settings.tutorial == 0 then
    return
  end

  -- Advice popup: Unit selected
  if AdviceValid("unit") then
    LookAtWrapper(unit.hex)
    ui.advicePanel:AddAdvice("unit", {unit.hex.id})
    AdviceClose("unit")
  end

  -- Advice popup: Repair
  if unit.hp < 91 and unit.mp > 0 then
    if AdviceValid("repair") then
      ui.advicePanel:AddAdvice("repair", {792, 730, 1})
      AdviceClose("repair")
    end
  end

  -- Advice unit type
  if AdviceValid(unit.prototype.name) then
    LookAtWrapper(GetHex(unit.hex.x, unit.hex.y - 2))
    ui.advicePanel:AddAdvice(unit.prototype.name)
    AdviceClose(unit.prototype.name)
  end

  -- Advice popup: Out of Ammo
  if GetUnitAmmoRequirement(unit) > unit.faction.am and unit.ap > 0 then
    if AdviceValid("outofammo") then
      LookAtWrapper(unit.hex)
      ui.advicePanel:AddAdvice("outofammo")
      AdviceClose("outofammo")
    end
  end

  -- Advice popup: Naval Transportation
  if AdviceValid("embarkment") then
    if unit.hex.construction ~= nil and unit.mp > 0 then
      local adjacentHex
      for i = 0, 5 do
        adjacentHex = GetAdjacent(unit.hex.x, unit.hex.y, i)
        if adjacentHex ~= nil then
          if adjacentHex.construction ~= nil then
            if adjacentHex.construction.type == Construction.TYPE_PORT then
              ui.advicePanel:AddAdvice("embarkment", {adjacentHex.id})
              AdviceClose("embarkment")
              return
            end
          end
        end
      end
    end
  end

  -- Efficiency
  if unit.efficiency < 70 then
    if AdviceValid("efficiency") then
      ui.advicePanel:AddAdvice("efficiency")
      AdviceClose("efficiency")
    end
  end

end


function AdviceAttack(attacker, defender, attackerDamage, defenderDamage)

  -- Cancel if tutorial is switched off
  if settings.tutorial == 0 then
    return
  end

  -- Only when player is attacker
  if game.currentAlliance.id == playerAlliance.id then

--~       -- Units without Bombard perform direct attacks
--~       local bombard = false
--~       if attacker.bombard >= 1 then
--~         if attacker.type == "naval" then
--~           if defender.type == "land" then
--~             -- Naval unit use bombard attack against land target
--~             bombard = true
--~           end
--~         else
--~           bombard = true
--~         end
--~       end

      -- Advice efficiency
--~       if attacker.efficiency < 70 then
--~         if settings.tutorial["efficiency"] ~= 1 and settings.tutorial["on"] == 1 then
--~           ui.advicePanel:AddAdvice("efficiency", "efficiency", 1, 1)
--~           settings.tutorial["efficiency"] = 1
--~         end
--~       end

      -- Advice retreat
      if gameplay.retreat then
        if AdviceValid("retreat") then
          ui.advicePanel:AddAdvice("retreat")
          AdviceClose("retreat")
        end
      end

      -- Advice air intercept
    end

end

function AdviceMove(unit)

  -- Cancel if tutorial is switched off
  if settings.tutorial == 0 then
    return
  end

  -- Only when player is attacker
  if unit.faction.alliance.id == playerAlliance.id and game.currentAlliance.id == playerAlliance.id then

    -- Advice popup
    if unit.alliance.id == playerAlliance.id then
      if AdviceValid("movement") then
        ui.advicePanel:AddAdvice("movement")
        AdviceClose("movement")
      end
    end

    -- Advice popup
    if unit.efficiency < 70 then
      if AdviceValid("efficiency") then
        ui.advicePanel:AddAdvice("efficiency")
        AdviceClose("efficiency")
      end
    end

  end

end

function AdviceFactionProduction(faction, tab)

  -- Cancel if tutorial is switched off
  if settings.tutorial == 0 then
    return
  end

end

function AdviceDeploy(faction, unit)

  -- Cancel if tutorial is switched off
  if settings.tutorial == 0 then
    return
  end

  if faction.luaData.colonial == 1 then
    if AdviceValid("colonial") then
      LookAtWrapper(game:GetHex(137, game.map.hexHeight - 1))
      ui.advicePanel:AddAdvice("colonial")
      AdviceClose("colonial")
    end
  end

end
