MAX_FLAGS_PER_PANEL = 26

class 'DiplomacyPanel' (LuaPanel)

function DiplomacyPanel:__init(alliance)
  LuaPanel.__init(self, diplomacy)
  
   


  self.tabImage = self:AddWidget({
    type = "image",
    position = {66, 315},
    image = "infotab1"
  })
  self.closeButton = self:AddWidget({
    name = "close_label",
    type = "button",
    image = "button_default",
    position = {195, 492},
    text = "close",
    sfx = "click",
    on_click = function(button)
      button.parent:Hide()
      ui.hotkeysActive = 1
    end
  })
 
   
  
  self:AddWidget({
    name = "stats_label",
    type = "label",
    position = {128, 330},
    align = "center",
    font = "hud12_font",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "statistics",
    sfx = "click",
    on_click = function(button)
      button.parent.statisticsPanel:Show()
     -- button.parent.relationPanel:Show()
      button.parent:UpdateRelationStats(ui.selectedRelation)
      button.parent.informationPanel:Hide()
      button.parent.tabImage:SetImage("graphics/hud", "infotab1.png")
    --  self.closeButton:Hide()
	 -- self.eventButton:Show()
    end
  })
  self:AddWidget({
    name = "info_label",
    type = "label",
    position = {258, 330},
    align = "center",
    font = "hud12_font",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "information",
    sfx = "click",
    on_click = function(button)
      button.parent.statisticsPanel:Hide()
      --button.parent.relationPanel:Hide()
      button.parent.informationPanel:Show()
	  	  

      button.parent.informationPanel.content:SetLocalText(ui.selectedRelation.name .. "_info")
      button.parent.tabImage:SetImage("graphics/hud", "infotab2.png")
      self.closeButton:Show()
    end
  })

  self.informationPanel = self:AddWidget({
    type = "panel",
  })
  self.informationPanel.content = self.informationPanel:AddWidget({
    type = "memo",
    position = {78, 357},
    size = {220, 120},
    font = "times12_font",
    color   = {224, 220, 218},
    border = 0,
    OnScroll = function(this, delta)
      if delta == 1 then
        if self.informationPanel.content.startingLine > 0 then
          self.informationPanel.content.startingLine = self.informationPanel.content.startingLine - 1
          self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
        end
      else
        if self.informationPanel.content.startingLine < self.informationPanel.content.numLines - 8 then
          self.informationPanel.content.startingLine = self.informationPanel.content.startingLine + 1
          self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
        end
      end
    end
  })
  self.informationPanel:AddWidget({
    type = "button",
    image = "scroll_up",
    position = {230+66, 43+315},
    sfx = "click",
    on_click = function(button)
      if self.informationPanel.content.startingLine > 0 then
        self.informationPanel.content.startingLine = self.informationPanel.content.startingLine - 1
        self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
      end
    end
  })
  self.informationPanel:AddWidget({
    type = "button",
    image = "scroll_down",
    position = {230+66, 148+315},
    sfx = "click",
    on_click = function(button)
      if self.informationPanel.content.startingLine < self.informationPanel.content.numLines - 8 then
        self.informationPanel.content.startingLine = self.informationPanel.content.startingLine + 1
        self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
      end
    end
  })
   
  
  self.informationPanel.pagebar = self.informationPanel:AddWidget({
    type = "image",
    image = "pagebar_dark",
    position = {235+66, 63+315},
  })
  self.informationPanel:Hide()

  self.alliance = alliance

  -- Create sub panel types
  self.statisticsPanel = self:AdoptWidget(RelationStatsPanel())

  -- Create alliance flag buttons
  self.flags = {}
  local slot = 1
  for faction in playerAlliance.factions do
    -- only for factions with capitals
    if (faction.luaData.capitals > 0 or IsNewFaction(faction) == true) then
      self:FactionDiplomacyFlag(faction, slot)
      slot = slot + 1
    end
  end


  self:AddWidget({
    name = "relation_flag",
    type = "image",
    position = {76, 130},
  })
  self:AddWidget({
    name = "relation_name",
    type = "text",
    font = "times16_font",
    position = {195, 289},
    color   = {67, 56, 47},
    align = "center"
  })

  self.allianceName = {}
  self.allianceColour = {}
  for i = 0, 2 do
    self.allianceName[i] = self:AddWidget({
      type = "text",
      font = "hud14_font",
      position = {250, 30},
      align = "left",
      color   = {67, 56, 47},
      text = "alliance" .. i .. "_title"
    })
    self.allianceColour[i] = self:AddWidget({
      type = "image",
      position = {250, 30},
      image = "alliance_colour_" .. i
    })
  end

  self.relationsRow = {}
  for i = 0, 5 do
    self.relationsRow[i] = self:AddWidget({
      type = "image",
      position = {250, 30},
      image = "relations_row"
    })
  end

  j = 0
  self.relations = {}
  -- Create relation flags
  for faction in game.factions do
    if IsFactionVisible(faction) then

      --  Select first nation by default
      if j == 0 then
        ui.selectedRelation = faction
      end

      self.relations[faction.id] = self:AdoptWidget(DiplomacyRelationFlag(faction, j))

      j = j + 1

      -- Dont exceed max flags
      if j == MAX_FLAGS_PER_PANEL then
        break
      end

    end
  end


end

function DiplomacyPanel:OnShow()
  
self:Refresh()
  self:UpdateRelationStats(ui.selectedRelation)
  self:RefreshRelations()
  ui.hotkeysActive = 0
  	

end

function DiplomacyPanel:FactionDiplomacyFlag(faction, slot)

  --wow what a bad hack...
  if slot == nil then
    slot = 0
    for faction2 in playerAlliance.factions do
      if faction2.luaData.capitals > 0 or faction.id == 26 or faction.id == 27  then
        slot = slot + 1
      end
    end
  end


  if self.flags[faction.id] == nil then

    local factionName = faction.name

    self.flags[faction.id] = self:AddWidget({
      name = "flag" .. faction.id .. "_button",
      type = "button",
      image = "../flags/flag_" .. factionName .. "_32_button",
      position = {19, 16 + (slot - 1) * 30},
      sfx = "click",
      tooltip = factionName,
      on_click = function(button)
        ui.diplomacyFaction = faction
        SelectPanelFaction(faction)
        self:Refresh()
      end
    })

    -- Auto select first flag
    if slot == 1 then
      self:GetText("pp_value"):SetNumber(GetIncomePP(faction) - GetUpkeep(faction) - GetResearchUpkeep(faction))
      self:GetText("mp_value"):SetNumber(faction.mp)
      self:GetText("am_value"):SetNumber(GetIncomeAM(faction))
      self:GetText("faction_name"):SetLocalText(faction.name .. "_title")
  --    self:GetText("alliance_name"):SetLocalText(faction.alliance.name)
      self:GetImage("faction_flag"):SetImage("graphics/flags","flag_" .. factionName .. "_128.png")

      ui.diplomacyFaction = faction
    end

  else
    self.flags[faction.id]:SetPosition(19, 16 + (slot - 1) * 30)
    self.flags[faction.id]:Show()
  end

end

function DiplomacyPanel:RemoveDiplomacyFlag(faction)
  -- If this faction is currently selected, select another
  if ui.diplomacyFaction.id == faction.id then
    for otherFaction in playerAlliance.factions do
      if CanFactionProduce(otherFaction) then
        ui.diplomacyFaction = otherFaction
        SelectPanelFaction(otherFaction)
        break
      end
    end
  end

  -- Remove flag button
  self:GetButton("flag" .. faction.id .. "_button"):Hide()

  -- Shift other flags
  local slot = 1
  for otherFaction in playerAlliance.factions do
    if CanFactionProduce(otherFaction) then
      self.flags[otherFaction.id]:SetPosition(19, 16 + (slot - 1) * 30)
      slot = slot + 1
    end
  end
end

function DiplomacyPanel:RefreshRelations()

 print("refresh")
  local counter = {}
  counter[0] = 0
  counter[1] = 0
  counter[2] = 0

  local totalRows = {}
  totalRows[ui.playerAlliance.id] = math.floor((playerAlliance.numFactions - 1) / 6) + 1
   totalRows[ui.neutralAlliance.id] = math.floor((ui.neutralAlliance.numFactions - 1) / 6)
  totalRows[ui.enemyAlliance.id] = math.floor((ui.enemyAlliance.numFactions - 1) / 6) + 1
  totalRows[ui.neutralAlliance.id] = 6 - totalRows[playerAlliance.id] - totalRows[ui.enemyAlliance.id]

   if totalRows[playerAlliance.id] + totalRows[ui.neutralAlliance.id] + totalRows[enemyAlliance.id] < 6 then
     totalRows[ui.neutralAlliance.id] = totalRows[ui.neutralAlliance.id] + 1
   end
 print(playerAlliance.numFactions)
 print(ui.enemyAlliance.numFactions)
 print(totalRows[playerAlliance.id])
 print(totalRows[ui.enemyAlliance.id])
 print(totalRows[ui.neutralAlliance.id])
  for faction in game.factions do
    if IsFactionVisible(faction) then
      local flag = self.relations[faction.id]
      if faction.alliance.id == playerAlliance.id then
        flag:SetPosition(361 + (counter[playerAlliance.id] % 6) * 81, 58 + math.floor(counter[playerAlliance.id] / 6) * 66)
        counter[playerAlliance.id] = counter[playerAlliance.id] + 1
      elseif faction.alliance.id == 0 then
        flag:SetPosition(361 + (counter[0] % 6) * 81, 58 + 30 + totalRows[playerAlliance.id] * 66 + math.floor(counter[0] / 6) * 66)
        counter[0] = counter[0] + 1
      else
        flag:SetPosition(361 + (counter[ui.enemyAlliance.id] % 6) * 81, 58 + 30 + 30 + totalRows[ui.neutralAlliance.id] * 66 + totalRows[playerAlliance.id] * 66 + math.floor(counter[ui.enemyAlliance.id] / 6) * 66)
        counter[ui.enemyAlliance.id] = counter[ui.enemyAlliance.id] + 1
      end
    end
  end
  for alliance in game.alliances do
    self.allianceName[playerAlliance.id]:SetPosition(387, 38)
    self.allianceColour[playerAlliance.id]:SetPosition(360, 38)
    self.allianceName[ui.neutralAlliance.id]:SetPosition(387, 38 + 30 + totalRows[playerAlliance.id] * 66)
    self.allianceColour[ui.neutralAlliance.id]:SetPosition(360, 38 + 30 + totalRows[playerAlliance.id] * 66)
    self.allianceName[ui.enemyAlliance.id]:SetPosition(387, 38 + 30 + 30 + totalRows[ui.neutralAlliance.id] * 66 + totalRows[playerAlliance.id] * 66)
    self.allianceColour[ui.enemyAlliance.id]:SetPosition(360, 38 + 30 + 30 + totalRows[ui.neutralAlliance.id] * 66 + totalRows[playerAlliance.id] * 66)
  end

  local rowcount = 0
  for i = 0, totalRows[playerAlliance.id] - 1 do
    self.relationsRow[rowcount]:SetPosition(357, 54 + i * 66)
    rowcount = rowcount + 1
  end
  for i = rowcount, rowcount + totalRows[ui.neutralAlliance.id] - 1 do
    self.relationsRow[rowcount]:SetPosition(357, 84 + i * 66)
    rowcount = rowcount + 1
  end
  for i = rowcount, rowcount + totalRows[ui.enemyAlliance.id] - 1 do
    self.relationsRow[rowcount]:SetPosition(357, 114 + i * 66)
    rowcount = rowcount + 1
  end
end

function DiplomacyPanel:UpdateRelationStats(faction)

  self.statisticsPanel:Refresh(faction)
		
				
				
			
end


function DiplomacyPanel:Refresh(faction)
		
		if faction ~= nil then
			self:GetText("pp_value"):SetNumber(ui.diplomacyFaction.pp)
			self:GetText("mp_value"):SetNumber(ui.diplomacyFaction.mp)
			self:GetText("am_value"):SetNumber(ui.diplomacyFaction.am)
			self:GetText("faction_name"):SetLocalText(ui.diplomacyFaction.name .. "_title")
			self:GetImage("faction_flag"):SetImage("graphics/flags","flag_" .. ui.diplomacyFaction.name .. "_128.png")
		end

end

-----------------------------------------------------------------------


class 'DiplomacyRelationFlag' (LuaPanel)

function DiplomacyRelationFlag:__init(faction)
  LuaPanel.__init(self)

  self:AddWidget({
    name = "flag" .. faction.id .. "_button",
    type = "button",
    image = "../flags/flag_" .. faction.name .. "_64_button",
    position = {0, 0},
    sfx = "click",
    tooltip = faction.name,
    on_click = function(button)
      self.parent:UpdateRelationStats(faction)
    end
  })

end


-----------------------------------------------------------------------

class 'RelationStatsPanel' (LuaPanel)

function RelationStatsPanel:__init()
			
 
  LuaPanel.__init(self)
  
  	self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 411},
    align = "left",
    color = {241, 237, 233},
    text = "Influence:"
  })
  
	self.influenceNumber = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {152, 411},
    align = "left",
    color = {248, 215, 53},
  })
  
  
  self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 431},
    align = "left",
    color = {241, 237, 233},
    text = "Diplo budget:"
  })
  
	self.diplobudget = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {173, 431},
    align = "left",
    color = {248, 215, 53},
  })
  
   	self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 451},
    align = "left",
    color = {241, 237, 233},
    text = "Diplo cost:"
  })
  
	self.diplobudgetcost = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {162, 451},
    align = "left",
    color = {241, 237, 233},
  })
  
   	self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 471},
    align = "left",
    color = {241, 237, 233},
    text = "Gain/turn:"
  })
  
  self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 491},
    align = "left",
    color = {241, 237, 233},
    text = "Intel:"
  })
  
	self.intelNumber = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {127, 491},
    align = "left",
    color = {241, 237, 233},
  })
  
   self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 511},
    align = "left",
    color = {241, 237, 233},
    text = ""
  })
  
	self.cypher = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 511},
    align = "left",
    color = {241, 237, 233},
  })
  
  
	self.diploincome = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {162, 471},
    align = "left",
    color = {241, 237, 233},
  })
  	self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {80, 367},
    align = "left",
    color = {241, 237, 233},
    text = "relation_status"
  })
 
 
  self.relationStatus = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {210, 367},
    align = "left",
    color = {248, 215, 53},
  })
   self.relationNumber = self:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {290, 367},
    align = "left",
    color = {248, 215, 53},
  })


  
  self:AddWidget({
    type = "image",
    image = "progress_black",
    position = {90, 386},
  })

  self.alignmentBar = self:AddWidget({
    type = "image",
    image = "progress_green",
    position = {90, 386},
  })
  
  self.eventcount = self:AddWidget({         --------new
    type = "text",
    font = "hud12_font",
    position = {195, 465},
    align = "left",
    color = {241, 237, 233},
    text = "SPECIAL EVENT %",
	tooltip = "event_prob",
             
  })
  self.eventcountnumber = self:AddWidget({  ---- new
    type = "text",
    font = "hud12_font",
    position = {250, 479},
    align = "left",
    color = {241, 237, 233},
  })
  
  

	 self.counterButton = self:AddWidget({
    name = "dow_button",
    type = "button",
    image = "button_default",
    position = {195, 402},
    text = "COUNTER INTEL",
    sfx = "click",
    on_click = function(button)
      CounterIntelligence(playerAlliance, ui.diplomacyFaction)
    local budget
local budgetcost
local entente = game:GetAllianceById(1)
local cp = game:GetAllianceById(2)  
   
   if game.currentAlliance.id == 1 then
		
		budget = entente.luaData.DP 
		budgetcost = entente.luaData.DPcost 
			if budget <0 then
				budget =0
			end
  else
  	
	budget = cp.luaData.DP 		
  	budgetcost = cp.luaData.DPcost 
			if budget <0 then
				budget =0
			end
  end
local faction = ui.selectedRelation
	if playerAlliance.id ~= faction.alliance.id then
 
		playerAlliance = GetPlayer().alliance
		if playerAlliance.luaData.DPcost < playerAlliance.luaData.DP then
		self.diplobudget:SetColour( 241, 237, 233,255)
		else
		self.diplobudget:SetColour(248, 215, 53,255)

		end
		RefreshDiplomacy()
		self.diplobudget:SetNumber(budget)
		self.diplobudgetcost:SetNumber(budgetcost)
		RefreshDiplomacy()
		ui.diplomacyPanel:Refresh()
	end
 if playerAlliance.id == faction.alliance.id then
		playerAlliance = GetPlayer().alliance
		if playerAlliance.luaData.DPcost < playerAlliance.luaData.DP then
		self.diplobudget:SetColour( 241, 237, 233,255)
		else
		--self.diplobudget:SetColour(248, 215, 53,255)

		end
		
		RefreshDiplomacy()
		self.diplobudget:SetNumber(budget)
		self.diplobudgetcost:SetNumber(budgetcost)
		RefreshDiplomacy()
		ui.diplomacyPanel:Refresh()
 end

        ui.mainPanel.diplomacyTab:Refresh()
      end
     
  })




self.eventButton = self:AddWidget({
    name = "event_button",
    type = "button",
    image = "button_default",
    position = {195, 432},
    text = "CHOOSE EVENT",
--	tooltip = "chooseevent",
    sfx = "click",
       on_click = function(button) --- DIPLO
		EventProb()
		DoDiploEvents()

	--	ShowEvents("cp")
		
local budget
local budgetcost
local entente = game:GetAllianceById(1)
local cp = game:GetAllianceById(2)  
  
  
   if game.currentAlliance.id == 1 then
		
		budget = entente.luaData.DP 
		budgetcost = entente.luaData.DPcost 
			if budget <0 then
				budget =0
			end
  else
  	
	budget = cp.luaData.DP 		
  	budgetcost = cp.luaData.DPcost 
			if budget <0 then
				budget =0
			end
  end
local faction = ui.selectedRelation
	if playerAlliance.id ~= faction.alliance.id then
 
				playerAlliance = GetPlayer().alliance
				if playerAlliance.luaData.DPcost < playerAlliance.luaData.DP then
				self.diplobudget:SetColour( 241, 237, 233,255)
				else
			--	self.diplobudget:SetColour(248, 215, 53,255)

				end
				RefreshDiplomacy()
				self.diplobudget:SetNumber(budget)
			--	LogUi("YA")
				self.diplobudgetcost:SetNumber(budgetcost)
						--		LogUi("YU")

				RefreshDiplomacy()
	end
	if playerAlliance.id == faction.alliance.id then
			 
				playerAlliance = GetPlayer().alliance
				
				
				self.diplobudget:SetNumber(budget)
				--				LogUi("AA")

				self.diplobudgetcost:SetNumber(budgetcost)
					--			LogUi("BB")

				
				RefreshDiplomacy()
				ui.diplomacyPanel:Refresh()
				self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)
				RefreshDiplomacy()
	end 
 ui.diplomacyPanel:Refresh()
 
 
		end	

  })


  self.allyPanel = self:AdoptWidget(RelationAllyPanel())
  self.enemyPanel = self:AdoptWidget(RelationEnemyPanel())
  self.neutralPanel = self:AdoptWidget(RelationNeutralPanel())
  self.currentPanel = self.allyPanel


end

function RelationStatsPanel:OnShow()


RefreshDiplomacy()
end

function RelationStatsPanel:Refresh(faction)
  ui.selectedRelation = faction
--	ui.diplomacyFaction = faction

		


  self.parent:GetText("relation_name"):SetLocalText(faction.name .. "_title")
  self.parent:GetImage("relation_flag"):SetImage("graphics/flags","flag_" .. faction.name .. "_32_dis.png")
  self.parent.informationPanel.content:SetLocalText(ui.selectedRelation.name .. "_info")
  self.parent.informationPanel.content.maxLines = 8
  self.parent.informationPanel.pageCount = math.max(8, self.parent.informationPanel.content.numLines)
  self.parent.informationPanel.pagebar:SetSource(0, 0, 6, 80 * 8 / self.parent.informationPanel.pageCount)

  self.parent:GetText("pp_value"):SetNumber(ui.diplomacyFaction.pp)
  self.parent:GetText("mp_value"):SetNumber(ui.diplomacyFaction.mp)
  self.parent:GetText("am_value"):SetNumber(ui.diplomacyFaction.am)
 
	--LogUi("UXXX:" .. ui.diplomacyFaction.id)
	
local budget
local budgetcost
local entente = game:GetAllianceById(1)
local cp = game:GetAllianceById(2)  
   
   if game.currentAlliance.id == 1 then
	--	entente.luaData.DP = math.ceil(entente.luaData.DP)
	--	entente.luaData.DPcost = math.ceil(entente.luaData.DPcost)
		budget = entente.luaData.DP 
		budgetcost = entente.luaData.DPcost 
			if budget <0 then
				budget =0
			end
  else
  	--cp.luaData.DP = math.ceil(cp.luaData.DP)
	--	cp.luaData.DPcost = math.ceil(cp.luaData.DPcost)
	budget = cp.luaData.DP 		
  	budgetcost = cp.luaData.DPcost 
			if budget <0 then
				budget =0
			end
  end

 if playerAlliance.id ~= faction.alliance.id then
				 self.eventButton:Hide()
				self.counterButton:Show()
				self.eventcountnumber:Show()	
				self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)

					playerAlliance = GetPlayer().alliance
									if playerAlliance.luaData.DPcost < playerAlliance.luaData.DP then
									self.diplobudget:SetColour( 241, 237, 233,255)
									else
								--	self.diplobudget:SetColour(248, 215, 53,255)

									end
					RefreshDiplomacy()
					self.diplobudget:SetNumber(budget)
					--LogUi("789")
					self.diplobudgetcost:SetNumber(budgetcost)
					self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)

					RefreshDiplomacy()
 
 end
 if playerAlliance.id == faction.alliance.id then
self.eventButton:Hide()
self.counterButton:Hide() 
self.eventButton:Show()
self.eventcount:Show() 
self.eventcountnumber:Show()



self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)
self.eventcountnumber:Show()
self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)


self.counterButton:Show() 
	playerAlliance = GetPlayer().alliance
	
	RefreshDiplomacy()
	self.diplobudget:SetNumber(budget)
	self.diplobudgetcost:SetNumber(budgetcost)
	--LogUi("820")
	RefreshDiplomacy()
 end 
if ui.selectedRelation.id ~= ui.diplomacyFaction.id then --faction.alliance.id then
--	self.counterButton:Hide()
--	self.eventcount:Hide() 
--	self.eventcountnumber:Hide()
	self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)
	RefreshDiplomacy()
	self.eventcount:Hide() 
	self.eventcountnumber:Hide()
end
  
local entente = game:GetAllianceById(1)
local cp = game:GetAllianceById(2)
  if playerAlliance.id == 1 then
  local income = entente.luaData.DPincome
    self.diploincome:SetNumber(income)

  else
  local income = cp.luaData.DPincome
 -- LogUi("Income:" .. income)
  self.diploincome:SetNumber(cp.luaData.DPincome)

  end
  local percent
  if playerAlliance.id == 1 then
    percent = faction.luaData.alignment
  else
    percent = 100 - faction.luaData.alignment
  end
		  self.relationNumber:SetNumber(percent)
	
---	

  ---
  
  self.currentPanel:Hide()
  if faction.id ~= ui.diplomacyFaction.id then
    if percent == 100 then
      self.currentPanel = self.allyPanel
    elseif percent == 0 then
      self.currentPanel = self.enemyPanel
    else
      self.currentPanel = self.neutralPanel
    end
    self.currentPanel:Show()
  end

  if ui.selectedRelation.alliance.id == playerAlliance.id then
    self.relationStatus:SetLocalText("status_ally")
    self.relationStatus:SetColour(192,204,111,255)
  end

  -- Alignment bar & status update
  if percent < 30 then
    self.alignmentBar:SetImage("graphics/hud", "progress_red.png")
    if percent == 0 then
      self.relationStatus:SetLocalText("status_enemy")
      self.relationStatus:SetColour(255,48,48,255)
    else
      self.relationStatus:SetLocalText("status_resentful")
      self.relationStatus:SetColour(255,145,48,255)
	  self.influenceNumber:SetColour(255,145,48,255)    
	  
	end
	elseif percent > 70 then
    self.alignmentBar:SetImage("graphics/hud", "progress_green.png")
    if percent == 100 then
      self.relationStatus:SetLocalText("status_ally")
      self.relationStatus:SetColour(174,237,40,255)

    else
      self.relationStatus:SetLocalText("status_sympathetic")
      self.relationStatus:SetColour(233,255,48,255)
	  self.influenceNumber:SetColour(233,255,48,255)    

    end
  else
    self.alignmentBar:SetImage("graphics/hud", "progress_yellow.png")
    self.relationStatus:SetLocalText("status_neutral")
    self.relationStatus:SetColour(248, 215, 53,255)
		  self.influenceNumber:SetColour(248, 215, 53,255)    

  end
  self.alignmentBar:SetSource(0, 0, 1+202*percent/100, 8)

			local influence 
   			local entente = game:GetAllianceById(1)
			local cp = game:GetAllianceById(2)
			local belgium  = game:GetFactionById(6)
			local totintcp = GetTotalIntel(cp)
			local totintent = GetTotalIntel(entente)

if (faction.id >= 8 and faction.alliance.id == 0) or (faction.id == 6 and belgium.luaData.caninfluence == 2 and GetEvent("Surrenderbelgium") == 0) then
		  if playerAlliance.id == 1 then
		  influence = entente.luaData.influence[faction.id] -- - cp.luaData.influence[faction.id]
		  else
		  influence = cp.luaData.influence[faction.id] --- entente.luaData.influence[faction.id]
		 
		 -- LogUi("1x" .. cp.luaData.influence[faction.id])
		 -- LogUi("2x" .. entente.luaData.influence[faction.id])
		  
		  end
    			self.influenceNumber:SetNumber(influence)

		playerAlliance = GetPlayer().alliance

		if  (playerAlliance.id == 2 and cp.luaData.influence[faction.id] > entente.luaData.influence[faction.id] and totintcp > totintent ) or (playerAlliance.id == 1 and entente.luaData.influence[faction.id] > cp.luaData.influence[faction.id] and totintent > totintcp) then
		self.influenceNumber:SetColour(174,237,40,255) --green
		else
				self.influenceNumber:SetColour(241, 237, 233,255) --red

		end		
		
elseif playerAlliance.id == faction.alliance.id then
	    	self.influenceNumber:SetLocalText("Allied")	
			self.influenceNumber:SetColour(174,237,40,255)

else

    	self.influenceNumber:SetLocalText("n.a.")	
		
end  
--------------- INTEL
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local intel = 0
-- playerAlliance = GetPlayer().alliance

 if playerAlliance.id == 1 then
	--	if entente.luaData.intel[faction.id] == nil then
	--		entente.luaData.intel[faction.id] = 0
	--	end
		if cp.luaData.influence[faction.id] == nil then
		cp.luaData.influence[faction.id] = 0
		end
		if entente.luaData.influence[faction.id] == nil then
		entente.luaData.influence[faction.id] = 0
		end
			if cp.luaData.intel[faction.id] == nil then
		cp.luaData.intel[faction.id] = 0
		end
		if entente.luaData.intel[faction.id] == nil then
		entente.luaData.intel[faction.id] = 0
		end
	--ENT	
		
		intel = entente.luaData.intel[faction.id]
		if player.alliance.id ~= faction.alliance.id then
			self.intelNumber:SetNumber(intel)
				if entente.luaData.sigint[faction.id] <= cp.luaData.sigint[faction.id]   then --- own cipher must be higher to break enemys
					self.cypher:SetLocalText("Cipher unknown")
					self.cypher:SetColour(241, 237, 233, 255) --- white

				else -- own cipher greater: good!
					self.cypher:SetLocalText("Cipher decoded")
					self.cypher:SetColour(174,237,40,255) -- green
					----INTEL--------
						if entente.luaData.intel[faction.id] >  cp.luaData.intel[faction.id] then
							self.intelNumber:SetColour(174,237,40,255) -- green
						
						elseif entente.luaData.intel[faction.id] *2 <=  cp.luaData.intel[faction.id]
								and entente.luaData.intel[faction.id] >0 then
								self.intelNumber:SetColour(255,48,48,255) ---red
								
						elseif entente.luaData.intel[faction.id] <=  cp.luaData.intel[faction.id]
								and entente.luaData.intel[faction.id] >0 then
							self.intelNumber:SetColour(248, 215, 53,255) -- yellow
						
						else
							self.intelNumber:SetColour(241,237,233,255)  ----white
						end	
						---- INF ------
						if entente.luaData.influence[faction.id] >  cp.luaData.influence[faction.id] then
							self.influenceNumber:SetColour(174,237,40,255) -- green
						
						elseif entente.luaData.influence[faction.id] *2 <  cp.luaData.influence[faction.id]
								and entente.luaData.influence[faction.id] >0 then
								self.influenceNumber:SetColour(255,48,48,255) ---red
								
						elseif entente.luaData.influence[faction.id] <  cp.luaData.influence[faction.id]
								and entente.luaData.influence[faction.id] >0 then
							self.influenceNumber:SetColour(248, 215, 53,255) -- yellow
						
						else
							self.influenceNumber:SetColour(241,237,233,255)  ----white
						end	
						
						-----------
					end		
		
		elseif player.alliance.id == faction.alliance.id then
				self.intelNumber:SetLocalText("Allied")	
				self.intelNumber:SetColour(174,237,40,255)
				
				if cp.luaData.sigint[faction.id] <= entente.luaData.sigint[faction.id]  then
					self.cypher:SetLocalText("Cipher safe!")	  ------241, 237, 233 - white
					self.cypher:SetColour(174,237,40,255) -- green
				else self.cypher:SetLocalText("Cipher broken") -- 255,48,48,255 red
					self.cypher:SetColour(255,48,48,255)
				end
		end
		
  else
		
 --CP
		if cp.luaData.influence[faction.id] == nil then
		cp.luaData.influence[faction.id] = 0
		end
		if entente.luaData.influence[faction.id] == nil then
		entente.luaData.influence[faction.id] = 0
		end
			if cp.luaData.intel[faction.id] == nil then
		cp.luaData.intel[faction.id] = 0
		end
		if entente.luaData.intel[faction.id] == nil then
		entente.luaData.intel[faction.id] = 0
		end
		
		intel = cp.luaData.intel[faction.id]
		
		if player.alliance.id ~= faction.alliance.id then
		self.intelNumber:SetNumber(intel)
				
				
			if cp.luaData.sigint[faction.id] <= entente.luaData.sigint[faction.id] then
					self.cypher:SetLocalText("Cipher unknown")
					self.cypher:SetColour(241, 237, 233,255)

				else -- own cipher greater: good!
					self.cypher:SetLocalText("Cipher decoded")
					self.cypher:SetColour(174,237,40,255)
				------------
			----INTEL--------
				if cp.luaData.intel[faction.id] >  entente.luaData.intel[faction.id] then
					self.intelNumber:SetColour(174,237,40,255) -- green
				
				elseif cp.luaData.intel[faction.id] *2 <  entente.luaData.intel[faction.id]
						and cp.luaData.intel[faction.id] >=0 then
						self.intelNumber:SetColour(255,48,48,255) ---red
						
				elseif cp.luaData.intel[faction.id] <=  entente.luaData.intel[faction.id]
						and cp.luaData.intel[faction.id] >0 then
					self.intelNumber:SetColour(248, 215, 53,255) -- yellow
				
				else
					self.intelNumber:SetColour(241,237,233,255)  ----white
				end	
				---- INF ------
				if cp.luaData.influence[faction.id] >  entente.luaData.influence[faction.id] then
					self.influenceNumber:SetColour(174,237,40,255) -- green
				
				elseif cp.luaData.influence[faction.id] *2 <  entente.luaData.influence[faction.id]
						and cp.luaData.influence[faction.id] >=0 then
						self.influenceNumber:SetColour(255,48,48,255) ---red
						
				elseif cp.luaData.influence[faction.id] <=  entente.luaData.influence[faction.id]
						and cp.luaData.influence[faction.id] >=0 then
					self.influenceNumber:SetColour(248, 215, 53,255) -- yellow
				
				else
					self.influenceNumber:SetColour(241,237,233,255)  ----white
				end	
				
				-----------
				
				-----------
					
					
			end	
		
		elseif player.alliance.id == faction.alliance.id then
				self.intelNumber:SetLocalText("Allied")	
				self.intelNumber:SetColour(174,237,40,255)
				
				if entente.luaData.sigint[faction.id] <=  cp.luaData.sigint[faction.id]  then
					self.cypher:SetLocalText("Cipher safe!")	 -- green
					self.cypher:SetColour(174,237,40,255)
				else self.cypher:SetLocalText("Cipher broken") -- 255,48,48,255
					self.cypher:SetColour(255,48,48,255)
				end

		end

  end
      		--	self.intelNumber:SetNumber(intel)
 --local eventcounter = 0
--EventProb()
ui.diplomacyPanel:Refresh()

self.eventcountnumber:SetNumber(game.currentAlliance.luaData.eventcounter)

end


-----------------------------------------------------------------------

 
 

diplomacy =
{
  name = "diplomacy_panel",
  type = "panel",
  position = {(engine.window.width)/2-437, (engine.window.height-200)/2-274},
  image = "diplomacy_panel",
  visible = false,

  tooltip =
  {
    rect  = {100, 100, 0, 0},
   -- color = (255,255,255),
   -- bgcolor = (10,10,10),
    font  = "hud_font"
  },

  controls =
  {
    {
      name = "pp_title",
      type = "image",
      position = {204, 39},
      image = "resource_pp_white",
      tooltip = "resourcePP"
    },
    {
      name = "pp_value",
      type = "text",
      font = "hud14_font",
      position = {258, 48},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentPP"
    },
    {
      name = "mp_title",
      type = "image",
      position = {204, 64},
      image = "resource_mp_white",
      tooltip = "resourceMP"
    },
    {
      name = "mp_value",
      type = "text",
      font = "hud14_font",
      position = {258, 73},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentMP"
    },
    {
      name = "am_title",
      type = "image",
      position = {204, 89},
      image = "resource_am_white",
      tooltip = "resourceAM"
    },
    {
      name = "am_value",
      type = "text",
      font = "hud14_font",
      position = {258, 98},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentAM"
    },
    {
      name = "pp_income",
      type = "text",
      font = "hud12_font",
      position = {298, 48},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "incrementPP"
    },
	
	{
       name = "mp_income",
       type = "text",
       font = "hud12_font",
       position = {298, 73},
       align = "center",
       color   = {241, 237, 233},
       tooltip = "incrementMP"
     },
    {
      name = "am_income",
      type = "text",
      font = "hud12_font",
      position = {298, 98},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "incrementAM"
    },
	
    {
      name = "faction_name",
      type = "text",
      font = "hud14_font",
      position = {258, 24},
      align = "center",
      color   = {241, 237, 233},
    },
    {
      name = "faction_flag",
      type = "image",
      position = {65, 16},
    },
  }
}


-----------------------------------------------------------------------

class 'RelationNeutralPanel' (LuaPanel)




function RelationNeutralPanel:__init()

 LuaPanel.__init(self)

-----
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
-----
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local germany = game:GetFactionById(2)
local austria = game:GetFactionById(3)
local russia = game:GetFactionById(4)
local turkey = game:GetFactionById(5)
local belgium = game:GetFactionById(6)
local serbia = game:GetFactionById(7)
local italy = game:GetFactionById(8)
local netherlands = game:GetFactionById(9)
local usa = game:GetFactionById(10)
local sweden = game:GetFactionById(11)
local denmark = game:GetFactionById(12)
local finland = game:GetFactionById(13)
local greece = game:GetFactionById(14)
local spain = game:GetFactionById(15)
local portugal = game:GetFactionById(16)
local switzerland = game:GetFactionById(17)
local romania = game:GetFactionById(18)
local bulgaria = game:GetFactionById(19)
local norway = game:GetFactionById(20)
local persia = game:GetFactionById(22)
local arabia = game:GetFactionById(21)
local whites = game:GetFactionById(26)
local bolshevik = game:GetFactionById(27)


  LuaPanel.__init(self)

  
  self:AddWidget({
    name = "dow_button",
    type = "button",
    image = "button_default",
    position = {195, 402},
    text = "INFLUENCE",
    sfx = "click",
    on_click = function(button)
      Influence(playerAlliance, ui.selectedRelation)
              self.parent.parent:UpdateRelationStats(ui.selectedRelation)
        self.parent.parent:RefreshRelations()
        ui.mainPanel.diplomacyTab:Refresh()
      end
     
  })

   
 
   
      self:AddWidget({
     name = "war_button",
     type = "button",
     image = "button_default",
     position = {195, 462},
     text = "DECLARE WAR!",
	 sfx = "click",
     on_click = function(button)
      function DeclareWarConfirmed()
        DeclareWar(playerAlliance, ui.selectedRelation)
        self.parent.parent:UpdateRelationStats(ui.selectedRelation)
        self.parent.parent:RefreshRelations()
        ui.mainPanel.diplomacyTab:Refresh()
      end
      PopupDialog("declare_war_confirm", DeclareWarConfirmed)
    end
   })
   
 
  self:Hide()


end

function RelationNeutralPanel:OnHide()

 -- self.parent.relationNeutralPanel:Hide()
 --self:Hide()
end



-----------------------------------------------------------------------


class 'RelationAllyPanel' (LuaPanel)



function RelationAllyPanel:__init()

  LuaPanel.__init(self)



  
   self:AddWidget({
     type = "image",
     position = {200, 467},
     image = "resource_pp_white",
     tooltip = "SendPP"
   })
   self.transferPP = self:AddWidget({
     type = "edit",
     text = "0",
     size = {width=30, height=20},
     position = {230, 465},
   })
   self:AddWidget({
     type = "image",
     position = {260, 467},
     image = "resource_am_white",
	 tooltip = "SendAM"
   })
   self.transferAM = self:AddWidget({
     type = "edit",
     text = "0",
     size = {width=30, height=20},
     position = {287, 465},
   })
 

   self.DonateButton = self:AddWidget({
     name = "donate_button",
     type = "button",
     image = "button_default",
     position = {195, 432},
     text = "TRANSFER",
     sfx = "click",
     on_click = function(button)
	 	 function TransferConfirmed()
       TransferResource(ui.diplomacyFaction, ui.selectedRelation, tonumber(self.transferPP.text), "PP")
       TransferResource(ui.diplomacyFaction, ui.selectedRelation, tonumber(self.transferAM.text), "AM")
       ui.resourcesPanel:Refresh()
	 end
	 	
		if playerAlliance.id == 2 then 
			
		PopupDialog("This will use up a RAIL or SEA TRANSPORT move depending on possible routes.;Rail connection will be checked first.;Some cargo might be lost.;Sea Transports might get intercepted! Continue?", TransferConfirmed)
		elseif playerAlliance.id == 1 then
					
		PopupDialog("This will use up a RAIL or SEA TRANSPORT move depending on possible routes.;Rail connection will be checked first.;Some cargo might be lost.;Sea Transports might get intercepted! Continue?", TransferConfirmed)
		end
	 end
   })

 
   
  


   
   
  self:Hide()

end

function RelationAllyPanel:Refresh(faction)
 

	ui.selectedRelation = faction
 --LogUi("ALLY:" .. faction.id)
 -- self.parent:GetText("relation_flag"):SetImage("graphics/flags","flag_" .. faction.name .. "_32_dis.png")

 
end

function RelationAllyPanel:OnHide()
--  

end

-----------------------------------------------------------------------


class 'RelationEnemyPanel' (LuaPanel)

function RelationEnemyPanel:__init()
  LuaPanel.__init(self)
--[[
   self.acceptSurrenderButton = self:AddWidget({
     name = "accept_button",
     type = "button",
     image = "button_default",
     position = {77, 492},
     text = "accept",
     sfx = "click",
     on_click = function(button)
     end
   })]]


   self:AddWidget({
     name = "insurgency_button",
     type = "button",
     image = "button_default",
     position = {195, 402},
     text = "DESTABILIZE",
     sfx = "click",
     on_click = function(button) 
		 function DestabConfirmed()
			Destabilize(playerAlliance, ui.selectedRelation)
			self.parent.parent:UpdateRelationStats(ui.selectedRelation)
			self.parent.parent:RefreshRelations()
			ui.mainPanel.diplomacyTab:Refresh()
			ui.resourcesPanel:Refresh()
		 end
	local chance = GetDestabChance(playerAlliance, ui.selectedRelation)
	-- LogUi("CHANCE" .. chance)
		if chance ~= nil then
			if chance >0  then
				PopupDialog("ORGANIZING INSURGENCY; This will use up ALL your diplomatic points!;The projected chance for this to succeed: " .. chance .."%", DestabConfirmed)
			else
				PopupMessage("ORGANIZING INSURGENCY NOT POSSIBLE!; The enemy government exerts total control at the moment.")
			end	
		 end
	 end
	 
	 
   })


   
   self:AddWidget({
     name = "denounce_button",
     type = "button",
     image = "button_default",
     position = {195, 432},
     text = "PILLAGE",
     sfx = "click",
     on_click = function(button)
	  function DenounceConfirmed()
      Denounce(playerAlliance, ui.selectedRelation)
      self.parent.parent:UpdateRelationStats(ui.selectedRelation)
        self.parent.parent:RefreshRelations()
        ui.mainPanel.diplomacyTab:Refresh()
	 end
		if game.currentAlliance.id == 1 then
			PopupDialog("denouncetext", DenounceConfirmed)
		else
			 PopupDialog("denouncetext", DenounceConfirmed)
		end
	 end
   })
   
   
   
   
  self:AddWidget({
     name = "intel_button",
     type = "button",
     image = "button_default",
     position = {195, 462},
     text = "INTEL",
     sfx = "click",
     on_click = function(button)
      Intelligence(playerAlliance, ui.selectedRelation)
      self.parent.parent:UpdateRelationStats(ui.selectedRelation)
        self.parent.parent:RefreshRelations()
        ui.mainPanel.diplomacyTab:Refresh()
	 end
   })

  

  self:Hide()

end

function RelationEnemyPanel:OnShow()
   if ui.selectedRelation.morale <= 0 then
    -- self.acceptSurrenderButton:Show()
   else
   --  self.acceptSurrenderButton:Hide()
   end
end

function RelationEnemyPanel:OnHide()

 
 -- self.parent.relationPanel:Hide()
end



