class 'DeveloperPanel' (LuaPanel)

function DeveloperPanel:__init()
  LuaPanel.__init(self, menu_credits_developer)

  if engine.window.height < 768 then
    self:SetPosition(78, 5)
  else
    self:SetPosition(78 + (engine.window.width-1024) / 2, 120 + (engine.window.height-768) / 2)
  end
  --self:SetPosition((engine.window.width - self.width) / 2, (engine.window.height - self.height) / 2)

end

menu_credits_developer =
{
    name = "developer_panel",
    type = "panel",
    position = {78, 150},
    image = "paneltab1",

    controls =
    {
      {
        name = "developer_text",
        type = "text",
        font = "menu_font",
        position = {72, 28},
        align = "center",
        color   = {255, 255, 255},
        text = "developer",
      },
      {
        name = "publisher_label",
        type = "label",
        font = "menu_font",
        position = {242, 28},
        align = "center",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {224, 220, 218},
        text = "publisher",
        sfx = "click",
        Clicked = function(this)
          engine.screen.hud:GetPanel("developer_panel"):Hide()
          engine.screen.hud:GetPanel("publisher_panel"):Show()
        end
      },
      {
        type = "image",
        position  = {40, 110},
				image = "logo_lgs"
      },
      {
        type = "memo",
        position  = {290, 60},
        font  = "verdana12_font",
        color = {224, 220, 218},
        shadow = {offset = {0, 0}},
        text  = "credits_developer_1",
        border = 10
      },
      {
        type = "memo",
        position  = {590, 60},
        font  = "verdana12_font",
        color = {224, 220, 218},
        shadow = {offset = {0, 0}},
        text  = "credits_developer_2",
        border = 10
      },
      {
        name = "version_text",
        type = "text",
        font = "menu_font",
        position = {800, 20},
        align = "left",
        color   = {255, 255, 255},
        text = engine.versionString,
      },
      {
        name = "close_button",
        type = "button",
        image = "button_default",
        position = {30, 487},
        align = "left",
        text = "close",
        sfx = "click",
        Clicked = function(this)
          engine:SetScreen(screens.mainMenu)
        end
      },
      {
        type = "label",
        font = "menu_font",
        position = {300, 491},
        align = "left",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        text = "www.thelordzgamesstudio.com",
        sfx = "click",
        Clicked = function(this)
          OpenUrl("http://www.thelordzgamesstudio.com/")
        end
      },
    }

}


class 'PublisherPanel' (LuaPanel)

function PublisherPanel:__init()
  LuaPanel.__init(self, menu_credits_publisher)

  if engine.window.height < 768 then
    self:SetPosition(78, 5)
  else
    self:SetPosition(78 + (engine.window.width-1024) / 2, 120 + (engine.window.height-768) / 2)
  end

  self:Hide()

end

menu_credits_publisher =
{
    name = "publisher_panel",
    type = "panel",
    position = {78, 150},
    image = "paneltab2",

    tooltip =
    {
      rect  = {10, 10, 0, 0},
      --color = (255 255 255),
      --bgcolor = (10 10 10),
      font  = "hud_font"
    },

    controls =
    {
      {
        name = "developer_label",
        type = "label",
        font = "menu_font",
        position = {72, 28},
        align = "center",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        text = "developer",
        sfx = "click",
        Clicked = function(this)
          engine.screen.hud:GetPanel("developer_panel"):Show()
          engine.screen.hud:GetPanel("publisher_panel"):Hide()
        end
      },
      {
        type = "image",
        position  = {40, 120},
				image = "logo_slitherine"
      },
      {
        type = "image",
        position  = {570, 170},
				image = "logo_matrix"
      },
      {
        name = "publisher_text",
        type = "text",
        font = "menu_font",
        position = {242, 28},
        align = "center",
        color   = {255, 255, 255},
        text = "publisher",
      },
      {
        type = "memo",
        position  = {290, 60},
        font  = "verdana12_font",
        color = {224, 220, 218},
        shadow = {offset = {0, 0}},
        text  = "credits_publisher_1",
        border = 10
      },
      {
        name = "version_text",
        type = "text",
        font = "menu_font",
        position = {800, 20},
        align = "left",
        color   = {255, 255, 255},
        text = engine.versionString,
      },
      {
        name = "close_button",
        type = "button",
        image = "button_default",
        position = {30, 487},
        align = "left",
        text = "close",
        sfx = "click",
        Clicked = function(this)
          engine:SetScreen(screens.mainMenu)
        end
      },
    }
}
