class 'SingleplayerPanel' (LuaPanel)

function SingleplayerPanel:__init()
  LuaPanel.__init(self, menu_single)

  if engine.window.height < 768 then
    self:SetPosition(78, 5)
  else
    self:SetPosition(78 + (engine.window.width-1024) / 2, 120 + (engine.window.height-768) / 2)
  end
  --self:SetPosition((engine.window.width - self.width) / 2, (engine.window.height - self.height) / 2)


  -- Select first scenario by default
  self.scenSelection = campaign[1].script
  self.allianceSelection = 1
  self.difficultySelection = GetUserInt("difficulty", 2)

  -- Load Scenarios list
  self:AdoptWidget(ScenarioSelectionPanel(40, 100))

  self.video = self:AdoptWidget(VideoPanel(351, 107, 0.75, 0.75))
  self.video:SetVideo(campaign[1])
	
  local civilwarOn = function() settings.civilwar = 1 settings.tutorial = 0  end
  local civilwarOff = function() settings.civilwar = 0 settings.tutorial = 0 end
 
  self:AdoptWidget(CheckBox(44, 450, "tutorial_checkbox", civilwarOn, civilwarOff, settings.tutorial))

 -- local tutorialOn = function() settings.tutorial = 1 end
  --local tutorialOff = function() settings.tutorial = 0 end
  --self:AdoptWidget(CheckBox(44, 450, "tutorial_checkbox", tutorialOn, tutorialOff, settings.tutorial))


  self.historical = self:AdoptWidget(HistoricalBriefingPanel(351, 107))

  self:GetButton("video_button"):Hide()

end

function SingleplayerPanel:OnShow()
  self:GetButton("launch_button"):Show()

  nonsense = 1
end

function SingleplayerPanel:OnHide()
  nonsense = 0
end

menu_single =
{
    name = "sp_panel",
    type = "panel",
    position = {78, 150},
    image = "panelSPtab1",

    controls =
    {

      {
        name = "selectCampaign_text",
        type = "text",
        position = {178, 80},
        font = "menu_font",
        align = "center",
        color   = {224, 220, 218},
        text = "select_campaign",
      },

      {
        name = "briefing_type",
        type = "text",
        position = {591, 80},
        font = "menu_font",
        align = "center",
        color   = {224, 220, 218},
        text = "briefing_video",
      },
--~       {
--~         name  = "info_memo",
--~         type = "memo",
--~         position  = {405, 60},
--~         font  = "verdana12_font",
--~         color = {224, 220, 218},
--~         text  = "campaign0info",
--~         size = {300, 200},
--~         border = 10
--~       },

      {
        name = "selectAlliance_text",
        font = "menu_font",
        position = {44, 235},
        align = "left",
        color   = {67, 56, 47},
        text = "select_alliance",
      },
      {
        name = "alliance1_label",
        type = "label",
        font = "menu_font",
        position = {63, 260},
        align = "left",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        shadow = {offset = {0, 0}},
        text = "alliance1",
        sfx = "click",
        Clicked = function(button)
          button.parent:GetImage("alliance_checkon"):SetPosition(44, 260)
          self = button.parent
          self.allianceSelection = 1
        end
      },
      {
        name = "alliance2_label",
        type = "label",
        font = "menu_font",
        position = {63, 285},
        align = "left",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        shadow = {offset = {0, 0}},
        text = "alliance2",
        sfx = "click",
        Clicked = function(button)
          button.parent:GetImage("alliance_checkon"):SetPosition(44, 285)
          self = button.parent
          self.allianceSelection = 2
        end
      },
      {
        name = "alliance_check1",
        type = "button",
        image = "radio",
        position = {44, 260},
        sfx = "click",
        on_click = function(button)
          button.parent:GetImage("alliance_checkon"):SetPosition(44, 260)
          self = button.parent
          self.allianceSelection = 1
        end
      },
      {
        name = "alliance_check2",
        type = "button",
        image = "radio",
        position = {44, 285},
        sfx = "click",
        on_click = function(button)
          button.parent:GetImage("alliance_checkon"):SetPosition(44, 285)
          self = button.parent
          self.allianceSelection = 2
        end
      },
      {
        name = "alliance_checkon",
        type = "image",
        image = "radio_on",
        position = {44, 260},
      },
      {
        name = "selectDifficulty_text",
        font = "menu_font",
        rect = {44, 320, 0, 0},
        align = "left",
        color   = {67, 56, 47},
        text = "difficulty",
        sfx = "click"
      },
      {
        name = "difficulty1_label",
        type = "label",
        font = "menu_font",
        position = {63, 345},
        align = "left",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        shadow = {offset = {0, 0}},
        text = "difficulty0",
        sfx = "click",
        Clicked = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 345)
          self = button.parent
          self.difficultySelection = 1
          SetUserInt("difficulty", 1)
        end
      },
      {
        name = "difficulty2_label",
        type = "label",
        font = "menu_font",
        position = {63, 370},
        align = "left",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        shadow = {offset = {0, 0}},
        text = "difficulty1",
        sfx = "click",
        Clicked = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 370)
          self = button.parent
          self.difficultySelection = 2
          SetUserInt("difficulty", 2)
        end
      },
      {
        name = "difficulty3_label",
        type = "label",
        font = "menu_font",
        position = {63, 395},
        align = "left",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        shadow = {offset = {0, 0}},
        text = "difficulty2",
        sfx = "click",
        Clicked = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 395)
          self = button.parent
          self.difficultySelection = 3
          SetUserInt("difficulty", 3)
        end
      },
	        {
        name = "difficulty4_label",
        type = "label",
        font = "menu_font",
        position = {63, 420},
        align = "left",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        shadow = {offset = {0, 0}},
        text = "difficulty3",
        sfx = "click",
        Clicked = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 420)
          self = button.parent
          self.difficultySelection = 4
          SetUserInt("difficulty", 4)
        end
      },
      {
        name = "difficulty_check1",
        type = "button",
        image = "radio",
        position = {44, 345},
        sfx = "click",
        on_click = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 345)
          self = button.parent
          self.difficultySelection = 1
          SetUserInt("difficulty", 1)
        end
      },
      {
        name = "difficulty_check2",
        type = "button",
        image = "radio",
        position = {44, 370},
        sfx = "click",
        on_click = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 370)
          self = button.parent
          self.difficultySelection = 2
          SetUserInt("difficulty", 2)
        end
      },
      {
        name = "difficulty_check3",
        type = "button",
        image = "radio",
        position = {44, 395},
        sfx = "click",
        on_click = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 395)
          self = button.parent
          self.difficultySelection = 3
          SetUserInt("difficulty", 3)
        end
      },
	  {
        name = "difficulty_check4",
        type = "button",
        image = "radio",
        position = {44, 420},
        sfx = "click",
        on_click = function(button)
          button.parent:GetImage("difficulty_checkon"):SetPosition(44, 420)
          self = button.parent
          self.difficultySelection = 4
          SetUserInt("difficulty", 4)
        end
      },
      {
        name = "difficulty_checkon",
        type = "image",
        image = "radio_on",
        position = {44, 345 + 25 * (GetUserInt("difficulty", 1) - 1)},
      },
      {
        name = "new_text",
        type = "text",
        font = "menu_font",
        position = {72, 28},
        align = "center",
        color   = {255, 255, 255},
        text = "newcampaign",
      },
      {
        name = "load_label",
        type = "label",
        font = "menu_font",
        position = {242, 28},
        align = "center",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {224, 220, 218},
        text = "loadscen",
--~         sfx = "click",
        Clicked = function(this)
          engine.screen.hud:GetPanel("sp_panel"):Hide()
          engine.screen.hud:GetPanel("load_panel"):Show()
          engine.screen.hud:GetPanel("sp_panel").video:Stop()
          PlaySample(sClick)
        end
      },
      {
        name = "loading_text",
        font = "menu_font",
        type = "text",
        position = {783, 502},
        color = {224, 220, 218},
        align = "center",
        text = "loading",
      },
      {
        name = "info_button",
        type = "button",
        image = "button_default",
        position = {343, 487},
        text = "information",
        sfx = "click",
        Clicked = function(this)
          this.parent.video:Stop(this.parent.playing)
          this.parent.video:Hide()
          this.parent.historical:Show()
          this:Hide()
          this.parent:GetButton("video_button"):Show()
          this.parent:GetText("briefing_type"):SetLocalText("briefing_text")
        end
      },
      {
        name = "video_button",
        type = "button",
        image = "button_default",
        position = {343, 487},
        text = "video",
        sfx = "click",
        Clicked = function(this)
          this.parent.video:Show()
          this.parent.historical:Hide()
          this:Hide()
          this.parent:GetButton("info_button"):Show()
          this.parent:GetText("briefing_type"):SetLocalText("briefing_video")
        end
      },

      {
        type = "label",
        font = "menu_font",
        position = {500, 494},
        align = "left",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {50, 50, 50},
        text = "gameplay_help_link",
        sfx = "click",
        Clicked = function(this)
          OpenUrl("http://www.slitherine.com/forum/viewtopic.php?f=102&t=51294&p=482378#p482378")
        end
      },

      {
        name = "launch_button",
        type = "button",
        image = "button_default",
        position = {725, 487},
        text = "launch",
        sfx = "click",
        Clicked = function(this)
          engine:SetScreen(screens.loadingMenu)
          SetUserInt("tutorial", settings.tutorial)
          this.parent.video:Stop(this.parent.playing)
          this:Hide()
          engine:CreateSingleplayerGame(this.parent.scenSelection, this.parent.allianceSelection, this.parent.difficultySelection)
          --scenario.difficulty = this.parent.difficultySelection
        end
      },
      {
        name = "close_button",
        type = "button",
        image = "button_default",
        position = {30, 487},
        text = "close",
        sfx = "click",
        Clicked = function(this)
          engine:SetScreen(screens.mainMenu)
        end
      },
    }
}


-----------------------------------------------------------------------

class 'LoadPanel' (LuaPanel)

function LoadPanel:__init()
  LuaPanel.__init(self, menu_load)

  if engine.window.height < 768 then
    self:SetPosition(78, 5)
  else
    self:SetPosition(78 + (engine.window.width-1024) / 2, 120 + (engine.window.height-768) / 2)
  end
  --self:SetPosition((engine.window.width - self.width) / 2, (engine.window.height - self.height) / 2)

  self.savesList = self:AddWidget({type = "panel"})

  self.scrollPos = 0
  self.listmax = 16
  self.listLength = 0
  self:AddWidget({
    type = "button",
    image = "scroll_up",
    position = {814, 110},
    Clicked = function()
      if self.scrollPos > 0 then
        self.scrollPos = self.scrollPos - self.listmax
        --self:GetPanel("gameslist_panel"):SetPosition(0, self.scrollPos*-20)
        self:RefreshSaves()
      end
    end
  })
  self:AddWidget({
    type = "button",
    image = "scroll_down",
    position = {814, 447},
    Clicked = function()
      if self.scrollPos < self.listLength - self.listmax then
        self.scrollPos = self.scrollPos + self.listmax
        --self:GetPanel("gameslist_panel"):SetPosition(0, self.scrollPos*-20)
        self:RefreshSaves()
      end
    end
  })

  self:AddWidget({
    name = "pagebar",
    type = "image",
    image = "pagebar",
    position = {820,131},
  })

  self:Hide()

end

function LoadPanel:OnShow()
  self:GetButton("launch_button"):Show()
end

function LoadPanel:RefreshSaves()

  self.savesList:RemoveWidgets()
  self.selectedSave = nil

  local savegames = engine:GetSavegames()

  self.listLength = 0
  self.listLengthCurrent = 0
  local first = 0
  for _, save in ipairs(savegames) do
    --Log(save.name .. ", " .. save.file)
    if self.listLength >= self.scrollPos and self.listLength - self.scrollPos < self.listmax then
      self:AddSavegame(self.listLength + 1, 40, 132 + (self.listLength - self.scrollPos) *20, save)
      if first == 0 then
        self.selectedSave = save.name
        self:GetImage("selected_game"):SetPosition(40, 132)
        first = 1
      end
      self.listLengthCurrent = self.listLengthCurrent + 1
    end
    self.listLength = self.listLength + 1
  end

  --self.listLength = row
  self.pageCount = math.floor((self.listLength+9)/self.listmax)
  --print(self.pageCount)
  self:GetImage("pagebar"):SetSource(0, 0, 6, 311 * self.listLengthCurrent / self.listLength)
  self:GetImage("pagebar"):SetPosition(820, 131 + (311 * (self.scrollPos) / self.listLength) )


end

function LoadPanel:AddSavegame(id, x, y, save)

  if id == 1 then
    self.selectedSave = save.name
  end

  local listElement = self.savesList:AddWidget({
    type = "panel",
    position = {x, y},
  })
  listElement:AddWidget({
    type = "image",
    image = "save_selection_hotspot",
    sfx = "click",
    Clicked = function(button)
      self.selectedSave = save.name
      self:GetImage("selected_game"):SetPosition(40, y)
    end
  })
  listElement:AddWidget({
    type = "label",
    font = "menu_font",
    position = {5, 3},
    align = "left",
    normal   = {67, 56, 47},
    hilight  = {67, 56, 47},
    select   = {67, 56, 47},
    disabled = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = save.name,
    sfx = "click",
    Clicked = function(button)
      self.selectedSave = save.name
      self:GetImage("selected_game"):SetPosition(40, y)
    end
  })
  listElement:AddWidget({
    type = "label",
    font = "menu_font",
    position = {500, 3},
    align = "left",
    normal   = {67, 56, 47},
    hilight  = {67, 56, 47},
    select   = {67, 56, 47},
    disabled = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = save.time,
    sfx = "click",
    Clicked = function(button)
      self.selectedSave = save.name
      self:GetImage("selected_game"):SetPosition(40, y)
    end
  })

end



menu_load =
{
    name = "load_panel",
    type = "panel",
    position = {78, 150},
    image = "panelSPtab2",
    controls =
    {
      {
        type = "text",
        position = {436, 80},
        font = "menu_font",
        align = "center",
        color   = {224, 220, 218},
        text = "saved_campaigns",
      },
--~       {
--~         type = "image",
--~         position = {25, 60},
--~         image = "pbem_bg"
--~       },
      {
        type = "text",
        text = "pbem_game_name",
        color = {67, 56, 47},
        position = {45, 115},
      },
      {
        type = "text",
        text = "save_game_date",
        color = {67, 56, 47},
        position = {540, 115},
        align = "left"
      },
      {
        name = "selected_game",
        type = "image",
        image = "pbem_selection_highlight",
        position = {40, 132},
      },
      {
        name = "new_label",
        type = "label",
        font = "menu_font",
        position = {72, 28},
        align = "center",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {224, 220, 218},
        text = "newcampaign",
        sfx = "click",
        Clicked = function(this)
          engine.screen.hud:GetPanel("sp_panel"):Show()
          engine.screen.hud:GetPanel("load_panel"):Hide()
          --engine.screen.hud:GetPanel("sp_panel").video:Play()
        end
      },
      {
        type = "text",
        font = "menu_font",
        position = {242, 28},
        align = "center",
        color   = {255, 255, 255},
        text = "loadscen",
      },
      {
        name = "loading_text",
        font = "menu_font",
        type = "text",
        position = {783, 502},
        color = {224, 220, 218},
        align = "center",
        text = "loading",
      },
      {
        name = "delete_button",
        type = "button",
        image = "button_default",
        position = {548, 487},
        text = "delete",
        sfx = "click",
        Clicked = function(this)
          function DeleteConfirmed()
            engine:DeleteSave(this.parent.selectedSave)
            this.parent.listLength = this.parent.listLength - 1
            if this.parent.scrollPos >= this.parent.listLength then
              this.parent.scrollPos = this.parent.scrollPos - this.parent.listmax
            end
            engine.screen.loadGamePanel:RefreshSaves()
          end
          MenuPopupDialog("delete_confirm", DeleteConfirmed)
        end
      },
      {
        name = "launch_button",
        type = "button",
        image = "button_default",
        position = {725, 487},
        text = "launch",
        sfx = "click",
        Clicked = function(this)
          if this.parent.selectedSave ~= nil then
            this:Hide()
            engine:SetScreen(screens.loadingMenu)
            LoadGame(this.parent.selectedSave)
          end
        end
      },
      {
        name = "close_button",
        type = "button",
        image = "button_default",
        position = {30, 487},
        align = "left",
        text = "close",
        sfx = "click",
        Clicked = function(this)
          engine:SetScreen(screens.mainMenu)
        end
      },
    },

    visibleChanged = function(self)
      -- refresh save games list when this panel becomes visible
      if self.isVisible then
        engine.screen.loadGamePanel:RefreshSaves()
      end
    end
}



class 'HistoricalBriefingPanel' (LuaPanel)

function HistoricalBriefingPanel:__init(x, y)
  LuaPanel.__init(self)

  self:SetPosition(x, y)

  self:SetBackgroundImage("briefing_bg")

  self.content = self:AddWidget({
    type = "memo",
    position = {15, 12},
    size = {440, 120},
    font = "times12_font",
    color   = {67, 56, 47},
    text = "historical_1914",
    border = 0,
    OnScroll = function(this, delta)
      self:Scroll(delta)
    end
  })
  self:AddWidget({
    type = "button",
    image = "scroll_up",
    position = {461, 2},
    sfx = "click",
    on_click = function(button)
      self:Scroll(1)
    end
  })
  self:AddWidget({
    type = "button",
    image = "scroll_down",
    position = {461, 341},
    sfx = "click",
    on_click = function(button)
      self:Scroll(-1)
    end
  })
  self.pagebar = self:AddWidget({
    type = "image",
    image = "pagebar_dark",
    position = {466, 22},
    OnScroll = function(this, delta)
      self:Scroll(delta)
    end
  })

  self.content.maxLines = 22

  self.pageCount = math.max(self.content.maxLines, self.content.numLines)
  self.pagebar:SetSource(0, 0, 6, 314 * self.content.maxLines / self.pageCount)
  self:Hide()

end

function HistoricalBriefingPanel:SetScenario(scenario)

  self.content:SetLocalText("historical_" .. scenario)
  self.content.maxLines = 22

  self.content.startingLine = 0
  self.pagebar:SetPosition(466, 22 + (314 * self.content.startingLine / self.pageCount) )

  self.pageCount = math.max(self.content.maxLines, self.content.numLines)
  self.pagebar:SetSource(0, 0, 6, 314 * self.content.maxLines / self.pageCount)

end

function HistoricalBriefingPanel:OnScroll(delta)
  self:Scroll(delta)
end

function HistoricalBriefingPanel:Scroll(delta)
  if delta == 1 then
    if self.content.startingLine > 0 then
      self.content.startingLine = self.content.startingLine - 1
      self.pagebar:SetPosition(466, 22 + (314 * self.content.startingLine / self.pageCount) )
    end
  else
    if self.content.startingLine < self.content.numLines - self.content.maxLines then
      self.content.startingLine = self.content.startingLine + 1
      self.pagebar:SetPosition(466, 22 + (314 * self.content.startingLine / self.pageCount) )
    end
  end
end
