class 'OptionsMenuScreen' (GameScreen)

function OptionsMenuScreen:__init()
	GameScreen.__init(self)
end

function OptionsMenuScreen:OnInit()

  self.hud:Load(hud.menu_main)

  -- Draw background & hi-res bar edges
  local bg = self.hud:GetPanel("main_panel")
  local temp = bg:GetImage("background")
  local date = GetDate()
  local date11 = false
  if (date.day == 11 and date.month == 11) then
    date11 = true
  end
  local date28 = false
  if (date.day == 28 and date.month == 7) then
    date28 = true
  end
  
  if engine.window.width / engine.window.height > 1.5 then
    if date28 then
	   temp:SetImage("graphics/hud","menu_background_wide_22.png")	
	 
	elseif date11 then	
		 temp:SetImage("graphics/hud","menu_background_wide_11.png")
	
	else
		temp:SetImage("graphics/hud","menu_background_wide.png")
	end
	
  else
	if date28 then
		temp:SetImage("graphics/hud","menu_background_22.png")
	
    elseif date11 then
		temp:SetImage("graphics/hud","menu_background_11.png")
    
	else
		temp:SetImage("graphics/hud","menu_background.png")
	end
  end
  temp:SetScaling(engine.window.width / bg.width, engine.window.height / bg.height)
  temp = bg:GetImage("menu_hiresbarleft_image")
  temp:SetPosition(0, engine.window.height-18)
  temp = bg:GetImage("menu_hiresbarright_image")
  temp:SetPosition(engine.window.width-1024, engine.window.height-18)

  -- reposition menu bar
  local temp = self.hud:CreateWidget(hud.menu_bar)
  temp:SetPosition((engine.window.width-1024) / 2, engine.window.height - 40)

  self.ContentPanel = self.hud:AdoptWidget(OptionsPanel())

  if engine.window.height < 768 then
    self.ContentPanel:SetPosition(78, 5)
  else
    self.ContentPanel:SetPosition(78 + (engine.window.width-1024) / 2, 120 + (engine.window.height-768) / 2)
  end

end

function OptionsMenuScreen:OnEnter()
  self.hud:GetImage("menu_bar_image"):SetSource(0, 120, 1024, 40);

  self.ContentPanel:Display("frontEnd")

  -- Highlight selected language flag icon
  local language = GetUserString("lang", "english")
  if language == "english" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english_sel.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "german" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german_sel.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "italian" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian_sel.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "french" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french_sel.png")
  end
end

function OptionsMenuScreen:OnExit()

end
