dofile("ui/scenarios.lua")
dofile("ui/frontend/menu_singleplayer.lua")

class 'SingleplayerMenuScreen' (GameScreen)

function SingleplayerMenuScreen:__init()
  GameScreen.__init(self)
end

function SingleplayerMenuScreen:OnInit()

  self.hud:Load(hud.menu_main)

  -- Draw background & hi-res bar edges
  local bg = self.hud:GetPanel("main_panel")
  local temp = bg:GetImage("background")
  local date = GetDate()
  local date11 = false
  if (date.day == 11 and date.month == 11) then
    date11 = true
  end
  local date28 = false
  if (date.day == 28 and date.month == 7) then
    date28 = true
  end
  
  if engine.window.width / engine.window.height > 1.5 then
    if date28 then
	   temp:SetImage("graphics/hud","menu_background_wide_22.png")	
	 
	elseif date11 then	
		 temp:SetImage("graphics/hud","menu_background_wide_11.png")
	
	else
		temp:SetImage("graphics/hud","menu_background_wide.png")
	end
	
  else
	if date28 then
		temp:SetImage("graphics/hud","menu_background_22.png")
	
    elseif date11 then
		temp:SetImage("graphics/hud","menu_background_11.png")
    
	else
		temp:SetImage("graphics/hud","menu_background.png")
	end
  end
  temp:SetScaling(engine.window.width / bg.width, engine.window.height / bg.height)
  temp = bg:GetImage("menu_hiresbarleft_image")
  temp:SetPosition(0, engine.window.height-18)
  temp = bg:GetImage("menu_hiresbarright_image")
  temp:SetPosition(engine.window.width-1024, engine.window.height-18)

  -- reposition menu bar
  local temp = self.hud:CreateWidget(hud.menu_bar)
  temp:SetPosition((engine.window.width-1024) / 2, engine.window.height - 40)

  self.newGamePanel = self.hud:AdoptWidget(SingleplayerPanel())

  --self.allianceSelection = 1
  --self.scenSelection = 0
  --self.difficultySelection = 3

  self.loadGamePanel = self.hud:AdoptWidget(LoadPanel())
 nonsense=1
 --menuLoadPanel.selectedScen = 3;

  --self.hud:GetPanel("load_panel"):Hide()

end

function SingleplayerMenuScreen:OnEnter()
  self.hud:GetImage("menu_bar_image"):SetSource(0, 40, 1024, 40);

  --self.newGamePanel.video:Play("campaign0");

  self.newGamePanel:GetButton("launch_button"):Show()
  self.loadGamePanel:GetButton("launch_button"):Show()
  self.loadGamePanel:RefreshSaves()

  if nonsense == 1 then
  --self.newGamePanel.video:Play()
  --self.garbage = 1145461023
  end

  -- Highlight selected language flag icon
  local language = GetUserString("lang", "english")
  if language == "english" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english_sel.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "german" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german_sel.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "italian" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian_sel.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french.png")
  elseif language == "french" then
    self.hud:GetImage("language_english"):SetImage("graphics/hud/flags", "english.png")
    self.hud:GetImage("language_german"):SetImage("graphics/hud/flags", "german.png")
    self.hud:GetImage("language_italian"):SetImage("graphics/hud/flags", "italian.png")
    self.hud:GetImage("language_french"):SetImage("graphics/hud/flags", "french_sel.png")
  end

end

function SingleplayerMenuScreen:OnExit()
  self.newGamePanel.video:Stop()

end

--~ function SingleplayerMenuScreen:CreateVideoPanel(campaign)

--~   local videoName = "video_" .. campaign
--~   local video = self.hud:GetPanel("sp_panel"):AddWidget({type = "video", name = videoName, file = "campaign0"})

--~   video:SetPosition(35, 68)
--~   video:SetScaling(.445, .417)
--~   --video:SetColor(255, 0, 0, 128)

--~ end

function SingleplayerMenuScreen:DrawListElement(panelID, id, x, y, labelText, localize)

  local listElement =
  {
    name = "list_label_" .. panelID .. "_" .. id,
    type = "label",
    font = "menu_font",
    position = {x, y},
    align = "left",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    sfx = "click",
    Clicked = function(button)
      self.scenSelection = id
    end
  }

  self.hud:GetPanel(panelID):AddWidget(listElement):Show()
  if localize == 1 then
    self.hud:GetText("list_label_" .. panelID .. "_" .. id):SetLocalText(labelText)
  else
    self.hud:GetText("list_label_" .. panelID .. "_" .. id):SetText(labelText)
  end
end



----------------------------

class 'ScenarioSelectionPanel' (LuaPanel)

function ScenarioSelectionPanel:__init(x, y)
  LuaPanel.__init(self)

  local function CreateListClosure(row)
    local n = row
    local m = i
    return function()
      self.parent.scenSelection = campaign[n].script
      self.pointer:SetPosition(x-9, y+(n-1)*20+2)
      --self.parent:GetMemo("info_memo"):SetLocalText(campaign[n].desc)
      self.parent.video:SetVideo(campaign[n])
      self.parent.historical:SetScenario(campaign[n].script)
      --self.parent.video:Play()
    end
  end

  -- Add campaign list items
  local i = 1
  while campaign[i] ~= nil do
    local temp = i
    self:AddWidget({
      name = campaign[i].script,
      type = "label",
      font = "menu_font",
      position = {x, y + (i-1)*20},
      align = "left",
      normal   = {224, 220, 218},
      hilight  = {255, 255, 255},
      select   = {255, 255, 255},
      disabled = {224, 220, 218},
      text = campaign[i].text,
      sfx = "click",
      Clicked = CreateListClosure(i)
    })
    i = i + 1
  end

  -- Add selected pointer
  self.pointer = self:AddWidget({
    type = "image",
    image = "selected_pointer",
    position = {x-9, y+2},
  })

end

function ScenarioSelectionPanel:OnShow()
end
