ui = {}

dofile("ui/production_panel.lua")
dofile("ui/research_panel.lua")
dofile("ui/diplomacy_panel.lua")
dofile("ui/management_panel.lua")
dofile("ui/cursor_modes.lua")
dofile("ui/chat_panel.lua")
dofile("ui/turn_report.lua")
dofile("ui/info_panel.lua")

-- the main bottom panel
if IsUsingTouchScreen() then
  dofile("ui/touch_main_panel.lua")
else
  dofile("ui/main_panel.lua")
end

dofile("ui/popups.lua")
dofile("ui/message_que.lua")

dofile("ui/advice.lua")

ui.UIMode = 0
DEFAULT = 0
DEPLOY = 1
REPAIR = 2
UPGRADE = 3
DISBAND = 4
ATTACH = 5

ui.overlayActive = false

ui.disableControls = false
ui.disableHUD = false

ui.queueRow = 0
ui.prodqueue = {}
ui.prodqueue.slot = 0

ui.production_queue = {}
ui.queue_faction = {}
ui.queue_type = {}
ui.queue_unit = {}
ui.queue_turns = {}

ui.UItech = 0

ui.messageQue = MessageQue()

ui.unitTypes = {"garrison", "infantry", "cavalry", "artillery", "railgun", "armouredcar", "armouredtrain", "armour", "fighter", "bomber", "zeppelin", "lightcruiser", "dreadnought", "submarine", "battlecruiser"}

ui.movementHexes = {}
ui.targetHexes = {}
--~ ui.forcedHexes = {}

function GetSelectedUnit()
  return GetPlayer().selectedUnit
end

function GetSelectedHex()
  return ui.selectedHex
end

function RefreshDiplomacy()
				

  hud:GetPanel("diplomacy_panel"):Refresh()
end

function UpdateTechStats(tech, faction)
  hud:GetPanel("research_panel"):UpdateTechStats(tech, faction)
end

hud =
{
  {
    type = "image",
    position = {(engine.window.width-1024)/2-94, engine.window.height-194},
    image = "bar_left",
  },
  {
    type = "image",
    position = {(engine.window.width-1024)/2+1024, engine.window.height-193},
    image = "bar_right",
  },
}


  ---------------------- ON SCENARIO INIT -----------------------------

function hud.OnInit()
  
  player = GetPlayer()
  playerAlliance = GetPlayer().alliance
  enemyAlliance = game:GetAllianceById(2 / playerAlliance.id)
  neutralAlliance = game:GetAllianceById(0)

  ui.playerAlliance = playerAlliance
  ui.enemyAlliance = game:GetAllianceById(2 / playerAlliance.id)
  ui.neutralAlliance = game:GetAllianceById(0)

  -- Load control settings
  SetControls(1)
  ui.disableControls = false

  -- Switch tutorial off in MP
  if game.type ~= Game.TYPE_SINGLE then
    settings.tutorial = 0
    autoRefreshOn = false
    ui.chatPanel = hud:AdoptWidget(ChatPanel())
    playerAlliance.luaData.avatar = settings.avatar
    --playerAlliance.luaData.opponentAvatar = settings.avatar
  end
	
  --type is lua reserved!
  --type = player.type

  --selectedUnit = player.selectedUnit

  --local alliance = GetPlayer().alliance

  Log("Hud initialization")

  -- temp solution
  ui.cursormode = hud:AdoptWidget(CursorModePanel())

  ui.productionPanel = hud:AdoptWidget(ProductionPanel(playerAlliance))
  ui.diplomacyPanel = hud:AdoptWidget(DiplomacyPanel(playerAlliance))
  ui.researchPanel = hud:AdoptWidget(ResearchPanel(playerAlliance))
  ui.managementPanel = hud:AdoptWidget(ManagementPanel(playerAlliance))
  ui.UnitInfoPopupPanel = hud:AdoptWidget(UnitInfoPopup())
  ui.TerrainInfoPopupPanel = hud:AdoptWidget(TerrainInfoPopup())

  ui.mainPanel = hud:AdoptWidget(MainPanel(playerAlliance))
	local germany = game:GetFactionById(2)
	local entente =  game:GetAllianceById(1)
	local cp =  game:GetAllianceById(2)
	local impassable = game:GetFactionById(24)
	if germany.luaData.blockaded == 0 then
		
				ui.mainPanel.blockadestatus:Hide()

	elseif germany.luaData.blockaded == 1 then
				ui.mainPanel.blockadestatus:Show()
		
	end
	
	
	if germany.luaData.misharvest  == 0 then
		
				ui.mainPanel.foodcrisisCP:Hide()

	elseif germany.luaData.misharvest == 1 then
				ui.mainPanel.foodcrisisCP:Show()
		
	end
------------------INIT RUSSIA SUPPLY ON LOAD ETC.-------------------------	
	local russia = game:GetFactionById(4)

	if russia.alliance.id == 1
		and game.currentAlliance.id == player.alliance.id
		and game.currentAlliance.id == 1
		and GetEvent("RussiaSupplyCrisis") == 0 then
		
			ui.mainPanel.RusSupCrisis:Show()
			ui.mainPanel.russupply:SetNumber(russia.luaData.crisis)
			ui.mainPanel.russupply:Show()
	
	else
		ui.mainPanel.RusSupCrisis:Hide()
			ui.mainPanel.russupply:Hide()
	
	end
	-----MINES-----------------


	if germany.alliance.id == 2 then
		if game.currentAlliance.id == player.alliance.id
			and game.currentAlliance.id == 1
			and entente.luaData.cpminesspot >0
			and entente.luaData.cpminesspot +3 >= game.turn then
				ui.mainPanel.EntMinesSpot:Show()
		else
				ui.mainPanel.EntMinesSpot:Hide()
		
		end	
		if game.currentAlliance.id == player.alliance.id
			and game.currentAlliance.id == 2
			and cp.luaData.entminesspot >0
			and cp.luaData.entminesspot +3 >= game.turn then
				ui.mainPanel.CPMinesSpot:Show()
		else
			ui.mainPanel.CPMinesSpot:Hide()
		end		
	else
		ui.mainPanel.CPMinesSpot:Hide()
		ui.mainPanel.EntMinesSpot:Hide()
	
	end

--------------------INIT BRITISH SUPPLY-----------------------	
	local britain = game:GetFactionById(1)
	if britain.luaData.britishsupply  >= 4 then
			
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Hide()

	elseif britain.luaData.britishsupply == 3  then
				ui.mainPanel.foodcrisisEnt:Show()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Hide()
		
	elseif britain.luaData.britishsupply == 2 then 
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Show()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Hide()
	
	elseif britain.luaData.britishsupply == 1  then			
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Show()
				ui.mainPanel.foodcrisisEnt3:Hide()
	
	elseif britain.luaData.britishsupply <= 0  then
				
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Show()
	
	
	
	end
	
	
  ui.turn_report = hud:AdoptWidget(TurnReportPanel())

  ui.newsPaper = hud:AdoptWidget(NewsEvent())

  ui.cursorModeTooltipPanel = hud:AdoptWidget(CursorModeTooltip())

  ui.renamePanel = hud:AdoptWidget(UnitRenamePanel())
  ui.convoyPanel = hud:AdoptWidget(PopupConvoy())
  ui.transportPanel = hud:AdoptWidget(PopupTransport())
  ui.factionPanel = hud:AdoptWidget(PopupUnmovedFaction())

  ui.advicePanel = hud:AdoptWidget(PopupAdvice())

  ui.optionsPanel = hud:AdoptWidget(OptionsPanel())


  -- Set date & turn
  local day, month, year = GetTurnDate()
  hud:GetText("date_day"):SetNumber(day)
  hud:GetText("date_month"):SetLocalText("month" .. month)
  hud:GetText("date_year"):SetNumber(year)
  if game.turn < 1 then
    hud:GetText("turn_text"):SetText("Turn 1/" .. scenario.turnLimit)
  else
    hud:GetText("turn_text"):SetText("Turn " .. game.turn .. "/" .. scenario.turnLimit)
  end

  -- Load sounds
  --engine:StopMusic()
  --engine:PlayMusic("game2")

  MusicPlayer():Stop()
  MusicPlayer():ClearPlayList()
 -- local playListLength = 4
 -- math.randomseed( os.time() )
 -- local randomMusicStart = math.random(1, playListLength)
 -- for i = 0, 3 do
 --   local trackId =  ((i + randomMusicStart)  % playListLength) + 1
  --  MusicPlayer():AddToPlayList("game" .. trackId)
 -- end
  MusicPlayer():SetLooping(true)
 -- MusicPlayer():Play()
  
  

  CallNoSelectTab()

  ui.resourcesPanel:Refresh()
  -- Refresh Prod Queue
  --ManageQueue(playerAlliance, ui.queueRow)

  if GetClimate() > 0 then
    gameplay.winter = 1
  else
    gameplay.winter = 0
  end

  -- Clear advance info
  gameplay.advanceUnit = nil
  gameplay.advanceHex = nil

--~   -- check for water hexes with no region defined
--~   for x = 0, game.map.hexWidth-1 do
--~     for y = 0, game.map.hexHeight-1 do
--~       local hex = game:GetHex(x,y)
--~       if hex.terrain.type == Terrain.WATER and hex.region == 255 then
--~         Log("hex has no region : " .. x .. "," .. y)
--~       end
--~     end
--~   end

  if game.type == Game.TYPE_PBEM then
    local something = game:GetAllianceById(2)
    if something.luaData.firstPhase == nil then
      something.luaData.firstPhase = 1
    else
      if replaystuff == nil then
        ui.chatPanel:Show()
        ui.chatPanel.replayButton:Show()
        ui.chatPanel.turnButton:Hide()
        ui.chatPanel.surrenderButton:Hide()
        PopupReplayStart()
        replaystuff = 1
      elseif replaystuff == 1 then
        replaystuff = 2
      end
    end
  end
end


  ---------------------- ON TURN START -----------------------------

function hud.OnTurnStart()
  ui.lastLookedAtHex = nil

  --FIXME: should be in game logic but FOW is redrawn after GamePhaseStart
  CoastalCityLOS(playerAlliance)

  --FIXME: should be in game logic but movement points recovery happens after GamePhaseStart
      -- Convoys dont auto move in first turn, so take away their mp
  if game.turn == 1 and playerAlliance.id == startingAlliance then
    for faction in game.factions do
      for unit in faction.units do
        if unit.prototype.name == "convoy" then
          unit.mp = 0
        end
      end
    end
  end
--~   for faction in game.factions do
--~     for unit in faction.units do
--~       SetUnitMovePenalty(unit)
--~     end
--~   end

  printLog("turn start")

  -- Close "AI turn" dialog
  --ui.mainPanel.blockingPanel:Hide()
    
--------------TURN START--------------	
	local britain = game:GetFactionById(1)
	local germany = game:GetFactionById(2)
  	local russia = game:GetFactionById(4)
	local serbia = game:GetFactionById(7)
	
	-----RUSSIA SUPPLY ICON------------
	if russia.alliance.id == 1
		and game.currentAlliance.id == player.alliance.id
		and game.currentAlliance.id == 1
		and GetEvent("RussiaSupplyCrisis") == 0 then
		
			ui.mainPanel.RusSupCrisis:Show()
			ui.mainPanel.russupply:SetNumber(russia.luaData.crisis)
			ui.mainPanel.russupply:Show()
	
	else
		ui.mainPanel.RusSupCrisis:Hide()
		ui.mainPanel.russupply:Hide()
	
	end
	------MINES-----------------
	local entente =  game:GetAllianceById(1)
	local cp =  game:GetAllianceById(2)
	local impassable = game:GetFactionById(24)

	if germany.alliance.id == 2 then
		if game.currentAlliance.id == player.alliance.id
			and game.currentAlliance.id == 1
			and entente.luaData.cpminesspot >0
			and entente.luaData.cpminesspot +3 >= game.turn then
				ui.mainPanel.EntMinesSpot:Show()
		else
				ui.mainPanel.EntMinesSpot:Hide()
		
		end	
		if game.currentAlliance.id == player.alliance.id
			and game.currentAlliance.id == 2
			and cp.luaData.entminesspot >0
			and cp.luaData.entminesspot +3 >= game.turn then
				ui.mainPanel.CPMinesSpot:Show()
		else
			ui.mainPanel.CPMinesSpot:Hide()
		end		
	else
		ui.mainPanel.CPMinesSpot:Hide()
		ui.mainPanel.EntMinesSpot:Hide()
	end
  
	-------NORTH SEA BLOCKED ICON----------------
	if germany.luaData.blockaded == 0 then
		
				ui.mainPanel.blockadestatus:Hide()

	elseif germany.luaData.blockaded == 1 then
				ui.mainPanel.blockadestatus:Show()
		
	end
	
	------- BAD HARVEST ICON----------------
	if germany.luaData.misharvest  == 0 then
		
				ui.mainPanel.foodcrisisCP:Hide()

	elseif germany.luaData.misharvest == 1 then
				ui.mainPanel.foodcrisisCP:Show()
		
	end
						

--------------BRITISH SUPPLY ICON-----------------

	if britain.luaData.britishsupply  >= 4 then
			
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Hide()

	elseif britain.luaData.britishsupply == 3  then
				ui.mainPanel.foodcrisisEnt:Show()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Hide()
		
	elseif britain.luaData.britishsupply == 2 then 
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Show()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Hide()
	
	elseif britain.luaData.britishsupply == 1  then			
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Show()
				ui.mainPanel.foodcrisisEnt3:Hide()
	
	elseif britain.luaData.britishsupply <= 0  then
				
				ui.mainPanel.foodcrisisEnt:Hide()
				ui.mainPanel.foodcrisisEnt1:Hide()
				ui.mainPanel.foodcrisisEnt2:Hide()
				ui.mainPanel.foodcrisisEnt3:Show()
	
	
	
	end


  -- Intro popup
  if AdviceValid("intro") and settings.tutorial == 1 then
    ui.advicePanel:AddAdvice("intro")
    ui.advicePanel:AddAdvice("mainUI")
    ui.advicePanel:AddAdvice("tabs")
    ui.advicePanel:AddAdvice("tabselection", {315, 588, 2})
    ui.advicePanel:AddAdvice("tabproduction", {415, 588, 2})
    ui.advicePanel:AddAdvice("tabresearch", {515, 588, 2})
    ui.advicePanel:AddAdvice("tabdiplomacy", {615, 588, 2})
    ui.advicePanel:AddAdvice("tabmanagement", {715, 588, 2})
    AdviceClose("intro")
  end

  local day, month, year = GetTurnDate()
  hud:GetText("date_day"):SetNumber(day)
  hud:GetText("date_month"):SetLocalText("month" .. month)
  hud:GetText("date_year"):SetNumber(year)

  hud:GetText("turn_text"):SetText("Turn " .. game.turn .. "/" .. scenario.turnLimit)

  ui.resourcesPanel:Refresh()

  ui.mainPanel.researchTab:CountQueueTechs()
  --ui.mainPanel.productionTab:CountQueueTechs()

  --UpdateTechStats(ui.selectedTech, ui.researchFaction)

  -- Refresh Prod Queue
  if ui.productionFaction ~= nil then
    --ManageQueue(playerAlliance, ui.queueRow)
  end
  --productionPanel:Refresh()

  -- Research panel refresh
  ui.researchPanel:Refresh()

  -- Turn report & event messages
  if game.turn == 1 and game.currentAlliance.id ~= startingAlliance and game.year == 1914 then

    if playerAlliance.id == game.currentAlliance.id then
      ui.disableControls = false
    end

    ui.mainPanel.blockingPanel:Hide()

    ui.newsPaper:Refresh(0)

    ui.turn_report:Show()

    ui.messageQue:ShowNext()
  else
    -- Advice messages
    AdviceTurnStart()
  end

  -- Autosave
  if game.type == Game.TYPE_SINGLE then
    if settings.autosave == 1 then
      playerAlliance.luaData.camera = {}
      playerAlliance.luaData.camera["x"] = GetPlayer().camera.x
      playerAlliance.luaData.camera["y"] = GetPlayer().camera.y
      SaveGame("AutoSave")
    end
  end


  --engine:ScheduleTask(1000, EndTurnProcess)

end


  ---------------------- ON UNIT SELECT -----------------------------

function hud.OnUnitSelect(unit)
local impassable = game:GetFactionById(24)
local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
local russia = game:GetFactionById(4)
local germany = game:GetFactionById(2)


  GetScene():ClearActions()
 if unit ~= nil and unit.type == Unit.NAVAL then

   GetScene():EnableUnitLayer(true)
	  				
			for alliance in game.alliances do
			
			for faction in alliance.factions do
				if faction.alliance.id == game.currentAlliance.id  then			
				  	local noendurance = {}
					local halfendurance = {}

					for unit in faction.units do
						
						if unit.hex ~= nil 
							and unit.luaData.endurance ~= nil 
							and unit.luaData.endurance <= 1 then
								table.insert(noendurance, unit.hex)
						
						elseif unit.hex ~= nil 
							and unit.luaData.endurance ~= nil 
							and unit.luaData.endurance <= 2 
							and unit.efficiency <= 39 then					
							table.insert(noendurance, unit.hex)
						
						
						elseif unit.hex ~= nil 
							and unit.luaData.endurance ~= nil  
							and unit.luaData.endurance <= 4
							and unit.efficiency <= 50 then													
							table.insert(halfendurance, unit.hex)
							

						elseif unit.hex ~= nil 
							and unit.luaData.endurance ~= nil 
							and unit.luaData.endurance <= 3
							and unit.efficiency > 50 then	
							table.insert(halfendurance, unit.hex)		
						
						
						
						end
			
					end
				   	-- GetScene():AddActionImages(halfendurance, "allianceOverlay_0_100")
				--GetScene():AddActionImages(noendurance, "allianceOverlay_red_100")
				GetScene():AddActionImages(noendurance, "rot")
				GetScene():AddActionImages(halfendurance, "gelb")

				end
		
				
			
			
			end
		end
elseif unit ~= nil and unit.type == Unit.LAND and impassable.luaData.mud == game.turn  then --mud					      

	 GetScene():EnableUnitLayer(true)
	  					
			for alliance in game.alliances do
			
			for faction in alliance.factions do
						
				  	local swamp = {}

					for unit in faction.units do
						if unit.hex ~= nil and unit.luaData.mud ~= nil and unit.luaData.mud == game.turn   then
							table.insert(swamp, unit.hex)
						end
			
					end
				   	 GetScene():AddActionImages(swamp, "mud")
				
				end
			end
				
				
elseif unit ~= nil 
	and unit.hex ~= nil
	and unit.type == Unit.LAND   then -- army code broken					      

	 GetScene():EnableUnitLayer(true)
	  					
		for alliance in game.alliances do
			
			for faction in alliance.factions do
						
				  	local codebroken = {}

					for unit in faction.units do
						if unit.hex ~= nil then
							if (unit.luaData.codebroken ~= nil
								and unit.luaData.codebroken +2 >= game.turn) 
								or (unit.faction.id == 4 
									and unit.type == Unit.LAND
									and (unit.hex.originalFaction.id == 2 or unit.hex.y <= 21)
									and germany.luaData.funk >0)	then
									
									table.insert(codebroken, unit.hex)
							end
						end		
					end
					
					if faction.alliance.id == 1 then
						if (game.currentAlliance.id == player.alliance.id
							and game.currentAlliance.id == 2)
							
						or (game.currentAlliance.id == player.alliance.id
								and game.currentAlliance.id == 1
								and entente.luaData.sigint[faction.id] > cp.luaData.sigint[faction.id]) then
								
									GetScene():AddActionImages(codebroken, "code")		
						end		
					
					elseif faction.alliance.id == 2 then
							if (game.currentAlliance.id == player.alliance.id
								and game.currentAlliance.id == 1)
							
							or (game.currentAlliance.id == player.alliance.id
								and game.currentAlliance.id == 2
								and cp.luaData.sigint[faction.id] > entente.luaData.sigint[faction.id]) then

								GetScene():AddActionImages(codebroken, "codeent")
							end
							
					end
			end	
		end	
		
		
elseif unit ~= nil 
	and unit.hex ~= nil
	and unit.type == Unit.NAVAL   then -- naval code broken					      

	 GetScene():EnableUnitLayer(true)
	  					
			for alliance in game.alliances do
			
				for faction in alliance.factions do
						
				  	local navalcodebroken = {}

					for unit in faction.units do
						if unit.hex ~= nil then
							if	unit.luaData.navalcodebroken ~= nil
							and unit.luaData.navalcodebroken +2 >= game.turn then
							table.insert(navalcodebroken, unit.hex)
							end
						end
			
					end
						if faction.alliance.id == 1 then
							if (game.currentAlliance.id == player.alliance.id
								and game.currentAlliance.id == 2)
								
								or (game.currentAlliance.id == player.alliance.id
									and game.currentAlliance.id == 1
									and entente.luaData.sigint[faction.id] > cp.luaData.sigint[faction.id]) then
								
									GetScene():AddActionImages(navalcodebroken, "code")
							end		
						
						elseif faction.alliance.id == 2 then
								if (game.currentAlliance.id == player.alliance.id
									and game.currentAlliance.id == 1)
								
								or (game.currentAlliance.id == player.alliance.id
									and game.currentAlliance.id == 2
									and cp.luaData.sigint[faction.id] > entente.luaData.sigint[faction.id]) then

									GetScene():AddActionImages(navalcodebroken, "codeent")
								end
								
						end
				end	
			end			

			
 --[[seif unit ~= nil and GetEvent("Ice") >0 and gameplay.winter == 1
		GetScene():EnableUnitLayer(true)
		local petersburg  = game:GetHex(106, 42)
		local hexes = game.map:GetHexesInRange(petersburg, 10)
						local icefield = {}

			for _, hex in pairs(hexes) do
				if hex.unit == nil and hex.terrain.type == Terrain.WATER  and math.random(1,6) >= 5 then
					table.insert(icefield, hex)
				end
			end	
		GetScene():AddActionImages(icefield, "ice")
		end]]
		
else

--[[	local unit = GetSelectedUnit()
    if unit ~= nil then
      --GetPlayer():DeselectUnit()
      --GetPlayer():SelectUnit(unit)
      ui.SelectHex(unit.hex)
    end]]
end
end
HudUtil = {}

function IsIdInTable(id, table)
  for _, e in ipairs(table) do
    if e.id == id then
      return true
    end
  end
  return false
end

--[[
function HudUtil.HandleMoveOrder(unit, hex)
  if hex.unit == nil or not playerAlliance:IsVisible(hex) or not playerAlliance:IsVisible(hex.unit) then
    if unit.type == Unit.NAVAL then
      if hex.terrain.type == Terrain.WATER then
        GetPlayer():MoveUnit(unit, hex)
        -- check for sub reveal
        if hex.unit ~= nil and hex.unit.prototype.name == "submarine" then
          unit.luaData.subRevealedUnit = hex.unit.id
          unit.luaData.subRevealedTurn = game.turn
        end
      elseif unit.cargo ~= nil then
        DisembarkUnit(unit, hex, function(unit, hex) GetPlayer():DisembarkUnit(unit, hex) end)
        ui.SelectHex(hex)
      end
    else
      if hex.terrain.type == Terrain.WATER then
        EmbarkUnit(unit, hex, function(unit, hex) GetPlayer():EmbarkUnit(unit, hex) end)
        ui.SelectHex(hex)
      else
        GetPlayer():MoveUnit(unit, hex)
      end
    end
  end
end]]

function HudUtil.HandleMoveOrder(unit, hex)
  if hex.unit == nil or not playerAlliance:IsVisible(hex) or not playerAlliance:IsVisible(hex.unit) then
    if unit.type == Unit.NAVAL then
      if hex.terrain.type == Terrain.WATER then
        GetPlayer():MoveUnit(unit, hex)
        -- check for sub reveal
        if hex.unit ~= nil and hex.unit.prototype.name == "submarine" then
                    if unit.alliance.id == player.alliance.id 
						and math.random(0,250) > unit.luaData.experience
						and player.alliance.id == game.currentAlliance.id 
						and not (HasUnitTech(unit, "passive_hydrophone")) then
						local subdamage = math.random(1,4) * 0.5 
								LogUi("SUB AMBUSH")
								unit:Damage(subdamage)
								unit.efficiency = unit.efficiency * 0.5
							--	PopupMessage("subsurprise")
							if game.type == Game.TYPE_SINGLE then
								PopupMessage("AMBUSHED BY SUBMARINES!")
							end
							--	PopupInfoDialog("ATTACKED BY SUBMARINES!")
								AttackSound(hex.unit)
								local sfx = {}
							sfx = LoadSample("submarine_attack_1.wav")
							PlaySample(sfx)
							PlaySample(LoadSample("submarine_attack_1.wav"))
							
					end
		  
		  
		  unit.luaData.subRevealedUnit = hex.unit.id
          unit.luaData.subRevealedTurn = game.turn
        end
      elseif unit.cargo ~= nil then
        DisembarkUnit(unit, hex, function(unit, hex) GetPlayer():DisembarkUnit(unit, hex) end)
        ui.SelectHex(hex)
      end
    else
      if hex.terrain.type == Terrain.WATER then
        EmbarkUnit(unit, hex, function(unit, hex) GetPlayer():EmbarkUnit(unit, hex) end)
        ui.SelectHex(hex)
      else
        GetPlayer():MoveUnit(unit, hex)
      end
   
 end
  end
end





function HudUtil.HandleSwapOrder(unit, hex)
  assert(unit.hex ~= nil and hex:Distance(unit.hex) == 1)
  assert((unit.prototype.lua.chassis == "rail" and hex.hasRailroad) or
         (hex.unit.prototype.lua.chassis == "rail" and unit.hex.hasRailroad) or
         (unit.prototype.lua.chassis ~= "rail" and hex.unit.prototype.lua.chassis ~= "rail"))
  ui.swappedHex = hex
  GetPlayer():SwapUnits(unit, hex.unit)
end

function HudUtil.HandleDisembarkOrder(unit, hex)
  assert(unit.type == Unit.NAVAL)
  assert(unit.cargo ~= nil)
  DisembarkUnit(unit, hex, function(unit, hex) GetPlayer():DisembarkUnit(unit, hex) end)
  ui.SelectHex(hex)
end

function HudUtil.DetectOrder(unit, hex)
  if unit.mp > 0 and IsIdInTable(hex.id, ui.movementHexes) then
    if hex.unit == nil or not playerAlliance:IsVisible(hex) or not playerAlliance:IsVisible(hex.unit) then
      return "MOVE"
    elseif unit.hex ~= nil and hex:Distance(unit.hex) == 1 then
      if  (unit.prototype.lua.chassis == "rail" and hex.hasRailroad) or
          (hex.unit.prototype.lua.chassis == "rail" and unit.hex.hasRailroad) or
          (unit.prototype.lua.chassis ~= "rail" and hex.unit.prototype.lua.chassis ~= "rail") then
            return "SWAP"
      end
    end
  end
  
  if unit.ap > 0 and IsIdInTable(hex.id, ui.targetHexes) then
    return "ATTACK"
  end
  
  return nil
end
---------------------- ON HEX SELECT -----------------------------




function hud.OnHexClick(hex, button)

  ui.swappedHex = nil

  -- Order unit
  if ui.UIMode == DEFAULT and not ui.disableControls then
    if button == Command.Order then

      local unit = GetSelectedUnit()

      if unit ~= nil and unit.faction.alliance.id == playerAlliance.id then
        
        local confirmed = false
        
        if hud.orderSource == unit then
          if hud.orderTarget == hex then
            confirmed = true
          end
        end
        
        hud.orderSource = unit
        hud.orderTarget = hex

        local order = HudUtil.DetectOrder(unit, hex)
    
        if order == "MOVE" then
          if confirmed == true then
            HudUtil.HandleMoveOrder(hud.orderSource, hud.orderTarget)
          else
            GetScene():ShowMovePath(hud.orderSource, hud.orderTarget)
          end
        elseif order == "ATTACK" then
			
		  if confirmed == true then
            ui.UnitAttack(hud.orderSource, hud.orderTarget)
          else
            GetScene():ClearActions();
            GetScene():AddActionImages({hud.orderTarget}, "confirm_attack");
            ui.ShowCombatPrognosis(hud.orderTarget, hud.orderSource)
          end
        elseif order == "SWAP" then
          if confirmed then
            HudUtil.HandleSwapOrder(hud.orderSource, hud.orderTarget)
          else
            GetScene():ClearActions();
            GetScene():AddActionImages({hud.orderTarget}, "confirm_swap");
          end
        end
        
        if confirmed then
          hud.orderSource = nil
          hud.orderTarget = nil
        end
        
        if order ~= nil then
          return
        end

        -- Advance into hex
        if gameplay.advanceHex ~= nil and gameplay.advanceUnit ~= nil then
          if unit.id == gameplay.advanceUnit.id and gameplay.advanceHex.id == hex.id then
            if unit.type ~= Unit.NAVAL then
              GetPlayer():WarpUnit(unit, gameplay.advanceHex)
            else
              DisembarkUnit(unit, gameplay.advanceHex, function(unit, hex) GetPlayer():DisembarkUnit(unit, hex) end)
            end
            ui.SelectHex(gameplay.advanceHex)
          end
        end

        -- Ask DOW when clicking on neutral hex
        if ui.dowMessage ~= 1 then
          if hex.faction ~= nil then
            if hex.faction.alliance.id == 0 and IsFactionVisible(hex.faction) then
              function DeclareWarConfirmed()
                DeclareWar(playerAlliance, hex.faction)
                ui.diplomacyPanel:UpdateRelationStats(hex.faction)
                --GetPlayer():DeselectUnit()
                --GetPlayer():SelectUnit(unit)
                ui.SelectHex(unit.hex)
                ui.dowMessage = 0
              end
              function NoFunc() ui.dowMessage = 0 end
              PopupDialog("declare_war_confirm", DeclareWarConfirmed, NoFunc)
            end
          end
        end

      end

    end
    if button == Command.Deselect and Command.Deselect ~= Command.Select and ui.overlayActive == false then
      -- Unselect unit
      local unit = GetSelectedUnit()
      if unit ~= nil then
        GetPlayer():DeselectUnit()
        GetScene():ClearActions()
        ui.firstSelected = nil
        hud:GetWidget("noselected_panel"):Show()
        ui.cursorModeTooltipPanel:Hide()
      end
    end
  end

  if button == Command.Select and ui.swappedHex == nil then

    -- Select unit
    if ui.UIMode == DEFAULT and game.currentAlliance ~= nil and not ui.disableControls then
      if game.currentAlliance.id == playerAlliance.id and not ui.overlayActive then
        if settings.hexesSelectable or (hex.unit ~= nil and playerAlliance:IsVisible(hex.unit)) then
          PlaySample(sSelectUnit)
          ui.SelectHex(hex)
        end
      end
    end

    if hex.unit ~= nil then
	  hud:GetText("turn_text"):SetText(hex.x .. "," .. hex.y.. " " .. game.turn) --- coord1

      local unit = hex.unit

      -- dave's debugging

      ClearAiLayer()

      if hasAttacked ~= nil and unit.alliance.id ~= playerAlliance.id then
        showAssignmentCosts(unit)
      end

      -- Repair unit
      if ui.UIMode == REPAIR then
        if CanRepairUnit(unit) then -- Only repair units that appear damaged (visible strength <= 9)
          if RepairUnit(unit) then
            ui.resourcesPanel:Refresh()
       --     PlaySample(sRepairUnit)
		
		if unit.prototype.name ~= "infantry" and unit.prototype.name ~= "cavalry" and unit.prototype.name ~= "garrison" and unit.prototype.name ~= "smallgarrison" and unit.prototype.name ~= "arabinfantry" and unit.prototype.name ~= "arabgarrison" and unit.prototype.name ~= "arabcavalry" and unit.prototype.name ~= "arabsmallgarrison" then  
			if math.random(1,2) == 1 then
				sfx = LoadSample("repair1.wav")
				PlaySample(sfx)
			else
				sfx = LoadSample("repair2.wav")
				PlaySample(sfx)
			end	           
		else
			local luck = math.random(1,7)
			if luck == 1 then
				sfx = LoadSample("repair3.wav")
				PlaySample(sfx)
			elseif luck == 2 then
				sfx = LoadSample("repair4.wav")
				PlaySample(sfx)
			elseif luck == 3 then
				sfx = LoadSample("repair5.wav")
				PlaySample(sfx)
			elseif luck == 4 then
				sfx = LoadSample("repair6.wav")
				PlaySample(sfx)
			elseif luck == 5 then
				sfx = LoadSample("repair7.wav")
				PlaySample(sfx)
			elseif luck == 6 then
				sfx = LoadSample("repair8.wav")
				PlaySample(sfx)
			elseif luck == 7 then
				sfx = LoadSample("repair9.wav")
				PlaySample(sfx)	
			end
		
		
		end
		
		   DisplayRepairZone()
          end
        end
      end

      -- Upgrade unit
      if ui.UIMode == UPGRADE then
        if UpgradeUnit(unit) == true then
          PlaySample(sPurchase)
          ui.resourcesPanel:Refresh()
          DisplayUpgradeZone()
          ui.improvementsPanel:Hide()
        end
      end

      -- Disband unit
      if ui.UIMode == DISBAND then
        if CanUnitDisband(unit) then
          function DisbandUnitConfirm()
            if GetSelectedUnit() ~= nil then
              if GetSelectedUnit().id == unit.id then
                GetPlayer():DeselectUnit()
                GetScene():ClearActions()
                ui.firstSelected = nil
                hud:GetWidget("noselected_panel"):Show()
              end
            end
            DisbandUnit(unit)
            DisplayDisbandZone()
            ui.resourcesPanel:Refresh()
          end
          PopupDialog("disbandConfirm", DisbandUnitConfirm)
        end
      end
	 
	
	  
	  
	  
      -- Attach Commander to unit
      if ui.UIMode == ATTACH then
        if CommanderCompatible(ui.prodqueue.slot, unit) == true then
          AttachCommanderToUnit(ui.prodqueue.slot, unit)
          -- Refresh Prod Queue
          ui.mainPanel.productionTab:Refresh()

          ui.improvementsPanel:Hide()

          ResetCursorMode()

          GetScene():ClearActions()

          PlaySample(sAttach)
        end
      end
    end
		    hud:GetText("turn_text"):SetText(hex.x .. "," .. hex.y.. " T:" .. game.turn)-- coord2

  end

  -- Deploy unit
  if ui.UIMode == DEPLOY then
    if button == Command.Deploy then
      if LimitedDeployUnit(ui.prodqueue.faction, ui.prodqueue.slot, hex) == true then
        -- Refresh Prod Queue
        ui.mainPanel.productionTab:Refresh()

        GetScene():ClearActions()

        ResetCursorMode()

        PlaySample(sDeploy)
      end
    end
  end

  -- Cancel cursor mode
  if ui.UIMode ~= DEFAULT then
    if button == Command.Cancel then
      GetScene():ClearActions()
      ResetCursorMode()
      ui.improvementsPanel:Hide()
    end
  end

end

  ---------------------- ON ALLIANCE CHANGE -----------------------------

function hud.OnFactionJoined(alliance, faction)

  -- Add AI bonuses
  GiveOneOffBonuses(faction,alliance)

  faction.luaData.turnJoined = game.turn

  -- Add to turn report queue
  AddToReportQueue(playerAlliance, faction.name .. "_joined_" .. alliance.id, "../flags/flag_" .. faction.name .. "_16")

  -- Add faction to various UI panels
  if alliance.id == playerAlliance.id then

    ui.resourcesPanel:AddFactionResourceInfo(faction, alliance.numFactions)

    if CanFactionProduce(faction) then
      ui.productionPanel:AddFaction(faction)

      ui.researchPanel:AddFaction(faction)

      ui.diplomacyPanel:FactionDiplomacyFlag(faction)

      ui.managementPanel:AddFaction(faction)
    end

  end

  -- Update diplomacy panel
  --RefreshDiplomacy()

  -- Add to event popup queue
--~   local eventName = "event_" .. faction.name .. "_joins"
--~   for construction in faction.constructions do
--~     if construction.type == Construction.TYPE_CAPITAL then
--~       ui.newsPaper:AddEvent(eventName, eventName .. ".png", construction.hex)
--~       break
--~     end
--~   end

end


function hud.OnFactionLeft(alliance, faction)
  if alliance.id == playerAlliance.id then

    if CanFactionProduce(faction) then
      ui.productionPanel:RemoveFaction(faction)

      ui.researchPanel:RemoveFaction(faction)

      ui.diplomacyPanel:RemoveDiplomacyFlag(faction)

      ui.managementPanel:RemoveFaction(faction)
    end

    ui.resourcesPanel:RemoveFaction(faction)

  end
end

function ui.ShowCombatPrognosis(hex, unit)

  if hex.unit == nil or unit == nil then
    return false
  end
  
  local showTooltip = false

  hud:GetPanel("selection_tab"):DisplayStats()

  for i, validTarget in pairs(ui.targetHexes) do
    if validTarget.id == hex.id then
      -- Advice popup
      if AdviceValid("prognosis") and settings.tutorial == 1 then
        ui.advicePanel:AddAdvice("prognosis")
        AdviceClose("prognosis")
      end

      -- Prognosis
      if hex.unit ~= nil and playerAlliance:IsVisible(hex) then
        hud:GetPanel("selection_tab"):DisplayPrognosis(unit, hex.unit)
        if unit.type ~= Unit.NAVAL or hex.unit.type ~= Unit.NAVAL then
          showTooltip = true
        end
        showTooltip = true
      end
      break
    end
  end
  return showTooltip
end

---------------------- !!!ON HEX HOVER SHOW COORDINATES!!!----------------------------- 
--function hud.OnHexClick(hex, button)
--hud:GetText("turn_text"):SetText("Hex: " .. hex.x .. "," .. hex.y)
--end



function hud.OnHotHexChange(hex)

  if hex ~= nil then

   -- print("hot hex: " .. hex.x .. "," .. hex.y .. " terrain: " .. hex.terrain.name)

    if ui.UIMode ~= DEFAULT then
      if hex.unit ~= nil then
        if hex.unit.faction.alliance.id == playerAlliance.id then
          if ui.UIMode == REPAIR then
            if CanRepairUnit(hex.unit) then
              ui.cursorModeTooltipPanel:Display(hex)
              local PPcost, MPcost = GetRepairCost(hex.unit)
              ui.cursorModeTooltipPanel.hitpoints_text:SetText("+" .. math.floor(GetRepairPoints(hex.unit) / 10))
              ui.cursorModeTooltipPanel.resource_1_text:SetNumber(-PPcost)
              ui.cursorModeTooltipPanel.resource_2_text:SetNumber(-MPcost)
              ui.cursorModeTooltipPanel.hitpoints_text:SetColour(0, 0, 0, 255)
            end
          end
          if ui.UIMode == UPGRADE then
            local upgrade_cost, improvements = UnitCanUpgradeDetailed(hex.unit)
            if upgrade_cost > 0 then
              ui.cursorModeTooltipPanel.hitpoints_text:SetText("/")
              ui.cursorModeTooltipPanel:Display(hex)
              ui.cursorModeTooltipPanel.resource_1_text:SetNumber(-upgrade_cost)
              ui.cursorModeTooltipPanel.hitpoints_text:SetColour(0, 0, 0, 255)
              ui.cursorModeTooltipPanel.resource_2_text:SetText("/")
              ui.improvementsPanel:Display(hex.unit, improvements)
              SetCursorAnimation("cursor_upgrade")
            else
              SetCursorImage("cursor_upgrade")
              ui.improvementsPanel:Hide()
            end
          end
          if ui.UIMode == DISBAND then
            if hex.unit.supply > 0 then
              ui.cursorModeTooltipPanel:Display(hex)
              local PPrefund, MPrefund = GetDisbandRefund(hex.unit)
              ui.cursorModeTooltipPanel.hitpoints_text:SetNumber(-math.floor((hex.unit.hp+9)/10))
              ui.cursorModeTooltipPanel.resource_1_text:SetText("+" .. PPrefund)
              ui.cursorModeTooltipPanel.resource_2_text:SetText("+" .. MPrefund)
              ui.cursorModeTooltipPanel.hitpoints_text:SetColour(0, 0, 0, 255)
            end
          end
          if ui.UIMode == ATTACH then
            if CommanderCompatible(ui.prodqueue.slot, hex.unit) then
              local improvements = {}
              for statName, value in pairs(data.commanders[ui.prodqueue.slot+1].stats) do
                improvements[statName] = value
              end
              ui.improvementsPanel:Display(hex.unit, improvements)
              DisplayAttachZone(ui.prodqueue.slot)
              MarkCommanderRange(hex.unit, ui.prodqueue.slot)
              SetCursorAnimation("cursor_deploy")
            else
              SetCursorImage("cursor_deploy")
              ui.improvementsPanel:Hide()
            end
          end
        else
          ui.cursorModeTooltipPanel:Hide()
          ui.improvementsPanel:Hide()
        end
      else
        ui.cursorModeTooltipPanel:Hide()
        ui.improvementsPanel:Hide()
        if ui.UIMode == ATTACH then
          SetCursorImage("cursor_deploy")
        end
      end
      if ui.UIMode == DEPLOY then
        if IsValidDeploymentHex(hex, ui.prodqueue.unit, ui.prodqueue.faction) ~= -1 then
          SetCursorAnimation("cursor_deploy")
        else
          SetCursorImage("cursor_deploy")
        end
      end
    end

    local unit = GetSelectedUnit()

    local showTooltip = false
    if unit ~= nil then
      showTooltip = ui.ShowCombatPrognosis(hex, unit);
    end


    -- Show ammo tooltip
    if showTooltip and unit.prototype:GetLevelStats(1).ammunition > 0  then
	
	
	
	  ui.cursorModeTooltipPanel:Display(hex)
      ui.cursorModeTooltipPanel.hitpoints_text:SetNumber(-GetUnitAmmoRequirement(unit))
    

	if unit.prototype:GetLevelStats(1).ammunition > unit.faction.am then
        ui.cursorModeTooltipPanel.hitpoints_text:SetColour(197, 17, 17, 255)
      else
        ui.cursorModeTooltipPanel.hitpoints_text:SetColour(0, 0, 0, 255)
      end
    else
      if ui.UIMode == DEFAULT then
        ui.cursorModeTooltipPanel:Hide()
      end
    end

  --else

    --ui.cursorModeTooltipPanel:Hide()

  end

end

  ---------------------- ON UNIT ATTACKED -----------------------------

function PopupCommanderKilledMessageOnTurnReport()
  if playerAlliance.id == game.currentAlliance.id then
    PopupMessage("commander_killed")
  else
    playerAlliance.luaData.popupCommander_killed = 1
  end
end
  
  
  
  
  function PopupCommanderWoundedMessageOnTurnReport()
  if playerAlliance.id == game.currentAlliance.id then
    PopupMessage("commander_wounded")
  else
    playerAlliance.luaData.popupCommanderWounded = 1
  end
end

function PopupCommanderCapturedMessageOnTurnReport()
  if playerAlliance.id == game.currentAlliance.id then
    PopupMessage("commander_captured")
  else
    playerAlliance.luaData.popupCommanderCaptured = 1
  end
end
-- new
function PopupCommanderKaiserCaptureMessageOnTurnReport()
  if playerAlliance.id == game.currentAlliance.id then
    PopupMessage("commanderkaiser_captured")
  else
    playerAlliance.luaData.popupCommanderCaptured = 1
  end
end





function hud.OnUnitAttacked(attacker, defender, attackerDamage, defenderDamage)

  --Log("Unit #" .. defender.id .. " attacked by #" .. attacker.id .. " damage: " .. attackerDamage .. " : " .. defenderDamage);

  -- Reveil attacker
  if not playerAlliance:IsVisible(ui.attackerHex) then
    playerAlliance:AddVisibleHex(ui.attackerHex)
  end

  -- Update unit selection
  if attacker.faction.alliance.id == playerAlliance.id then
    GetScene():ClearActions()
    if attacker.alive then
      --GetPlayer():SelectUnit(attacker)
      ui.SelectHex(attacker.hex)
    else
      -- Deselect attacker if it died
      GetPlayer():DeselectUnit()
      ui.firstSelected = nil
      hud:GetWidget("noselected_panel"):Show()

      -- Commander wounded
      if attacker.commander ~= nil then
        PopupCommanderWoundedMessageOnTurnReport()
        --PopupMessage("commander_wounded")
      end
    end
  end

  local attackerHex
  if attacker.alive then
    attackerHex = attacker.hex
  else
    attackerHex = attacker.previousHex
  end

  -- Attack animations
  local visualDamage, hex
  if defender.prototype ~= nil then
    local defenderHex
    if defender.alive then
      defenderHex = defender.hex
    else
      defenderHex = defender.previousHex
    end

    visualDamage = math.floor((defender.hp + ui.defenderDamage + 9)/10) - math.floor((defender.hp + 9)/10)
    View:AddEffect(defenderHex, "damage_" .. visualDamage)

    if attacker.bombard == 0 then
      visualDamage = math.floor((attacker.hp + ui.attackerDamage + 9)/10) - math.floor((attacker.hp + 9)/10)
      View:AddEffect(attackerHex, "damage_" .. visualDamage)
    end

    -- Commander wounded message
    if defender.alliance.id == playerAlliance.id then
      if not defender.alive then
        if defender.commander ~= nil then
          PopupCommanderWoundedMessageOnTurnReport()
          --PopupMessage("commander_wounded")
        end
      end
    end
  else
    local hex = defender.hex
    if attacker.alliance.id ~= playerAlliance.id then
      showAttack(attackerHex,hex,MoveLogType.Attack)
    end
    visualDamage = math.floor((defender.efficency + ui.defenderDamage - math.floor(defender.efficency / 10) * 10) / 10)
    View:AddEffect(hex, "damage_" .. visualDamage)
  end

  -- Ammo consumption
  if attacker.alliance.id == playerAlliance.id and attacker.bombard > 0 then
    ui.resourcesPanel:Refresh()
  end

  -- Tutorial messages
  AdviceAttack(attacker, defender, ui.attackerDamage, ui.defenderDamage)

end



function hud.OnKeyEvent(key, pressed)

  if ui.hotkeysActive ~= 0 then

    -- Space Bar = City production
    if key == Key.SPACE then
      ShowCityProduction(pressed)
      --GetScene():EnableUnitLayer(not pressed)

    elseif key == Key.ESCAPE and pressed then
      ui.optionsPanel:Display()


	 
			
	  
	  
    -- R = Repair mode
    elseif key == Key.R and pressed then
      if ui.UIMode ~= REPAIR then
        ui.UIMode = REPAIR
        ui.cursormode:Show()

        DisplayRepairZone()

        -- Advice popup
        if AdviceValid("repair") and settings.tutorial == 1 then
          ui.advicePanel:AddAdvice("repair", {792, 730, 1})
          AdviceClose("repair")
        end
      else
        GetScene():ClearActions()
        ResetCursorMode()
      end


    -- U = Upgrade mode
    elseif key == Key.U and pressed then
      if ui.UIMode ~= UPGRADE then
        ui.UIMode = UPGRADE
        ui.cursormode:Show()

        DisplayUpgradeZone()

        -- Advice popup
        if AdviceValid("upgrade") and settings.tutorial == 1 then
          ui.advicePanel:AddAdvice("upgrade", {818, 730, 1})
          AdviceClose("upgrade")
        end
      else
        GetScene():ClearActions()
        ResetCursorMode()
      end


    -- D = Disband mode
    elseif key == Key.D and pressed then
      if ui.UIMode ~= DISBAND then
        ui.UIMode = DISBAND
        ui.cursormode:Show()

        DisplayDisbandZone()

        -- Advice popup
        if AdviceValid("disband") and settings.tutorial == 1 then
          ui.advicePanel:AddAdvice("disband", {844, 730, 1})
          AdviceClose("disband")
        end
      else
        GetScene():ClearActions()
        ResetCursorMode()
      end

--~     -- FIXME: DEBUG CHEAT! REMOVE!
--~     elseif key == 78 and pressed then
--~       local unit = GetSelectedUnit()
--~       if unit ~= nil then
--~         SetFactionMorale(unit.faction, -1000)
--~       end

    end

  end

  keysPressed[key] = pressed
end

function hud.OnHotKey(key, pressed)
  if key == Keys.PAGE_UP then
    if pressed then
      SelectActiveUnit("previous")
    end
  elseif key == Keys.PAGE_DOWN then
    if pressed then
      SelectActiveUnit("next")
    end
  end
  --also: TAB, UP, DOWN, LEFT, RIGHT, HOME, END
end

function SelectActiveUnit(which)
 -- LogUi("going to next unit")
  local previousUnit
  local firstUnit

  local HasUnitActions = function(unit)
    if unit.mp > 0 or (unit.ap > 0 and #GetValidTargets(unit, true) > 0) then
      return true
    end
    return false
  end

  for faction in playerAlliance.factions do
    for unit in faction.units do
      if unit.alive and unit.hex ~= nil and HasUnitActions(unit) then
        if GetSelectedUnit() == nil then
          ui.SelectHex(unit.hex)
          LookAtWrapper(unit.hex)
          return true
        end

        if firstUnit == nil then
          firstUnit = unit
        end

        if unit.id == GetSelectedUnit().id then
          if previousUnit ~= nil then
            if which == "previous" then
              ui.SelectHex(previousUnit.hex)
              LookAtWrapper(previousUnit.hex)
              return true
            end
          end
        end

        if previousUnit ~= nil and previousUnit.id == GetSelectedUnit().id then
          if which == "next" then
            ui.SelectHex(unit.hex)
            LookAtWrapper(unit.hex)
            return true
          end
        end

        previousUnit = unit
      end
    end
  end

  if which == "previous" and previousUnit ~= nil then
    ui.SelectHex(previousUnit.hex)
    LookAtWrapper(previousUnit.hex)
  end

  if which == "next" and firstUnit ~= nil then
    ui.SelectHex(firstUnit.hex)
    LookAtWrapper(firstUnit.hex)
  end

end


function hud.OnConstructionLost(alliance, construction)

  if construction.port ~= nil then
    RemovePortSupply(alliance, construction.port.hex)
  end

  if construction.type == Construction.TYPE_CAPITAL then
    if construction.hex.originalFaction.alliance.id == alliance.id then
      local faction = construction.hex.originalFaction
      faction.luaData.capitals = faction.luaData.capitals - 1
      if faction.luaData.capitals == 0 then
        faction.luaData.productionLost = game.turn

        -- Clear prod queue
        local canceledUnits = {}
        for unit in faction.production_que do
          table.insert(canceledUnits, unit)
        end
        for _, unit in pairs(canceledUnits) do
          CancelUnit(faction, unit, 0)
        end

        if alliance.id ~= playerAlliance.id then
          PopupProductionLost(faction)
        else
          ui.productionPanel:RemoveFaction(faction)
          ui.researchPanel:RemoveFaction(faction)
          ui.diplomacyPanel:RemoveDiplomacyFlag(faction)
          ui.managementPanel:RemoveFaction(faction)
        end
      end
    end
  end
end

function hud.OnConstructionCaptured(alliance, construction)
  --CaptureMoraleEffect(alliance, construction)

  if construction.port ~= nil then
    if alliance.id ~= 0 then
      AddPortSupply(alliance, construction.port.hex)
    end

    -- Push out enemy ship
    local unit = construction.port.hex.unit
    if unit ~= nil and unit.faction.alliance.id ~= alliance.id then
      local escaped = false
      local hexes = game.map:GetHexesInRange(construction.port.hex, 1)
      for _, hex in pairs(hexes) do
        if hex.terrain.type == Terrain.WATER and hex.unit == nil then
          unit.efficiency = unit.efficiency / 2
          GetPlayer():WarpUnit(unit, hex)
          escaped = true
          break
        end
      end
      if not escaped then
        unit:Kill()
      end
    end
  end

  -- City damage effect
  if construction.efficency > construction.pp * 5 then
    if construction.hex.originalFaction.alliance.id ~= alliance.id then
      construction:SetEfficency(construction.pp * 5)
    end
  end

  if construction.type == Construction.TYPE_CAPITAL then
    if construction.hex.originalFaction.alliance.id == alliance.id then
      local faction = construction.hex.originalFaction
      faction.luaData.capitals = faction.luaData.capitals + 1
      if faction.luaData.productionLost ~= 0 then
        faction.luaData.productionLost = 0
        if alliance.id == playerAlliance.id then
          --FIXME: popup to announce production is back?

          ui.productionPanel:AddFaction(faction)
          ui.researchPanel:AddFaction(faction)
          ui.diplomacyPanel:FactionDiplomacyFlag(faction)
          ui.managementPanel:AddFaction(faction)
        end
      end
    end
  end
end

function hud.OnZoom(zoom)
  -- Change to NATO counters on 25% zoom
  if zoom == 0 then
    if settings.natocounters == 0 then
      View:EnableUnitCounters(true)
    end
    ShowPoliticalOverlay(true)
  else
    if settings.natocounters == 0 then
      View:EnableUnitCounters(false)
    end
    ShowPoliticalOverlay(false)
	
  end
end


function ui.toggleWidget(widget)
  if widget.isVisible then
    widget:Hide()
  else
    widget:Show()
  end
end


function RefreshUnitStats(unit, panelName, real)
  -- If its transport unit, display cargo stats
  if unit.cargo ~= nil then
    local carrier = unit
    for cargo in carrier.cargo.units do
      unit = cargo
      break
    end
  end

  -- Display unit stats
  local panelID = hud:GetPanel(panelName)
  local commander = GetNearbyCommander(unit)
  local stat

  stat = GetStat(unit, "basedefense")
  if stat ~= nil then
    panelID:GetText("basedefense_text"):SetNumber(stat * (1 + GetUnitExperienceBonus(unit)) + GetCommanderBonus(commander, "basedefense"))
  else
    panelID:GetText("basedefense_text"):SetText("/")
  end

  stat = GetStat(unit, "highdefense")
  if stat ~= nil then
    panelID:GetText("highdefense_text"):SetNumber(stat * (1 + GetUnitExperienceBonus(unit)) + GetCommanderBonus(commander, "highdefense"))
  else
    panelID:GetText("highdefense_text"):SetText("/")
  end

  local statsSet = "assault"
  stat = GetStat(unit, "assault")
  if stat ~= nil then
    panelID:GetText("bombard_text"):SetNumber(stat + GetCommanderBonus(commander, "assault"))
    panelID:GetImage("bombard_image"):Hide()
    panelID:GetImage("assault_image"):Show()
    panelID:GetImage("background"):SetImage("graphics/hud", "selection_stats_assault.png")
  else
    stat = GetStat(unit, "bombard")
    if stat ~= nil then
     
	 statsSet = "bombard"
      panelID:GetImage("bombard_image"):Show()
      panelID:GetImage("assault_image"):Hide()
      if GetStat(unit, "counterattack") ~= nil then
        panelID:GetText("bombard_text"):SetNumber(stat + GetCommanderBonus(commander, "bombard"))
        panelID:GetImage("background"):SetImage("graphics/hud", "selection_stats_bombard.png")
      else
			
		panelID:GetText("bombard_text"):SetNumber(stat + GetCommanderBonus(commander, "bombard"))
        panelID:GetImage("background"):SetImage("graphics/hud", "selection_stats_bombard.png")
		
	  end
    else
      panelID:GetImage("background"):SetImage("graphics/hud", "selection_stats_bombard.png")
      panelID:GetText("bombard_text"):SetText("/")
    end
  end



  stat = GetStat(unit, "groundattack")
  if stat ~= nil then
    panelID:GetText("groundattack_text"):SetNumber(stat * (1 + GetUnitExperienceBonus(unit)) + GetCommanderBonus(commander, "groundattack"))
  else
    panelID:GetText("groundattack_text"):SetText("/")
  end
  stat = GetStat(unit, "airattack")
  if stat ~= nil then
    panelID:GetText("airattack_text"):SetNumber(stat * (1 + GetUnitExperienceBonus(unit)) + GetCommanderBonus(commander, "airattack"))
  else
    panelID:GetText("airattack_text"):SetText("/")
  end
  stat = GetStat(unit, "navalattack")
  if stat ~= nil then
    panelID:GetText("navalattack_text"):SetNumber(stat * (1 + GetUnitExperienceBonus(unit))+ GetCommanderBonus(commander, "navalattack"))
  else
    panelID:GetText("navalattack_text"):SetText("/")
  end
  --panelID:GetText("subattack_text"):SetNumber(GetStatSubAttack(unit))
  if unit.type ~= Unit.NAVAL and GetStat(unit, "subattack") == nil then
    if unit.prototype.name == "artillery" then
      stat = GetStat(unit, "counterattack")
      panelID:GetImage("subattack_image"):Hide()
      panelID:GetImage("counterattack_image"):Show()
      panelID:GetImage("armourattack_image"):Hide()
      if stat ~= nil then
        panelID:GetText("armourattack_text"):SetNumber(stat + GetCommanderBonus(commander, "counterattack"))
      else
        panelID:GetText("armourattack_text"):SetText("/")
      end
    else
      stat = GetStat(unit, "armourattack")
      panelID:GetImage("subattack_image"):Hide()
      panelID:GetImage("counterattack_image"):Hide()
      panelID:GetImage("armourattack_image"):Show()
      if stat ~= nil then
        panelID:GetText("armourattack_text"):SetNumber(stat + GetCommanderBonus(commander, "armourattack"))
      else
        panelID:GetText("armourattack_text"):SetText("/")
      end
    end
  else
	
    stat = GetStat(unit, "subattack")
    panelID:GetImage("subattack_image"):Show()
    panelID:GetImage("counterattack_image"):Hide()
    panelID:GetImage("armourattack_image"):Hide()
    if stat ~= nil then
      panelID:GetText("armourattack_text"):SetNumber(stat + GetCommanderBonus(commander, "subattack"))
    else
      panelID:GetText("armourattack_text"):SetText("/")
    end
  end


  stat = GetStat(unit, "stratattack")
  if stat ~= nil then
    panelID:GetText("stratattack_text"):SetNumber(stat + GetCommanderBonus(commander, "stratattack"))
  else
    panelID:GetText("stratattack_text"):SetText("/")
  end

  stat = GetStat(unit, "shock")
  if stat ~= nil then
    panelID:GetText("shock_text"):SetNumber(stat + GetCommanderBonus(commander, "shock"))
  else
    panelID:GetText("shock_text"):SetText("/")
  end

  panelID:GetText("range_text"):SetNumber(unit.prototype:GetLevelStats(unit.level).range)
  panelID:GetText("mp_text"):SetNumber(unit.prototype:GetLevelStats(unit.level).mp)
  panelID:GetText("los_text"):SetNumber(unit.prototype:GetLevelStats(unit.level).los)
  panelID:GetText("ammo_text"):SetNumber(unit.prototype:GetLevelStats(unit.level).ammunition)

  panelID:GetImage("mp_image"):SetImage("graphics/hud", "stat_chassis_" .. unit.prototype.lua.chassis .. ".png")


  if real == 0 then
	
    panelID:GetText("quality_text"):SetNumber(10)
    panelID:GetText("entrenchment_text"):SetText("/")
    panelID:GetText("efficiency_text"):SetNumber(10)
  else
	if unit.type ~= Unit.NAVAL and unit.luaData.endurance == nil then
	panelID:GetText("quality_text"):SetNumber(unit.luaData.quality / 10)
    elseif unit.type == Unit.NAVAL and unit.luaData.endurance ~= nil then
	if unit.luaData.endurance <0 then
		unit.luaData.endurance = 0
	end
	panelID:GetText("quality_text"):SetNumber(unit.luaData.endurance)
	end
	if unit.type == Unit.NAVAL or unit.hex == nil then
      panelID:GetText("entrenchment_text"):SetText("/")
    else
      panelID:GetText("entrenchment_text"):SetNumber(GetStatEntrenchment(unit))
    end
    panelID:GetText("efficiency_text"):SetNumber(unit.efficiency / 10)
  end

end


function CallNoSelectTab()

  noSelectedTab =
  {
    name = "noselected_panel",
    type = "panel",
    position = {12, 28},
    image = "tab_textbox",
    visible = true,

    controls =
    {
      {
        name = "title_text",
        type = "text",
        position = {248, 18},
        align = "center",
        font = "menu_font",
        color = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "noselected",
      },
      {
        name = "descr_text",
        type = "text",
        position = {248, 44},
        align = "center",
        font = "verdana12_font",
        color = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "selectany",
      },
    }
  }

  hud:GetPanel("selection_tab"):AddWidget(noSelectedTab):Show()

end

--[[
function ShowCityProduction(pressed)
  GetScene():ClearActions()
  if pressed then
    ui.overlayActive = true
    GetScene():EnableUnitLayer(false)
    for faction in game.factions do
      for construction in faction.constructions do
        if construction.pp > 0 then
          DisplayProductionValue(construction.hex,GetConstructionProduction(construction))--construction.hex,math.floor(construction.efficency / 10))
        end
      end
    end
  else
    ui.overlayActive = false
    GetScene():EnableUnitLayer(true)
    local unit = GetSelectedUnit()
    if unit ~= nil then
      --GetPlayer():DeselectUnit()
      --GetPlayer():SelectUnit(unit)
      ui.SelectHex(unit.hex)
    end
  end
end]]
function ShowCityProduction(pressed)
  GetScene():ClearActions()
  if pressed then
    ui.overlayActive = true
    GetScene():EnableUnitLayer(false)
    for faction in game.factions do
      for construction in faction.constructions do
        if construction.pp > 0 then
          DisplayProductionValue(construction.hex,GetConstructionProduction(construction))--construction.hex,math.floor(construction.efficency / 10))
        end
      end
    end
  else
    ui.overlayActive = false
    GetScene():EnableUnitLayer(true)
    local unit = GetSelectedUnit()
    if unit ~= nil then
      --GetPlayer():DeselectUnit()
      --GetPlayer():SelectUnit(unit)
      ui.SelectHex(unit.hex)
    end
  end
---------------
    
end

function ShowPoliticalOverlay(pressed)
  GetScene():ClearActions()
  if pressed then
    ui.overlayActive = true
    for alliance in game.alliances do
      if alliance.id ~= 0 then
        for faction in alliance.factions do
          local allHexes = {}
          for hex in faction.hexes do
            table.insert(allHexes, hex)
          end
          GetScene():AddActionImages(allHexes, "allianceOverlay_" .. alliance.id .. "_100")
        end
      end
    end
  else
    ui.overlayActive = false
    local unit = GetSelectedUnit()
    if unit ~= nil then
      --GetPlayer():DeselectUnit()
      --GetPlayer():SelectUnit(unit)
      ui.SelectHex(unit.hex)
    end
  end
end





function ui.MarkValidMoves(unit)
  local totalHexes = {}
  local validHexes = {}

  -- Normal moves
  local normalHexes = unit:GetPossibleMoves()

  --local normalHexesSet = Set(normalHexes, function(hex) return hex.id end)

  core.insertTable(totalHexes, normalHexes)
  if unit.type ~= Unit.NAVAL or unit.prototype.name == "transport" or unit.prototype.name == "convoy" then
    GetScene():AddActionImages(normalHexes, "move_100")
  else
    local supplyHexes = {}
    local noSupplyHexes = {}
    local homeHexes = {}
    for _, hex in pairs(normalHexes) do
      if unit.faction.alliance.luaData.portSupply[hex.id] ~= nil and unit.faction.alliance.luaData.portSupply[hex.id] > 0 then
        if unit.faction.alliance.luaData.portHome[hex.id] ~= nil and unit.faction.alliance.luaData.portHome[hex.id] > 0 then
          table.insert(homeHexes, hex)
        else
          table.insert(supplyHexes, hex)
        end
      else
        table.insert(noSupplyHexes, hex)
      end
    end
    GetScene():AddActionImages(supplyHexes, "move_100")
    GetScene():AddActionImages(noSupplyHexes, "move_2_100")
    GetScene():AddActionImages(homeHexes, "move_0_100")
  end

  core.insertTable(validHexes, normalHexes)

  -- Potential moves
  local allPotentialHexes = unit:GetPotentialMoves(false)
  local potentialHexes = core.setSymmetricDifference(allPotentialHexes, validHexes, function(hex1, hex2) return hex1.id == hex2.id end)

  core.insertTable(totalHexes, potentialHexes)
  GetScene():AddActionImages(potentialHexes, "potentialmove_100")
	
  -- Rail moves
  if unit.prototype.lua.chassis ~= "rail" and GetFactionRailmoves(unit.faction) > 0 then
    local allRailroadHexes = unit:GetPossibleRailroadMoves()
    local railroadHexes = core.setSymmetricDifference(allRailroadHexes, validHexes, function(hex1, hex2) return hex1.id == hex2.id end)

    core.insertTable(totalHexes, railroadHexes)
    GetScene():AddActionImages(railroadHexes, "rail_100")

    core.insertTable(validHexes, railroadHexes)
  end

  -- Embark moves
  local coastalHexes = {}
  if GetFactionTransportmoves(unit.faction) > 0 then
    if unit.hex.construction ~= nil and unit.hex.construction.hasPort then
      local adjacentHexes = game.map:GetHexesInRange(unit.hex, 1)
      for i,adjacent in pairs(adjacentHexes) do
        if adjacent.terrain.type == Terrain.WATER then
          table.insert(coastalHexes, adjacent)
        end
      end
    end
  end

  coastalHexes = core.setSymmetricDifference(coastalHexes, validHexes, function(hex1, hex2) return hex1.id == hex2.id end)

  core.insertTable(totalHexes, coastalHexes)
  GetScene():AddActionImages(coastalHexes, "embark_100")

  -- Disembark moves
  if unit.cargo ~= nil then

    local disembarkHexes = {}
    local adjacentHexes = game.map:GetHexesInRange(unit.hex, 1)
    for i,adjacent in pairs(adjacentHexes) do
      if adjacent.terrain.type ~= Terrain.WATER and adjacent.unit == nil and not adjacent.faction.isNeutral then
        for cargo in unit.cargo.units do
          if cargo.prototype.lua.chassis ~= "rail" or adjacent.hasRailroad then
            table.insert(disembarkHexes, adjacent)
          end
          break
        end
      end
    end
    core.insertTable(totalHexes, disembarkHexes)
    GetScene():AddActionImages(disembarkHexes, "embark_100")
  end

  return totalHexes

end


---------------------------------------------------------------


function ui.UnitAttack(unit, target)

  if unit.stats.ammunition > unit.faction.am then
    if unit.type == Unit.NAVAL and target.unit ~= nil and target.unit.type == Unit.NAVAL then
    else
      return
    end
  end

  if target.unit ~= nil then
    GetPlayer():AttackUnit(unit, target.unit)
  elseif target.construction ~= nil then
    --unit:AttackConstruction(target.construction)
    GetPlayer():AttackHex(unit, target);
  end
end


function ui.SelectNothing()
  GetPlayer():DeselectUnit()
  GetScene():ClearActions()
  ui.firstSelected = nil
  hud:GetWidget("noselected_panel"):Show()
  ui.cursorModeTooltipPanel:Hide()
end

------ clickhexcheck
function ui.SelectHex(hex)
local impassable = game:GetFactionById(24)
local cp =  game:GetAllianceById(2)
local entente =  game:GetAllianceById(1)
local neutrals =  game:GetAllianceById(0)
local bulgaria = game:GetFactionById(19)
local russia = game:GetFactionById(4)
local turkey = game:GetFactionById(5)
local austria = game:GetFactionById(3)
local germany = game:GetFactionById(2)
local belgium = game:GetFactionById(6)
local italy = game:GetFactionById(8)
local france = game:GetFactionById(0)
local britain = game:GetFactionById(1)
local serbia = game:GetFactionById(7)
local sweden = game:GetFactionById(11)
local finland = game:GetFactionById(13)
local redfinland = game:GetFactionById(25)
local impassable = game:GetFactionById(24)
local whites = game:GetFactionById(26)
local bolshevik = game:GetFactionById(27)
local arabia = game:GetFactionById(21)



---------------

-----------------------------------------------

----SHOW VALUES VIA POPUP----------------------
--local value = russia.luaData.surprisechance
--if hex.unit ~= nil then

--end

--if hex.unit ~= nil then
	--local unit = hex.unit
	--PopupMessage("")
--end

-------- SHOW ALL PP------------
--ShowPP()
--RussianCivilWar()
	
----- DUMMY FUNCTION TEST--------
--if GetEvent("AllEast") >  0 then
 -- SetEvent("AllEast", game.turn)
--end

----- STRAIGHTENING WEIRD ALIGNMENTS----
for faction in cp.factions do
	if faction.luaData.alignment ~= 0 then
		faction.luaData.alignment = 0
	end
end	
for faction in entente.factions do
	if faction.luaData.alignment ~= 100 then
		faction.luaData.alignment = 100
	end
end

----- SURRENDER ALL NATIONS ----------
for faction in entente.factions do
	--FactionSurrender(faction)
end
--local stars = 10
--DeclareVictory(stars)

--------SHOCK EVENTS----------------

if GetEvent("Wolf") == 0 
	and hex.unit ~= nil
	and hex.unit.faction.id == 1
	and hex.originalFaction ~= nil
	and hex.originalFaction.id == 0
	and hex.entrench ~= nil
	and hex.entrench >0 
	and hex.unit.alliance.id == player.alliance.id 
	and player.alliance.id == 1
	and hex.unit.type == Unit.LAND
	and game.date.year <= 1916
	and math.random(1,1000) == 335 then
		SetEvent("Wolf", game.turn)		
end	

if GetEvent("MeatFactory") == 0 
	and hex.unit ~= nil
	and hex.unit.type == Unit.LAND
	and hex.unit.alliance.id == 1
	and france.alliance.id == 1
	and germany.alliance.id == 2
	and hex.originalFaction ~= nil
	and (hex.originalFaction.id == 0
		 or (hex.originalFaction.id == 1 and hex.y <= 23)
		 or hex.originalFaction.id == 8
		 or hex.originalFaction.id == 10)	
	and player.alliance.id == 1
	and hex.unit.alliance.id == player.alliance.id 
	and GetEvent("HungerWinter") >0
	and game.date.year >= 1916
	and math.random(1,1000) == 447 then
		SetEvent("MeatFactory", game.turn)	
end	

if GetEvent("Crucified") == 0 
	and hex.unit ~= nil
	and hex.unit.type == Unit.LAND
	and hex.originalFaction ~= nil
	and hex.entrench ~= nil
	and hex.entrench >0 
	and hex.unit.alliance.id == player.alliance.id
	and (hex.originalFaction.id == france.id or hex.originalFaction.id == russia.id)	
	and game.date.year >= 1916
	and math.random(1,1000) == 589 then
		SetEvent("Crucified", game.turn)		
end	

if 	GetEvent("Ufo") == 0
	and hex.unit ~= nil
	and hex.unit.type == Unit.LAND		
	and game.date.year >= 1918
	and hex.unit.alliance.id == player.alliance.id
	and HasUnitTech(hex.unit, "searchlight")
	and math.random(1,1000) == 742 then
		SetEvent("Ufo", game.turn)		
end	


if game.date.year >= 1916
	and hex.unit ~= nil
	and hex.unit.type == Unit.LAND	
	and GetEvent("Default") == 0 then
	local value = os.date("%H")
	if value == "00" then
		SetEvent("Default", game.turn)
	end
end



if impassable.luaData.winter == 1 
	and (gameplay.winter == 0 or isloadedwinter == nil) then
	--	if game.type ==  Game.TYPE_SINGLE then
			isloadedwinter = 1
		--	PopupMessage("*** WINTER MAP LOADED! ***")
			gameplay.winter = 1
			GetPlayer().scene:LoadMap("map_winter")
			MusicPlayer():AddToPlayList("battleloopwinter")			
			MusicPlayer():SetLooping(true)
			MusicPlayer():Play()
	--		end	
	
end


  -- handle unit deselection
  local selectedUnit = GetSelectedUnit()
  if selectedUnit ~= nil then
    GetPlayer():DeselectUnit()
    GetScene():ClearActions()
  end

  -- Set current tab to selection
  ui.mainPanel:SwitchTab(ui.mainPanel.selectionTab, true)
  -- Get correct panel
  local panelID = ui.mainPanel.selectionTab

  -- Handle unit selection
  if hex.unit ~= nil and playerAlliance:IsVisible(hex) == true and playerAlliance:IsVisible(hex.unit) then
    ui.SelectUnit(hex.unit)

    --panelID:GetImage("HUDunit_image"):Show()
    panelID:GetImage("nation_image"):Show()
    panelID:GetImage("class_image"):Show()
    panelID:GetImage("level_image"):Show()
    panelID:GetButton("info_button"):Show()
  else
    hud:GetPanel("prognosis_panel"):Hide()
    hud:GetPanel("stats_panel"):Hide()

    panelID:GetText("type_text"):SetLocalText("no_unit")
    panelID:GetImage("HUDunit_image"):SetImage("graphics/hud", "no_unit.png")
    --panelID:GetImage("HUDunit_image"):Hide()
    panelID:GetImage("nation_image"):Hide()
    panelID:GetImage("class_image"):Hide()
    panelID:GetImage("level_image"):Hide()
    panelID:GetButton("detach_button"):Hide()
    panelID:GetButton("info_button"):Hide()
	panelID:GetImage("experience_image"):Hide() -- changed!

  end

  -- Hide "no selection" panel
  if ui.firstSelected == nil then
    ui.firstSelected = 1
    hud:GetWidget("noselected_panel"):Hide()
  end

  -- Handle hex selection
  ui.selectedHex = hex

  hud:GetPanel("terrain_panel"):Show()

  if hex.construction == nil then
    hud:GetImage("terrain_image"):SetImage("graphics/terrain", "terrain_" .. hex.terrain.name .. ".png")
    hud:GetText("terrain_text"):SetLocalText(hex.terrain.name)
	
	if hex.terrain.name == "desert" and hex.unit == nil then
	
	local	sfx = LoadSample("desert.wav")
		PlaySample(sfx)
	elseif hex.terrain.name == "dunes" then
	local	sfx = LoadSample("dunes.wav")
		PlaySample(sfx)
	elseif hex.terrain.name == "swamp" and impassable.luaData.winter == 0 and hex.unit == nil then
	local	sfx = LoadSample("swamp.wav")
		PlaySample(sfx)	
		
	elseif hex.terrain.name == "mountain" and impassable.luaData.winter == 0 and hex.unit == nil then
	local	sfx = LoadSample("mountain.wav")
		PlaySample(sfx)
	elseif hex.terrain.name == "channel" then
	local	sfx = LoadSample("channel.wav")
		PlaySample(sfx)
	elseif hex.terrain.name == "hard" and impassable.luaData.winter == 0 and hex.unit == nil then
	local	sfx = LoadSample("hard.wav")
		PlaySample(sfx)
	elseif hex.terrain.name == "difficult" and impassable.luaData.winter == 0 and hex.unit == nil then
	local	sfx = LoadSample("difficult.wav")
		PlaySample(sfx)
	elseif hex.terrain.name == "forest" and impassable.luaData.winter == 0 and hex.unit == nil then
	local	sfx = LoadSample("forest.wav")
		PlaySample(sfx)	
		
	elseif hex.terrain.name == "soft" and hex.unit == nil and impassable.luaData.winter == 0 then
			local luck = math.random(1,20)
			if luck == 1 then
					local	sfx = LoadSample("soft1.wav")
					PlaySample(sfx)
			elseif luck == 2 then
					if hex.faction.id ~= 5 and hex.faction.id ~= 21 and hex.faction.id ~= 22 then	
						local sfx = LoadSample("soft2.wav")
						PlaySample(sfx)
					else
						local	sfx = LoadSample("soft3.wav")
						PlaySample(sfx)
					end
			elseif luck == 3 then
					local	sfx = LoadSample("soft3.wav")
					PlaySample(sfx)
			end	
	elseif hex.terrain.name == "water" then
		local luck = math.random(1,3)
		if luck == 1 then
			local	sfx = LoadSample("water1.wav")
			PlaySample(sfx)
		elseif luck == 2 then
			local		sfx = LoadSample("water2.wav")
			PlaySample(sfx)
		elseif luck == 3 then
			local	sfx = LoadSample("water3.wav")
			PlaySample(sfx)
		end		
		
		
	end
	
	
  else
    if hex.construction.type == Construction.TYPE_PORT then
      hud:GetImage("terrain_image"):SetImage("graphics/terrain", "terrain_port.png")
      hud:GetText("terrain_text"):SetLocalText("port")
	local luck = math.random(1,5)
	if luck == 1 then
		local	sfx = LoadSample("port1.wav")
			PlaySample(sfx)
	elseif luck == 2 then
		local	sfx = LoadSample("port2.wav")
			PlaySample(sfx)
		
	elseif luck == 3 then
		local	sfx = LoadSample("port3.wav")
			PlaySample(sfx)
			
	elseif luck == 4 then
		local	sfx = LoadSample("port4.wav")
			PlaySample(sfx)
	
	elseif luck == 5 then
	local sfx = LoadSample("port5.wav")
			PlaySample(sfx)
	end			
	end
    
    if hex.construction.type == Construction.TYPE_FORTRESS then
      hud:GetImage("terrain_image"):SetImage("graphics/terrain", "terrain_fortress.png")
      hud:GetText("terrain_text"):SetLocalText("fortress")
	  	if hex.unit == nil then
			if math.random(1,2) == 1 then
			local	sfx = LoadSample("fortress1.wav")
				PlaySample(sfx)
		else
			local	sfx = LoadSample("fortress2.wav")
				PlaySample(sfx)
		end
    end
	end
    if hex.construction.type == Construction.TYPE_CITY then
      hud:GetImage("terrain_image"):SetImage("graphics/terrain", "terrain_city.png")
      hud:GetText("terrain_text"):SetLocalText("city")
	 if (hex.originalFaction.id == 5 or hex.faction.id == 21 or hex.originalFaction.id == 22 or hex.faction.id == 23)  and hex.unit == nil then
		if math.random(1,20) == 10 then
		local	sfx = LoadSample("Muslim.wav")
			PlaySample(sfx)
		end
	  elseif hex.unit == nil then
		if math.random(1,10) == 10 then
		local	sfx = LoadSample("SmallBell.wav")
			PlaySample(sfx)
		end
	  
 	  end	



			if math.random(1,2) == 1 and  hex.unit == nil then
				local	sfx = LoadSample("city1.wav")
					PlaySample(sfx)
				elseif hex.unit == nil then
				local	sfx = LoadSample("city2.wav")
					PlaySample(sfx)
				end	
    end
    if hex.construction.type == Construction.TYPE_CAPITAL then
      hud:GetImage("terrain_image"):SetImage("graphics/terrain", "terrain_capital.png")
      hud:GetText("terrain_text"):SetLocalText("capital")
	 if (hex.originalFaction.id == 5 or hex.faction.id == 21 or hex.originalFaction.id == 22 or hex.faction.id == 23)  and hex.unit == nil then
		if math.random(1,10) == 10 then
			local sfx = LoadSample("Muslim.wav")
			PlaySample(sfx)
		end
	  elseif  hex.unit == nil then
		if math.random(1,10) == 10 then
			local sfx = LoadSample("BigBell.wav")
			PlaySample(sfx)
		end
	  
 	  end
		if math.random(1,2) == 1 and  hex.unit == nil then
			local sfx = LoadSample("capital1.wav")
			PlaySample(sfx)
		elseif  hex.unit == nil then
			local sfx = LoadSample("capital2.wav")
			PlaySample(sfx)
		end	
		
    end
  end
  

  --panelID:GetImage("nation_image"):SetImage("graphics/flags", "emblem_" .. hex.faction.name .. "100.png")
  if hex.faction ~= nil then
    hud:GetImage("ter-owner_image"):Show()
    hud:GetImage("ter-owner_image"):SetImage("graphics/flags", "emblem_" .. hex.faction.name .. "100.png")
    hud:GetImage("ter-owner_image").tooltip = "terrain_owner_" .. hex.faction.name

    hud:GetImage("ter-nationality_image"):Show()
    hud:GetImage("ter-nationality_image"):SetImage("graphics/flags", "emblem_" .. hex.originalFaction.name .. "100.png")
    hud:GetImage("ter-nationality_image").tooltip = "terrain_nationality_" .. hex.originalFaction.name
  else
    hud:GetImage("ter-owner_image"):Hide()
    hud:GetImage("ter-nationality_image"):Hide()
  end
  
---------------------------------------------- "naval code broken" here to have markers not vanished
  local entente =  game:GetAllianceById(1)
local cp =  game:GetAllianceById(2)
if entente.luaData.spotted == 1 then 
	for faction in entente.factions do
			for unit in faction.units do
				if unit.hex ~= nil and unit.type == Unit.NAVAL then
					playerAlliance:AddVisibleHex(unit.hex)
					if unit.prototype.name == "submarine" then
						  local adjacentHexes = game.map:GetHexesInRange(unit.hex, 1)
							local counter = 0
							for i,adjacent in pairs(adjacentHexes) do
								
								if adjacent.terrain.type == Terrain.WATER and adjacent.unit ~= nil and adjacent.unit.alliance.id ~= unit.alliance.id then
									counter = counter +1
								end
								
							end
								if counter == 0 or entente.luaData.spotted == game.turn then
									SetAiImage("subspot",unit.hex)
								end
					end
				end
			end	
	end
end
  ui.resourcesPanel:Refresh()
end

function ui.SelectUnit(unit)
local impassable = game:GetFactionById(24)

  GetPlayer():SelectUnit(unit)

  -- Mark commander range
  if unit.commander ~= nil then
    MarkCommanderRange(unit)
  end

  -- For player's units:
  if unit.faction.alliance.id == playerAlliance.id then

    -- Mark valid moves
    if unit.mp > 0 then
		if (impassable.luaData.mud == game.turn and unit.luaData.mud ~= nil and unit.luaData.mud == game.turn) then
			unit.mp = 0
				if unit.mp < 1 then
				unit.mp = 1
				end
		end
		if gameplay.winter == 1 and GetEvent("Ice") >0 and unit.hex.region == 0 and unit.type == Unit.NAVAL and unit.prototype.name ~= "submarine" and unit.prototype.name ~= "convoy" then
			unit.mp = 0
				if unit.mp < 1 then
				unit.mp = 1
				end
		end
		if unit.luaData.immobil ~= nil then
		unit.mp = 0
		end
		
		ui.movementHexes = ui.MarkValidMoves(unit)
    
	end

    -- Mark targets
    if unit.ap > 0 then --and unit.stats.ammunition <= unit.faction.am then
      ui.targetHexes = GetValidTargets(unit, false)
      if ui.targetHexes ~= nil then
        GetScene():AddActionImages(ui.targetHexes, "attack_100")
      end
      if GetStat(unit, "stratattack") ~= nil then
        local validHexes = GetValidStrategicTargets(unit)
        if validHexes ~= nil then
          core.insertTable(ui.targetHexes, validHexes)
          GetScene():AddActionImages(validHexes, "attack_100")
        end
        core.insertTable(ui.targetHexes, validHexes)
      end
    else
      ui.targetHexes = {}
    end

    -- Advance hex handling
    if gameplay.advanceUnit ~= nil then
      if unit.id == gameplay.advanceUnit.id then
        local hexArray = {}
        table.insert(hexArray, gameplay.advanceHex)
        GetScene():AddActionImages(hexArray, "move_100")
      end
    end

    -- Advice messages related to selected unit
    AdviceUnit(unit)

  else

    -- Clear target hexes
    ui.targetHexes = {}
    ui.movementHexes = {}

  end

  hud:GetPanel("selection_tab"):DisplayStats(unit)

  -- Get correct panel
  local panelID = ui.mainPanel.selectionTab --hud:GetPanel("selection_tab")

  -- Unit faction
  panelID:GetImage("nation_image"):SetImage("graphics/flags", "emblem_" .. unit.faction.name .. "100.png")

  -- Unit experience
  if GetUnitExperienceLevel(unit) ~= nil and GetUnitExperienceLevel(unit) ~= 0 then
    panelID:GetImage("experience_image"):SetImage("graphics/flags", "exp_" .. GetUnitExperienceLevel(unit) .. ".png")
    panelID:GetImage("experience_image").tooltip = "unit_experience_level_" .. GetUnitExperienceLevel(unit)
    panelID:GetImage("experience_image"):Show()
--	LogUi("EXPERIENCE:" .. unit.luaData.experience .. "@:" .. unit.hex.x .. "/" .. unit.hex.y)
  else
    panelID:GetImage("experience_image"):Hide()
	 --   LogUi("EXPERIENCE:" .. unit.luaData.experience .. "@:" .. unit.hex.x .. "/" .. unit.hex.y .. "UNITHP:" .. unit.hp)

  end

  -- Display name, type & level
  if unit.cargo ~= nil then
    local carrier = unit
    for cargo in carrier.cargo.units do
      if cargo.params:Get("name") ~= nil and cargo.faction.alliance.id == playerAlliance.id then
        panelID:GetText("type_text"):SetText(cargo.params:Get("name"))
      else
        panelID:GetText("type_text"):SetLocalText(cargo.prototype.name)
      end
      panelID:GetImage("class_image"):SetImage("graphics/units", cargo.prototype.name .. "_" .. cargo.faction.alliance.id .. "_25.png")
      panelID:GetImage("level_image"):SetImage("graphics/hud", "level" .. GetUnitTechCount(cargo) .. ".png")
      break
    end
  else
    if unit.params:Get("name") ~= nil and unit.faction.alliance.id == playerAlliance.id then
      panelID:GetText("type_text"):SetText(unit.params:Get("name"))
    else
      panelID:GetText("type_text"):SetLocalText(unit.prototype.name)
    end
    panelID:GetImage("class_image"):SetImage("graphics/units", unit.prototype.name .. "_" .. unit.faction.alliance.id .. "_25.png")
    panelID:GetImage("level_image"):SetImage("graphics/hud", "level" .. GetUnitTechCount(unit) .. ".png")
  end

  -- Get the HUD image of the unit or commander
  if unit.commander ~= nil then
    panelID:GetImage("HUDunit_image"):SetImage("graphics/commanders", "commander_" .. unit.commander.id .. ".png")
    panelID:GetText("type_text"):SetLocalText("commander_" .. unit.commander.id)
    if unit.faction.alliance.id == playerAlliance.id then
      panelID:GetButton("detach_button"):Show()
    else
      panelID:GetButton("detach_button"):Hide()
    end
  else
    local unitImage
    if engine:FileExists("graphics/units", unit.prototype.name .. "_" .. unit.faction.name .. "_" .. unit.level .. "_hud.png") then
      unitImage = unit.prototype.name .. "_" .. unit.faction.name .. "_" .. unit.level .. "_hud.png"
    else
      unitImage = unit.prototype.name .. "_default_" .. unit.level .. "_hud.png"
    end
    panelID:GetImage("HUDunit_image"):SetImage("graphics/units", unitImage)
    panelID:GetButton("detach_button"):Hide()
  end

end


-- Replay start & end handling

function hud.OnReplayStarted()

  ui.mainPanel.blockingPanel:Popup("replay")
end

function hud.OnReplayFinished()

  ui.mainPanel.blockingPanel:Hide()
  ui.chatPanel.endTurn = 1
          ui.chatPanel:Hide()
          ui.chatPanel.turnButton:Show()
          ui.chatPanel.surrenderButton:Show()
          ui.chatPanel.replayButton:Hide()
          print("B")
end


MoveLogType = {}
MoveLogType.Move = 1
MoveLogType.Swap = 2
MoveLogType.Advance = 3
MoveLogType.Attack = 4
MoveLogType.Rail = 5

function showMovement(logEntry,hex2,type,path)
  if settings.arrows == 1 then
    local hex1
    if hex2 ~= nil then
      hex1 = logEntry
      if type == nil then
        type = MoveLogType.Move
      end
    else
      return
    end

    if type == MoveLogType.Swap then
      if playerAlliance:IsVisible(hex1) or playerAlliance:IsVisible(hex2) then
        local dir = GetDirection(hex1.x, hex1.y, hex2.x, hex2.y)
        if dir <= 2 then
          View:AddEffect(hex1, "swap_1" .. dir)
        else
          dir = dir - 3
          View:AddEffect(hex2, "swap_1" .. dir)
        end
        followTurn(hex1)
      end
    elseif type == MoveLogType.Move then
      local firstVisible, firstInvisible, lastInvisible, lastVisible
      local firstVisibleCount, firstInvisibleCount, lastInvisibleCount, lastVisibleCount
      if playerAlliance:IsVisible(hex1) then
        firstVisible = hex1
        lastVisible = hex1
        lastVisibleCount = 0
        firstVisibleCount = 0
      else
        lastInvisible = hex1
        lastInvisibleCount = 0
      end
      for i, hex in ipairs(path) do
        if firstVisible == nil then
          if playerAlliance:IsVisible(hex) then
            firstVisible = hex
            firstVisibleCount = i
          end
        elseif firstInvisible == nil and not playerAlliance:IsVisible(hex) then
          firstInvisible = hex
          firstInvisibleCount= i
        end

        if not playerAlliance:IsVisible(hex) then
          lastInvisible = hex
          lastInvisibleCount = i
        else
          lastVisible = hex
          lastVisibleCount = i
        end
      end

      if lastVisible ~= nil then
        followTurn(lastVisible)
      end

      if firstVisible ~= nil and firstVisible.id == hex1.id and firstInvisible == nil then
        DrawArrow(firstVisible,hex2)
      else
        if firstVisible ~= nil and firstInvisible ~= nil then
          DrawArrow(firstVisible,firstInvisible,"fo")
        end

        if lastInvisible ~= nil and lastVisible ~= nil and lastInvisibleCount < lastVisibleCount then
          DrawArrow(lastInvisible,lastVisible,"fi")
        end
      end
    elseif type == MoveLogType.Rail then
      local showHex
      if playerAlliance:IsVisible(hex1) then
        View:AddEffect(hex1, "move_railfrom")
        showHex = hex1
      end
      if playerAlliance:IsVisible(hex2) then
        View:AddEffect(hex2, "move_railto")
        showHex = hex2
      end
      if showHex ~= nil then
        followTurn(showHex)
      end
    end
  end
end

function DrawArrow(hex1,hex2,suffix)
  local dist = hex1:Distance(hex2)
  local dir
  if dist == 0 then
    return
  elseif dist == 1 then
    dir = GetDirection(hex1.x, hex1.y, hex2.x, hex2.y)
  elseif dist == 2 then
    dir = GetDirection2(hex1.x, hex1.y, hex2.x, hex2.y)
  elseif dist == 3 then
    dir = GetDirection3(hex1.x, hex1.y, hex2.x, hex2.y)
  else
    if suffix ~= "fi" then
      View:AddEffect(hex1, "move_warpfrom")
    end
    if suffix ~= "fo" then
      View:AddEffect(hex2, "move_warpto")
    end
  end

  if dir ~= nil then
    if suffix == nil then
      suffix = ""
    end
    View:AddEffect(hex1, "move_" .. dist .. dir..suffix)
  else
    printLog("-=========================================== Couldn't draw arrow: "..hex1.x..","..hex2.y.." to "..hex2.x..","..hex2.y.." dist "..dist)
  end
end

function showAttack(attackerhex,defenderhex,type,replay)
  followTurn(defenderhex)
  if settings.arrows == 1 then
    --if replay ~= true then
      --followMove(attackerhex,defenderhex,true)
    --end
    local dist = attackerhex:Distance(defenderhex)
    if dist == 1 then
      local dir = GetDirection(attackerhex.x, attackerhex.y, defenderhex.x, defenderhex.y)

      if type == MoveLogType.Advance then
        View:AddEffect(attackerhex, "advance_" .. dir)
      else
        View:AddEffect(attackerhex, "attack_"..dist..dir)
      end
    else
      View:AddEffect(attackerhex, "attack_ranged")
      View:AddEffect(attackerhex, "attack_rangedanim")
      View:AddEffect(defenderhex, "attack_rangedhit")
      View:AddEffect(defenderhex, "attack_rangedhitanim")
    end
  end
end

function LookAtWrapper(hex)
  if hex ~= nil then
    GetPlayer().camera:LookAt(hex)
  end
end


function followMove(startHex,endHex,isPossible)
  if isPossible == true and playerAlliance:IsVisible(endHex) then
    followTurn(endHex)
  elseif playerAlliance:IsVisible(startHex) then
    followTurn(startHex)
  end
end

ui.lastLookedAtHex = nil
function followTurn(target)
  ---[[
  if target == nil then
    local test = 0
  end
  if ui.lastLookedAtHex == nil then
    ui.lastLookedAtHex = target
    LookAtWrapper(ui.lastLookedAtHex)
  else
    if math.abs(ui.lastLookedAtHex.x - target.x) > 6 or math.abs(ui.lastLookedAtHex.y - target.y) > 2 then
      ui.lastLookedAtHex = target
      LookAtWrapper(ui.lastLookedAtHex)
    end
  end--]]
end


function GetDirection2(x1,y1,x2,y2)
  local dX = x2-x1
  local dY = y2-y1

  --printLog("AI: hex1 = " .. x1..","..y1.." hex 2 = "..x2..","..y2.." dX = " .. dX .. ", dY = " .. dY)

  if dX == 0 then
    if dY == 2 then
      return 3
    end
    if dY == -2 then
      return 0
    end
  end
  if dX == 1 then
    if(x1%2 == 0) then
      if dY == 1 then
        return 2.5
      end
      if dY == -2 then
        return 0.5
      end
    else
      if dY == -1 then
        return 0.5
      end
      if dY == 2 then
        return 2.5
      end
    end
  end
  if dX == 2 then
    if dY == -1 then
      return 1
    end
    if dY == 0 then
      return 1.5
    end
    if dY == 1 then
        return 2
    end
  end
  if dX == -1 then
    if(x1%2 == 0) then
      if dY == -2 then
        return 5.5
      end
      if dY == 1 then
        return 3.5
      end
    else
      if dY == -1 then
        return 5.5
      end
      if dY == 2 then
        return 3.5
      end
    end
  end
  if dX == -2 then
    if dY == -1 then
      return 5
    end
    if dY == 0 then
      return 4.5
    end
    if dY == 1 then
      return 4
    end
  end
end

function GetDirection3(x1,y1,x2,y2)
  local dX = x2-x1
  local dY = y2-y1

  --printLog("AI: hex1 = " .. x1..","..y1.." hex 2 = "..x2..","..y2.." dX = " .. dX .. ", dY = " .. dY)

  if dX == 0 then
    if dY == 3 then
      return 3
    end
    if dY == -3 then
      return 0
    end
  end
  if dX == 1 then
    if dY > 0 then
      return 2.6
    end
    if dY < 0 then
      return 0.3
    end
  end
  if dX == 2 then
    if dY > 0 then
      return 2.3
    end
    if dY < 0 then
      return 0.6
    end
  end
  if dX == 3 then
    if(x1%2 == 0) then
      if dY == -2 then
        return 1
      elseif dY == -1 then
        return 1.3
      elseif dY == 0 then
        return 1.6
      else
        return 2
      end
    else
      if dY == -1 then
        return 1
      elseif dY == 0 then
        return 1.3
      elseif dY == 1 then
        return 1.6
      else
        return 2
      end
    end
  end
  if dX == -1 then
    if dY > 0 then
      return 3.3
    end
    if dY < 0 then
      return 5.6
    end
  end
  if dX == -2 then
    if dY > 0 then
      return 3.6
    end
    if dY < 0 then
      return 5.3
    end
  end
  if dX == -3 then
    if(x1%2 == 0) then
      if dY == -2 then
        return 5
      elseif dY == -1 then
        return 4.6
      elseif dY == 0 then
        return 4.3
      else
        return 4
      end
    else
      if dY == -1 then
        return 5
      elseif dY == 0 then
        return 4.6
      elseif dY == 1 then
        return 4.3
      else
        return 4
      end
    end
  end
end

function SelectPanelFaction(faction)
  ui.productionFaction = faction
  ui.researchFaction = faction
  ui.diplomacyFaction = faction
  ui.managementFaction = faction
end


function ShowPP()
for faction in game.factions do
local value = GetFactionEconomicStrength(faction)
LogUi(faction.name .. "VALUE:" .. value)
--LogUi(faction.name .. "EVENTMORALE:" .. faction.luaData.eventMorale)

end
end

function StuffPanel()

  	self.RusSupCrisis = self:AddWidget({
    type = "button",
    position = {1000, 50},
	     -- enabled = 1,

    tooltip = "RusSupCrisis",
    image = "RusSupCrisis",
		     --on_click = function(button)
			--	end
	})
  
  
  	self.russupply = self:AddWidget({
    type = "text",
    font = "impact18_font",
    position = {1000, 50},
    align = "center",
    color = {0, 0, 0},
  })
  	self.RusSupCrisis:Show()
	self.russupply:SetNumber(russia.luaData.crisis)
end
