-- include tabs
dofile("ui/selection_tab.lua")
dofile("ui/production_tab.lua")
dofile("ui/diplomacy_tab.lua")
dofile("ui/research_tab.lua")
dofile("ui/management_tab.lua")

dofile("ui/resources_panel.lua")

class 'MainPanel' (LuaPanel)

function MainPanel:__init(alliance)
  LuaPanel.__init(self, main_panel)

  self.alliance = alliance

  self.tabs = self:GetPanel("main_tabgroup")

  self.selectionTab  = self.tabs:AdoptWidget(SelectionTab())
  self.diplomacyTab  = self.tabs:AdoptWidget(DiplomacyTab(self.alliance))
  self.productionTab = self.tabs:AdoptWidget(ProductionTab())
  self.researchTab   = self.tabs:AdoptWidget(ResearchTab(self.alliance))
  self.managementTab   = self.tabs:AdoptWidget(ManagementTab(self.alliance))

  -- ugly... How do i access these from main tab panels?
  ui.researchTabPanel = self.researchTab

  self.resourcesPanel = self:AdoptWidget(ResourcesPanel(self.alliance))
  ui.resourcesPanel = self.resourcesPanel

  -- Panel overlapping tabs during AI turn
  self.blockingPanel = self:AdoptWidget(BlockingPanel())
  self.blockingPanel:Hide()

  self.improvementsPanel = self:AdoptWidget(ImprovementsTab())
  ui.improvementsPanel = self.improvementsPanel

  ui.briefingPanel = self:AdoptWidget(PopupBriefing())

  self.selectionTab:Hide()
  self.diplomacyTab:Hide()
  self.productionTab:Hide()
  self.researchTab:Hide()
  self.managementTab:Hide()

  self:InitTabLabels()

  self:SwitchTab(self.selectionTab)
----------------------------------
  self.blockadestatus = self:AddWidget({
    type = "button",
    position = {755, 0},
	     -- enabled = 1,

    tooltip = "cp_blocked",
    image = "blockade",
		     --on_click = function(button)
			--	end
	})
	self.foodcrisisCP = self:AddWidget({
    type = "button",
    position = {1000, 0},
	     -- enabled = 1,

    tooltip = "cp_starved",
    image = "crisisCP",
		     --on_click = function(button)
			--	end
	})
	------------------------------------
	self.RusSupCrisis = self:AddWidget({
    type = "button",
    position = {1000, 50},
	     -- enabled = 1,

    tooltip = "RusSupCrisis",
    image = "RusSupCrisis",
		     --on_click = function(button)
			--	end
	})
	self.russupply = self:AddWidget({
    type = "text",
    font = "impact18_font",
    position = {1027, 77},
    align = "center",
    color = {0, 0, 0},
  })
	-------------------------------------
	self.CPMinesSpot = self:AddWidget({
    type = "button",
    position = {1050, 00},
	     -- enabled = 1,

    tooltip = "MineImmunity",
    image = "CPMinesSpot",
		     --on_click = function(button)
			--	end
	})
	self.EntMinesSpot = self:AddWidget({
    type = "button",
    position = {1050, 100},
	     -- enabled = 1,

    tooltip = "MineImmunity",
    image = "EntMinesSpot",
		     --on_click = function(button)
			--	end
	})
	
	------------------------------------
	self.foodcrisisEnt = self:AddWidget({
    type = "button",
    position = {1000, 100},
	     -- enabled = 1,

    tooltip = "ent_starved",
    image = "crisisEnt",
		     --on_click = function(button)
			--	end
	})
	self.foodcrisisEnt1 = self:AddWidget({
    type = "button",
    position = {1000, 100},
	     -- enabled = 1,

    tooltip = "ent_starved1",
    image = "crisisEnt1",
		     --on_click = function(button)
			--	end
	})
	self.foodcrisisEnt2 = self:AddWidget({
    type = "button",
    position = {1000, 100},
	     -- enabled = 1,

    tooltip = "ent_starved2",
    image = "crisisEnt2",
		     --on_click = function(button)
			--	end
	})
	self.foodcrisisEnt3 = self:AddWidget({
    type = "button",
    position = {1000, 100},
	     -- enabled = 1,

    tooltip = "ent_starved3",
    image = "crisisEnt3",
		     --on_click = function(button)
			--	end
	})
	
 
 
  if game.type == Game.TYPE_SINGLE then
    self.turnButton = self:AddWidget({
      type = "button",
      position = {971, 152},
      tooltip = "end_turn_button",
      image = "button_turn",
      on_click = function(button)
        if game.currentAlliance ~= nil and not ui.disableHUD then
          if game.currentAlliance.id == playerAlliance.id then

            -- Close current tab menu
            if ui.mainPanel.currentTab ~= nil then
              ui.mainPanel.currentTab:Hide()
            end

            -- Reset cursor
            ResetCursorMode()

            PlaySample(sClick)
            PreEndTurn()
          end
        else
          ui.briefingPanel:Close()
          PlaySample(sClick)
        end
      end
    })
    self.undoButton = self:AddWidget({
      type = "button",
      position = {11, -35},
      image = "undo",
      on_click = function(button)
        game:UndoLastCommand()
      end
    })
  else
    self.turnButton = self:AddWidget({
      type = "button",
      position = {971, 152},
      sfx = "click",
      tooltip = "end_turn_button_mp",
      image = "button_turn_mp",
      on_click = function(button)
        if replaystuff ~= 1 and not ui.MPturnEnded then
          -- Close current tab menu
          if ui.mainPanel.currentTab ~= nil then
            ui.mainPanel.currentTab:Hide()
          end

          -- Reset cursor
          ResetCursorMode()

          ui.chatPanel:Show()
        end
      end
    })
	-------new
	 self.terminateturnButton = self:AddWidget({
      type = "button",
      position = {1021, 152},
      sfx = "click",
      tooltip = "terminate_game",
      image = "button_surrender",
     on_click = function(button)
      local function ConfirmSurrender()
        -- Surrender game
        GetPlayer():Surrender()

        -- Block UI
        ui.MPturnEnded = true
        ui.mainPanel.blockingPanel:Popup("pbem")

        -- Upload turn
        GetPlayer():UploadTurn(function(error) UploadFailed(error) end)

        -- Hide chat panel
        button.parent:Hide()
      end
      PopupDialog("surrender_confirm", ConfirmSurrender)
    end
    })
  end
end

function MainPanel:InitTabLabels()

  self.tabs:AddWidget({
    type = "label",
    font = "hud12_font",
    position = {58, 13},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "selection_label",
    sfx = "tab",
    on_click = function(button)
      if game.currentAlliance ~= nil and not ui.disableHUD then
        if game.currentAlliance.id == playerAlliance.id then
          self:SwitchTab(self.selectionTab)
        end
      end
    end
  })

  self.tabs:AddWidget({
    type = "label",
    font = "hud12_font",
    position = {355, 13},
    align = "center",
    normal   = {224, 220, 218},
--	normal   = {174, 237, 40},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "diplomacy_label",
	sfx = "tab",
    on_click = function(button)
      if game.currentAlliance ~= nil and not ui.disableHUD then
        if game.currentAlliance.id == playerAlliance.id then
          self:SwitchTab(self.diplomacyTab)
        end
      end
    end
  })




  self.tabs:AddWidget({
    name = "production_label",
    font = "hud12_font",
    position = {157, 13},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "production_label",
    sfx = "tab",
    on_click = function(button)
      if game.currentAlliance ~= nil and not ui.disableHUD then
        if game.currentAlliance.id == playerAlliance.id then
          self:SwitchTab(self.productionTab)
        end
      end
    end
  })

  self.tabs:AddWidget({
    name = "research_label",
    font = "hud12_font",
    position = {256, 13},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "research_label",
    sfx = "tab",
    on_click = function(button)
      if game.currentAlliance ~= nil and not ui.disableHUD then
        if game.currentAlliance.id == playerAlliance.id then
          self:SwitchTab(self.researchTab)

          -- Advice popup
          if AdviceValid("research") and settings.tutorial == 1 then
            ui.advicePanel:AddAdvice("research")
            ui.advicePanel:AddAdvice("techlines")
            ui.advicePanel:AddAdvice("focusing")
            AdviceClose("research")
          end
        end
      end
    end
  })

  self.tabs:AddWidget({
    name = "management_label",
    font = "hud12_font",
    position = {454, 13},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "management_label",
    sfx = "tab",
    on_click = function(button)
      if game.currentAlliance ~= nil and not ui.disableHUD then
        if game.currentAlliance.id == playerAlliance.id then
          self:SwitchTab(self.managementTab)

          -- Advice popup
          if AdviceValid("management") and settings.tutorial == 1 then
            ui.advicePanel:AddAdvice("management")
            AdviceClose("management")
          end
        end
      end
    end
  })

end

function MainPanel:SwitchTab(tab, force)


  ui.hotkeysActive = 1

  -- Reset cursor
  ResetCursorMode()

  -- Cancel if no factions that can produce
  local continue = false
  for faction in playerAlliance.factions do
    if CanFactionProduce(faction) then
      continue = true
      break
    end
  end
  if not continue and not force then
    return
  end

  if ui.briefing ~= 1 then
    if self.currentTab ~= nil then
      self.currentTab:Hide()
    end
--~     if ui.briefingPanel ~= nil then
--~       --ui.briefingPanel:Close()
--~     end
    if ui.turn_report ~= nil then
      ui.turn_report:Hide()
    end

    if ui.optionsPanel ~= nil then
      ui.optionsPanel:Hide()
    end

    self.currentTab = tab

    self.currentTab:Show()
  end
end

function MainPanel:OnShow()

 


		
-- if widget.isVisible then
 --   widget:Hide()
 -- else
  --  widget:Show()
 -- end


end
 
main_panel =
{
  name = "main_panel",
  type = "panel",
  position = {(engine.window.width-1024)/2, engine.window.height-200},
  image = "bar",

  controls =
  {
    {
      name = "main_minimap",
      position = {783, 29},
      color   = {69, 40, 23},
    },

    {
      name = "repair_button",
      type = "button",
      image = "button_repair",
      position = {780, 150},
      enabled = 1,
      tooltip = "repair_button",
      sfx = "click",
      on_click = function(button)
        if game.currentAlliance ~= nil and not ui.disableHUD then
          if game.currentAlliance.id == playerAlliance.id then
            if ui.UIMode ~= REPAIR then
              ui.UIMode = REPAIR
              ui.cursormode:Show()

              DisplayRepairZone()

              -- Advice popup
              if AdviceValid("repair") and settings.tutorial == 1 then
                ui.advicePanel:AddAdvice("repair", {792, 730, 1})
                AdviceClose("repair")
              end
            else
              GetScene():ClearActions()
              ResetCursorMode()
              ui.improvementsPanel:Hide()
            end
          end
        end
      end
    },
    {
      name = "upgrade_button",
      type = "button",
      image = "button_upgrade",
      position = {806, 150},
      enabled = 1,
      tooltip = "upgrade_button",
      sfx = "click",
      on_click = function(button)
        if game.currentAlliance ~= nil and not ui.disableHUD then
          if game.currentAlliance.id == playerAlliance.id then
            if ui.UIMode ~= UPGRADE then
              ui.UIMode = UPGRADE
              ui.cursormode:Show()

              DisplayUpgradeZone()

              -- Advice popup
              if AdviceValid("upgrade") and settings.tutorial == 1 then
                ui.advicePanel:AddAdvice("upgrade", {818, 730, 1})
                AdviceClose("upgrade")
              end
            else
              GetScene():ClearActions()
              ResetCursorMode()
              ui.improvementsPanel:Hide()
            end
          end
        end
      end
    },
    {
      name = "disband_button",
      type = "button",
      image = "button_disband",
      position = {832, 150},
      enabled = 1,
      tooltip = "disband_button",
      sfx = "click",
      on_click = function(button)
        if game.currentAlliance ~= nil and not ui.disableHUD then
          if game.currentAlliance.id == playerAlliance.id then
            if ui.UIMode ~= DISBAND then
              ui.UIMode = DISBAND
              ui.cursormode:Show()

              DisplayDisbandZone()

              -- Advice popup
              if AdviceValid("disband") and settings.tutorial == 1 then
                ui.advicePanel:AddAdvice("disband", {844, 730, 1})
                AdviceValid("disband")
              end
            else
              GetScene():ClearActions()
              ResetCursorMode()
              ui.improvementsPanel:Hide()
            end
          end
        end
      end
    },
    {
      name = "options_button",
      type = "button",
      image = "button_options",
      position = {780, 176},
      enabled = 1,
      tooltip = "options_button",
      sfx = "click",

      --text = "menu",
      on_click = function(button)
        if not ui.disableHUD then

          -- Reset cursor
          ResetCursorMode()

          ui.optionsPanel:Display()
        end
      end
    },
    {
      name = "next_unit_button",
      type = "button",
      image = "next_unit",
      position = {971, -35},
      enabled = 1,
      sfx = "click",
      on_click = function(button)
        SelectActiveUnit("next")
      end
    },
    {
      name = "date_day",
      type = "text",
      font = "hud_font",
      position = {884, 180},
      color   = {42, 34, 22},
      align = "center",
    },
    {
      name = "date_month",
      type = "text",
      font = "hud_font",
      position = {906, 180},
      color   = {42, 34, 22},
      align = "center",
    },
    {
      name = "date_year",
      type = "text",
      font = "hud_font",
      position = {924, 174},
      color   = {42, 34, 22},
      align = "left",
    },
    {
      name = "turn_text",
      type = "text",
      font = "hud_font",
      position = {914, 165},
      color   = {42, 34, 22},
      align = "center"
    },

    -- selection group
    {
      name = "main_tabgroup",
      type = "panel",
      rect = {256, 8, 500, 500},

      controls =
      {
      }
    },
  }
}


---------------------------------------------


class 'BlockingPanel' (LuaPanel)

function BlockingPanel:__init()
  LuaPanel.__init(self)

  self:SetPosition(256, 30)
  self:SetBackgroundImage("tab_blocking")

  self.title = self:AddWidget({
    type = "text",
    position = {260, 24},
    align = "center",
    font = "menu_font",
    color = {67, 56, 47},
    text = "aiturn",
  })
  self.text = self:AddWidget({
    type = "text",
    position = {260, 50},
    align = "center",
    font = "verdana12_font",
    color = {67, 56, 47},
    text = "wait",
  })
  self.status = self:AddWidget({
    type = "text",
    position = {260, 145},
    align = "center",
    font = "menu_font",
    color = {67, 56, 47},
  })

  self.video = self:AddWidget({type = "animation"});
  self.video:SetScaling(1, 1)
  self.video:SetPosition(226, 62)

  self:Hide()
end

function BlockingPanel:Popup(mode)

  self.status:SetText("")

  if mode == "single" then
    self.video:Show()
    self.video:PlayFile("ai_gearwheel")
    self.title:SetLocalText("aiturn")
    self.text:SetLocalText("wait")
  elseif mode == "pbem" then
    self.video:Show()
    self.video:PlayFile("ai_gearwheel")
    self.title:SetLocalText("uploading")
    self.text:SetLocalText("waitMP")
  elseif mode == "view" then
    self.video:Hide()
    self.title:SetLocalText("view_mode")
    self.text:SetLocalText("view_mode_info")
  elseif mode == "replay" then
    self.video:Show()
    self.video:PlayFile("ai_gearwheel")
    self.title:SetLocalText("replay_mode")
    self.text:SetLocalText("replay_mode_info")
  elseif mode == "convoy" then
    self.video:Show()
    self.video:PlayFile("ai_gearwheel")
    self.title:SetLocalText("convoy_mode")
    self.text:SetLocalText("convoy_mode_info")
  end

  ui.hotkeysActive = 0

  self:Show()
end

function BlockingPanel:SetStatus(text)

  self.status:SetLocalText(text)

end

function BlockingPanel:OnHide()
  ui.hotkeysActive = 1
end



------------------------------------------------------

function PopupReplayStart()

  replayPanel =
  {
    name = "replay_panel",
    type = "panel",
    position = {256 + (engine.window.width-1024)/2, engine.window.height - 170},
    image = "tab_briefing",

    controls =
    {
      {
        type = "text",
        position = {255, 24},
        align = "center",
        font = "menu_font",
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "replay_mode",
      },
      {
        type = "memo",
        position = {40, 42},
        size = {430, 150},
        font = "verdana12_font",
        color   = {0, 0, 0},
        text = "replay_start_text",
        border = 0
      },
      {
        type = "button",
        image = "button_default",
        position = {198, 139},
        text = "start_replay",
        sfx = "click",
        on_click = function(button)
          game:StartReplay()
          button.parent:Hide()
          ui.chatPanel:Hide()
          ui.chatPanel.turnButton:Show()
          ui.chatPanel.surrenderButton:Show()
          ui.chatPanel.replayButton:Hide()
        end
      },
    }
  }

  ui.replayStartPanel = hud:CreateWidget(replayPanel)
end


------------------------------------------------------


function PreEndTurn(check)

  function ConvoyWarning()
    if settings.convoyWarning == 1 then
      --PopupConvoy()
      ui.convoyPanel:Show()
      return true
    end
  end

  function TransportWarning()
    if settings.transportWarning == 1 then
      ui.transportPanel:Show()
      return true
    end
    PreEndTurn("transports")
  end

  function UnmovedFactionWarning()
    if settings.nomovesWarning == 1 then
      ui.factionPanel:Show()
      return true
    end
    PreEndTurn("unmovedfaction")
  end

  function NoResearch()
    if settings.researchWarning == 1 then
      local techCategories = {"ground", "artillery", "air", "naval", "armour"}
      local techId
      for faction in playerAlliance.factions do
        for i=1, # techCategories do
          techId = faction.luaData.currentTech
          if techId == -1 and faction.luaData.labs[techCategories[i]] > 0 then
            function YesFunc() PreEndTurn("research") end
            PopupDialog("research_warning", YesFunc)
            ui.mainPanel:SwitchTab(ui.mainPanel.researchTab)
            hud:GetPanel("research_panel"):Hide()
            return true
          end
        end
      end
    end
    PreEndTurn("research")
  end

  if check == "research" then
    EndTurnProcess()
  elseif check == "transports" then
    NoResearch()
  elseif check == "unmovedfaction" then
    TransportWarning()
  else
    UnmovedFactionWarning()
  end

end


function EndTurnProcess()

  -- Advice unit type
--~   if tutorial["on"] == 1 then
--~     if tutorial["firstturn"] ~= 1 then
--~       ui.advicePanel:AddAdvice("advice_firstturn_title", "advice_firstturn", 1, 1)
--~       tutorial["firstturn"] = 1
--~       return
--~     end
--~   end

  -- Only trigger during player's turn
  if game.currentAlliance ~= nil then
    if game.currentAlliance.id == playerAlliance.id then

      -- Deselect unit
      GetPlayer():DeselectUnit()

      -- Hide popups
      ui.newsPaper:Clear()

      -- Hide turn report
      ui.turn_report:Hide()
	  
	  
      -- Switch to default cursor
      ResetCursorMode()

      -- Auto save
      if game.type == Game.TYPE_SINGLE then
        if settings.autosave == 1 then
          SaveGame("AutoSaveEndTurn")
        end
      end

      -- First check if anyone wishes to surrender before continuing
      if CheckForSurrender() then
        return
      end

      PlaySample(sEndTurn)

      -- End turn
      if game.type == Game.TYPE_SINGLE then
        ui.mainPanel.blockingPanel:Popup("single")
        GetPlayer():EndTurn()
      else
        ui.MPturnEnded = true
        ui.mainPanel.blockingPanel:Popup("pbem")
        GetPlayer():EndTurn()
        GetPlayer():UploadTurn(function(error) UploadFailed(error) end)
      end
    end
  end
end

function UploadFailed(error)
  if error ~= 0 then
    local YesFunc = function() GetPlayer():UploadTurn(function(error) UploadFailed(error) end) end
    local NoFunc = function() ui.MPturnEnded = false end
    hud:CreateWidget(ErrorPopup("upload_failed", YesFunc, NoFunc))
  else
    -- Check Victory conditions
    if playerAlliance.id ~= startingAlliance then
    print("step 1")
      if not VictoryConditions("next") then
      print("step 2")
        replaystuff = nil
        engine:SetScreen(screens.multiplayerMenu)
      end
    else
    print("step 3")
      replaystuff = nil
      engine:SetScreen(screens.multiplayerMenu)
    end
  end
end
