function OptionsLoad()

  settings.autosave = GetUserInt("autosave", 1)
--~   settings.autoResearch = GetUserInt("autoResearch", 1)
--~   settings.autoProduction = GetUserInt("autoProduction", 1)
--~   settings.autoManagement = GetUserInt("autoManagement", 1)
--~   settings.warningConvoys = GetUserInt("warningConvoys", 1)
  settings.tutorial = GetUserInt("tutorial", 1)

  settings.showgrid = GetUserInt("showgrid", 0)
  settings.natocounters = GetUserInt("natocounters", 0)
  settings.unitglow = GetUserInt("unitglow", 1)

  settings.hexesSelectable = GetUserInt("hexesSelectable", 1)
  settings.arrows = GetUserInt("arrows", 1)
  settings.showKills = GetUserInt("showKills", 1)
  settings.sortQueue = GetUserInt("sortQueue", 1)

  settings.controlScheme = GetUserInt("controlScheme", 1)
--~   settings.convoyWarning = GetUserInt("convoyWarning", 1)
  settings.transportWarning = GetUserInt("transportWarning", 1)
  settings.nomovesWarning = GetUserInt("nomovesWarning", 1)
--~   settings.researchWarning = GetUserInt("researchWarning", 1)

  settings.musicVol = GetUserInt("musicVol", 4)
  settings.sfxVol = GetUserInt("sfxVol", 11)

  settings.rememberPW = GetUserInt("rememberPW", 0)

end

function OptionsSave()

  for setting, value in pairs(settings) do
    if setting ~= "tutorial" and type(value) == "number" then
      SetUserInt(setting, value)
    end
  end

end

class 'OptionsPanel' (LuaPanel)

function OptionsPanel:__init()
  LuaPanel.__init(self, options_panel)

  self.tabs = {}

  self.tabs["visuals"] = self:AdoptWidget(OptionsVisualsPanel())

  self.tabs["audio"] = self:AdoptWidget(OptionsAudioPanel())

  self.tabs["controls"] = self:AdoptWidget(OptionsControlsPanel())

  self.tabs["savegames"] = self:AdoptWidget(OptionsLoadPanel())

--~   if game ~= nil then
--~     if game.type == Game.TYPE_SINGLE then

--~     end
--~   end
      self.tabSaves = self:AddWidget({
        type = "image",
        image = "tab_saves",
        position = {663, 13},
        sfx = "click",
        on_click = function(button)
          self.tabSaves:SetImage("graphics/hud", "tab_saves_sel.png")
          self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
          self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
          self.tabControls:SetImage("graphics/hud", "tab_controls.png")
          self.tabs["current"]:Hide()
          self.tabs["current"] = self.tabs["savegames"]
          self.tabs["current"]:Show()
        end
      })
      self.tabSavesText = self:AddWidget({
        type = "label",
        font = "menu_font",
        position = {763, 28},
        align = "center",
        normal   = {224, 220, 218},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {224, 220, 218},
        text = "savegames_settings",
        sfx = "click",
        on_click = function(button)
          self.tabSaves:SetImage("graphics/hud", "tab_saves_sel.png")
          self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
          self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
          self.tabControls:SetImage("graphics/hud", "tab_controls.png")
          self.tabs["current"]:Hide()
          self.tabs["current"] = self.tabs["savegames"]
          self.tabs["current"]:Show()
        end
      })
  self.tabVisuals = self:AddWidget({
    type = "image",
    image = "tab_visuals",
    position = {9, 13},
    sfx = "click",
    on_click = function(button)
      self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
      self.tabVisuals:SetImage("graphics/hud", "tab_visuals_sel.png")
      self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
      self.tabControls:SetImage("graphics/hud", "tab_controls.png")
      self.tabs["current"]:Hide()
      self.tabs["current"] = self.tabs["visuals"]
      self.tabs["current"]:Show()
    end
  })
  self:AddWidget({
    type = "label",
    font = "menu_font",
    position = {109, 28},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "display_settings",
    sfx = "click",
    on_click = function(button)
      self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
      self.tabVisuals:SetImage("graphics/hud", "tab_visuals_sel.png")
      self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
      self.tabControls:SetImage("graphics/hud", "tab_controls.png")
      self.tabs["current"]:Hide()
      self.tabs["current"] = self.tabs["visuals"]
      self.tabs["current"]:Show()
    end
  })
  self.tabAudio = self:AddWidget({
    type = "image",
    image = "tab_audio",
    position = {227, 13},
    sfx = "click",
    on_click = function(button)
      self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
      self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
      self.tabAudio:SetImage("graphics/hud", "tab_audio_sel.png")
      self.tabControls:SetImage("graphics/hud", "tab_controls.png")
      self.tabs["current"]:Hide()
      self.tabs["current"] = self.tabs["audio"]
      self.tabs["current"]:Show()
    end
  })
  self:AddWidget({
    type = "label",
    font = "menu_font",
    position = {327, 28},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "audio_settings",
    sfx = "click",
    on_click = function(button)
      self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
      self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
      self.tabAudio:SetImage("graphics/hud", "tab_audio_sel.png")
      self.tabControls:SetImage("graphics/hud", "tab_controls.png")
      self.tabs["current"]:Hide()
      self.tabs["current"] = self.tabs["audio"]
      self.tabs["current"]:Show()
    end
  })
  self.tabControls = self:AddWidget({
    type = "image",
    image = "tab_controls",
    position = {445, 13},
    sfx = "click",
    on_click = function(button)
      self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
      self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
      self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
      self.tabControls:SetImage("graphics/hud", "tab_controls_sel.png")
      self.tabs["current"]:Hide()
      self.tabs["current"] = self.tabs["controls"]
      self.tabs["current"]:Show()
    end
  })
  self:AddWidget({
    type = "label",
    font = "menu_font",
    position = {545, 28},
    align = "center",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "controls_settings",
    sfx = "click",
    on_click = function(button)
      self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
      self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
      self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
      self.tabControls:SetImage("graphics/hud", "tab_controls_sel.png")
      self.tabs["current"]:Hide()
      self.tabs["current"] = self.tabs["controls"]
      self.tabs["current"]:Show()
    end
  })

  if game ~= nil and game.type == Game.TYPE_SINGLE then
    self.tabs["current"] = self.tabs["savegames"]
    self.tabSaves:SetImage("graphics/hud", "tab_saves_sel.png")
  else
    self.tabs["current"] = self.tabs["visuals"]
    self.tabSaves:Hide()
    self.tabSavesText:Hide()
    self.tabVisuals:SetImage("graphics/hud", "tab_visuals_sel.png")
    if game == nil then
      self:GetButton("quitMenu_button"):Hide()
      self:GetButton("quitOS_button"):Hide()
    end
  end

end

function OptionsPanel:Display(where)

  if game ~= nil and game.type == Game.TYPE_SINGLE and where ~= "frontEnd" then
    self.tabs["savegames"]:RefreshSaves()

    self.tabSaves:SetImage("graphics/hud", "tab_saves_sel.png")
    self.tabVisuals:SetImage("graphics/hud", "tab_visuals.png")
    self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
    self.tabControls:SetImage("graphics/hud", "tab_controls.png")
    self.tabs["current"]:Hide()
    self.tabs["current"] = self.tabs["savegames"]

    hud:GetWidget("production_panel"):Hide()
    hud:GetWidget("research_panel"):Hide()
    hud:GetWidget("diplomacy_panel"):Hide()
    hud:GetWidget("management_panel"):Hide()

    ui.hotkeysActive = 0
  else

    self.tabSaves:SetImage("graphics/hud", "tab_saves.png")
    self.tabVisuals:SetImage("graphics/hud", "tab_visuals_sel.png")
    self.tabAudio:SetImage("graphics/hud", "tab_audio.png")
    self.tabControls:SetImage("graphics/hud", "tab_controls.png")

    self.tabs["savegames"]:Hide()
    self.tabs["current"]:Hide()
    self.tabs["current"] = self.tabs["visuals"]
  end
  self.tabs["current"]:Show()

  self:Show()

end

options_panel =
{
  name = "options_panel",
  type = "panel",
  position = {(engine.window.width)/2-436, (engine.window.height-200)/2-273},
  image = "options_panel",
  visible = false,

  controls =
  {
    {
      name = "close_button",
      type = "button",
      image = "button_default",
      position = {30, 487},
      align = "center",
      colour   = {224, 220, 218},
      text = "close",
      sfx = "click",
      on_click = function(button)
        OptionsSave()
        if game ~= nil then
          button.parent:Hide()
          ui.hotkeysActive = 1
        else
          engine:SetScreen(screens.mainMenu)
        end
      end
    },
    {
      name = "quitMenu_button",
      type = "button",
      image = "button_default",
      position = {605, 487},
      align = "center",
      colour   = {224, 220, 218},
      text = "exitMenu",
      sfx = "click",
      on_click = function(button)
        OptionsSave()
        function printYes()
          if game.type == Game.TYPE_SINGLE then
            engine:SetScreen(screens.mainMenu)
          else
            replaystuff = nil
            engine:SetScreen(screens.multiplayerMenu)
          end


          MusicPlayer():Stop()
          MusicPlayer():ClearPlayList()
          MusicPlayer():AddToPlayList("main_menu")
          MusicPlayer():SetLooping(true)
          MusicPlayer():Play()
          StopAllSounds()
          --[[
              there are also: Stop() and ClearPlayList(),
              use them when going to/from game
          ]]--
          button.parent:Hide()
        end
        PopupDialog("exitConfirm", printYes)
      end
    },
    {
      name = "quitOS_button",
      type = "button",
      image = "button_default",
      position = {725, 487},
      align = "center",
      colour   = {224, 220, 218},
      text = "exitOS",
      sfx = "click",
      on_click = function(button)
        OptionsSave()
        function printYes() engine:Close() end
        PopupDialog("exitConfirm", printYes)
      end
    },
  }
}





-----------------------------------------------------------------------

class 'OptionsLoadPanel' (LuaPanel)

function OptionsLoadPanel:__init()
  LuaPanel.__init(self)

  self:SetPosition(29, 50)

  self.saveEdit = self:AddWidget({
    type = "edit",
    name = "saveEdit",
    text = "savegame",
    size = {width=570, height=20},
    position = {3, 410-9},
    on_click = function(button)
      self.saveButton:Show()
      self.loadButton:Hide()
      self:GetImage("selected_game"):Hide()
    end,
    EnterPressed = function(button)
      SaveGame(button.text)
      Log("saving game " .. button.text)
      self.saveButton:Hide()
    end
  })
  self:AddWidget({
    type = "image",
    position = {578, 407-9},
    image = "button_default_disabled",
  })
  self:AddWidget({
    type = "image",
    position = {698, 407-9},
    image = "button_default_disabled",
  })
  self:AddWidget({
    type = "text",
    position = {578+55, 420-9},
    font = "hud12_font",
    align = "center",
    color = {192,204,111},
    text = "saved",
  })
  self.saveButton = self:AddWidget({
    name = "save_button",
    type = "button",
    image = "button_default",
    position = {576, 405-9},
    colour   = {224, 220, 218},
    text = "save",
    sfx = "click",
    on_click = function(button)
      local overWrite = false
      local savegames = engine:GetSavegames()
      for _, save in ipairs(savegames) do
        if save.name == self.saveEdit.text then
          overWrite = true
          local saveFunc = function()
            SaveGame(self.saveEdit.text)
            self:RefreshSaves()
            self.saveButton:Hide()
          end
          PopupDialog("confirm_overwrite", saveFunc)
        end
      end
      if not overWrite then
        SaveGame(self.saveEdit.text)
        self:RefreshSaves()
        self.saveButton:Hide()
      end
      --engine:ScheduleTask(1000, function() self.saveButton:Show() end)
    end
  })
  self.loadButton = self:AddWidget({
    type = "button",
    image = "button_default",
    position = {696, 405-9},
    colour   = {224, 220, 218},
    text = "load",
    sfx = "click",
    on_click = function(button)
      engine:SetScreen(screens.loadingMenu)
      LoadGame(self.saveEdit.text)
    end
  })
--~   self:AddWidget({
--~     name = "save_text",
--~     type = "text",
--~     position = {16, 390},
--~     color   = {224, 220, 218},
--~     align = "left",
--~     text = "saveas_text"
--~   })

  self:AddWidget({
    type = "text",
    text = "pbem_game_name",
    color = {67, 56, 47},
    position = {16, 26},
  })
  self:AddWidget({
    type = "text",
    text = "save_game_date",
    color = {67, 56, 47},
    position = {511, 26},
    align = "left"
  })

  self.scrollPos = 0
  self.listmax = 16
  self.listLength = 0
  self:AddWidget({
    type = "button",
    image = "scroll_up",
    position = {785, 21},
    Clicked = function()
      if self.scrollPos > 0 then
        self.scrollPos = self.scrollPos - self.listmax
        --self:GetPanel("gameslist_panel"):SetPosition(0, self.scrollPos*-20)
        self:RefreshSaves()
      end
    end
  })
  self:AddWidget({
    type = "button",
    image = "scroll_down",
    position = {785, 358},
    Clicked = function()
      if self.scrollPos < self.listLength - self.listmax then
        self.scrollPos = self.scrollPos + self.listmax
        --self:GetPanel("gameslist_panel"):SetPosition(0, self.scrollPos*-20)
        self:RefreshSaves()
      end
    end
  })
  self:AddWidget({
    name = "selected_game",
    type = "image",
    image = "pbem_selection_highlight",
    position = {40, 132},
  }):Hide()

  self:AddWidget({
    name = "pagebar",
    type = "image",
    image = "pagebar",
    position = {791,42},
  })

  self.savesList = self:AddWidget({type = "panel"})

  self:Hide()

end

function OptionsLoadPanel:OnShow()
  self.saveButton:Show()
  self.loadButton:Hide()
end

function OptionsLoadPanel:RefreshSaves()

--~   self.savesList:RemoveWidgets()

--~   local savegames = engine:GetSavegames()

--~   local i = 0
--~   local maxItems = 6
--~   for _, save in ipairs(savegames) do
--~     --Log(save.name .. ", " .. save.file)
--~     self:AddSavegame(i + 1, 30, i*20, save)
--~     i = i + 1
--~     if i == maxItems then
--~       break
--~     end
--~   end


  self.savesList:RemoveWidgets()
  self.selectedSave = nil

  local savegames = engine:GetSavegames()

  self.listLength = 0
  self.listLengthCurrent = 0
  local first = 0
  for _, save in ipairs(savegames) do
    --Log(save.name .. ", " .. save.file)
    if self.listLength >= self.scrollPos and self.listLength - self.scrollPos < self.listmax then
      self:AddSavegame(self.listLength + 1, 11, 43 + (self.listLength - self.scrollPos) *20, save)
      if first == 0 then
        self.selectedSave = save.name
        self:GetImage("selected_game"):SetPosition(11, 43)
        first = 1
      end
      self.listLengthCurrent = self.listLengthCurrent + 1
    end
    self.listLength = self.listLength + 1
  end

  --self.listLength = row
  self.pageCount = math.floor((self.listLength+9)/self.listmax)
  --print(self.pageCount)
  self:GetImage("pagebar"):SetSource(0, 0, 6, 311 * self.listLengthCurrent / self.listLength)
  self:GetImage("pagebar"):SetPosition(791, 42 + (311 * (self.scrollPos) / self.listLength) )

end

--~ function OptionsLoadPanel:AddSavegame(id, x, y, save)

--~   local listElement =
--~   {
--~     type = "label",
--~     font = "menu_font",
--~     position = {x, y},
--~     align = "left",
--~     normal   = {224, 220, 218},
--~     hilight  = {255, 255, 255},
--~     select   = {255, 255, 255},
--~     disabled = {224, 220, 218},
--~     text = save.name,
--~     sfx = "click",
--~     Clicked = function(button)
--~     end
--~   }

--~   if id == 1 then
--~     self.selectedSave = save.name
--~   end

--~   self.savesList:AddWidget(listElement):Show()

--~ end

function OptionsLoadPanel:AddSavegame(id, x, y, save)

  local listElement = self.savesList:AddWidget({
    type = "panel",
    position = {x, y},
  })
  listElement.save = save.name
  listElement:AddWidget({
    type = "image",
    image = "save_selection_hotspot",
    sfx = "click",
    Clicked = function(this)
      self:SelectSavegame(save.name, y)
    end
  })
  listElement:AddWidget({
    type = "label",
    font = "menu_font",
    position = {5, 3},
    align = "left",
    normal   = {67, 56, 47},
    hilight  = {67, 56, 47},
    select   = {67, 56, 47},
    disabled = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = save.name,
    sfx = "click",
    Clicked = function(this)
      self:SelectSavegame(save.name, y)
    end
  })
  listElement:AddWidget({
    type = "label",
    font = "menu_font",
    position = {500, 3},
    align = "left",
    normal   = {67, 56, 47},
    hilight  = {67, 56, 47},
    select   = {67, 56, 47},
    disabled = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = save.time,
    sfx = "click",
    Clicked = function(this)
      self:SelectSavegame(save.name, y)
    end
  })

  if id == 1 then
    self.selectedSave = save.name
  end

end

function OptionsLoadPanel:SelectSavegame(save, y)
  self.selectedSave = save
  self.saveEdit:SetText(save)
  self.saveButton:Show()
  self.loadButton:Show()
  self:GetImage("selected_game"):Show()
  self:GetImage("selected_game"):SetPosition(11, y)
end

-----------------------------------------------------------------------

class 'OptionsVisualsPanel' (LuaPanel)

function OptionsVisualsPanel:__init()
  LuaPanel.__init(self)

  local gridOnEffect = function() if View ~= nil then View:EnableHexGrid(true) end settings.showgrid = 1 end
  local gridOffEffect = function() if View ~= nil then View:EnableHexGrid(false) end settings.showgrid = 0 end
  self:AdoptWidget(CheckBox(55, 87, "grid_text", gridOnEffect, gridOffEffect, settings.showgrid))

  local natoOnEffect = function() if View ~= nil then View:EnableUnitCounters(true) end settings.natocounters = 1 end
  local natoOffEffect = function() if View ~= nil then View:EnableUnitCounters(false) end settings.natocounters = 0 end
  self:AdoptWidget(CheckBox(55, 112, "nato_text", natoOnEffect, natoOffEffect, settings.natocounters))

  local glowOnEffect = function() if View ~= nil then View:EnableUnitGlow(true) end settings.unitglow = 1 end
  local glowOffEffect = function() if View ~= nil then View:EnableUnitGlow(false) end settings.unitglow = 0 end
  self:AdoptWidget(CheckBox(55, 137, "glow_text", glowOnEffect, glowOffEffect, settings.unitglow))

  local arrowsOnEffect = function() settings.arrows = 1 end
  local arrowsOffEffect = function() settings.arrows = 0 end
  self:AdoptWidget(CheckBox(55, 182, "arrows_text", arrowsOnEffect, arrowsOffEffect, settings.arrows))

  local showKillsOnEffect = function() settings.showKills = 1 if ui ~= nil and View ~= nil then ui.mainPanel.selectionTab.prognosisPanel:GetText("kills_text"):SetColour(70, 104, 10, 255) ui.mainPanel.selectionTab.prognosisPanel:GetText("casualties_text"):SetColour(137, 31, 3, 255) end end
  local showKillsOffEffect = function() settings.showKills = 0 if ui ~= nil and View ~= nil then ui.mainPanel.selectionTab.prognosisPanel:GetText("casualties_text"):SetColour(70, 104, 10, 255) ui.mainPanel.selectionTab.prognosisPanel:GetText("kills_text"):SetColour(137, 31, 3, 255) end end
  self:AdoptWidget(CheckBox(55, 237, "showkills_text", showKillsOnEffect, showKillsOffEffect, settings.showKills))

  local sortQueueOnEffect = function() settings.sortQueue = 1 if ui ~= nil and View ~= nil then ui.mainPanel.productionTab:Refresh() end end
  local sortQueueOffEffect = function() settings.sortQueue = 0 if ui ~= nil and View ~= nil then ui.mainPanel.productionTab:Refresh() end end
  self:AdoptWidget(CheckBox(55, 272, "sortqueue_text", sortQueueOnEffect, sortQueueOffEffect, settings.sortQueue))


  self:Hide()

end




-----------------------------------------------------------------------

class 'OptionsAudioPanel' (LuaPanel)

function OptionsAudioPanel:__init()
  LuaPanel.__init(self)

  self:SetPosition(0, 0)

  self:AddWidget({
    type = "text",
    font = "menu_font",
    position = {50, 80},
    align = "left",
    color   = {67, 56, 47},
    text = "music_volume"
  })

  self:AddWidget({
    type = "text",
    font = "menu_font",
    position = {65, 125},
    align = "center",
    color   = {67, 56, 47},
    text = "off"
  })

  self:AddWidget({
    type = "text",
    font = "menu_font",
    position = {465, 125},
    align = "center",
    color   = {67, 56, 47},
    text = "maximum"
  })


  local effectMusic = function(setting)
    --[[if settings.musicVol == 0 and setting > 0 then
      engine:PlayMusic("game2")
    end
    if settings.musicVol > 0 and setting == 0 then
      engine:StopMusic()
    end]]--
    MusicPlayer():SetVolume((setting - 1) * 2)
    settings.musicVol = setting
  end
  self:AdoptWidget(RadioButton(60, 100, 11, 0, effectMusic, settings.musicVol, 0, 40))


  self:AddWidget({
    type = "text",
    font = "menu_font",
    position = {40, 160},
    align = "left",
    color   = {67, 56, 47},
    text = "sfx_volume"
  })

  self:AddWidget({
    type = "text",
    font = "menu_font",
    position = {65, 205},
    align = "center",
    color   = {67, 56, 47},
    text = "off"
  })

  self:AddWidget({
    type = "text",
    font = "menu_font",
    position = {465, 205},
    align = "center",
    color   = {67, 56, 47},
    text = "maximum"
  })

  local effectSfx = function(setting) settings.sfxVol = setting engine:SetSfxVolume((setting - 1) * 10) end
  self:AdoptWidget(RadioButton(60, 180, 11, 0, effectSfx, settings.sfxVol, 0, 40))

  self:Hide()

end


-----------------------------------------------------------------------

class 'OptionsControlsPanel' (LuaPanel)

function OptionsControlsPanel:__init()
  LuaPanel.__init(self)

  self:SetPosition(0, 0)


  self:AddWidget({
    name = "hexes_label",
    type = "label",
    font = "menu_font",
    position = {65, 100},
    align = "left",
    normal   = {67, 56, 47},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {50, 50, 50},
    shadow = {offset = {0, 0}},
    text = "hexesSelectable_text",
    sfx = "click",
    Clicked = function(button)
      if settings.hexesSelectable ~= 1 then
        settings.hexesSelectable = 1
        button.parent:GetButton("hexes_checkbox_on"):Show()
        button.parent:GetButton("hexes_checkbox_off"):Hide()
      else
        settings.hexesSelectable = 0
        button.parent:GetButton("hexes_checkbox_off"):Show()
        button.parent:GetButton("hexes_checkbox_on"):Hide()
      end
    end
  })
  self:AddWidget({
    name = "hexes_checkbox_off",
    type = "button",
    image = "checkboxSquare",
    position = {40, 100},
    sfx = "click",
    on_click = function(button)
      settings.hexesSelectable = 1
      button.parent:GetButton("hexes_checkbox_on"):Show()
      button:Hide()
    end
  })
  self:AddWidget({
    name = "hexes_checkbox_on",
    type = "button",
    image = "checkboxSquareChecked",
    position = {40, 100},
    sfx = "click",
    visible = false,
    on_click = function(button)
      settings.hexesSelectable = 0
      button.parent:GetButton("hexes_checkbox_off"):Show()
      button:Hide()
    end
  })

  --local test = function() return 1 end
  --self:AdoptWidget(CheckBox(40, 125, "auto_production", test, test))
  --local autoResearchOnEffect = function() return 1 end
  --local autoResearchOffEffect = function() return 1 end
  --self:AdoptWidget(CheckBox(40, 150, "auto_research", test, test))

  local effect = function(setting) settings.controlScheme = setting SetControls(setting) end
  self:AdoptWidget(RadioButton(40, 200, 2, "control_scheme_", effect, settings.controlScheme))

  local transportOnEffect = function() settings.transportWarning = 1 end
  local transportOffEffect = function() settings.transportWarning = 0 end
  self:AdoptWidget(CheckBox(40, 250, "enable_unmoved_transports", transportOnEffect, transportOffEffect, settings.transportWarning))

  local nomovesOnEffect = function() settings.nomovesWarning = 1 end
  local nomovesOffEffect = function() settings.nomovesWarning = 0 end
  self:AdoptWidget(CheckBox(40, 275, "enable_unmoved_faction", nomovesOnEffect, nomovesOffEffect, settings.nomovesWarning))

--~   local convoysOnEffect = function() settings.convoyWarning = 1 end
--~   local convoysOffEffect = function() settings.convoyWarning = 0 end
--~   self:AdoptWidget(CheckBox(40, 275, "Enable unmoved convoys warning", convoysOnEffect, convoysOffEffect, settings.convoyWarning))

--~   local researchOnEffect = function() settings.researchWarning = 1 end
--~   local researchOffEffect = function() settings.researchWarning = 0 end
--~   self:AdoptWidget(CheckBox(40, 300, "Enable idle research warning", researchOnEffect, researchOffEffect, settings.researchWarning))

  self:Hide()

end


