class 'EventPopup' (LuaPanel)

function EventPopup:__init(params, x, y)
  LuaPanel.__init(self, params)
  self.x = x
  self.y = y
end

function EventPopup:OnShow()
  -- play sound and jump camera when shown
 --- PlaySample(sPopupEvent) -- überflüssig

  if self.x ~= nil and self.y ~= nil then
    local hex = GetHex(self.x, self.y)
    LookAtWrapper(hex)
  end
end

-------------------------------------------------

class 'UnitRenamePanel' (LuaPanel)

function UnitRenamePanel:__init()
  LuaPanel.__init(self)

  self:SetPosition((engine.window.width)/2-240, (engine.window.height-200)/2-88)
  self:SetBackgroundImage("dialog")

  self:AddWidget({
    name = "dialogtext_text",
    type = "memo",
    --position = {243, 81},
    position = {50, 50},
    font = "times12_font",
    align = "center",
    color   = {67, 56, 47},
    size = {400, 95},
    border = 0,
    text = "rename_unit",
  })
  self.edit = self:AddWidget({
    type = "edit",
    name = "nameEdit",
    --text = unit.prototype.name,
    size = {width=350, height=20},
    position = {50, 70},
    EnterPressed = function(edit)
      self:ConfirmRename()
    end
  })
  self:AddWidget({
    name = "yes_label",
    type = "button",
    image = "button_default",
    position = {86, 141},
    font = "hud14_font",
    text = "yes",
    sfx = "click",
    on_click = function(button)
      self:ConfirmRename()
    end
  })
  self:AddWidget({
    name = "no_label",
    type = "button",
    image = "button_default",
    position = {286, 141},
    font = "hud14_font",
    text = "cancel",
    sfx = "click",
    on_click = function(button)
      button.parent:Hide()
    end
  })

  self:Hide()

end

function UnitRenamePanel:OnShow()

  ui.hotkeysActive = 0

  self.unit = GetSelectedUnit()

  if self.unit.params:Get("name") == nil then
    --self.edit.text:SetLocalText(unit.prototype.name)
    self.edit:SetText(self.unit.prototype.name)
  else
    self.edit:SetText(self.unit.params:Get("name"))
  end

end

function UnitRenamePanel:OnHide()

  ui.hotkeysActive = 1

end

function UnitRenamePanel:ConfirmRename()
  self.unit.params:Set("name", self:GetEdit("nameEdit").text)
  ui.mainPanel.selectionTab:GetText("type_text"):SetText(self.unit.params:Get("name"))
  self:Hide()
end

-------------------------------------------------

class 'NewsEvent' (LuaPanel)

function NewsEvent:__init()
  LuaPanel.__init(self)

  self.newsData = {}
  for alliance in game.alliances do
    if alliance.id ~= 0 then
      if alliance.luaData.newsEvents == nil or gameLoaded then
        alliance.luaData.newsEvents = {}
        self.newsData[alliance.id] = alliance.luaData.newsEvents
        self.newsData[alliance.id].text = {}
        self.newsData[alliance.id].image = {}
        self.newsData[alliance.id].hex = {}
        self.newsData[alliance.id].total = 0
      else
        self.newsData[alliance.id] = alliance.luaData.newsEvents
      end
    end
  end

  self:SetPosition((engine.window.width)/2-275, (engine.window.height-200)/2-290)

  self:AddWidget({
    type = "image",
    position = {0, 0},
    image = "eventbg",
  })

  self:AddWidget({
    type = "text",
    font = "impact18_font",
    position = {275, 32},
    color   = {67, 56, 47},
    text = "special_event",
    align = "center"
  })

  self.title = self:AddWidget({
    type = "text",
    font = "impact36_font",
    position = {275, 70},
    color   = {67, 56, 47},
    align = "center"
  })

  self.image = self:AddWidget({
    type = "image",
    position = {67, 97},
  })

  self.text = self:AddWidget({
    type = "memo",
    position = {63, 457},
    size = {414, 50},
    font = "times12_font",
    color   = {67, 56, 47},
    border = 0
  })

  -- Buttons
--~   self.next = self:AddWidget({
--~     type = "label",
--~     font = "times14_font",
--~     position = {424, 545},
--~     shadow = {offset = {0, 0}},
--~     align = "right",
--~     normal   = {67, 56, 47},
--~     hilight  = {255, 255, 255},
--~     select   = {255, 255, 255},
--~     disabled = {224, 220, 218},
--~     text = "next",
--~     sfx = "click",
--~     on_click = function(button)
--~       self:Refresh(self.id + 1)
--~     end
--~   })
--~   self.nextButton = self:AddWidget({
--~     type = "button",
--~     image = "event_next",
--~     position = {356, 543},
--~     sfx = "click",
--~     on_click = function(button)
--~       self:Refresh(self.id + 1)
--~     end
--~   })

--~   self.previous = self:AddWidget({
--~     type = "label",
--~     font = "times14_font",
--~     position = {103, 545},
--~     shadow = {offset = {0, 0}},
--~     align = "left",
--~     normal   = {67, 56, 47},
--~     hilight  = {255, 255, 255},
--~     select   = {255, 255, 255},
--~     disabled = {224, 220, 218},
--~     text = "previous",
--~     sfx = "click",
--~     on_click = function(button)
--~       self:Refresh(self.id - 1)
--~     end
--~   })
--~   self.previousButton = self:AddWidget({
--~     type = "button",
--~     image = "event_previous",
--~     position = {68, 543},
--~     sfx = "click",
--~     on_click = function(button)
--~       self:Refresh(self.id - 1)
--~     end
--~   })

  self.close = self:AddWidget({
    type = "label",
    font = "times14_font",
    position = {275, 553},
    shadow = {offset = {0, 0}},
    align = "center",
    normal   = {67, 56, 47},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "close",
    sfx = "click",
    on_click = function(button)
      if self.lastEvent then
        self:Clear()
      else
        self:Refresh(self.id + 1)
      end
    end
  })

  self:Hide()
  --ui.messageQue:PushMessage(hud:AdoptWidget(EventPopup(eventPanel, x, y)))
end

function NewsEvent:OnShow()
		
 --PlaySample(sPaperEvent)
	sfx = LoadSample("paper_event.wav")
	PlaySample(sfx)

end
 
function PlayEffect(paptext)
	local eventname = paptext
	
if eventname == "Schlieffen" then

	if GetEvent("UltimatumBelgium2") <= 0 then
	 PlaySample(LoadSample("schlieffen.wav"))
	else
		PlaySample(LoadSample("military.wav"))
	end


elseif eventname == "TechsArtillery" then
	  PlaySample(LoadSample("armouredcruiser_attack_2.wav"))


elseif eventname == "TechsNaval" then
	  PlaySample(LoadSample("port4.wav"))

elseif eventname == "TechsAir" then
	  PlaySample(LoadSample("fighter_move_1.wav"))

elseif eventname == "TechsArmour" then
	  PlaySample(LoadSample("armour_move_3.wav"))


elseif eventname == "goeben" then
	  PlaySample(LoadSample("port4.wav"))
	  
elseif eventname == "Doom" then
	  PlaySample(LoadSample("piano.wav"))

elseif eventname == "BarbedWire" then
	  PlaySample(LoadSample("uneasy.wav"))	  

elseif eventname == "KaiserGold" then
		PlaySample(LoadSample("coins.wav"))

elseif eventname == "DiplomaticPoker" then
  PlaySample(LoadSample("clock.wav"))

elseif eventname == "AHPlanning" then
  PlaySample(LoadSample("military.wav"))

elseif eventname == "AllEast" then
  PlaySample(LoadSample("infantry_move_2.wav"))
  PlaySample(LoadSample("cavalry_move_4.wav"))
  PlaySample(LoadSample("artillery_move_3.wav"))
  PlaySample(LoadSample("armouredtrain_move_3.wav"))

elseif eventname == "Rupprecht" then
			  PlaySample(LoadSample("military2.wav"))

elseif eventname == "Bergmann" then
			  PlaySample(LoadSample("military2.wav"))			  
	
elseif eventname == "Redeploy" then
					  PlaySample(LoadSample("heart.wav"))

elseif eventname == "BringHindenburg" then
					  PlaySample(LoadSample("heart.wav"))	
					  
elseif eventname == "DardanellesClosed" then
					  PlaySample(LoadSample("heart.wav"))	
					  			  
elseif eventname == "SevastopolShelling" then
					  PlaySample(LoadSample("dreadnought_attack_3.wav"))
					  
elseif eventname == "SenussiEnd" then
					  PlaySample(LoadSample("garrison_attack_3.wav"))					  
					  
elseif eventname == "BoloPasha" then
					  PlaySample(LoadSample("piano.wav"))
					  
elseif eventname == "GrafSpeeRaider" then
					  PlaySample(LoadSample("Radio.wav"))	

elseif eventname == "SerbsinAustria" then
					  PlaySample(LoadSample("military2.wav"))						  
					  
elseif eventname == "Ersatz" then
					  PlaySample(LoadSample("lab_construct.wav"))
					  
elseif eventname == "Jihad" then
					  PlaySample(LoadSample("muslim.wav"))
					  
elseif eventname == "Kitchener" then
					  PlaySample(LoadSample("dramaticclap.wav"))
					  
elseif eventname == "ShipsSunk" then
					  PlaySample(LoadSample("uneasy.wav"))
					  
elseif eventname == "PolivanovDismissed" then
					  PlaySample(LoadSample("ghost2.wav"))
					  
elseif eventname == "Rasputin" then
					  PlaySample(LoadSample("foreboding.wav"))
					  
elseif eventname == "GallipoliStraits" then
					  PlaySample(LoadSample("uneasy.wav"))

elseif eventname == "GallipoliCampaign" then
						PlaySample(LoadSample("drama1.wav"))

elseif eventname == "GallipoliCampaign2" then
						PlaySample(LoadSample("drama1.wav"))

					  
elseif eventname == "Senussi" then
					  PlaySample(LoadSample("uprising.wav"))
					  
elseif eventname == "ArmenianUprising" then
					  PlaySample(LoadSample("uprising.wav"))
					  
elseif eventname == "EasterRising" then
					  PlaySample(LoadSample("uprising.wav"))
					  
elseif eventname == "IndiaRevolt" then
					  PlaySample(LoadSample("uprising.wav"))
					  
elseif eventname == "Kriegsanleihetwo" then
					  PlaySample(LoadSample("coins.wav"))
					  
elseif eventname == "VenizelosMurder" then
					  PlaySample(LoadSample("piano2.wav"))
					  
elseif eventname == "PersianBorder" then
					  PlaySample(LoadSample("crickets.wav"))

elseif eventname == "LeninTrain" then
					  PlaySample(LoadSample("uneasy.wav"))
					  
elseif eventname == "GottStrafeEngland" then
					  PlaySample(LoadSample("submarine_move_1.wav"))
					  
elseif eventname == "GottStrafeEngland2" then
					  PlaySample(LoadSample("zeppelin_move_2.wav"))
					  
elseif eventname == "UnrestrictedSubwarfare" then
					  PlaySample(LoadSample("submarine_attack_1.wav"))

elseif eventname == "RussoJapWar" then
					  PlaySample(LoadSample("evilhorns.wav"))
					  
elseif eventname == "BritishGuarantee" then
					  PlaySample(LoadSample("heart.wav"))

elseif eventname == "KaiserFury" then
					  PlaySample(LoadSample("desaster.wav"))	
					  
elseif eventname == "BorderWar" then
					  PlaySample(LoadSample("desaster.wav"))					  

elseif eventname == "AustralianNewZealandCorps" then
					  PlaySample(LoadSample("popupcommander.wav"))					  

elseif eventname == "Taxis" then
					  PlaySample(LoadSample("repair4.wav"))

elseif eventname == "Gallieni" then
					  PlaySample(LoadSample("drumroll.wav"))
					  
elseif eventname == "AlbertFlee" then
					  PlaySample(LoadSample("drumroll.wav"))
					  
elseif eventname == "Doodendraad" then
					  PlaySample(LoadSample("pianodark.wav"))
					  
elseif eventname == "BlockadeFormed" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "Evert" then
					  PlaySample(LoadSample("popupcommander.wav"))

elseif eventname == "Brussilow" then
					  PlaySample(LoadSample("popupcommander.wav"))

elseif eventname == "Kerenski" then
					  PlaySample(LoadSample("popupcommander.wav"))

elseif eventname == "Enver" then
					  PlaySample(LoadSample("popupcommander.wav"))					  

elseif eventname == "RomaniaKing" then
					  PlaySample(LoadSample("reverb.wav"))
					  
elseif eventname == "RussiaSurprise" then
					  PlaySample(LoadSample("evilhorns.wav"))
elseif eventname == "DutchCrisis1" then
					  PlaySample(LoadSample("heart.wav"))
					  
elseif eventname == "Entscience" then
					  PlaySample(LoadSample("lab_construct.wav"))
					  
elseif eventname == "CPscience" then
					  PlaySample(LoadSample("lab_construct.wav"))
					  
elseif eventname == "PalsBattalions" then
					  PlaySample(LoadSample("popupcommander.wav"))
					  
elseif eventname == "Spy3" then
					  PlaySample(LoadSample("Radio.wav"))
					  
elseif eventname == "Spy2" then
					  PlaySample(LoadSample("interference2.wav"))

elseif eventname == "SalonikaDonation" then
					  PlaySample(LoadSample("piano2.wav"))
					  
elseif eventname == "WarPropagandaTwo" then
					  PlaySample(LoadSample("ominous.wav"))
					  
elseif eventname == "PersianBorderEnt" then
					  PlaySample(LoadSample("crickets.wav"))

elseif eventname == "ArabianRevolt" then
					  PlaySample(LoadSample("muslim.wav"))
					  
					  					  
elseif eventname == "BritishConscription" then
					  PlaySample(LoadSample("popupcommander.wav"))
					  
elseif eventname == "ColmarDeath" then
					  PlaySample(LoadSample("reverb.wav"))

					  elseif eventname == "" then
					  PlaySample(LoadSample(".wav"))
					  
elseif eventname == "DutchCrisis2" then
					  PlaySample(LoadSample("piano2.wav"))
					  
elseif eventname == ("ItalyCharge") then
					  PlaySample(LoadSample("charge11.wav"))
						PlaySample(LoadSample("infantry_attack_11.wav"))

elseif eventname == ("ItalyChargeEnt") then
					  PlaySample(LoadSample("charge11.wav"))
						PlaySample(LoadSample("infantry_attack_11.wav"))					  
					  
elseif eventname == "Lusitania" then
					  PlaySample(LoadSample("morse.wav"))

elseif eventname == "DOWbrazil" then
					  PlaySample(LoadSample("signature.wav"))
					  
elseif eventname == "Masaryk" then
					PlaySample(LoadSample("piano.wav"))
					  
elseif eventname == "Germanophobia" then
					  PlaySample(LoadSample("piano2.wav"))
					  
elseif eventname == "RussianDread" then
					  PlaySample(LoadSample("port4.wav"))
					  
elseif eventname == "RailroadSabotage" then
					PlaySample(LoadSample("armouredtrain_attack_1.wav"))
					  
elseif eventname == "SevereBlockade" then
					  PlaySample(LoadSample("reverb.wav"))
					  
elseif eventname == "WarPropagandaRomania" then
					  PlaySample(LoadSample("drama1.wav"))
					  
elseif eventname == "DutchCrisis" then
					PlaySample(LoadSample("uneasy.wav"))
					  
elseif eventname == "LeninShot" then
					  PlaySample(LoadSample("piano.wav"))
					  
elseif eventname == "Zimmermanntelegram" then
					  PlaySample(LoadSample("Radio.wav"))

elseif eventname == "Clemenceau" then
					  PlaySample(LoadSample("heart.wav"))

elseif eventname == "Default" then
					  PlaySample(LoadSample("doom.wav"))

elseif eventname == "Lusitiania" then
					  PlaySample(LoadSample("fear.wav"))

elseif eventname == "BulgariaAttack" then
					  PlaySample(LoadSample("military2.wav"))					  
					  
elseif eventname == "U282" then
					  PlaySample(LoadSample("shock.wav"))

elseif eventname == "Misharvest" then
					  PlaySample(LoadSample("ominous.wav"))

elseif eventname == "Hunger" then
					  PlaySample(LoadSample("dramaticclap.wav"))

elseif eventname == "HungerWinter" then
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("fear.wav"))	
					  else
						PlaySample(LoadSample("hall.wav"))	
					  end

elseif eventname == "RussianPorts" then
					  PlaySample(LoadSample("iceberg.wav"))
					  
elseif eventname == "WarHorses" then
					  PlaySample(LoadSample("garrison_attack_3.wav"))					  

elseif eventname == "Wondering" then
					  PlaySample(LoadSample("clock.wav"))

elseif eventname == "ChristmasTruce" then
					  PlaySample(LoadSample("xmas.wav"))

elseif eventname == "Xmas" then
					  PlaySample(LoadSample("xmas.wav"))

elseif eventname == "TsarMurder" then
					  PlaySample(LoadSample("ghost.wav"))

elseif eventname == "BrestLitovTreaty" then
					  PlaySample(LoadSample("heart.wav"))

elseif eventname == "Lenin" then
					  PlaySample(LoadSample("inter.wav"))

elseif eventname == "SerbianTyphoid" then
					  PlaySample(LoadSample("doom.wav"))

elseif eventname == "SerbianTyphoidEnds" then
					  PlaySample(LoadSample("sadness.wav"))

elseif eventname == "GermanFleetRest" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "SpanishFlu" then
					  PlaySample(LoadSample("ominous.wav"))

elseif eventname == "GoebenRaid" then
					  PlaySample(LoadSample("artillery_attack_4.wav"))

elseif eventname == "AnconaRaid" then
					  PlaySample(LoadSample("artillery_attack_4.wav"))
					  
elseif eventname == "MacedoniaDonation" then
					  PlaySample(LoadSample("military2.wav"))					  

elseif eventname == "WilhelmshavenMutiny" then
					  PlaySample(LoadSample("inter.wav"))

elseif eventname == "KielMutiny" then
					  PlaySample(LoadSample("inter.wav"))

elseif eventname == "Rationing" then
					  PlaySample(LoadSample("piano2.wav"))
					  
elseif eventname == "VenizelistTriumvirate" then
					  PlaySample(LoadSample("fight.wav"))					  
					  
elseif eventname == "Swinton" then
					  PlaySample(LoadSample("hmm.wav"))	

elseif eventname == "TriesteDonation" then
					  PlaySample(LoadSample("popupcommander.wav"))	

elseif eventname == "TunisiaCeded" then
					  PlaySample(LoadSample("popupcommander.wav"))					  

elseif eventname == "Spy4" then
					  PlaySample(LoadSample("hmm.wav"))						  
					  
elseif eventname == "Bruchmuller" then
					  PlaySample(LoadSample("hmm.wav"))

elseif eventname == "Hutier" then
					  PlaySample(LoadSample("hmm.wav"))					  

elseif eventname == "Polivanov" then
					  PlaySample(LoadSample("hmm.wav"))	
					  
elseif eventname == "FranzJosef" then
					  PlaySample(LoadSample("ghost.wav"))

elseif eventname == "PotiorekFired" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "EgyptRevolt" then
					  PlaySample(LoadSample("uprising.wav"))

elseif eventname == "Kriegsanleihetwo" then
					  PlaySample(LoadSample("coins.wav"))

elseif eventname == "Kriegsanleihethree" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "Kriegsanleihefour" then
					  PlaySample(LoadSample("ominous.wav"))

elseif eventname == "WarWearFrance" then
					  PlaySample(LoadSample("bells.wav"))

elseif eventname == "WarWearBritain" then
					  PlaySample(LoadSample("bells.wav"))

elseif eventname == "WarWearGermany" then
					  PlaySample(LoadSample("bells.wav"))

elseif eventname == "WarWearAustria" then
					  PlaySample(LoadSample("bells.wav"))

elseif eventname == "WarWearItaly" then
					  PlaySample(LoadSample("bells.wav"))

elseif eventname == "DemonstrationFrance" then
					  PlaySample(LoadSample("demos.wav"))

elseif eventname == "DemonstrationBritain" then
					  PlaySample(LoadSample("demos.wav"))

elseif eventname == "DemonstrationGermany" then
					  PlaySample(LoadSample("demos.wav"))

elseif eventname == "DemonstrationAustria" then
					  PlaySample(LoadSample("demos.wav"))

elseif eventname == "DemonstrationItaly" then
					  PlaySample(LoadSample("demos.wav"))

elseif eventname == "DemonstrationRussia" then
					  PlaySample(LoadSample("demos.wav"))
					  
elseif eventname == "FranceDead" then
					  PlaySample(LoadSample("sadness.wav"))

elseif eventname == "BritainDead" then
					  PlaySample(LoadSample("sadness.wav"))
					  
elseif eventname == "GermanyDead" then
					  PlaySample(LoadSample("sadness.wav"))

elseif eventname == "AustriaDead" then
					  PlaySample(LoadSample("sadness.wav"))
					  
elseif eventname == "ItalyDead" then
					  PlaySample(LoadSample("sadness.wav"))

elseif eventname == "RussiaDead" then
					  PlaySample(LoadSample("sadness.wav"))
					  
elseif eventname == "GermanMinority" then
					  PlaySample(LoadSample("heart.wav"))

elseif eventname == "SerbiaMoral" then
					  PlaySample(LoadSample("Event.wav"))
					  
elseif eventname == "RasputinKilled" then
					  PlaySample(LoadSample("ghost2.wav"))

elseif eventname == "GallieniDismissed" then
					  PlaySample(LoadSample("reverb.wav"))
					  
elseif eventname == "MoltkeDeath" then
					  PlaySample(LoadSample("ghost2.wav"))
			  
elseif eventname == "Angels" then
					  PlaySample(LoadSample("shock.wav"))

elseif eventname == "GasAttack" then
					  PlaySample(LoadSample("gas.wav"))

elseif eventname == "Verdunhell" then
					  PlaySample(LoadSample("shock.wav"))
					  
elseif eventname == "ParisAttack" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "KaiserAbdicate" then
					  PlaySample(LoadSample("ghost.wav"))
					  
elseif eventname == "LanrezacDismissed" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "RussiaPrussia" then
					  PlaySample(LoadSample("uprising.wav"))
					  
elseif eventname == "GermanRefugees" then
					  PlaySample(LoadSample("Event.wav"))
					  

elseif eventname == "ArmyOrient" then
					  PlaySample(LoadSample("military.wav"))
					  
elseif eventname == "ArthurBopp" then
					  PlaySample(LoadSample("heart.wav"))
					  
elseif eventname == "Mud" then
					  PlaySample(LoadSample("lightning.wav"))

elseif eventname == "PigMurder" then
					  PlaySample(LoadSample("clock.wav"))

elseif eventname == "Samsonov" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "GasMasks" then
					  PlaySample(LoadSample("uneasy.wav"))						  

elseif eventname == "GasMasks2" then
					  PlaySample(LoadSample("strange.wav"))
					  
elseif eventname == "Mud2" then
					  PlaySample(LoadSample("lightning.wav"))
					  
elseif eventname == "Mud3" then
					  PlaySample(LoadSample("lightning.wav"))
					  
elseif eventname == "MisharvestEnd" then
					  PlaySample(LoadSample("clock.wav"))

elseif eventname == "MiningWar" then
					  PlaySample(LoadSample("bigboom.wav"))

					  
elseif eventname == "ShellShortage" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "NailMen" then
					  PlaySample(LoadSample("CPmoral.wav"))

elseif eventname == "Michel" then
					  PlaySample(LoadSample("clock.wav"))
					  
elseif eventname == "FrenchTrench" then
					  PlaySample(LoadSample("clock.wav"))

elseif eventname == "TurkBB" then
					  PlaySample(LoadSample("port4.wav"))

elseif eventname == "Kluck" then
					  PlaySample(LoadSample("desaster.wav"))
					  
elseif eventname == "KluckDismissed" then
					  PlaySample(LoadSample("reverb.wav"))
					  
elseif eventname == "HausenDismissed" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "BulowDismissed" then
					  PlaySample(LoadSample("reverb.wav"))
elseif eventname == "Zar" then
					  PlaySample(LoadSample("hall.wav"))
					  
elseif eventname == "KaiserVisit2" then
					  PlaySample(LoadSample("drumroll.wav"))

elseif eventname == "KaiserVisit" then
					  PlaySample(LoadSample("drumroll.wav"))

elseif eventname == "KingdomPoland" then
					  PlaySample(LoadSample("hall.wav"))
					  
elseif eventname == "Kaiser" then
					  PlaySample(LoadSample("triumph2.wav"))

elseif eventname == "BefTwo" then
					  PlaySample(LoadSample("infantry_move_1.wav"))
					  
elseif eventname == "ScottishWomen" then
					  PlaySample(LoadSample("Event.wav"))

elseif eventname == "BelgiumAbandoned" then
					  PlaySample(LoadSample("Event.wav"))					  

elseif eventname == "ItalyLeaves" then
					  PlaySample(LoadSample("clock.wav"))	

elseif eventname == "ItalySwing" then
					  PlaySample(LoadSample("clock.wav"))

elseif eventname == "VeraCruz" then
					  PlaySample(LoadSample("military.wav"))

elseif eventname == "Subsretreat" then
					  PlaySample(LoadSample("Naval.wav"))			

elseif eventname == "EmdenReturn" then
					  PlaySample(LoadSample("Naval.wav"))

elseif eventname == "MerchantSubmarine" then
					  PlaySample(LoadSample("Naval.wav"))
					  
elseif eventname == "Tirpitz" then
					  PlaySample(LoadSample("popupcommander.wav"))

elseif eventname == "NavalRaid" then
					  PlaySample(LoadSample("dramaticclap.wav"))			

elseif eventname == "RussiaMob" then
					  PlaySample(LoadSample("military.wav"))

elseif eventname == "RussiaAttack" then
					  PlaySample(LoadSample("repair9.wav"))

elseif eventname == "BalloonCorps" then
					  PlaySample(LoadSample("zeppelin_move_3.wav"))

elseif eventname == "Flight" then
					  PlaySample(LoadSample("bomber_move_1.wav"))				  
				 
elseif eventname == "ObsoleteWeapons" then
					  PlaySample(LoadSample("desaster.wav"))

elseif eventname == "UptoDateWeapons" then
					  PlaySample(LoadSample("new_pbem.wav"))


elseif eventname == "GreeceAbdication" then
					  PlaySample(LoadSample("piano2.wav"))

elseif eventname == "GreeceCoup" then
					  PlaySample(LoadSample("drumroll.wav"))					  
					  
elseif eventname == "RussiaSupplyCrisis" then
					  PlaySample(LoadSample("doom.wav"))			

elseif eventname == "Sarikamis" then
					  PlaySample(LoadSample("piano2.wav"))

elseif eventname == "SarikamisDefeat" then
					  PlaySample(LoadSample("metalhit.wav"))			

elseif eventname == "TurkeyDeserts" then
					  PlaySample(LoadSample("fight.wav"))

elseif eventname == "LuckyHit" then
					  PlaySample(LoadSample("bigboom.wav"))

elseif eventname == "SeaBlock" then
					  PlaySample(LoadSample("uneasy.wav"))			

elseif eventname == "Spithead" then
					  PlaySample(LoadSample("military2.wav"))

elseif eventname == "BoerRevolt" then
					  PlaySample(LoadSample("uprising.wav"))

elseif eventname == "Cochinchina" then
					  PlaySample(LoadSample("uprising.wav"))					  

elseif eventname == "Kamerun" then
					  PlaySample(LoadSample("uprising.wav"))		
					  
elseif eventname == "Cochinchina" then
					  PlaySample(LoadSample("uprising.wav"))

elseif eventname == "Samoa" then			
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("Event.wav"))	
					  else
						PlaySample(LoadSample("triumph.wav"))	
					  end						  

elseif eventname == "Coronel" then
					  PlaySample(LoadSample("armouredcruiser_attack_2.wav"))	

elseif eventname == "UltimatumSerbia3" then
					  PlaySample(LoadSample("foreboding.wav"))			

elseif eventname == "MesCampaign" then
					  PlaySample(LoadSample("military2.wav"))

elseif eventname == "TradingSub" then
					  PlaySample(LoadSample("Naval.wav"))

elseif eventname == "Trento3" then
					  PlaySample(LoadSample("dramaticclap.wav"))			

elseif eventname == "Wolf" then
					  PlaySample(LoadSample("wolf.wav"))

elseif eventname == "Ufo" then
					  PlaySample(LoadSample("ufo.wav"))			

elseif eventname == "MeatFactory" then
					  PlaySample(LoadSample("shock.wav"))

elseif eventname == "Crucified" then
					  PlaySample(LoadSample("ghost2.wav"))			

elseif eventname == "BritishCruisers" then
					  PlaySample(LoadSample("Naval.wav"))
					  
elseif eventname == "WomenWorkforceFrance" then
					  PlaySample(LoadSample("factory.wav"))

elseif eventname == "WomenWorkforceBritain" then
					  PlaySample(LoadSample("factory.wav"))			

elseif eventname == "WomenWorkforceGermany" then
					  PlaySample(LoadSample("factory.wav"))

elseif eventname == "WomenWorkforceAustria" then
					  PlaySample(LoadSample("factory.wav"))			

elseif eventname == "WomenWorkforceRussia" then
					  PlaySample(LoadSample("factory.wav"))

elseif eventname == "WomenWorkforceItaly" then
					  PlaySample(LoadSample("factory.wav"))			

elseif eventname == "WarPropaganda" then
					  PlaySample(LoadSample("foreboding.wav"))

elseif eventname == "USALanded" then
					  PlaySample(LoadSample("military.wav"))			

elseif eventname == "Kaiserschlacht" then
					  PlaySample(LoadSample("military.wav"))
					  
elseif eventname == "Kaiserschlacht1" then
					  PlaySample(LoadSample("assault.wav"))	
					  
elseif eventname == "Kaiserschlacht2" then
					  PlaySample(LoadSample("charge3.wav"))
					  
					  
elseif eventname == "Kaiserschlacht3" then
					  PlaySample(LoadSample("charge2.wav"))	
					  
elseif eventname == "KaiserschlachtEnds" then
	
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("sadness.wav"))	
					  else
						PlaySample(LoadSample("triumph2.wav"))	
					  end						  
					  
					  
elseif eventname == "VenizelosResign" then
					  PlaySample(LoadSample("heart.wav"))
					  
elseif eventname == "ParisEvac" then
					  PlaySample(LoadSample("desaster.wav"))					  

elseif eventname == "Skagerrak" then
					  PlaySample(LoadSample("triumph2.wav"))			
					  
elseif eventname == "Skagerraktwo" then
					  PlaySample(LoadSample("triumph2.wav"))

elseif eventname == "RFC" then
					  PlaySample(LoadSample("fighter_move_1.wav"))			

elseif eventname == "ReformsCanceled" then
					  PlaySample(LoadSample("heart.wav"))

elseif eventname == "Rennenkampf" then
					  PlaySample(LoadSample("heart.wav"))			
					  
elseif eventname == "RailroadTurkey" then
					  PlaySample(LoadSample("train_move_5.wav"))

elseif eventname == "KaiserTurkey" then
					  PlaySample(LoadSample("drumroll.wav"))

elseif eventname == "Pope" then
					  PlaySample(LoadSample("peace.wav"))			
	
elseif eventname == "ArabRevolt" then
					  PlaySample(LoadSample("uprising.wav"))

elseif eventname == "Attaque" then
					  PlaySample(LoadSample("charge6.wav"))
					  PlaySample(LoadSample("charge1.wav"))
					  
	
elseif eventname == "AthensBombarded" then
					  PlaySample(LoadSample("pre-dreadnought_attack_1.wav"))

elseif eventname == "AustrianSubs" then
					  PlaySample(LoadSample("Naval.wav"))			
	
elseif eventname == "Bef" then
					  PlaySample(LoadSample("port2.wav"))

elseif eventname == "BlockadeBroken" then
					  PlaySample(LoadSample("Naval.wav"))			
	
elseif eventname == "FebruaryRevolution" then
					  PlaySample(LoadSample("metalhit.wav"))

elseif eventname == "OctoberRevolution" then
					  PlaySample(LoadSample("peace.wav"))
					  PlaySample(LoadSample("uprising.wav"))						  
	
elseif eventname == "OnLesAura" then
					  PlaySample(LoadSample("charge5.wav"))
					  PlaySample(LoadSample("charge1.wav"))

elseif eventname == "Avalanche" then
					  PlaySample(LoadSample("avalanche.wav"))

elseif eventname == "NorthSeaBlockade" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "secret" then
			local luck = math.random(1,6)
			if luck == 1 then 
					PlaySample(LoadSample("strange.wav"))

			elseif luck == 2 then 
					PlaySample(LoadSample("heart.wav"))
					
			elseif luck == 3 then 
					PlaySample(LoadSample("reverb.wav"))
					
			elseif luck == 4 then 
					PlaySample(LoadSample("interference1.wav"))
			
			elseif luck == 5 then 
					PlaySample(LoadSample("interference2.wav"))	

			elseif luck == 6 then 
					PlaySample(LoadSample("clock.wav"))						
					
			end

	
elseif eventname == "DreadnoughtLost" then
					  PlaySample(LoadSample("iceberg.wav"))							  
	
elseif eventname == "Avalanche2" then
					  PlaySample(LoadSample("avalanche.wav"))

elseif eventname == "Avalanche3" then
					  PlaySample(LoadSample("avalanche.wav"))

elseif eventname == "BlockadeRunner" then
					  PlaySample(LoadSample("Naval.wav"))			
	
elseif eventname == "Dannunzio" then
					  PlaySample(LoadSample("foreboding.wav"))

elseif eventname == "Dannunzio2" then
					  PlaySample(LoadSample("fight.wav"))			
	
elseif eventname == "CrownPrince" then
					  PlaySample(LoadSample("popupcommander.wav"))
					  
elseif eventname == "EntHospitals" then
					  PlaySample(LoadSample("sadness.wav"))

elseif eventname == "CPHospitals" then
					  PlaySample(LoadSample("sadness.wav"))

elseif eventname == "VerdunOne" then
					  PlaySample(LoadSample("military.wav"))

elseif eventname == "VerdunTrigger" then
					  PlaySample(LoadSample("military2.wav"))

elseif eventname == "GermanColonies" then
					  PlaySample(LoadSample("military2.wav"))

elseif eventname == "AfricaWar" then
					  PlaySample(LoadSample("uprising.wav"))	
					  
elseif eventname == "AfricaWar2" then
					  PlaySample(LoadSample("uprising.wav"))	

elseif eventname == "AfricaWar3" then
					  PlaySample(LoadSample("uprising.wav"))						  
					  					  

elseif eventname == "Emden" then
					  PlaySample(LoadSample("lightcruiser_move.wav"))			

			
elseif eventname == "EmdenRaider" then
					  PlaySample(LoadSample("lightcruiser_attack_2.wav"))

elseif eventname == "FrenchMutiny" then
					  PlaySample(LoadSample("metalhit.wav"))			
	
elseif eventname == "FrenchColonies" then
					  PlaySample(LoadSample("uprising.wav"))
					  
elseif eventname == "Pipeline" then
					  PlaySample(LoadSample("repair1.wav"))					  

elseif eventname == "FritzHaber" then
					  PlaySample(LoadSample("lab_construct.wav"))			
	
elseif eventname == "GeneralGov" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "Room40" then
					  PlaySample(LoadSample("morse.wav"))

elseif eventname == "Subwarfare" then

					  PlaySample(LoadSample("submarine_attack_3.wav"))	
					  PlaySample(LoadSample("morse.wav"))	
					  
elseif eventname == "Subwarfare2" then
					  PlaySample(LoadSample("submarine_attack_2.wav"))	
					  PlaySample(LoadSample("Radio.wav"))						  

elseif eventname == "Torpedo" then
					  PlaySample(LoadSample("submarine_attack_1.wav"))	

elseif eventname == "AmmoBoom" then
					  PlaySample(LoadSample("bigboom.wav"))		

elseif eventname == "Falkenhayn2" then
					  PlaySample(LoadSample("uneasy.wav"))	
					  
elseif eventname == "Falkenhayn" then
					PlaySample(LoadSample("dramaticclap.wav"))	

elseif eventname == "Greece1" then
					PlaySample(LoadSample("armouredtrain_attack_1.wav"))	

elseif eventname == "BritishRaid" then
					PlaySample(LoadSample("metalhit.wav"))

elseif eventname == "BritishRaid2" then
					PlaySample(LoadSample("drama1.wav"))	

elseif eventname == "AthensBombarded" then
					PlaySample(LoadSample("pre-dreadnought_attack_1.wav"))	

elseif eventname == "MilanCaptured" then
	
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "IsmailiaCaptured" then
	
					  if playerAlliance.id == 1 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "LilleCaptured" then
	
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end

elseif eventname == "VeniceCaptured" then
	
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	


elseif eventname == "MetzCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("defeat.wav"))	
					  else
						PlaySample(LoadSample("triumph.wav"))	
					  end	

elseif eventname == "RuhrCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("defeat.wav"))	
					  else
						PlaySample(LoadSample("triumph2.wav"))	
					  end	

elseif eventname == "WilhelmshavenCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("defeat.wav"))	
					  else
						PlaySample(LoadSample("triumph2.wav"))	
					  end
					  
elseif eventname == "KielCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("defeat.wav"))	
					  else
						PlaySample(LoadSample("triumph2.wav"))	
					  end					  
					  

elseif eventname == "AntwerpCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "BrusselsCaptured" then
	
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  
					  
elseif eventname == "SarikamisCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "NisCaptured" then
	
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  

elseif eventname == "SkopjeCaptured" then
	
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  

elseif eventname == "AmsterdamCaptured" then
					  PlaySample(LoadSample("bells.wav"))						  

elseif eventname == "TrentoCeded" then
					  PlaySample(LoadSample("BigBell.wav"))

elseif eventname == "Trento3" then
					  PlaySample(LoadSample("desaster.wav"))					  
					  
elseif eventname == "GoebenArrives" then
					  PlaySample(LoadSample("triumph.wav"))			
	
elseif eventname == "GrafSpeeEscape" then
					  PlaySample(LoadSample("Naval.wav"))
					  
elseif eventname == "NorwayShips" then
					  PlaySample(LoadSample("Naval.wav"))					  

elseif eventname == "GrafSpeeReturn" then
					  PlaySample(LoadSample("triumph2.wav"))			
	
elseif eventname == "GrafSpeeSunk" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "GrafSpeeMerchant" then
					  PlaySample(LoadSample("armouredcruiser_attack_3.wav"))					  
					  
elseif eventname == "EmdenSunk" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "NavalRaidBattle" then
					  PlaySample(LoadSample("drama1.wav"))
					  PlaySample(LoadSample("armouredcruiser_attack_3.wav"))					  

elseif eventname == "CanadianCorps" then
					  PlaySample(LoadSample("military2.wav"))	

elseif eventname == "CoastalDefense" then
					  PlaySample(LoadSample("armouredcruiser_attack_3.wav"))					  

elseif eventname == "GrimmHoffmann" then
					  PlaySample(LoadSample("clock.wav"))			

elseif eventname == "MaxHoffmann" then
					  PlaySample(LoadSample("drumroll.wav"))						  

elseif eventname == "Groener" then
					  PlaySample(LoadSample("railsound.wav"))

elseif eventname == "Hentsch" then
					  PlaySample(LoadSample("heart.wav"))			
	
elseif eventname == "Hentsch2" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "RussianCode" then
					  PlaySample(LoadSample("morse.wav"))	

elseif eventname == "SarikamisCapture" then
					  PlaySample(LoadSample("triumph.wav"))

elseif eventname == "BrudermannDismissed" then
					  PlaySample(LoadSample("reverb.wav"))	

elseif eventname == "CedeTsingtao" then
					  PlaySample(LoadSample("reverb.wav"))						  
					  
elseif eventname == "AuffenbergDismissed" then
					  PlaySample(LoadSample("reverb.wav"))

elseif eventname == "Burstyn" then
					  PlaySample(LoadSample("armour_move_3.wav"))	

elseif eventname == "TankPrototype" then
					  PlaySample(LoadSample("armour_move_1.wav"))

elseif eventname == "MurmanConvoys" then
					  PlaySample(LoadSample("Naval.wav"))

elseif eventname == "SerbiaHelp" then
					  PlaySample(LoadSample("clock.wav"))						  

elseif eventname == "MurmanRailway" then
					  PlaySample(LoadSample("railsound.wav"))
					  
elseif eventname == "ConvoyAttacks1" then
					  PlaySample(LoadSample("desaster.wav"))	

elseif eventname == "ConvoyAttacks2" then
					  PlaySample(LoadSample("fear.wav"))
					  
elseif eventname == "NeutralSunk" then
					  PlaySample(LoadSample("submarine_attack_2.wav"))
					  PlaySample(LoadSample("morse.wav"))
					  
elseif eventname == "NeutralSunkCP" then
					PlaySample(LoadSample("submarine_attack_1.wav"))
					PlaySample(LoadSample("morse.wav"))					  

elseif eventname == "KuwaitRevolt" then
					  PlaySample(LoadSample("reverb.wav"))					  

					  
elseif eventname == "RussiaSupplyCrisisEnd" then
					  PlaySample(LoadSample("factory.wav"))

elseif eventname == "AbadanOccupy" then
					  PlaySample(LoadSample("military.wav"))						  
					  
elseif eventname == "TabrizOccupy" then
					  PlaySample(LoadSample("cavalry_attack_5.wav"))

elseif eventname == "PanchoVilla" then
					  PlaySample(LoadSample("smallgarrison_attack_1.wav"))					  

elseif eventname == "PrzemyslSiege" then
					  PlaySample(LoadSample("charge1.wav"))	
					  
elseif eventname == "VerdunDefended" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "AbadanCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					  
elseif eventname == "TiflisCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  

elseif eventname == "TranscaucasiaRevolt" then 
					  PlaySample(LoadSample("fight.wav"))	
					
elseif eventname == "RhineBridges" then 
					  PlaySample(LoadSample("railsound.wav"))	
					  
elseif eventname == "BridgeCompleted" then 
					  PlaySample(LoadSample("CPmoral.wav"))						  


elseif eventname == "KuwaitCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
					  
elseif eventname == "Tannenberg" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "ParisCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "DanzigCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					  
elseif eventname == "TriesteCaptured" then
					 local italy = game:GetFactionById(8)
						
					  if playerAlliance.id == 1 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					
									  

elseif eventname == "KoenigsbergCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
elseif eventname == "KievCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "MinskCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					  
					  
elseif eventname == "GallipoliCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end

elseif eventname == "PetrogradCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
elseif eventname == "MoscowCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "KrakowCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  
elseif eventname == "ViennaCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "BudapestCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "ConstantinopleCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "BaghdadCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end

elseif eventname == "JerusalemCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end

elseif eventname == "MedinaCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
elseif eventname == "BordeauxCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "BerlinCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "VerdunCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
elseif eventname == "AnzacBeachCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
elseif eventname == "SommeEnds" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end

elseif eventname == "OdessaCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
				  
				
elseif eventname == "PrzemyslCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					  
elseif eventname == "SommeEnds2" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					  
elseif eventname == "BasraCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  
					  
					  
elseif eventname == "Scandal" then
					PlaySample(LoadSample("piano.wav"))	
					
elseif eventname == "Hentsch" then
					PlaySample(LoadSample("heart.wav"))						

elseif eventname == "Hentsch2" then
					PlaySample(LoadSample("drumroll.wav"))	
					  						  					  
					  
elseif eventname == "SuezBlock" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("doom.wav"))	
					  end
					  
elseif eventname == "SofiaCaptured" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
elseif eventname == "BucharestCaptured" then
			 local romania = game:GetFactionById(18)

					  if playerAlliance.id == 2 and romania.alliance.id == 1  then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
elseif eventname == "BattleKomarow" then
			
					  if playerAlliance.id == 2   then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
elseif eventname == "BattleKrasnik" then
			
					  if playerAlliance.id == 2   then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "AustriaInvasion" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
elseif eventname == "TiranaCaptured" then
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "BelgradeCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  
					  
elseif eventname == "LondonCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
					  
elseif eventname == "WarsawCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph2.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "KovnoCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "BelfortCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  

elseif eventname == "BrestLitovskCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "NovoGeorgievskCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "OssowitzCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  

					  
					  
elseif eventname == "ToulCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "LiegeCaptured" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	

elseif eventname == "BelgiumAttacked2" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("military.wav"))	
					  else
						PlaySample(LoadSample("repair3.wav"))	
						PlaySample(LoadSample("reverb.wav"))	
					  end	

elseif eventname == "PlanXVII" then
					  if playerAlliance.id == 2 then
					  PlaySample(LoadSample("charge11.wav"))	
					  else
						PlaySample(LoadSample("metalhit.wav"))	
					  end							  
					  
					  
elseif eventname == "RigaCaptured" then
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end
					  
elseif eventname == "LotzenCaptured" then
					  if playerAlliance.id == 1 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  
					  
elseif eventname == "WilnaCaptured" then
					  if playerAlliance.id == 2 then
						PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  

elseif eventname == "Moltke" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end	
					  
elseif eventname == "MoltkeEast" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  

elseif eventname == "OffensiveEnds" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end					  
					  
elseif eventname == "Stalemate" then
					  PlaySample(LoadSample("uneasy.wav"))	
					  
elseif eventname == "FranceDefended" then
					  if playerAlliance.id == 1 then
					  PlaySample(LoadSample("triumph.wav"))	
					  else
						PlaySample(LoadSample("defeat.wav"))	
					  end						  
elseif eventname == "Gorlice" then
					  PlaySample(LoadSample("military2.wav"))

elseif eventname == "BigPush" then
					  PlaySample(LoadSample("military.wav"))

elseif eventname == "Somme" then
					  PlaySample(LoadSample("military2.wav"))					  

elseif eventname == "Somme" then
					  PlaySample(LoadSample("military2.wav"))	
					  
elseif eventname == "TsarCommand" then
					  PlaySample(LoadSample("popupcommander.wav"))	
					  
elseif eventname == "RoupelDonation" then
					  PlaySample(LoadSample("popupcommander.wav"))
					  
elseif eventname == "NavalRaidSuccess" then
					  PlaySample(LoadSample("triumph.wav"))	

elseif eventname == "Fokker" then
					  PlaySample(LoadSample("fighter_attack_2.wav"))

elseif eventname == "ReformsSuccess" then
					  PlaySample(LoadSample("triumph.wav"))	
					  
elseif eventname == "JapanWar" then
					  PlaySample(LoadSample("popupcommander.wav"))
					  
elseif eventname == "ForeignLegion" then
					  PlaySample(LoadSample("popupcommander.wav"))					  

elseif eventname == "Cossacks" then
					  PlaySample(LoadSample("popupcommander.wav"))							  

elseif eventname == "ReformsFailed" then
					  PlaySample(LoadSample("doom.wav"))
					  
elseif eventname == "Verdunfort" then
					  PlaySample(LoadSample("doom.wav"))					  

elseif eventname == "UncleSam" then
					  PlaySample(LoadSample("drumroll.wav"))	
elseif eventname == "USAWhitePeace" then
					  PlaySample(LoadSample("bells.wav"))	

elseif eventname == "Surrenderserbia" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderaustria" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrendergermany" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderfrance" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderbritain" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderrussia" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderturkey" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderbelgium" then
					  PlaySample(LoadSample("surrender.wav"))	
					  
elseif eventname == "Surrendernetherlands" then
					  PlaySample(LoadSample("surrender.wav"))						  
					  
				  
elseif eventname == "Surrenderitaly" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderswitzerland" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderromania" then
					  PlaySample(LoadSample("surrender.wav"))	
				  
elseif eventname == "Surrenderbulgaria" then
					  PlaySample(LoadSample("surrender.wav"))

elseif eventname == "Surrendersweden" then
					  PlaySample(LoadSample("surrender.wav"))

elseif eventname == "Surrendergreece" then
					  PlaySample(LoadSample("surrender.wav"))	
					  
elseif (eventname == "SigintCP1" 
		or eventname == "SigintCP2"
		or eventname == "SigintCP3"
		or eventname == "SigintCP4") then
			local luck = math.random(1,5)
			if luck == 1 then 
					PlaySample(LoadSample("Radio.wav"))

			elseif luck == 2 then 
					PlaySample(LoadSample("morse.wav"))
					
			elseif luck == 3 then 
					PlaySample(LoadSample("rattler.wav"))
					
			elseif luck == 4 then 
					PlaySample(LoadSample("interference1.wav"))
			
			elseif luck == 5 then 
					PlaySample(LoadSample("interference2.wav"))			
					
			end
					
elseif (eventname == "SigintEnt1" 
		or eventname == "SigintEnt2"
		or eventname == "SigintEnt3"
		or eventname == "SigintEnt4") then
			local luck = math.random(1,5)
			if luck == 1 then 
					PlaySample(LoadSample("Radio.wav"))

			elseif luck == 2 then 
					PlaySample(LoadSample("morse.wav"))
					
			elseif luck == 3 then 
					PlaySample(LoadSample("rattler.wav"))
					
			elseif luck == 4 then 
					PlaySample(LoadSample("interference1.wav"))
			
			elseif luck == 5 then 
					PlaySample(LoadSample("interference2.wav"))			
					
			end			

					  
					  
					  

elseif eventname == "FrenchArmyOfAfrica" then
					  PlaySample(LoadSample("popupcommander.wav"))	

elseif eventname == "Passage" then
					  PlaySample(LoadSample("hall.wav"))

elseif eventname == "EssenStrike" then
					  PlaySample(LoadSample("hall.wav"))					  

elseif eventname == "GoebenBreslauEscape" then
					  PlaySample(LoadSample("pre-dreadnought_move_1.wav"))

elseif eventname == "GoebenAustria" then
					  PlaySample(LoadSample("Naval.wav"))

elseif eventname == "GoebenBreslau" then
					  PlaySample(LoadSample("Naval.wav"))

elseif eventname == "Masurian" then
					  PlaySample(LoadSample("military.wav"))	

elseif eventname == "UltimatumBelgium" then
					  PlaySample(LoadSample("dice.wav"))	

elseif eventname == "UltimatumBelgium2" then
					  PlaySample(LoadSample("evilhorns.wav"))						  

elseif eventname == "UltimatumSerbia" then
					  PlaySample(LoadSample("dice.wav"))	

elseif eventname == "UltimatumSerbia2" then
					  PlaySample(LoadSample("uneasy.wav"))	
					  
elseif eventname == "Bluff" then
					  PlaySample(LoadSample("dice.wav"))	

elseif eventname == "BritishFoodCrisis" then
					  PlaySample(LoadSample("pianodark.wav"))

elseif eventname == "NorthSeaClear" then
					  PlaySample(LoadSample("Naval.wav"))
					  
elseif eventname == "RaceSea" then
					  PlaySample(LoadSample("popupcommander.wav"))

elseif eventname == "RaceSeaStart" then
					  PlaySample(LoadSample("popupcommander.wav"))

elseif eventname == "RaceSeaB" then
					  PlaySample(LoadSample("popupcommander.wav"))					  
					  
elseif eventname == "NavalSupply" then
					  PlaySample(LoadSample("reverb.wav"))	

elseif eventname == "Phosgene" then
					  PlaySample(LoadSample("strange.wav"))				

elseif eventname == "Mustard" then
					  PlaySample(LoadSample("strange.wav"))	

elseif eventname == "Khalil" then
					  PlaySample(LoadSample("sadness.wav"))	
					  
elseif eventname == "Yser" then
					  PlaySample(LoadSample("infantry_attack_5.wav"))						  

elseif eventname == "KornilovAffair" then
					  PlaySample(LoadSample("reverb.wav"))	

elseif eventname == "Outrance" then
					  PlaySample(LoadSample("military2.wav"))
					  PlaySample(LoadSample("charge7.wav"))


elseif eventname == "KornilovAffair2" then
					  PlaySample(LoadSample("reverb.wav"))	

elseif eventname == "Hotzendorf" then
					  PlaySample(LoadSample("drama1.wav"))	
					  
elseif eventname == "Hotzendorf2" then
					  PlaySample(LoadSample("drama1.wav"))						  

elseif eventname == "DOWaustria" then
					  PlaySample(LoadSample("intro.wav"))	
					  
elseif eventname == "Entmoral" 
or eventname == "Entmoral2" 
or eventname == "Entmoral3"
or eventname == "Entmoral4"
or eventname == "Entmoral5" then
				  PlaySample(LoadSample("tipperary.wav"))	
					  
elseif eventname == "Cpmoral" 
or eventname == "Cpmoral2" 
or eventname == "Cpmoral3"
or eventname == "Cpmoral4"
or eventname == "Cpmoral5" then
				  PlaySample(LoadSample("siegerkranz.wav"))	
	
elseif eventname == "DOWgermany" 
or eventname == "DOWfrance" 
or eventname == "DOWbritain"
or eventname == "DOWrussia"
or eventname == "DOWturkey" 
or eventname == "DOWitaly"
or eventname == "DOWswitzerland"
or eventname == "DOWsweden"
or eventname == "DOWromania"
or eventname == "DOWpersia"
or eventname == "DOWbulgaria"
or eventname == "DOWusa"
or eventname == "DOWgreece"
or eventname == "DOWdenmark"
or eventname == "DOWnorway"
or eventname == "SwitzerlandAttacked1"
or eventname == "SwitzerlandAttacked2"
or eventname == "DOWnetherlands"
or eventname == "DOWbelgium"



							then
				  PlaySample(LoadSample("popupcommander.wav"))	

	
	end
	
end


 


function NewsEvent:Refresh(id)

  local p = playerAlliance.id

--~   print("here " .. self.newsData[1].total)
--~   print("here " .. self.newsData[2].total)
  if self.newsData[p].total == 0 then
    return false
  end

  self.id = id

  local popImage = self.newsData[p].image[id]
  local popText = self.newsData[p].text[id]
  if popImage == nil or not engine:FileExists("graphics/hud/events", popImage) then
    popImage = "event_secret.png"
  end

  self.title:SetLocalText(popText .. "_title")
  self.text:SetLocalText(popText .. "_descr")

  self.image:SetImage("graphics/hud/events", popImage)

local paptext = self.newsData[p].text[id] 
paptext = string.gsub(paptext, "event_", "" ) 
LogUi(paptext)  
PlayEffect(paptext)	

  
  -- Hide/Show next button
  if self.id + 1 == self.newsData[p].total then
--~     self.next:Hide()
--~     self.nextButton:Hide()
--~   else
--~     self.next:Show()
--~     self.nextButton:Show()
    self.lastEvent = true
  else
    self.lastEvent = false
  end
	
  -- Hide/Show previous button
--~   if self.id == 0 then
--~     self.previous:Hide()
--~     self.previousButton:Hide()
--~   else
--~     self.previous:Show()
--~     self.previousButton:Show()
--~   end

  -- Focus camera on event hex
  if self.newsData[p].hex[id] ~= nil then
    LookAtWrapper(game:GetHex(self.newsData[p].hex[id]))
  end
	
  self:Show()

end

function NewsEvent:AddEvent(popText, popImage, hex, alliance)
  if alliance ~= nil then
    targetAllianceId = alliance.id
  else
    -- for both
    targetAllianceId = 0
  end


  for alliance in game.alliances do
    if alliance.id ~= 0 and (alliance.id == targetAllianceId or targetAllianceId == 0) then
      self.newsData[alliance.id].text[self.newsData[alliance.id].total] = popText
      self.newsData[alliance.id].image[self.newsData[alliance.id].total] = popImage
      if hex ~= nil then
        self.newsData[alliance.id].hex[self.newsData[alliance.id].total] = hex.id
      else
        self.newsData[alliance.id].hex[self.newsData[alliance.id].total] = nil
      end

      self.newsData[alliance.id].total = self.newsData[alliance.id].total + 1
--~       print("added event for " .. alliance.id .. " " .. self.newsData[alliance.id].total)

      if game.currentAlliance.id == playerAlliance.id and not ui.disableControls then
        self:Refresh(0)
      end
    end
  end
end

function NewsEvent:Clear()
  self.newsData[playerAlliance.id].total = 0
  self:Hide()
--~   print("cleared events for " .. playerAlliance.id)
end


------------------------------------------------------------

  --  PopupFinal("victory_type_" .. stars, "event_defeat", "defeat_"  .. playerAlliance.id .. "_text")

-- Victory/Defeat popup
function PopupFinal(popTitle, popImage, popText)
	

  eventPanel =
  {
    name = "event_panel",
    position = {(engine.window.width)/2-275, (engine.window.height-200)/2-290},
    image = "eventbg",

    controls =
    {
    {
      name = "eventName_text",
      type = "text",
      font = "impact18_font",
      position = {275, 32},
      color   = {67, 56, 47},
      shadow = {offset = {0, 0}},
      text = "final_event",
      align = "center"
    },
    {
      name = "eventTitle_text",
      type = "text",
      font = "impact36_font",
      position = {275, 70},
      color   = {67, 56, 47},
      shadow = {offset = {0, 0}},
      text = popTitle,
      align = "center"
    },
    {
      name = "event_image",
      type = "image",
      image = popImage,
      position = {41, 112},
    },
    {
	  name = "eventDescr_memo",
      type = "memo",
      position = {37, 428},
      font = "times12_font",
      color   = {67, 56, 47},
      text = popText,
	  align = "right",
      border = 0
    },
	
	
--~     {
--~       name = "eventBack_button",
--~       type = "button",
--~       image = "x",
--~       position = {489, 22},
--~       sfx = "paper_event",
--~       on_click = function(button)
--~         if not x == nil or not y == nil then
--~           hex = GetHex(x, y)
--~           LookAtWrapper(hex)
--~         end
--~         button.parent:Hide()
--~       end
--~     },

      {
        type = "label",
        font = "times14_font",
        position = {275, 553},
        shadow = {offset = {0, 0}},
        align = "center",
        normal   = {67, 56, 47},
        hilight  = {255, 255, 255},
        select   = {255, 255, 255},
        disabled = {224, 220, 218},
        text = "END GAME",
        sfx = "click",
        on_click = function(button)
			MusicPlayer():Stop()
			MusicPlayer():ClearPlayList() 
			StopAllSounds()
			IntroMusic()	
		
          if game.type == Game.TYPE_SINGLE then
            engine:SetScreen(screens.mainMenu)
          elseif game.type == Game.TYPE_PBEM then

            if not ui.MPturnEnded then
              -- Surrender game
              GetPlayer():Surrender()

              -- Block UI
              ui.MPturnEnded = true
              ui.mainPanel.blockingPanel:Popup("pbem")

              -- Upload turn
              GetPlayer():UploadTurn(function(error) UploadFailed(error) end)
            else
              replaystuff = nil
              engine:SetScreen(screens.multiplayerMenu)
            end

          end
          button.parent:Hide()
        end
      }
    }
  }

 -- PlaySample(sPopupEvent)

  hud:CreateWidget(eventPanel):Show()
end


------------------------------------------------------------

class 'UnitInfoPopup' (LuaPanel)

function UnitInfoPopup:__init()
  LuaPanel.__init(self, unit_info_popup_table)

  self.stats = self:AdoptWidget(UnitInfoPanel(-1, 10, 206))
  self.commanderStats = self:AdoptWidget(CommanderInfoPanel(10, 206))
end

function UnitInfoPopup:OnShow()
  --self:Refresh(unit)
end

function UnitInfoPopup:Refresh(unit, showCommander)

  -- If it's a transport, display its cargo
  if unit.cargo ~= nil then
    local carrier = unit
    for cargo in carrier.cargo.units do
      unit = cargo
      break
    end
  end

  local name = unit.prototype.name

  local class = name .. "_" .. unit.faction.alliance.id .. "_50.png"
  local flag = "flag_" .. unit.faction.name .. "_32.png"

  -- Change content
  self:GetImage("infoClass_image"):SetImage("graphics/units", class)
  self:GetImage("infoFlag_image"):SetImage("graphics/flags", flag)

  if showCommander == 1 then

    self:GetText("infoTitle_text"):SetLocalText("commander_" .. unit.commander.id)
    self:GetImage("infoUnit_image"):SetImage("graphics/commanders", "commander_" .. unit.commander.id .. "_info.png")
    --temp patch
    self:GetImage("infoUnit_image"):SetPosition(17, 18)

    self:GetButton("commander_button"):Hide()
    self:GetButton("unit_button"):Show()
    self.stats:Hide()
    self.commanderStats:Show()
    self.commanderStats:Refresh(unit.commander.id)

  else

    self:GetText("infoTitle_text"):SetLocalText(name)

    -- Default icons
    local factionName = unit.faction.name
    if not engine:FileExists("graphics/units", unit.prototype.name .. "_" .. factionName .. "_" .. unit.level .. "_info.png") then
      factionName = "default"
    end

    local image = unit.prototype.name .. "_" .. factionName .. "_" .. unit.level .. "_info.png"
    self:GetImage("infoUnit_image"):SetImage("graphics/units", image)
    self:GetImage("infoUnit_image"):SetPosition(10, 18)

    self:GetButton("unit_button"):Hide()
    if unit.commander == nil then
      self:GetButton("commander_button"):Hide()
    else
      self:GetButton("commander_button"):Show()
    end
    self.stats:Show()
    self.stats:Refresh(unit, false)
    self.commanderStats:Hide()
  end


  self:Show()
end

unit_info_popup_table =
{
  name = "info_panel",
  type = "panel",
  position = {engine.window.width / 2 - 312, (engine.window.height-200)/2-219},
  image = "unitinfo_stats",
  visible= false,

  controls =
  {
--~     {
--~       name = "infotab_image",
--~       type = "image",
--~       image = "infotab1",
--~       position = {10, 206},
--~       sfx = "click"
--~     },
    {
      name = "infoUnit_image",
      type = "image",
      position = {17, 18},
    },
    {
      name = "infoTitle_text",
      type = "text",
      font = "times18_font",
      position = {135, 179},
      color   = {67, 56, 47},
      align = "center"
    },
    {
      name = "infoClass_image",
      type = "image",
      position = {15, 167},
    },
    {
      name = "infoFlag_image",
      type = "image",
      position = {225, 167},
    },
    {
      name = "commander_button",
      type = "button",
      image = "button_default",
      position = {20, 383},
      text = "commander",
      sfx = "click",
      on_click = function(button)
        button.parent:Refresh(unit, 1)
      end
    },
    {
      name = "unit_button",
      type = "button",
      image = "button_default",
      position = {20, 383},
      text = "unit",
      sfx = "click",
      on_click = function(button)
        button.parent:Refresh(unit, 0)
      end
    },
    {
      name = "close_label",
      type = "button",
      image = "button_default",
      position = {145, 383},
      text = "close",
      sfx = "click",
      on_click = function(button)
        button.parent:Hide()
      end
    },
  }
}

---------------------------------------------------


class 'TerrainInfoPopup' (LuaPanel)

function TerrainInfoPopup:__init()
  LuaPanel.__init(self, terrain_info_popup_table)

  self.information = self:AddWidget({type = "panel"})
  self.information:SetPosition(10, 206)
  self.information.content = self.information:AddWidget({
    type = "memo",
    position = {12, 42},
    size = {220, 120},
    font = "times12_font",
    color   = {224, 220, 218},
    text = "normal",
    border = 0,
    OnScroll = function(button, delta)
      if delta == 1 then
        if self.information.content.startingLine > 0 then
          self.information.content.startingLine = self.information.content.startingLine - 1
          self.information.pagebar:SetPosition(235, 63 + (80 * self.information.content.startingLine / self.information.pageCount) )
        end
      else
        if self.information.content.startingLine < self.information.content.numLines - 8 then
          self.information.content.startingLine = self.information.content.startingLine + 1
          self.information.pagebar:SetPosition(235, 63 + (80 * self.information.content.startingLine / self.information.pageCount) )
        end
      end
    end
  })
  self.information.content.maxLines = 8

  self.information:AddWidget({
    type = "button",
    image = "scroll_up",
    position = {230, 43},
    sfx = "click",
    on_click = function(button)
      if self.information.content.startingLine > 0 then
        self.information.content.startingLine = self.information.content.startingLine - 1
        self.information.pagebar:SetPosition(235, 63 + (80 * self.information.content.startingLine / self.information.pageCount) )
      end
    end
  })
  self.information:AddWidget({
    type = "button",
    image = "scroll_down",
    position = {230, 148},
    sfx = "click",
    on_click = function(button)
      if self.information.content.startingLine < self.information.content.numLines - 8 then
        self.information.content.startingLine = self.information.content.startingLine + 1
        self.information.pagebar:SetPosition(235, 63 + (80 * self.information.content.startingLine / self.information.pageCount) )
      end
    end
  })
  self.information:Hide()

  self.information.pagebar = self.information:AddWidget({
    type = "image",
    image = "pagebar_dark",
    position = {235, 63},
  })

  self.stats = self:AddWidget({ type = "panel" })
  self.stats:SetPosition(35, 249)
  self.stats:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {0, 0},
    color   = {244, 238, 231},
    align = "left",
    text = "combat_effects",
  })
  self.stats:AddWidget({
    type = "text",
    font = "hud12_font",
    position = {0, 52},
    color   = {244, 238, 231},
    align = "left",
    text = "movement_costs",
  })
  self.stats:AddWidget({
    type = "image",
    position = {0, 15},
    image = "terrain_stats"
  })
  self.defense = self.stats:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {111, 29},
    color = {67, 56, 47},
    align = "center",
    text = "10"
  })
  self.attack = self.stats:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {30, 29},
    color = {67, 56, 47},
    align = "center",
    text = "10"
  })
  self.entrenchment = self.stats:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {192, 29},
    color = {67, 56, 47},
    align = "center",
    text = "10"
  })

  self.stats:AddWidget({
    type = "image",
    position = {0, 15},
    image = "stat_attackerbonus",
    tooltip = "bonus_defender"
  })
  self.stats:AddWidget({
    type = "image",
    position = {81, 15},
    image = "stat_defenderbonus",
    tooltip = "bonus_attacker"
  })
  self.stats:AddWidget({
    type = "image",
    position = {162, 14},
    image = "stat_entrenchment",
    tooltip = "terrain_entrenchment_bonus"
  })

  self.moveCost = {}
  for i = 0, 4 do
    self.moveCost[i] = self.stats:AddWidget({
      type = "text",
      font = "hud14_font",
      position = {30 + (i % 3) * 81, 81 + math.floor(i / 3) * 34},
      color = {67, 56, 47},
      align = "center",
      text = "10"
    })
  end

  self.stats:AddWidget({
    type = "image",
    position = {0, 67},
    image = "stat_chassis_foot",
    tooltip = "mp_cost_foot"
  })
  self.stats:AddWidget({
    type = "image",
    position = {81, 67},
    image = "stat_chassis_mount",
    tooltip = "mp_cost_mount"
  })
  self.stats:AddWidget({
    type = "image",
    position = {162, 67},
    image = "stat_chassis_wheels",
    tooltip = "mp_cost_wheels"
  })
  self.stats:AddWidget({
    type = "image",
    position = {0, 101},
    image = "stat_chassis_tracks",
    tooltip = "mp_cost_tracks"
  })
  self.stats:AddWidget({
    type = "image",
    position = {81, 101},
    image = "stat_chassis_rail",
    tooltip = "mp_cost_rail"
  })

end

function TerrainInfoPopup:OnShow()
end

function TerrainInfoPopup:Refresh(hex)

  local descr = hex.terrain.name .. "_info"
  local nationality, owner
  if hex.terrain.type ~= Terrain.WATER then
    nationality = "flag_" .. hex.originalFaction.name .. "_32.png"
    owner = "flag_" .. hex.faction.name .. "_32.png"
    self:GetImage("infoNationality_image").tooltip = "terrain_nationality_" .. hex.originalFaction.name
    self:GetImage("infoOwner_image").tooltip = "terrain_owner_" .. hex.faction.name
  else
    nationality = "empty.png"
    owner = "empty.png"
  end

  if hex.construction == nil then
    self:GetImage("infoTerrain_image"):SetImage("graphics/terrain", "terrain_" .. hex.terrain.name .. "_info.png")
    self:GetText("infoTitle_text"):SetLocalText(hex.terrain.name)
    self.information.content:SetLocalText(hex.terrain.name .. "_info")
  else
    if hex.construction.type == Construction.TYPE_PORT then
      self:GetImage("infoTerrain_image"):SetImage("graphics/terrain", "terrain_port_info.png")
      self:GetText("infoTitle_text"):SetLocalText("port")
      self.information.content:SetLocalText("port_info")
    end
    if hex.construction.type == Construction.TYPE_FORTRESS then
      self:GetImage("infoTerrain_image"):SetImage("graphics/terrain", "terrain_fortress_info.png")
      self:GetText("infoTitle_text"):SetLocalText("fortress")
      self.information.content:SetLocalText("fortress_info")
    end
    if hex.construction.type == Construction.TYPE_CITY then
      self:GetImage("infoTerrain_image"):SetImage("graphics/terrain", "terrain_city_info.png")
      self:GetText("infoTitle_text"):SetLocalText("city")
      self.information.content:SetLocalText("city_info")
    end
    if hex.construction.type == Construction.TYPE_CAPITAL then
      self:GetImage("infoTerrain_image"):SetImage("graphics/terrain", "terrain_capital_info.png")
      self:GetText("infoTitle_text"):SetLocalText("capital")
      self.information.content:SetLocalText("capital_info")
    end
  end
  self.information.content.maxLines = 8
  self.information.pageCount = math.max(8, self.information.content.numLines)
  self.information.pagebar:SetSource(0, 0, 6, 80 * 8 / self.information.pageCount)

  self:GetImage("infoNationality_image"):SetImage("graphics/flags", nationality)
  self:GetImage("infoOwner_image"):SetImage("graphics/flags", owner)

  self.attack:SetNumber(hex.terrain.attack)
  self.defense:SetNumber(hex.terrain.defense)
  self.entrenchment:SetNumber(hex.terrain.entrench)

  for i = 0, 4 do
    if data.chassis[i+1].costs[hex.terrain.name] ~= nil then
      self.moveCost[i]:SetNumber(data.chassis[i+1].costs[hex.terrain.name])
    else
      self.moveCost[i]:SetText("/")
    end
    --self.moveCost[i].tooltip = "mp_cost_ " .. data.chassis[i+1].name
  end

  self:Show()
end

terrain_info_popup_table =
{
  name = "info_panel",
  type = "panel",
  position = {engine.window.width / 2 + 35, (engine.window.height-200)/2-219},
  image = "unitinfo_stats",
  visible= false,

  controls =
  {
    {
      name = "infoTerrain_image",
      type = "image",
      position = {17, 18},
    },
    {
      name = "infoTitle_text",
      type = "label",
      font = "times20_font",
      position = {135, 179},
      normal   = {250, 235, 216},
      hilight  = {250, 235, 216},
      select   = {250, 235, 216},
      disabled = {250, 235, 216},
      shadow = {offset = {1, 1}},
      text = "statistics",
      align = "center"
    },
    {
      name = "infoNationality_image",
      type = "image",
      position = {225, 167},
      tooltip = "terrain_nationality",
    },
    {
      name = "infoOwner_image",
      type = "image",
      position = {20, 167},
      tooltip = "terrain_owner",
    },
    {
      name = "close_label",
      type = "button",
      image = "button_default",
      position = {145, 383},
      text = "close",
      sfx = "click",
      on_click = function(button)
        button.parent:Hide()
      end
    },
    {
      name = "selected_tab",
      type = "image",
      position = {10, 206},
      image = "infotab1"
    },
    {
      type = "label",
      position = {71, 221},
      align = "center",
      font = "hud12_font",
      normal   = {224, 220, 218},
      hilight  = {255, 255, 255},
      select   = {255, 255, 255},
      disabled = {224, 220, 218},
      text = "statistics",
      sfx = "click",
      on_click = function(button)
        button.parent:GetImage("selected_tab"):SetImage("graphics/hud", "infotab1.png")
        button.parent.information:Hide()
        button.parent.stats:Show()
      end
    },
    {
      type = "label",
      position = {202, 221},
      align = "center",
      font = "hud12_font",
      normal   = {224, 220, 218},
      hilight  = {255, 255, 255},
      select   = {255, 255, 255},
      disabled = {224, 220, 218},
      text = "information",
      sfx = "click",
      on_click = function(button)
        button.parent:GetImage("selected_tab"):SetImage("graphics/hud", "infotab2.png")
        button.parent.information:Show()
        button.parent.stats:Hide()
      end
    },
  }
}


-----------------------------------------------------------


function PopupTab(popText, x, y)

  if x > 0 or y > 0 then
    local hex = GetHex(x, y)
    LookAtWrapper(hex)
  end

  tabPanel =
  {
    name = "event_panel",
    type = "panel",
    position = {256, 598},
    image = "tab_blocking",

    controls =
    {
      {
        name = "briefingDescr_memo",
        type = "memo",
        position = {20, 15},
        font = "times12_font",
        color   = {67, 56, 47},
        text = popText,
        border = 0
      },
      {
        name = "briefingBack_button",
        type = "button",
        image = "x",
        position = {450, 30},
        sfx = "click",
        on_click = function(button)
          button.parent:Hide()
        end
      },
    }
  }

  --hud:CreateWidget(tabPanel):Show()
end


function PopupDialog(popText, yes_func, no_func)

  dialogPanel =
  {
    name = "dialog_panel",
    type = "panel",
    position = {(engine.window.width)/2-240, (engine.window.height-200)/2-88},
    image = "dialog",

    controls =
    {
      {
        name = "dialogtext_text",
        type = "memo",
        --position = {243, 81},
        position = {50, 50},
        font = "times12_font",
        align = "center",
        color   = {67, 56, 47},
        size = {400, 95},
        border = 0,
        text = popText,
      },
      {
        name = "yes_label",
        type = "button",
        image = "button_default",
        position = {86, 141},
        font = "hud14_font",
        text = "yes",
        sfx = "click",
        on_click = function(button)
          yes_func()
          button.parent:Hide()
        end
      },
      {
        name = "no_label",
        type = "button",
        image = "button_default",
        position = {286, 141},
        font = "hud14_font",
        text = "no",
        sfx = "click",
        on_click = function(button)
          if no_func ~= nil then
            no_func()
          end
          button.parent:Hide()
        end
      },
    }
  }

  hud:CreateWidget(dialogPanel):Show()
end


function PopupScorebox(popText)
LogUi("++++++++++++++++++++++++POPU MESSAGE START")
  dialogPanel =
  {
    name = "dialog_panel",
    type = "panel",
    position = {(engine.window.width)/2-240, (engine.window.height+540)/2-88},
    image = "dialog",

    controls =
    {
      {
        name = "dialogtext_text",
        type = "memo",
        --position = {243, 81},
        position = {50, 50},
        font = "impact18_font",
        align = "center",
        color   = {67, 56, 47},
        size = {400, 95},
        border = 0,
        text = popText,
		align = "center"
      },

    }
  }

	
  hud:CreateWidget(dialogPanel):Show()
  LogUi("++++++++++++++++++++++++POPU MESSAGE END")
end








function PopupMessage(popText, faction, ok_func)
LogUi("++++++++++++++++++++++++POPU MESSAGE START")
  dialogPanel =
  {
    name = "dialog_panel",
    type = "panel",
    position = {(engine.window.width)/2-240, (engine.window.height-200)/2-88},
    image = "dialog",

    controls =
    {
      {
        name = "dialogtext_text",
        type = "memo",
        --position = {243, 81},
        position = {50, 50},
        font = "times12_font",
        align = "center",
        color   = {67, 56, 47},
        size = {400, 95},
        border = 0,
        text = popText,
		align = "center"
      },
      {
        name = "ok_label",
        type = "button",
        image = "button_default",
        position = {187, 141},
        font = "hud14_font",
        text = "ok",
        sfx = "click",
        on_click = function(button)
          if ok_func ~= nil then
            ok_func()
          end
          button.parent:Hide()
        end
      },
    }
  }
  local luck = math.random(1,10)
  if luck == 1 or luck == 2 then
local sfx = {}
    sfx = LoadSample("Radio.wav")
	PlaySample(sfx)
elseif luck == 3 then
    sfx = LoadSample("fone.wav")
	PlaySample(sfx)
elseif luck == 4 or luck == 5 then
	sfx = LoadSample("rattler.wav")
	PlaySample(sfx)

elseif luck == 6 or luck == 7 then
	sfx = LoadSample("typer.wav")
	PlaySample(sfx)
elseif luck == 8 then
	sfx = LoadSample("signature.wav")
	PlaySample(sfx)
	
else

    sfx = LoadSample("morse.wav")
	PlaySample(sfx)
	
end	
	
  hud:CreateWidget(dialogPanel):Show()
  LogUi("++++++++++++++++++++++++POPU MESSAGE END")
end
----new
function PopupChoice(faction, eventname)

  eventPanel =
  {
    name = "choice_panel",
    type = "panel",
    position = {(engine.window.width)/2-239, (engine.window.height-200)/2-98},
    image = "commanderevent",

    controls =
    {
      {
        name = "choiceName_text",
        type = "text",
        font = "impact18_font",
        position = {312, 38},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
		text = "choice_" .. eventname,       
	   align = "center"
      },
      {
        name = "choice_image",
        type = "image",
        image = "../hud/events/choice_" .. eventname,
        position = {15, 25},
      },
      {
        name = "choice_flag",
        type = "image",
         image = "../flags/flag_" .. faction.name .. "_32",
        position = {17, 161},
        tooltip = faction.name
      },
      {
        name = "choiceDescr_memo",
        type = "memo",
        position = {166, 55},
        font = "times12_font",
        color   = {67, 56, 47},
        text = "choice_" .. eventname .. "_info",
       
	   size = {300, 95},
        border = 0
      },
      {
        name = "deploy_label",
        type = "button",
        image = "button_default",
        position = {150, 159},
        font = "hud14_font",
        text = "OPTION#1",
        	--	tooltip = "wassmuss",

		sfx = "click",
        on_click = function(button)        
		-----------WASSMUSS------------
		if eventname == "Wassmuss" then
			local germany = game:GetFactionById(2)
			local britain = game:GetFactionById(1)
			germany.luaData.wassmuss = 1
        	SetEvent("Wassmuss", game.turn)	
				--	Discard("ArthurBopp")

		-------------GOEBEN---------------
		elseif eventname == "Goeben" then
				SetEvent("GoebenBreslauEscape", game.turn)

			local germany = game:GetFactionById(2)
			local france = game:GetFactionById(0)
			local aluck = math.random(0,8)
			local bluck = math.random(0,7)
				if game.turn == 1 then
					SpawnUnit(26, germany, 79 + aluck, 46 + bluck , 0, 100) 
					local hex = GetHex(79 + aluck, 46 + bluck)
							if hex.unit ~= nil then
								--UpdateUnit(hex.unit)
							end
					
				else
					SpawnUnit(26, germany, 79 + aluck, 46 + bluck, 0, 80) 
					PopupMessage("goebendamage")
					local hex = GetHex(79 + aluck, 46 + bluck)
							if hex.unit ~= nil then
								--UpdateUnit(hex.unit)
							end
				end
				
				  if GetEvent("FrenchArmyOfAfrica") >0 
					and GetEvent("FrenchArmyOfAfrica") +1 == game.turn 
					and GetEvent("GoebenBreslau") == 0 
					and GetEvent("DOWgermany") >0  then
					if luck == 3 then
					local hex = GetHex(77, 55)
					hex.unit:Damage(math.random(40,90))
					PopupMessage("goebenintercept")
					
					elseif luck == 2 then
						local hex = GetHex(77, 55)
						hex.unit:Damage(math.random(15,35))
						PopupMessage("goebenintercept2")
					end
				  
				  end
		---------------AH REFORMS-----------------
		elseif eventname == "Reforms" then
			local austria = game:GetFactionById(3)
			local factor = 5
			local luck = austria.luaData.reformchance
			if GetEvent("FourteenPoints") >0 then
				factor = 7
			end
			local austria = game:GetFactionById(3)
			if luck >=  (austria.luaData.collaps * factor) then
				SetEvent("Reforms", game.turn)
				SetEvent("ReformsSuccess", game.turn)
				ChangeFactionMorale(austria, ((austria.luaData.czechs + austria.luaData.collaps) *3))
				austria.luaData.collaps = math.floor(austria.luaData.collaps * 0.5)
				
				austria.luaData.czechs	= 0
				austria.luaData.croats	=  0	
				austria.luaData.hungarians = austria.luaData.hungarians + 3
			
			else
				if austria.luaData.collaps < 10 then
					austria.luaData.collaps = 10
				end
			
				austria.luaData.collaps = austria.luaData.collaps  + (math.floor((austria.luaData.czechs + austria.luaData.croats + austria.luaData.hungarians)/2))
				SetEvent("Reforms", game.turn)
				SetEvent("ReformsFailed", game.turn)
				SetEvent("WarWearAustria", game.turn)
				
			end
			
			
		elseif eventname == "AllEast" then
			local germany = game:GetFactionById(2)
			germany.luaData.eastchoice = 1
			 PopupMessage("You have chosen to conquer the Baltic region and Belarus.;You must take Vilna, Riga and Minks before onset of winter.;If you fail, Germany and Austria will suffer 1 collapse point each!")
			
		
		elseif eventname == "Tirpitz" then
			local germany = game:GetFactionById(2)
			germany.luaData.tirpitz = 1
			SetEvent("Tirpitz", game.turn)
			

			
		
		-------------<<<<<<<<<<----  other OPTION#1 choices go here --------------------

		
		-------------<<<<<<<<<<-------HERE START OPTION#2:
		ui.resourcesPanel:Refresh()
		ui.diplomacyPanel:Refresh()
		end     
		-------------------------		  
		button.parent:Hide()
		end
      },
      {
        name = "close_label",
        type = "button",
        image = "button_default",
        position = {359, 159},
        font = "hud14_font",
        text = "OPTION#2",
	   sfx = "click",
        on_click = function(button)
		------------WASSMUSS----------------------------		
		local germany = game:GetFactionById(2)
		local cp =  game:GetAllianceById(2)
		local persia = game:GetFactionById(22)
		if eventname == "Wassmuss" then
				local chance = germany.luaData.wassluck 
					--germany:ConsumeProductionPoints(germany.pp)   ---- instigate persian revolt
					
						if germany.luaData.orient <= chance then
							persia.luaData.alignment = 1
						else
							cp.luaData.influence[22] = cp.luaData.influence[22] + chance
						end
						SetEvent("PersianBorder", game.turn)
						Discard("ArthurBopp")
						ui.resourcesPanel:Refresh()
						ui.diplomacyPanel:Refresh()
		----------------GOEBEN---------------
		elseif eventname == "Goeben" then
				if game.currentAlliance.id == player.alliance.id and player.alliance.id == 2 then
				PopupMessage("German cruisers Goeben and Breslau en route to reinforce German EastAsia squadron. Royal Navy units in pursuit, diverted from North Sea.")
				end
				germany.luaData.pacific = 2
				Discard("Spithead")
				PutinCP("DardanellesClosed")

		
		elseif eventname == "Reforms" then
			local austria = game:GetFactionById(3)
			SetEvent("Reforms", game.turn)


			if GetEvent("FourteenPoints") == 0 then
				ChangeFactionMorale(austria, 10)
				austria.luaData.hungarians = 0
			elseif GetEvent("FourteenPoints") > 0 then
				ChangeFactionMorale(austria, 3)
			end
			
			SetEvent("ReformsCanceled", game.turn)
 		
		elseif eventname == "AllEast" then
			local germany = game:GetFactionById(2)
			germany.luaData.eastchoice = 2
			PopupMessage("You have chosen to conquer Poland. You must conquer Warsaw and Brest-Litovsk before onset of winter. If you fail, Germany and Austria will suffer 2 collapse points each!")

		
			-----------------<<<<<<<<<<<<<<----------------- other OPTION#2 choices go here
		
		elseif eventname == "Tirpitz" then
			local germany = game:GetFactionById(2)
			germany.luaData.tirpitz = 2
			SetEvent("Tirpitz", game.turn)
			germany:ConsumeProductionPoints(15)	
		
		end
		ui.resourcesPanel:Refresh()
		ui.diplomacyPanel:Refresh()
         ---------------------------------
		 button.parent:Hide()
        end
      },
    }
  }

  PlaySample(sPopupEvent)

  hud:CreateWidget(eventPanel):Show()
end
-----
function PopupCommander(faction, id, slot)

  eventPanel =
  {
    name = "commander_panel",
    type = "panel",
    position = {(engine.window.width)/2-239, (engine.window.height-200)/2-98},
    image = "commanderevent",

    controls =
    {
      {
        name = "commanderName_text",
        type = "text",
        font = "impact18_font",
        position = {312, 38},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "commander_" .. id,
        align = "center"
      },
      {
        name = "commander_image",
        type = "image",
        image = "../commanders/commander_" .. id,
        position = {15, 25},
      },
      {
        name = "commander_flag",
        type = "image",
         image = "../flags/flag_" .. faction.name .. "_32",
        position = {17, 161},
        tooltip = faction.name
      },
      {
        name = "commanderDescr_memo",
        type = "memo",
        position = {166, 55},
        font = "times12_font",
        color   = {67, 56, 47},
        text = "commander_" .. id .. "_info",
        size = {300, 95},
        border = 0
      },
      {
        name = "deploy_label",
        type = "button",
        image = "button_default",
        position = {150, 159},
        font = "hud14_font",
        text = "deploy",
        sfx = "click",
        on_click = function(button)
          ui.UIMode = ATTACH
          ui.cursormode:Show()

          ui.prodqueue.faction = faction
          ui.prodqueue.slot = id

          DisplayAttachZone(ui.prodqueue.slot)

          button.parent:Hide()
        end
      },
      {
        name = "close_label",
        type = "button",
        image = "button_default",
        position = {359, 159},
        font = "hud14_font",
        text = "continue",
        sfx = "click",
        on_click = function(button)
          button.parent:Hide()
        end
      },
    }
  }

  PlaySample(sPopupEvent)
  	sfx = LoadSample("popupcommander.wav")
		PlaySample(sfx)	

  hud:CreateWidget(eventPanel):Show()
end

-------------------------------------------------

class 'PopupAdvice' (LuaPanel)

function PopupAdvice:__init()
  LuaPanel.__init(self)

  self:SetPosition((engine.window.width)/2-319, 30)
  self:SetBackgroundImage("adviceDialogLarge")

  self.queue = {}

  self.markerImage = hud:AdoptWidget(PopupAdviceMarker())

  self.title = self:AddWidget({
    type = "text",
    font = "impact18_font",
    position = {388, 38},
    color   = {67, 56, 47},
    shadow = {offset = {0, 0}},
    align = "center"
  })
  self:AddWidget({
    type = "image",
    image = "advice",
    position = {19, 29},
  })
  self.text = self:AddWidget({
    type = "memo",
    position = {163, 55},
    size = {440, 90},
    font = "times12_font",
    color   = {67, 56, 47},
    border = 0
  })
  self:AddWidget({
    type = "button",
    image = "button_default",
    position = {22, 159},
    text = "continue",
    sfx = "click",
    on_click = function(button)
      table.remove(button.parent.queue, 1)
      if # button.parent.queue > 0 and settings.tutorial == 1 then
        button.parent:Display()
      else
        button.parent.queue = {}
        ui.disableControls = false
        ui.disableHUD = false
        button.parent.visible = false
        button.parent:Hide()
        button.parent.markerImage:Hide()
      end
    end
  })
  self:AddWidget({
    name = "adviceHide_label",
    font = "hud12_font",
    position = {185, 167},
    align = "left",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "adviceOff",
    sfx = "click",
    on_click = function(button)
      if settings.tutorial == 1 then
        settings.tutorial = 0
        button.parent:GetButton("adviceHide_checkbox_on"):Show()
        button.parent:GetButton("adviceHide_checkbox_off"):Hide()
      else
        settings.tutorial = 1
        button.parent:GetButton("adviceHide_checkbox_on"):Hide()
        button.parent:GetButton("adviceHide_checkbox_off"):Show()
      end
      SetUserInt("tutorial", settings.tutorial)
    end
  })
  self:AddWidget({
    name = "adviceHide_checkbox_off",
    type = "button",
    image = "bigcheck_off",
    position = {153, 161},
    sfx = "click",
    on_click = function(button)
      settings.tutorial = 0
      SetUserInt("tutorial", settings.tutorial)
      button.parent:GetButton("adviceHide_checkbox_on"):Show()
      button:Hide()
    end
  })
  self:AddWidget({
    name = "adviceHide_checkbox_on",
    type = "button",
    image = "bigcheck_on",
    position = {153, 161},
    sfx = "click",
    visible = false,
    on_click = function(button)
      settings.tutorial = 1
      SetUserInt("tutorial", settings.tutorial)
      button.parent:GetButton("adviceHide_checkbox_off"):Show()
      button:Hide()
    end
  }):Hide()

  self:Hide()

--~   local panelID = hud:CreateWidget(eventPanel)
--~   panelID:Show()
--~   panelID:GetButton("adviceHide_checkbox_on"):Hide()
end

function PopupAdvice:AddAdvice(advice, marker)

  table.insert(self.queue, {advice, marker})

  if not self.visible then
    self.visible = true
    self:Display()
  end
end

function PopupAdvice:AddAdviceForced(advice, marker)

  -- dont show same message twice
  if self.queue[1] ~= nil and self.queue[1][1] == advice then
    return
  end

  -- copy current queue
  local workingTable = utils.deepcopy(self.queue)

  -- clear queue
  self.queue = {}

  -- set new advice as first
  table.insert(self.queue, {advice, marker})

  -- add remaining advice to queue
  for _, v in pairs(workingTable) do
    table.insert(self.queue, v)
  end

  self.visible = true
  self:Display()

end

function PopupAdvice:CloseCurrent()

  table.remove(self.queue, 1)
  if self.queue[1] ~= nil and settings.tutorial == 1 then
    self:Display()
  else
    self.queue = {}
    ui.disableControls = false
    ui.disableHUD = false
    self.visible = false
    self:Hide()
    self.markerImage:Hide()
  end
end


function PopupAdvice:Display()
  PlaySample(sPopupEvent)

  self.title:SetLocalText("advice_"..self.queue[1][1].."_title")
  self.text:SetLocalText("advice_"..self.queue[1][1].."_text")
  self.marker = self.queue[1][2]

  if self.marker ~= nil then
    local image
    local x, y
    if self.marker[3] ~= nil then -- UI marker
      self.markerImage:SetBackgroundImage("marker_" .. self.marker[3])
      x = self.marker[1]
      y = self.marker[2]
      self.markerImage:SetPosition((engine.window.width-1024 - self.markerImage.width)/2 + x, engine.window.height - (self.markerImage.height / 2) - 768 + y)
      self.markerImage:Show()
    else -- map marker
      --self.markerImage:SetImage("graphics/hud", "marker_" .. self.marker[2] .. ".png")
      --x = self.marker[1].x
      --y = self.marker[1].y
      View:AddEffect(game:GetHex(self.marker[1]), "marker_unit")
    end
  else
    self.markerImage:Hide()
  end

  --ui.disableControls = true
  --ui.disableHUD = true

  self:Show()
end

class 'PopupAdviceMarker' (LuaPanel)

function PopupAdviceMarker:__init()
  LuaPanel.__init(self)

end



function PopupInfoDialog(popText, x, y)

  dialogPanel =
  {
    name = "dialog_panel",
    type = "panel",
    position = {(engine.window.width)/2-240, (engine.window.height-200)/2-88},
    image = "dialog",

    controls =
    {
      {
        name = "dialogtext_text",
        type = "text",
        position = {243, 81},
        font = "times12_font",
        align = "center",
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = popText,
      },
--~       {
--~         name = "goto_label",
--~         type = "button",
--~         image = "button_default",
--~         position = {86, 141},
--~         font = "hud14_font",
--~         text = "view",
--~         sfx = "click",
--~         on_click = function(button)
--~           if x ~= nil and y ~= nil then
--~             hex = GetHex(x, y)
--~             LookAtWrapper(hex)
--~             button.parent:Hide()
--~           end
--~         end
--~       },
      {
        name = "close_label",
        type = "button",
        image = "button_default",
        position = {286, 141},
        font = "hud14_font",
        text = "close",
        sfx = "click",
        on_click = function(button)
          button.parent:Hide()
        end
      },
    }
  }

 ui.messageQue:PushMessage(hud:AdoptWidget(EventPopup(dialogPanel, x, y)))
end



function PopupSurrender(faction)

  ui.disableControls = true

  eventPanel =
  {
    name = "surrender_panel",
    type = "panel",
    position = {(engine.window.width)/2-239, (engine.window.height-200)/2-98},
    image = "commanderevent",

    controls =
    {
      {
        name = "titel_text",
        type = "text",
        font = "impact18_font",
        position = {312, 38},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "Surrender Request",
        align = "center"
      },
      {
        name = "surrender_image",
        type = "image",
        image = "surrender_icon",
        position = {19, 29},
      },
      {
        name = "flag",
        type = "image",
        image = "../flags/flag_" .. faction.name .. "_32",
        position = {17, 161},
        tooltip = faction.name
      },
      {
        type = "memo",
        position = {166, 55},
        font = "times12_font",
        color   = {67, 56, 47},
        size = {300, 50},
        border = 0,
        text = "surrender_offer_" .. faction.name,
      },
      {
        type = "text",
        position = {166, 95},
        font = "times12_font",
        color   = {67, 56, 47},
        text = "accept_surrender",
      },
      {
        name = "refuse_button",
        type = "button",
        image = "button_default",
        position = {150, 159},
        font = "hud14_font",
        text = "refuse",
        sfx = "click",
        on_click = function(button)
          RefuseSurrender(faction)

          EndTurnProcess()

          button.parent:Hide()
        end
      },
      {
        name = "accept_button",
        type = "button",
        image = "button_default",
        position = {359, 159},
        font = "hud14_font",
        text = "accept",
        sfx = "click",
        on_click = function(button)
          FactionSurrender(faction)

          EndTurnProcess()

          button.parent:Hide()
        end
      },
    }
  }

  PlaySample(sPopupEvent)

  hud:CreateWidget(eventPanel):Show()
end


-------------------------------------------------

class 'PopupConvoy' (LuaPanel)

function PopupConvoy:__init()
  LuaPanel.__init(self)

  self:SetPosition((engine.window.width)/2-239, 30)
  self:SetBackgroundImage("adviceDialog")

  self:AddWidget({
    name = "titel_text",
    type = "text",
    font = "impact18_font",
    position = {312, 38},
    color   = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = "unmoved_convoys",
    align = "center"
  })
  self:AddWidget({
    name = "convoy_image",
    type = "image",
    image = "convoy_icon",
    position = {19, 29},
  })
  self.text = self:AddWidget({
    type = "memo",
    position = {166, 55},
    font = "times12_font",
    color   = {67, 56, 47},
    size = {300, 50},
    border = 0,
    text = "convoy_warning",
  })
  self.nextButton = self:AddWidget({
    name = "next_button",
    type = "button",
    image = "button_default",
    position = {22, 159},
    text = "next",
    tooltip = "goto_convoy",
    sfx = "click",
    on_click = function(button)
      button.parent:SelectNext()

      if button.parent.currentConvoy == nil then
        button.parent.text:SetLocalText("convoy_done")

        button:Hide()
      end
    end
  })
  self:AddWidget({
    name = "cancel_button",
    type = "button",
    image = "button_default",
    position = {210, 159},
    font = "hud14_font",
    text = "cancel",
    sfx = "click",
    on_click = function(button)
      button.parent:Hide()
    end
  })
  self:AddWidget({
    name = "continue_button",
    type = "button",
    image = "button_default",
    position = {359, 159},
    font = "hud14_font",
    text = "end_turn",
    sfx = "click",
    on_click = function(button)
      PreEndTurn("convoys")

      button.parent:Hide()
    end
  })

  self:Hide()

end

function PopupConvoy:OnShow()
  self.text:SetLocalText("convoy_warning")

  self:SelectNext()

  if # self.convoys == 1 then
    self.nextButton:Hide()
  else
    self.nextButton:Show()
  end

  PlaySample(sPopupEvent)

  if self.currentConvoy == nil then
    PreEndTurn("convoys")
    self:Hide()
  end
end

function PopupConvoy:UpdateList()

  self.convoys = {}
  for faction in playerAlliance.factions do
    for unit in faction.units do
      if unit.prototype.name == "convoy" then
        if unit.mp > 0 and unit.alive then
          table.insert(self.convoys, unit)
        end
      end
    end
  end

end

function PopupConvoy:SelectNext()

  self:UpdateList()

  local firstConvoy
  local currentReached = false
  local nextConvoy
  for _, convoy in pairs(self.convoys) do
    if firstConvoy == nil then
      firstConvoy = convoy
    end
    if self.currentConvoy == nil or currentReached then
      nextConvoy = convoy
      break
    else
      if convoy.id == self.currentConvoy.id then
        currentReached = true
      end
    end
  end

  -- If none was selected cos end of list was reached
  if nextConvoy == nil then
    self.currentConvoy = firstConvoy
  else
    self.currentConvoy = nextConvoy
  end

  -- Select the convoy & focus camera
  if self.currentConvoy ~= nil then
    ui.SelectHex(self.currentConvoy.hex)
    local hexY = self.currentConvoy.hex.y - 2
    if hexY < 0 then hexY = self.currentConvoy.hex.y + hexY end
    local hex = GetHex(self.currentConvoy.hex.x, hexY)
    LookAtWrapper(hex)
    print("convoy selected")
  end

end


-------------------------------------------------

class 'PopupResearch' (LuaPanel)

function PopupResearch:__init()
  LuaPanel.__init(self)

  self:SetPosition((engine.window.width)/2-239, 30)
  self:SetBackgroundImage("adviceDialog")

  self:AddWidget({
    name = "titel_text",
    type = "text",
    font = "impact18_font",
    position = {312, 38},
    color   = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = "unmoved_convoys",
    align = "center"
  })
  self:AddWidget({
    name = "convoy_image",
    type = "image",
    image = "convoy_icon",
    position = {19, 29},
  })
  self.text = self:AddWidget({
    type = "memo",
    position = {166, 55},
    font = "times12_font",
    color   = {67, 56, 47},
    size = {300, 50},
    border = 0,
    text = "convoy_warning",
  })
  self.nextButton = self:AddWidget({
    name = "next_button",
    type = "button",
    image = "button_default",
    position = {22, 159},
    text = "next",
    tooltip = "goto_convoy",
    sfx = "click",
    on_click = function(button)
      button.parent:SelectNext()

      if button.parent.currentConvoy == nil then
        button.parent.text:SetLocalText("convoy_done")

        button:Hide()
      end
    end
  })
  self:AddWidget({
    name = "cancel_button",
    type = "button",
    image = "button_default",
    position = {210, 159},
    font = "hud14_font",
    text = "cancel",
    sfx = "click",
    on_click = function(button)
      button.parent:Hide()
    end
  })
  self:AddWidget({
    name = "continue_button",
    type = "button",
    image = "button_default",
    position = {359, 159},
    font = "hud14_font",
    text = "end_turn",
    sfx = "click",
    on_click = function(button)
      PreEndTurn("convoys")

      button.parent:Hide()
    end
  })

  self:Hide()

end

function PopupResearch:OnShow()
  self.text:SetLocalText("convoy_warning")

  self:SelectNext()

  if # self.convoys == 1 then
    self.nextButton:Hide()
  else
    self.nextButton:Show()
  end

  PlaySample(sPopupEvent)

  if self.currentConvoy == nil then
    PreEndTurn("convoys")
    self:Hide()
  end
end


-------------------------------------------------

class 'PopupTransport' (LuaPanel)

function PopupTransport:__init()
  LuaPanel.__init(self)

  self:SetPosition((engine.window.width)/2-239, 30)
  self:SetBackgroundImage("adviceDialog")

  self:AddWidget({
    name = "titel_text",
    type = "text",
    font = "impact18_font",
    position = {312, 38},
    color   = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = "unmoved_transports",
    align = "center"
  })
  self:AddWidget({
    name = "convoy_image",
    type = "image",
    image = "convoy_icon",
    position = {19, 29},
  })
  self.text = self:AddWidget({
    type = "memo",
    position = {166, 55},
    font = "times12_font",
    color   = {67, 56, 47},
    size = {300, 50},
    border = 0,
    text = "transport_warning",
  })
  self.nextButton = self:AddWidget({
    name = "next_button",
    type = "button",
    image = "button_default",
    position = {22, 159},
    text = "next",
    tooltip = "goto_transport",
    sfx = "click",
    on_click = function(button)
      button.parent:SelectNext()

      if button.parent.currentTransport == nil then
        button.parent.text:SetLocalText("transport_done")

        button:Hide()
      end
    end
  })
  self:AddWidget({
    name = "cancel_button",
    type = "button",
    image = "button_default",
    position = {210, 159},
    font = "hud14_font",
    text = "cancel",
    sfx = "click",
    on_click = function(button)
      button.parent:Hide()
    end
  })
  self:AddWidget({
    name = "continue_button",
    type = "button",
    image = "button_default",
    position = {359, 159},
    font = "hud14_font",
    text = "end_turn",
    sfx = "click",
    on_click = function(button)
      PreEndTurn("transports")

      button.parent:Hide()
    end
  })

  self:Hide()

end

function PopupTransport:OnShow()
  self.text:SetLocalText("transport_warning")

  self:SelectNext()

  if # self.transports == 1 then
    self.nextButton:Hide()
  else
    self.nextButton:Show()
  end

  PlaySample(sPopupEvent)

  if self.currentTransport == nil then
    PreEndTurn("transports")
    self:Hide()
  end
end

function PopupTransport:UpdateList()

  self.transports = {}
  for faction in playerAlliance.factions do
    for unit in faction.units do
      if unit.prototype.name == "transport" then
        if unit.mp > 0 and unit.alive then
          table.insert(self.transports, unit)
        end
      end
    end
  end

end

function PopupTransport:SelectNext()

  self:UpdateList()

  local firstTransport
  local currentReached = false
  local nextTransport
  for _, transport in pairs(self.transports) do
    if firstTransport == nil then
      firstTransport = transport
    end
    if self.currentTransport == nil or currentReached then
      nextTransport = transport
      break
    else
      if transport.id == self.currentTransport.id then
        currentReached = true
      end
    end
  end

  -- If none was selected cos end of list was reached
  if nextTransport == nil then
    self.currentTransport = firstTransport
  else
    self.currentTransport = nextTransport
  end

  -- Select the transport & focus camera
  if self.currentTransport ~= nil then
    ui.SelectHex(self.currentTransport.hex)
    local hexY = self.currentTransport.hex.y - 2
    if hexY < 0 then hexY = self.currentTransport.hex.y + hexY end
    local hex = GetHex(self.currentTransport.hex.x, hexY)
    LookAtWrapper(hex)
  end

end

-------------------------------------------------

class 'PopupUnmovedFaction' (LuaPanel)

function PopupUnmovedFaction:__init()
  LuaPanel.__init(self)

  self:SetPosition((engine.window.width)/2-239, 30)
  self:SetBackgroundImage("adviceDialogFlag")

  self:AddWidget({
    name = "titel_text",
    type = "text",
    font = "impact18_font",
    position = {312, 38},
    color   = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = "unmoved_faction",
    align = "center"
  })
  self.flag = self:AddWidget({
    name = "faction_image",
    type = "image",
    image = "../flags/flag_belgium_32",
    position = {14, 44},
  })
  self.text = self:AddWidget({
    type = "memo",
    position = {166, 55},
    font = "times12_font",
    color   = {67, 56, 47},
    size = {300, 50},
    border = 0,
    text = "unmoved_faction_warning",
  })
  self.nextButton = self:AddWidget({
    name = "next_button",
    type = "button",
    image = "button_default",
    position = {22, 159},
    text = "next",
    tooltip = "goto_faction",
    sfx = "click",
    on_click = function(button)
      button.parent:SelectNext()

      if button.parent.currentFaction == nil then
        button.parent.text:SetLocalText("faction_done")

        button:Hide()
      end
    end
  })
  self:AddWidget({
    name = "cancel_button",
    type = "button",
    image = "button_default",
    position = {210, 159},
    font = "hud14_font",
    text = "cancel",
    sfx = "click",
    on_click = function(button)
      button.parent:Hide()
    end
  })
  self:AddWidget({
    name = "continue_button",
    type = "button",
    image = "button_default",
    position = {359, 159},
    font = "hud14_font",
    text = "end_turn",
    sfx = "click",
    on_click = function(button)
      PreEndTurn("unmovedfaction")

      button.parent:Hide()
    end
  })

  self:Hide()

end

function PopupUnmovedFaction:OnShow()
  self.text:SetLocalText("unmoved_faction_warning")

  self:SelectNext()

  if # self.factions == 1 then
    self.nextButton:Hide()
  else
    self.nextButton:Show()
  end

  PlaySample(sPopupEvent)

  if self.currentFaction == nil then
    PreEndTurn("unmovedfaction")
    self:Hide()
  end
end

function PopupUnmovedFaction:UpdateList()
  self.factions = {}
  self.centres = {}
  for faction in playerAlliance.factions do
    --if faction.id ~= --Todo ignore minor factions
    local anyUnitMoved = false
    local unitCount = 0
    local xTotal = 0
    local yTotal = 0
    local count = 0
    for unit in faction.units do
      if unit.alive and (unit.type ~= Unit.NAVAL or unit.isCarrier) and unit.state ~= Unit.STATE_EMBARKED then
        unitCount = unitCount + 1
        if unit.hex ~= nil then
          xTotal = xTotal + unit.hex.x
          yTotal = yTotal + unit.hex.y
          count = count + 1
        end
        if unit.mp == 0 then
          anyUnitMoved = true
          break
        end
      end
    end
    if anyUnitMoved == false and unitCount > 2 then
      table.insert(self.factions,faction)
      local bestPP = 0
      local centre
      for construction in faction.constructions do
        if construction.type == Construction.TYPE_CAPITAL then
          local PP = construction.pp
          if PP > bestPP then
            bestPP = PP
            centre = construction.hex
          end
        end
      end
      if centre == nil then
        centre = GetHex(math.floor(xTotal/count),math.floor(yTotal/count))
      end
      self.centres[faction.id] = centre
    end
  end
end

function PopupUnmovedFaction:SelectNext()

  self:UpdateList()

  local firstFaction
  local currentReached = false
  local nextFaction
  for _, faction in pairs(self.factions) do
    if firstFaction == nil then
      firstFaction = faction
    end
    if self.currentFaction == nil or currentReached then
      nextFaction = faction
      break
    else
      if faction.id == self.currentFaction.id then
        currentReached = true
      end
    end
  end

  -- If none was selected cos end of list was reached
  if nextFaction == nil then
    self.currentFaction = firstFaction
  else
    self.currentFaction = nextFaction
  end

  -- Select the faction & focus camera
  if self.currentFaction ~= nil then
    -- set flag
    self:GetImage("faction_image"):SetImage("graphics/flags","flag_" .. self.currentFaction.name .. "_128.png")
    LookAtWrapper(self.centres[self.currentFaction.id])
  end

end

-----------------------------------------------------------------------




function PopupProductionLost(targetFaction)

  eventPanel =
  {
    name = "prodlost_panel",
    type = "panel",
    position = {(engine.window.width)/2-239, (engine.window.height-200)/2-98},
    image = "commanderevent",

    controls =
    {
      {
        type = "text",
        font = "impact18_font",
        position = {312, 38},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "production_lost_title",
        align = "center"
      },
      {
        type = "image",
        image = "production_lost_icon",
        position = {18, 28},
      },
      {
        type = "image",
         image = "../flags/flag_" .. targetFaction.name .. "_32",
        position = {17, 161},
        tooltip = targetFaction.name
      },
      {
        type = "memo",
        position = {166, 55},
        font = "times12_font",
        color   = {67, 56, 47},
        text = "production_lost_descr",
        size = {300, 95},
        border = 0
      },
      {
        type = "button",
        image = "button_default",
        position = {359, 159},
        font = "hud14_font",
        text = "continue",
        sfx = "click",
        on_click = function(button)
          button.parent:Hide()

          if targetFaction.alliance.id == playerAlliance.id then
            for faction in playerAlliance.factions do
              if faction.luaData.commanders ~= nil then
                for i, commander in pairs(faction.luaData.commanders) do
                  if commander.unlocked == game.turn then
                    PopupCommander(faction, i)
                  end
                end
              end
            end
          end

          -- Advice messages
          AdviceTurnStart()
        end
      },
    }
  }

  PlaySample(sPopupEvent)

  hud:CreateWidget(eventPanel):Show()
end


-----------------------------------------------------------------------




function PopupManpowerDrop(targetFaction)


  eventPanel =
  {
    name = "mpdrop_panel",
    type = "panel",
    position = {(engine.window.width)/2-239, (engine.window.height-200)/2-98},
    image = "commanderevent",

    controls =
    {
      {
        type = "text",
        font = "impact18_font",
        position = {312, 38},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
        text = "MP_drop",
        align = "center"
      },
      {
        type = "image",
        image = "output_icon",
        position = {18, 28},
      },
      {
        type = "image",
         image = "../flags/flag_" .. targetFaction.name .. "_32",
        position = {17, 161},
        tooltip = targetFaction.name
      },
      {
        type = "memo",
        position = {166, 55},
        font = "times12_font",
        color   = {67, 56, 47},
        text = "MPLevel" .. targetFaction.luaData.qualityMP,
        size = {300, 95},
        border = 0
      },
      {
        type = "button",
        image = "button_default",
        position = {359, 159},
        font = "hud14_font",
        text = "continue",
        sfx = "click",
        on_click = function(button)
          button.parent:Hide()
        end
      },
    }
  }

  PlaySample(sPopupEvent)

  hud:CreateWidget(eventPanel):Show()

  ui.resourcesPanel:Refresh()
end


---------------------------------------------------------

class 'PopupBriefing' (LuaPanel)

function PopupBriefing:__init()
  LuaPanel.__init(self)

  self:SetPosition(256,30)
  self:SetBackgroundImage("tab_briefing")

  self.step = 1

  self:AddWidget({
    name = "briefingTitle_text",
    type = "text",
    position = {255, 24},
    align = "center",
    font = "menu_font",
    color   = {67, 56, 47},
    shadow = {offset = {0, 0}},
    text = "briefing",
  })
  self:AddWidget({
    name = "briefingDescr_memo",
    type = "memo",
    position = {40, 42},
    size = {430, 150},
    font = "verdana12_font",
    color   = {0, 0, 0},
    --text = "" .. popText .. "" .. step,
    border = 0
  })
  self:AddWidget({
    name = "briefingPage_text",
    type = "text",
    position = {460, 107},
    align = "right",
    font = "verdana12_font",
    color   = {67, 56, 47},
  })
  self:AddWidget({
    type = "button",
    image = "button_default",
    position = {198, 139},
    text = "start_game",
    sfx = "click",
    on_click = function(button)
      button.parent:Close()
    end
  })
  self:AddWidget({
    name = "briefingPrev_button",
    type = "button",
    image = "briefing_scroll_left",
    position = {21, 16},
    enabled = enablePrev,
    sfx = "click",
    on_click = function(button)
      if self.step > 1 then
        self.step = self.step - 1

        if self.step == 1 then
          button:Hide()
        elseif self.step == self.total - 1 then
          ui.briefingPanel:GetButton("briefingNext_button"):Show()
        end

        local hex = GetHex(self.coordinates[self.step][1], self.coordinates[self.step][2])
        LookAtWrapper(hex)

        ui.briefingPanel:GetText("briefingPage_text"):SetText(self.step .. "/" .. self.total)
        ui.briefingPanel:GetMemo("briefingDescr_memo"):SetLocalText(self.popText .. "" .. self.step)
        StopAllSounds()
        PlaySample(vBriefing[self.step])
      end
    end
  })
  self:AddWidget({
    name = "briefingNext_button",
    type = "button",
    image = "briefing_scroll_right",
    position = {472, 16},
    enabled = enableNext,
    sfx = "click",
    on_click = function(button)
      if self.step < self.total then
        self.step = self.step + 1

        if self.step == self.total then
          button:Hide()
        elseif self.step == 2 then
          ui.briefingPanel:GetButton("briefingPrev_button"):Show()
        end

        local hex = GetHex(self.coordinates[self.step][1], self.coordinates[self.step][2])
        LookAtWrapper(hex)

        ui.briefingPanel:GetText("briefingPage_text"):SetText(self.step .. "/" .. self.total)
        ui.briefingPanel:GetMemo("briefingDescr_memo"):SetLocalText(self.popText .. "" .. self.step)
        StopAllSounds()
        PlaySample(vBriefing[self.step])
      end
    end
  })

  self:Hide()

end

function PopupBriefing:Start(step, total, popText, coordinates)

  self.popText = popText
  self.coordinates = coordinates
  self.total = total

  -- Load samples
  vBriefing = {}
  for i=1, self.total do
    vBriefing[i] = LoadSample("../voice/" .. self.popText .. i .. ".wav")
  end
  PlaySample(vBriefing[1])

  self.step = step
--~   if self.step > 1 then
--~     local enablePrev = 1
--~   end
--~   if self.step < self.total then
--~     local enableNext = 1
--~   end

  local hex = GetHex(self.coordinates[1][1], self.coordinates[1][2])
  GetPlayer().camera:JumpTo(hex)

  ui.briefing = 1
  ui.mainPanel.turnButton.tooltip = "start_game"

  self:Show()
  self:GetText("briefingPage_text"):SetText(self.step .. "/" .. self.total)
  self:GetButton("briefingPrev_button"):Hide()
  self:GetMemo("briefingDescr_memo"):SetLocalText("" .. self.popText .. "" .. 1)

  ui.hotkeysActive = 0

end

function PopupBriefing:Close()
  ui.briefing = 0
  ui.hotkeysActive = 1
  game:Start()
  StopAllSounds()
  ui.mainPanel.turnButton.tooltip = "end_turn_button"
  if game.type == Game.TYPE_SINGLE and startingAlliance ~= playerAlliance.id then
    hud:GetPanel("main_panel").blockingPanel:Popup("single")
  end
  self:Hide()
end

function MultiChoice(faction,firstname,secondname,thirdname)
	
	ui.diplomacyPanel:Refresh()
  eventPanel =
  {
    name = "choice_panel",
    type = "panel",
    image = "multichoice",
	   
 position = {395, 100},

    controls =
    {
	 
	     {
      name = "close_label",
      type = "button",
      image = "button_default",
      position = {340, 613},
      text = "CHOOSE NONE",
	  tooltip = "choosenone",
      sfx = "click",
      on_click = function(button)
				local neutral = game:GetAllianceById(0)
				local entente = game:GetAllianceById(1)
				local cp = game:GetAllianceById(2)					
				EventProb()
				ui.diplomacyPanel:Refresh()

if faction.alliance.id == 1 then
	-- ENT
		local diplinf = entente.luaData.DPcost
		while diplinf >0 do	
		
			if math.random(1,100) >90 then
				diplinf = diplinf -1
			end
			
		  local dieroll =  math.random(0,20) 
			for faction in game.factions do
				if faction.id == dieroll then
					  if faction.alliance.id == 0 then
							if math.random(1,100) <= faction.luaData.alignment 
								and faction.id > 8
								and faction.id ~= 6
								and faction.id ~= 7 								
								and faction.id ~= 21 
								and faction.id ~= 23 
								and faction.id ~= 24 
								and faction.id ~= 25 
								and faction.id ~= 26 
								and GetEvent("Surrender" .. faction.name) == 0 then
								entente.luaData.influence[faction.id] = entente.luaData.influence[faction.id] + math.random(1,2)
								diplinf = diplinf -1
								 LogUi("+1 INF on" .. faction.name)
								break
							end
					
					elseif faction.alliance.id >0 then
							if math.random(1,100) > entente.luaData.intel[faction.id] 
								and GetEvent("Surrender" .. faction.name) == 0 then
									entente.luaData.intel[faction.id] = entente.luaData.intel[faction.id] + math.random(1,2)
									diplinf = diplinf -1
									 LogUi("+1 INTEL on" .. faction.name)
								break	
							end
					  end
					end
				end
			end	
				
				
else --- CP
		local diplinf = cp.luaData.DPcost
		while diplinf >0 do	
		
			if math.random(1,100) >90 then
				diplinf = diplinf -1
			end
			
		  local dieroll =  math.random(0,20) 
			for faction in game.factions do
				if faction.id == dieroll then
					  if faction.alliance.id == 0 then
							if math.random(1,100) >= faction.luaData.alignment 
								and faction.id > 8
								and faction.id ~= 6
								and faction.id ~= 7 								
								and faction.id ~= 21 
								and faction.id ~= 23 
								and faction.id ~= 24 
								and faction.id ~= 25 
								and faction.id ~= 26 
								and GetEvent("Surrender" .. faction.name) == 0 then
								cp.luaData.influence[faction.id] = cp.luaData.influence[faction.id] +1
								diplinf = diplinf -1
								 LogUi("+1 INF on" .. faction.name)
								break
							end
					
					elseif faction.alliance.id >0 then
							if math.random(1,100) > cp.luaData.intel[faction.id] 
								and GetEvent("Surrender" .. faction.name) == 0 then
									cp.luaData.intel[faction.id] = cp.luaData.intel[faction.id] +1
									diplinf = diplinf -1
									 LogUi("+1 INTEL on" .. faction.name)
								break	
							end
					  end
					end
				end
			end						
		end

	      button.parent:Hide()
      end
    },
	 
	 {
        name = "multichoiceName_text",
        type = "text",
        font = "impact36_font",
        position = {250, 29},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
		text = "CHOOSE AN EVENT:",
				
	   align = "center"
      },
	  {
        name = "flag",
        type = "image",
        image = "../flags/flag_" .. faction.name .. "_32",
        position = {20, 19},
        tooltip = faction.name
      },
	    {
        name = "flag",
        type = "image",
        image = "../flags/flag_" .. faction.name .. "_32",
        position = {420, 19},
        tooltip = faction.name
      },
	 ----1----------------------------1     

	 {
        name = "choiceName_text",
        type = "text",
        font = "impact18_font",
        position = {312, 95},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
		text =  "" .. firstname .. "",       
	   align = "center"
      },
      {
        name = "choice_image",
        type = "image",
        image = "../hud/events/choiceevents/" .. firstname,
        position = {17, 80},
      },
      
      {
        name = "choiceDescr_memo",
        type = "memo",
        position = {166, 110},
        font = "times12_font",
        color   = {67, 56, 47},
        text = firstname .. "_info",
       
	   size = {300, 95},
        border = 0
      },
      {
        name = "deploy_label",
        type = "button",
        image = "button_default",
        position = {22, 213},
        font = "hud14_font",
        text = "CHOOSE",
		sfx = "click",
     on_click = function(button)        
		
				local eventname = firstname
				TriggerEvent(faction,eventname) 
				EventProb()
				ui.diplomacyPanel:Refresh()

			
				          button.parent:Hide()

		end
      },
------2------------------------------------------ 2	
	{
        name = "choiceName_text",
        type = "text",
        font = "impact18_font",
        position = {312, 295},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
		text =  "" .. secondname .. "",       
	   align = "center"
      },
      {
        name = "choice_image",
        type = "image",
        image = "../hud/events/choiceevents/" .. secondname,
        position = {17, 280},
      },
      
      {
        name = "choiceDescr_memo",
        type = "memo",
        position = {166, 310},
        font = "times12_font",
        color   = {67, 56, 47},
        text = secondname .. "_info",
       
	   size = {300, 95},
        border = 0
      },
      {
        name = "deploy_label",
        type = "button",
        image = "button_default",
        position = {22, 413},
        font = "hud14_font",
        text = "CHOOSE",
		sfx = "click",
         on_click = function(button)        
		
				local eventname = secondname
				TriggerEvent(faction,eventname) 
		
			
				          button.parent:Hide()

		end
      },
	  --3---------------------------------------- 3
	  {
        name = "choiceName_text",
        type = "text",
        font = "impact18_font",
        position = {312, 495},
        color   = {67, 56, 47},
        shadow = {offset = {0, 0}},
		text =  "" .. thirdname .. "",       
	   align = "center"
      },
      {
        name = "choice_image",
        type = "image",
        image = "../hud/events/choiceevents/" .. thirdname,
        position = {17, 479},
      },
      
      {
        name = "choiceDescr_memo",
        type = "memo",
        position = {166, 510},
        font = "times12_font",
        color   = {67, 56, 47},
        text = thirdname .. "_info",
       
	   size = {300, 95},
        border = 0
      },
      {
        name = "deploy_label",
        type = "button",
        image = "button_default",
        position = {22, 613},
        font = "hud14_font",
        text = "CHOOSE",
		sfx = "click",
     on_click = function(button)        
		
				local eventname = thirdname
				TriggerEvent(faction,eventname) 
		
			
				          button.parent:Hide()

		end
      },
    
    }
  }

  PlaySample(sPopupEvent)

ui.diplomacyPanel:Refresh()
 hud:CreateWidget(eventPanel):Show()
	
	
  end
