class 'ProductionPanel' (LuaPanel)




function ProductionPanel:__init(alliance)
  LuaPanel.__init(self, production)

  self.alliance = alliance

  self.factionPanels = {}
  self.commanderPanels = {}

  -- Create faction flag buttons
  local slot = 1
  for faction in alliance.factions do
    -- only for factions with capitals
    if (faction.luaData.capitals > 0 or IsNewFaction(faction) == true) then
      -- Select first faction by default
      if slot == 1 then
        ui.productionFaction = faction
      end
      self:AddFaction(faction, slot)
      slot = slot + 1
    end
  end

  self:AddWidget({
    name = "faction_name",
    type = "text",
    font = "hud14_font",
    position = {258, 24},
    align = "center",
    color   = {241, 237, 233},
    --text = faction.name .. "_title"
  })
  self:AddWidget({
    name = "alliance_name",
    type = "text",
    font = "hud12_font",
    position = {201, 31},
    align = "left",
    color   = {241, 237, 233},
    --text = faction.alliance.name
  }):Hide()
  self:AddWidget({
    name = "faction_flag",
    type = "image",
    --image = "../flags/flag_" .. faction.name .. "_128",
    position = {65, 16},
  })




    self:AddWidget({
      name = "tab_units",
      type = "image",
      position = {330, 10},
      image = "production_tab_units_sel",
      tooltip = "purchase_units",
      sfx = "click",
      on_click = function(button)
        if ui.selectedProductionTab == "commander" then
          button.parent.commanderPanels[ui.productionFaction.id]:Hide()
        end
        button.parent:GetImage("tab_" .. ui.selectedProductionTab):SetImage("graphics/hud", "production_tab_" .. ui.selectedProductionTab .. ".png")
        button.parent.currentTab = button.parent.factionPanels[ui.productionFaction.id]
        button.parent.currentTab:Show()
        button.parent:GetImage("tab_units"):SetImage("graphics/hud", "production_tab_units_sel.png")
      end
    })
    self:AddWidget({
      name = "tab_commander",
      type = "image",
      position = {507, 10},
      image = "production_tab_commander",
      tooltip = "commander_requirements",
      sfx = "click",
      on_click = function(button)
        if ui.selectedProductionTab == "units" then
          button.parent.factionPanels[ui.productionFaction.id]:Hide()
        end
        button.parent:GetImage("tab_" .. ui.selectedProductionTab):SetImage("graphics/hud", "production_tab_" .. ui.selectedProductionTab .. ".png")
        button.parent.currentTab = button.parent.commanderPanels[ui.productionFaction.id]
        button.parent.currentTab:Show()
        button.parent:GetImage("tab_commander"):SetImage("graphics/hud", "production_tab_commander_sel.png")
      end
    })
--~     self:AddWidget({
--~       type = "image",
--~       position = {680, 10},
--~       image = "class_artillery_white",
--~       tooltip = "colonial_units",
--~       sfx = "click",
--~       on_click = function(button)
--~         self:Hide()
--~         --self.parent.commanderPanels[faction.id]:Show()
--~         --button.parent:GetImage("tech_group_tabs"):SetImage("graphics/hud", "tech_group_tab_2.png")
--~       end
--~     })

end

function ProductionPanel:OnShow()
  self:SelectFaction(ui.productionFaction)
  ui.hotkeysActive = 0
  --self:Refresh()
end

function ProductionPanel:AddFaction(faction, slot)
assert(faction.id ~=13, "error")
  --wow what a bad hack...
  if slot == nil then
    slot = 0
    for faction2 in playerAlliance.factions do
      if faction2.luaData.capitals > 0 or faction.id == 27 or faction.id == 26 then
        slot = slot + 1
      end
    end
  end

  if self.factionPanels[faction.id] == nil then
    self:AddFactionPanel(faction, slot)
    self:AddFactionFlag(faction, slot)
  else
    self:GetButton("flag" .. faction.id .. "_button"):SetPosition(19, 16 + (slot - 1) * 30)
    --self:GetImage("flag" .. faction.id .. "_disabled"):SetPosition(19, 16 + (slot - 1) * 30)
  end
end

function ProductionPanel:RemoveFaction(faction)
  -- If this faction is currently selected, select another
  if ui.productionFaction.id == faction.id then
    for otherFaction in playerAlliance.factions do
      if CanFactionProduce(otherFaction) then
        ui.productionFaction = otherFaction
        SelectPanelFaction(otherFaction)
        --self:SelectFaction(faction)
        break
      end
    end
  end

  -- Remove flag button
  self:GetButton("flag" .. faction.id .. "_button"):Hide()

  -- Shift other flags
  local slot = 1
  for otherFaction in playerAlliance.factions do
    if CanFactionProduce(otherFaction) then
      self:GetButton("flag" .. otherFaction.id .. "_button"):SetPosition(19, 16 + (slot - 1) * 30)
      --self:GetImage("flag" .. otherFaction.id .. "_disabled"):SetPosition(19, 16 + (slot - 1) * 30)
      slot = slot + 1
    end
  end
end

function ProductionPanel:DisableFaction(faction)
  -- If this faction is currently selected, select another
  if ui.productionFaction.id == faction.id then
    for faction in playerAlliance.factions do
      if CanFactionProduce(faction) then
        ui.productionFaction = faction
        --SelectPanelFaction(faction)
        --self:SelectFaction(faction)
        break
      end
    end
  end

  -- Move flag button
  self:GetButton("flag" .. faction.id .. "_button"):Hide()
  --self:GetImage("flag" .. faction.id .. "_disabled"):Show()
  local slot = 1
  for otherFaction in playerAlliance.factions do
    if otherFaction.id ~= faction.id and otherFaction.luaData.productionLost ~= 0 then
      slot = slot + 1
    end
  end
  --self:GetImage("flag" .. faction.id .. "_disabled"):SetPosition(19, 16 + (slot - 1) * 30)

  -- Shift other flags
  local slot = 1
  for otherFaction in playerAlliance.factions do
    self:GetButton("flag" .. otherFaction.id .. "_button"):SetPosition(19, 16 + (slot - 1) * 30)
    --self:GetImage("flag" .. otherFaction.id .. "_disabled"):SetPosition(19, 16 + (slot - 1) * 30)
    slot = slot + 1
  end
end

function ProductionPanel:AddFactionPanel(faction, slot)
  self.factionPanels[faction.id] = self:AdoptWidget(FactionProductionPanel(faction))
  self.commanderPanels[faction.id] = self:AdoptWidget(FactionCommanderPanel(faction))
  -- Display first faction by default
  if slot == 1 then
    self.factionPanels[faction.id]:Show()
  end
end

function ProductionPanel:AddFactionFlag(faction, slot)

  self:AddWidget({
    name = "flag" .. faction.id .. "_button",
    type = "button",
    image = "../flags/flag_" .. faction.name .. "_32_button",
    position = {19, 16 + (slot - 1) * 30},
    sfx = "click",
    tooltip = faction.name,
    on_click = function(button)
      self:SelectFaction(faction)
    end
  })

end

function ProductionPanel:SelectFaction(faction)

  if self.currentTab ~= nil then
    self.currentTab:Hide()
  end

  ui.productionFaction = faction
  SelectPanelFaction(faction)

  self:Refresh()

  --hud:GetWidget("factionProd" .. faction.id):Show()
  if ui.selectedProductionTab == "units" then
    self.factionPanels[faction.id]:Show()
  end
  if ui.selectedProductionTab == "commander" then
    self.commanderPanels[faction.id]:Show()
  end

  -- Advice about specific factions
  AdviceFactionProduction(faction, self.currentTab)
end

function ProductionPanel:Refresh()

  -- Check if faction can produce, then refresh or disable flag
  for faction in self.alliance.factions do
    if CanFactionProduce(faction) then
      self.factionPanels[faction.id]:RefreshUnits()
      --self:GetImage("flag" .. faction.id .. "_disabled"):Hide()
    else
      -- Show disabled flag
      --self:GetImage("flag" .. faction.id .. "_disabled"):Show()

      -- Select another faction if necessary
      if ui.productionFaction.id == faction.id then
        if ui.productionFaction.id == faction.id then
          for otherFaction in playerAlliance.factions do
            if CanFactionProduce(otherFaction) then
              ui.productionFaction = otherFaction
              SelectPanelFaction(otherFaction)
              self:SelectFaction(otherFaction)
              return
            end
          end
          -- FIXME: If it reaches this point, it means player has no faction
          -- left that can produce. Needs proper UI!
        end
      end
    end
  end

  -- Production panel
  self:GetImage("faction_flag"):SetImage("graphics/flags", "flag_" .. ui.productionFaction.name .. "_128.png")
  self:GetText("faction_name"):SetLocalText(ui.productionFaction.name .. "_title")

  self:GetText("pp_value"):SetNumber(ui.productionFaction.pp)
  self:GetText("mp_value"):SetNumber(ui.productionFaction.mp)
  self:GetText("am_value"):SetNumber(ui.productionFaction.am)

  -- Set PP income colour & text
  local incomePP = GetIncomePP(ui.productionFaction) - GetUpkeep(ui.productionFaction) - GetResearchUpkeep(ui.productionFaction)
  if incomePP > 0 then
    self:GetText("pp_income"):SetText("+" .. incomePP)
    self:GetText("pp_income"):SetColour(192,204,111,255)
  elseif incomePP < 0 then
    self:GetText("pp_income"):SetNumber(incomePP)
    self:GetText("pp_income"):SetColour(254,83,30,255)
  else
    self:GetText("pp_income"):SetText("+" .. incomePP)
    self:GetText("pp_income"):SetColour(241, 237, 233, 255)
  end

  -- Set MP income colour & text
--~   local incomeMP = ui.productionFaction.incomeMP
--~   if incomeMP > 0 then
--~     self:GetText("mp_income"):SetText("+" .. incomeMP)
--~     self:GetText("mp_income"):SetColour(192,204,111,255)
--~   elseif incomeMP < 0 then
--~     self:GetText("mp_income"):SetNumber(incomeMP)
--~     self:GetText("mp_income"):SetColour(254,83,30,255)
--~   else
--~     self:GetText("mp_income"):SetText("+" .. incomeMP)
--~     self:GetText("mp_income"):SetColour(241, 237, 233, 255)
--~   end

  -- Set AM income colour & text
  local incomeAM = GetIncomeAM(ui.productionFaction)
  if incomeAM > 0 then
    self:GetText("am_income"):SetText("+" .. incomeAM)
    self:GetText("am_income"):SetColour(192,204,111,255)
  elseif incomeAM < 0 then
    self:GetText("am_income"):SetNumber(incomeAM)
    self:GetText("am_income"):SetColour(254,83,30,255)
  else
    self:GetText("am_income"):SetText("+" .. incomeAM)
    self:GetText("am_income"):SetColour(241, 237, 233, 255)
  end

  --ManageQueue(playerAlliance, ui.queueRow)

  self.factionPanels[ui.productionFaction.id]:Refresh(ui.product)
end


------------------------------------------------


class 'FactionProductionPanel' (LuaPanel)

function FactionProductionPanel:__init(faction)
  LuaPanel.__init(self)
  self:Hide()

  self.faction = faction
  self:SetPosition(60, 0)

  self.unitButton = {}

  self:AddWidget({
    name = "selected_image",
    type = "image",
    position = {7, 127},
    sfx = "click"
  })
  self:AddWidget({
    name = "selected_text",
    type = "text",
    font = "times16_font",
    position = {138, 289},
    color   = {67, 56, 47},
    text = "garrison",
    align = "center"
  })
  self:AddWidget({
    name = "selectedclass_image",
    type = "image",
    position = {11, 129},
    sfx = "click"
  })

  self:AddWidget({
    type = "image",
    image = "button_default_disabled",
    position = {20, 494}
  })
  self:AddWidget({
    name = "unit_availability",
    type = "text",
    position = {75, 507},
    font = "hud12_font",
    align = "center",
    color = {241, 237, 233},
    text = "unavailable",
  }):Hide()

  self:AddWidget({
    type = "text",
    position = {75, 507},
    font = "hud12_font",
    align = "center",
    color = {254,83,30},
    text = "purchase"
  })
  self:AddWidget({
    name = "purchase_button",
    type = "button",
    image = "button_default",
    position = {18, 492},
    text = "purchase",
    sfx = "click",
    on_click = function(button)
      local succes = PurchaseUnit(faction, self.proto)
      if succes then
        self:Refresh(self.proto)
        ui.mainPanel.productionTab:Refresh()
        PlaySample(sPurchase)
        ui.resourcesPanel:Refresh()
        self.parent:Refresh()
      end
    end
  })

  self:AddWidget({
    type = "button",
    image = "button_default",
    position = {135, 492},
    text = "close",
    sfx = "click",
    on_click = function(button)
      hud:GetPanel("production_panel"):Hide()
      ui.hotkeysActive = 1
    end
  })

  self.stats = self:AdoptWidget(UnitInfoPanel(faction, 6, 315))

  local x = 0
  local y = 0
  --self.firstUnit = 0
  for _, protoInfo in ipairs(faction.unit_prototypes) do
    proto = game:GetUnitPrototype(protoInfo.prototype)
    x = 0
    if proto.name == "garrison" then
      x = 278
      y = 39
    end
    if proto.name == "infantry" then
      x = 407
      y = 39
    end
    if proto.name == "cavalry" then
      x = 536
      y = 39
    end
    if proto.name == "armouredcar" then
      x = 665
      y = 39
    end
    if proto.name == "artillery" then
      x = 278
      y = 163
    end
    if proto.name == "armouredtrain" then
      x = 407
      y = 163
    end
    if proto.name == "armour" then
      x = 536
      y = 163
    end
    if proto.name == "railgun" then
      x = 665
      y = 163
    end
    if proto.name == "fighter" then
      x = 278
      y = 287
    end
    if proto.name == "bomber" then
      x = 536
      y = 287
    end
    if proto.name == "zeppelin" then
      x = 407
      y = 287
    end
    if proto.name == "lightcruiser" then
      x = 278
      y = 411
    end
    if proto.name == "dreadnought" then
      x = 407
      y = 411
    end
    if proto.name == "submarine" then
      x = 536
      y = 411
    end
    
	if proto.name == "battlecruiser" then
      x = 665
      y = 411
    end
	
	
	
	
	if x ~= 0 then
      self.unitButton[proto.name] = self:AdoptWidget(UnitProductionButtonPanel(faction, proto, protoInfo.level, x, y))
      if self.firstUnit == nil then
        self.firstUnit = proto
        --self:Refresh(proto)
        --self.proto = proto
      end
    end
  end
end

function FactionProductionPanel:OnShow()
  --populate with self.faction data
  self.parent.currentTab = self
  ui.selectedProductionTab = "units"
end

function FactionProductionPanel:Refresh(proto)

  if proto == nil or self.faction.luaData.unitLevel[proto.name] == 0 or self.faction.luaData.unitLevel[proto.name] == nil then
    proto = self.firstUnit
  end

  if proto == nil then
    return
  end

  self.proto = proto
  ui.product = self.proto

  self.stats:Refresh(self.proto, false)

  local unitImage
  local unitLevel = self.faction.luaData.unitLevel[self.proto.name]
  local imageLevel
  if unitLevel == 0 then
    imageLevel = 1
  else
    imageLevel = unitLevel
  end
  if engine:FileExists("graphics/units", self.proto.name .. "_" .. self.faction.name .. "_" .. imageLevel .. "_info.png") then
    unitImage = self.proto.name .. "_" .. self.faction.name .. "_" .. imageLevel .. "_info.png"
  else
    unitImage = self.proto.name .. "_default_" .. imageLevel .. "_info.png"
  end

  self:GetText("selected_text"):SetLocalText(self.proto.name)
  self:GetImage("selected_image"):SetImage("graphics/units", unitImage)
  self:GetImage("selectedclass_image"):SetImage("graphics/units", self.proto.name .. "_" .. self.faction.alliance.id .. "_50.png")

  -- Available?
  self:GetButton("purchase_button"):Show()
  if self.proto.costPP > self.faction.pp or self.proto.costMP > self.faction.mp then
    self:GetButton("purchase_button"):Hide()
    self:GetText("unit_availability"):SetText("insuffient_resources")
  end
  if unitLevel == 0 then
    self:GetButton("purchase_button"):Hide()
    self:GetText("unit_availability"):SetText("requires_rechnology")
  end
end

function FactionProductionPanel:RefreshUnits()
  for _, protoInfo in ipairs(self.faction.unit_prototypes) do
    proto = game:GetUnitPrototype(protoInfo.prototype)
    if self.unitButton[proto.name] ~= nil then
      self.unitButton[proto.name]:Refresh()
    end
  end
end


------------------------------------------------


class 'UnitProductionButtonPanel' (LuaPanel)

function UnitProductionButtonPanel:__init(faction, unit, level, x, y)
  LuaPanel.__init(self)

  self.faction = faction
  self.unit = unit

  self:SetPosition(x,y)

  local unitImage
  local unitLevel = level
  if unitLevel == 0 then
    unitLevel = 1
  end
  if engine:FileExists("graphics/units", unit.name .. "_" .. faction.name .. "_" .. unitLevel .. "_hud.png") then
    unitImage = "../units/" .. unit.name .. "_" .. faction.name .. "_" .. unitLevel .. "_hud"
  elseif engine:FileExists("graphics/units", unit.name .. "_default_" .. unitLevel .. "_hud.png") then
    unitImage = "../units/" .. unit.name .. "_default_" .. unitLevel .. "_hud"
  else
    unitImage = "../units/bomber_1_100"
  end

  self:AddWidget({
    name = "background_image",
    type = "image",
    image = "unitback",
    position = {0, 0},
  })
  self:AddWidget({
    name = "unit_image",
    type = "image",
    image = unitImage,
    position = {0, 0},
    sfx = "click",
    on_click = function(button)
      -- Change content
      --selectUnit(faction, unit)
      button.parent.parent:Refresh(unit)
    end
  })
  self:AddWidget({
    name = "unit_name",
    type = "text",
    font = "hud14_font",
    position = {64, 110},
    align = "center",
    color   = {67, 56, 47},
    text = unit.name,
    sfx = "click",
    on_click = function(button)
      button.parent.parent:Refresh(unit)
    end
  })
  self:AddWidget({
    name = "class_image",
    type = "image",
    image = "../units/" .. unit.name .. "_" .. faction.alliance.id .. "_25",
    position = {3, 3},
    sfx = "click",
    on_click = function(button)
      button.parent.parent:Refresh(unit)
    end
  })
  self:AddWidget({
    name = "level_image",
    type = "image",
    image = "level" .. level,
    position = {21, 3},
    sfx = "click",
    on_click = function(button)
      button.parent.parent:Refresh(unit)
    end
  }):Hide()
  self:AddWidget({
    name = "fade_image",
    type = "image",
    image = "unresearched_unit",
    position = {0, 0},
    --sfx = "click",
    --on_click = function(button)
      --button.parent.parent:Refresh(unit)
    --end,
    tooltip = "requires_technology"
  }):Hide()
  self:AddWidget({
    name = "required_text",
    type = "text",
    font = "hud12_font",
    position = {64, 58},
    align = "center",
    color   = {10, 5, 0},
    text = "requires_tech",
    on_click = function(button)
      button.parent.parent:Refresh(unit)
    end
  }):Hide()
  self:AddWidget({
    name = "required_tech",
    type = "text",
    font = "hud12_font",
    position = {64, 70},
    align = "center",
    color   = {10, 5, 0},
    text = "required_" .. unit.name,
    on_click = function(button)
      button.parent.parent:Refresh(unit)
    end
  }):Hide()
end

function UnitProductionButtonPanel:OnShow()
end

function UnitProductionButtonPanel:Refresh()

  local unitImage
  local unitLevel = self.faction.luaData.unitLevel[self.unit.name]
  if unitLevel == 0 or unitLevel == nil then
    --unitImage = "../hud/unresearched_unit.png"
    self:GetImage("fade_image"):Show()
    self:GetImage("unit_image"):Hide()
    --self:GetText("required_text"):Show()
    --self:GetText("required_tech"):Show()
    --self:Hide()
    unitLevel = 1
  else
    self:GetImage("fade_image"):Hide()
    self:GetImage("unit_image"):Show()
    --self:GetText("required_text"):Hide()
    --self:GetText("required_tech"):Hide()
    if engine:FileExists("graphics/units", self.unit.name .. "_" .. self.faction.name .. "_" .. unitLevel .. "_hud.png") then
      unitImage = self.unit.name .. "_" .. self.faction.name .. "_" .. unitLevel .. "_hud.png"
    elseif engine:FileExists("graphics/units", self.unit.name .. "_default_" .. unitLevel .. "_hud.png") then
      unitImage = self.unit.name .. "_default_" .. unitLevel .. "_hud.png"
    else
      unitImage = "bomber_1_100.png"
    end

    self:GetImage("level_image"):SetImage("graphics/hud", "level" .. GetUnitTechCount(self.unit.name, self.faction) .. ".png")

    self:GetImage("unit_image"):SetImage("graphics/units", unitImage)
  end
end




production =
{
  name = "production_panel",
  type = "panel",
  position = {(engine.window.width)/2-437, (engine.window.height-200)/2-274},
  image = "production_panel",
  visible = false,

  controls =
  {
    {
      name = "pp_title",
      type = "image",
      position = {204, 39},
      image = "resource_pp_white",
      tooltip = "resourcePP"
    },
    {
      name = "pp_value",
      type = "text",
      font = "hud14_font",
      position = {258, 48},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentPP"
    },
    {
      name = "mp_title",
      type = "image",
      position = {204, 64},
      image = "resource_mp_white",
      tooltip = "resourceMP"
    },
    {
      name = "mp_value",
      type = "text",
      font = "hud14_font",
      position = {258, 73},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentMP"
    },
    {
      name = "am_title",
      type = "image",
      position = {204, 89},
      image = "resource_am_white",
      tooltip = "resourceAM"
    },
    {
      name = "am_value",
      type = "text",
      font = "hud14_font",
      position = {258, 98},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentAM"
    },
    {
      name = "pp_income",
      type = "text",
      font = "hud12_font",
      position = {298, 48},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "incrementPP"
    },
--~     {
--~       name = "mp_income",
--~       type = "text",
--~       font = "hud12_font",
--~       position = {298, 73},
--~       align = "center",
--~       color   = {241, 237, 233},
--~       tooltip = "incrementMP"
--~     },
    {
      name = "am_income",
      type = "text",
      font = "hud12_font",
      position = {298, 98},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "incrementAM"
    },
  }
}



-- Highlight valid deployment hexes
function HighlightDeployment(unit, faction)
  GetScene():ClearActions()
  GetScene():AddActionImages(GetValidDeploymentHexes(unit, faction), "deploy_100")
end

------------------------------------------------


class 'FactionCommanderPanel' (LuaPanel)

function FactionCommanderPanel:__init(faction)
  LuaPanel.__init(self)

  self.faction = faction
  self:SetPosition(60, 0)

  self.faction = faction

  self.commanderPortrait = self:AddWidget({
    type = "image",
    position = {13, 127},
    sfx = "click"
  })
  self.commanderName = self:AddWidget({
    type = "text",
    font = "times20_font",
    position = {130, 289},
    color   = {241, 237, 233},
--~     normal   = {241, 237, 233},
--~     hilight  = {241, 237, 233},
--~     select   = {241, 237, 233},
--~     disabled = {241, 237, 233},
--~     shadow = {offset = {1, 1}},
    --text = "garrison",
    align = "center"
  })

  self:AddWidget({
    type = "button",
    image = "button_default",
    position = {136, 492},
    text = "close",
    sfx = "click",
    on_click = function(button)
      hud:GetPanel("production_panel"):Hide()
    end
  })

  self.stats = self:AdoptWidget(CommanderInfoPanel(6, 315))

  self.commanderBox = {}
  for i = 0, 2 do
    self.commanderBox[i] = self:AdoptWidget(CommanderConditionsPanel(283, 51+162*i))
  end
  self.commanderBox[0].type:SetLocalText("commander_land")
  self.commanderBox[1].type:SetLocalText("commander_naval")
  self.commanderBox[2].type:SetLocalText("commander_air")

  self:Hide()

end

function FactionCommanderPanel:OnShow()
  self:Refresh()
  self.parent.currentTab = self
  ui.selectedProductionTab = "commander"
end

function FactionCommanderPanel:SelectCommander(commander)
  ui.selectedCommander = commander

  if commander == -1 then
    self.commanderPortrait:SetImage("graphics/commanders", "commander_none_info.png")
    self.commanderName:Hide()
  else
    self.commanderPortrait:SetImage("graphics/commanders", "commander_" .. commander .. "_info.png")
    self.commanderName:Show()
    self.commanderName:SetLocalText("commander_" .. commander)
  end

  self.stats:Refresh(commander)
end

function FactionCommanderPanel:Refresh()

  --self.commanderBox[0]:Hide()
  --self.commanderBox[1]:Hide()
  --self.commanderBox[2]:Hide()

  for i = 0, 2 do
    self.commanderBox[i].portrait:SetImage("graphics/commanders", "commander_none.png")
    self.commanderBox[i].title:SetLocalText("commander_none")
    self.commanderBox[i].commander = -1
    self.commanderBox[i].killsIcon:Hide()
    self.commanderBox[i].casualtiesIcon:Hide()
    for j = 0, 4 do
      self.commanderBox[i].conditions[j]:Hide()
      self.commanderBox[i].checks[j]:Hide()
      self.commanderBox[i].conditionText[j]:Hide()
    end
  end
  self:SelectCommander(-1)

  local i = 1
  local conditionCounter, pos, id, valid
  while data.commanders[i] ~= nil do
    if data.commanders[i].faction == self.faction.id then
      if data.commanders[i].conditions ~= nil and data.commanders[i].conditions.removed ~= true then
        conditionCounter = 0
        id = data.commanders[i].id
	--	LogUi("ID:" .. id)
        valid = true

        if data.commanders[i].conditions.unlocked ~= nil then
          local requirement = GetCommanderByName(data.commanders[i].conditions.unlocked)
          if self.faction.luaData.commanders[requirement].unlocked ~= 0 
		  and self.faction.luaData.commanders[id].alive ~= nil then
            valid = true
          else
            valid = false
          end
        end

        if self.faction.luaData.commanders[id].unlocked == 0 and valid == true then
          if data.commanders[i].type == "land" then
            pos = 0
            self.commanderBox[pos]:Show()
            self:SelectCommander(data.commanders[i].id)
          end
          if data.commanders[i].type == "naval" then
            pos = 1
            self.commanderBox[pos]:Show()
          end
          if data.commanders[i].type == "air" then
            pos = 2
            self.commanderBox[pos]:Show()
          end
          self.commanderBox[pos].portrait:SetImage("graphics/commanders", "commander_" .. data.commanders[i].id .. ".png")
          self.commanderBox[pos].title:SetLocalText("commander_" .. data.commanders[i].id)
          self.commanderBox[pos].commander = data.commanders[i].id

          if data.commanders[i].conditions.kills ~= nil and data.commanders[i].conditions.kills[1] - GetFactionCommanderRequirementReduction(self.faction.id, "kills", data.commanders[i].conditions.kills[2]) > 0 then
            self.commanderBox[pos].killsIcon:SetImage("graphics/hud", "class_" .. data.commanders[i].conditions.kills[2] .. ".png")
            self.commanderBox[pos].killsIcon:Show()
            self.commanderBox[pos].conditionText[conditionCounter]:SetText(math.floor(self.faction.luaData.statsKills[data.commanders[i].conditions.kills[2]]/10) .. " / " .. data.commanders[i].conditions.kills[1] - GetFactionCommanderRequirementReduction(self.faction.id, "kills", data.commanders[i].conditions.kills[2]))
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_kills")
            if self.faction.luaData.statsKills[data.commanders[i].conditions.kills[2]] / 10 >= data.commanders[i].conditions.kills[1] - GetFactionCommanderRequirementReduction(self.faction.id, "kills", data.commanders[i].conditions.kills[2]) then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          else
            self.commanderBox[pos].killsIcon:Hide()
          end
          if data.commanders[i].conditions.casualties ~= nil and data.commanders[i].conditions.casualties[1] - GetFactionCommanderRequirementReduction(self.faction.id, "casualties", data.commanders[i].conditions.casualties[2]) > 0 then
            self.commanderBox[pos].casualtiesIcon:SetImage("graphics/hud", "class_" .. data.commanders[i].conditions.casualties[2] .. ".png")
            self.commanderBox[pos].casualtiesIcon:Show()
            self.commanderBox[pos].conditionText[conditionCounter]:SetText(math.floor(self.faction.luaData.statsCasualties[data.commanders[i].conditions.casualties[2]]/10) .. " / " .. data.commanders[i].conditions.casualties[1] - GetFactionCommanderRequirementReduction(self.faction.id, "casualties", data.commanders[i].conditions.casualties[2]))
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_casualties")
            if self.faction.luaData.statsCasualties[data.commanders[i].conditions.casualties[2]] / 10 >= data.commanders[i].conditions.casualties[1] - GetFactionCommanderRequirementReduction(self.faction.id, "casualties", data.commanders[i].conditions.casualties[2]) then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          else
            self.commanderBox[pos].casualtiesIcon:Hide()
          end
          if data.commanders[i].conditions.researched ~= nil then
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_research")
            self.commanderBox[pos].conditionText[conditionCounter]:SetLocalText("tech_" .. data.commanders[i].conditions.researched)
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            if self.faction.luaData.researchComplete[data.commanders[i].conditions.researched] > 0 then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          end
          if data.commanders[i].conditions.war ~= nil then
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_war")
            self.commanderBox[pos].conditionText[conditionCounter]:SetLocalText(game:GetFactionById(data.commanders[i].conditions.war).name)
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            if game:GetFactionById(data.commanders[i].conditions.war).alliance.id ~= playerAlliance.id and game:GetFactionById(data.commanders[i].conditions.war).alliance.id ~= 0 then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          end
          if data.commanders[i].conditions.ally ~= nil then
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_ally")
            self.commanderBox[pos].conditionText[conditionCounter]:SetLocalText(game:GetFactionById(data.commanders[i].conditions.ally).name)
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            if game:GetFactionById(data.commanders[i].conditions.ally).alliance.id == playerAlliance.id then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          end
          if data.commanders[i].conditions.year ~= nil then
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_year")
            self.commanderBox[pos].conditionText[conditionCounter]:SetNumber(data.commanders[i].conditions.year)
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            if game.date.year >= data.commanders[i].conditions.year then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          end
		  if data.commanders[i].conditions.month ~= nil then
            self.commanderBox[pos].conditions[conditionCounter]:Show()
            self.commanderBox[pos].conditions[conditionCounter]:SetLocalText("condition_month")
            self.commanderBox[pos].conditionText[conditionCounter]:SetNumber(data.commanders[i].conditions.month)
            self.commanderBox[pos].conditionText[conditionCounter]:Show()
            if game.date.month >= data.commanders[i].conditions.month then
              self.commanderBox[pos].checks[conditionCounter]:Show()
            else
              self.commanderBox[pos].checks[conditionCounter]:Hide()
            end
            conditionCounter = conditionCounter + 1
          end
          
          if conditionCounter < 5 then
            for i = conditionCounter, 4 do
              self.commanderBox[pos].conditions[i]:Hide()
              self.commanderBox[pos].checks[i]:Hide()
              self.commanderBox[pos].conditionText[i]:Hide()
            end
          end
        end
      end
    end
    i = i + 1
  end

end




------------------------------------------------


class 'CommanderConditionsPanel' (LuaPanel)

function CommanderConditionsPanel:__init(x, y)
  LuaPanel.__init(self)

  self:SetPosition(x,y)

  self.commander = -1

  self:AddWidget({
    type = "image",
    position = {0, 10},
    image = "commander_conditions"
  })
  self.portrait = self:AddWidget({
    type = "image",
    position = {1, 11},
    sfx = "click",
    on_click = function(button)
      self.parent:SelectCommander(self.commander)
    end
  })
  self.title = self:AddWidget({
    type = "text",
    position = {325, 27},
    align = "center",
    font = "hud14_font",
    color = {31, 21, 6},
  })
  self.type = self:AddWidget({
    type = "text",
    position = {64, 0},
    align = "center",
    font = "hud14_font",
    color = {224, 220, 218},
  })

  -- Conditions
  self.conditions = {}
  self.checks = {}
  self.conditionText = {}
  for i=0, 4 do
    self.conditions[i] = self:AddWidget({
      type = "text",
      position = {172, 39 + 20 * i},
      align = "left",
      font = "hud12_font",
      color   = {31, 21, 6},
    })
    self.conditionText[i] = self:AddWidget({
      type = "text",
      position = {470, 39 + 20 * i},
      align = "right",
      font = "hud12_font",
      color = {31, 21, 6},
      text = "10"
    })
    self.checks[i] = self:AddWidget({
      type = "image",
      position = {152, 35 + 20 * i},
      image = "tech_complete",
      tooltip = "condition_achieved"
    })
  end
  self.killsIcon = self:AddWidget({
    type = "image",
    position = {475, 31},
    image = "class_ground"
  })
  self.casualtiesIcon = self:AddWidget({
    type = "image",
    position = {475, 51},
    image = "class_ground"
  })

end


function DisplayProductionValue(hex,num)

  local image
  if hex.construction ~= nil then -- remove after naval AI test
  if hex.construction.pp * 10 == hex.construction.efficency then
    image = "numbers\\production"
  else
    image = "numbers\\production_damaged"
  end
  else -- remove after naval AI test
    image = "numbers\\production" -- remove after naval AI test
  end -- remove after naval AI test

  if num > 99 then
    num = 99
  end
  local digit1, digit2
  digit1 = math.floor(num/10)
  digit2 = num%10

  if digit1 > 0 then
    GetScene():AddActionImages({hex},image .. digit1 .."_")
    GetScene():AddActionImages({hex},image .. "_" .. digit2)
  else
    GetScene():AddActionImages({hex},image .. digit2)
  end
end
