class 'ResearchPanel' (LuaPanel)

function ResearchPanel:__init(alliance)
  LuaPanel.__init(self, research)

  self.alliance = alliance
    -- Research Panel
  --self:ResearchStats()


  self.factionPanels = {}
  local slot = 1
  for faction in self.alliance.factions do
    -- only for factions with capitals
    if (faction.luaData.capitals > 0 or IsNewFaction(faction) == true) then
      -- Select first faction by default
      if slot == 1 then
        ui.researchFaction = faction
        self.previousFaction = faction
      end

      self:FactionResearchFlag(faction, slot)
      self:FactionResearchPanel(faction, slot)
      slot = slot + 1

      -- Dont exceed list limit
      if slot == 17 then
        break
      end
    end
  end

  self.details = self:AdoptWidget(ResearchDetailsPanel())

  self.informationPanel = self:AddWidget({
    type = "panel",
  })
  self.informationPanel.content = self.informationPanel:AddWidget({
    name = "test",
    type = "memo",
    position = {78, 357},
    size = {220, 120},
    font = "times12_font",
    color   = {224, 220, 218},
    border = 0,
    OnScroll = function(this, delta)
      if delta == 1 then
        if self.informationPanel.content.startingLine > 0 then
          self.informationPanel.content.startingLine = self.informationPanel.content.startingLine - 1
          self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
        end
      else
        if self.informationPanel.content.startingLine < self.informationPanel.content.numLines - 8 then
          self.informationPanel.content.startingLine = self.informationPanel.content.startingLine + 1
          self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
        end
      end
    end
  })
  self.informationPanel:AddWidget({
    type = "button",
    image = "scroll_up",
    position = {230+66, 43+315},
    sfx = "click",
    on_click = function(button)
      if self.informationPanel.content.startingLine > 0 then
        self.informationPanel.content.startingLine = self.informationPanel.content.startingLine - 1
        self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
      end
    end
  })
  self.informationPanel:AddWidget({
    type = "button",
    image = "scroll_down",
    position = {230+66, 148+315},
    sfx = "click",
    on_click = function(button)
      if self.informationPanel.content.startingLine < self.informationPanel.content.numLines - 8 then
        self.informationPanel.content.startingLine = self.informationPanel.content.startingLine + 1
        self.informationPanel.pagebar:SetPosition(235+66, 63+315 + (80 * self.informationPanel.content.startingLine / self.informationPanel.pageCount) )
      end
    end
  })
  self.informationPanel.pagebar = self.informationPanel:AddWidget({
    type = "image",
    image = "pagebar_dark",
    position = {235+66, 63+315},
  })
  self.informationPanel:Hide()

  self.focusButton = self:AddWidget({
    type = "button",
    image = "button_default",
    position = {77, 492},
    text = "focus",
    sfx = "click",
    on_click = function(button)
      if ResearchTechnology(ui.researchFaction, ui.selectedTech) == true then
        button:Hide()
        PlaySample(sResearch)

        self:Refresh()

        ui.researchTabPanel:Refresh()

        self:UpdateTechStats(ui.selectedTech, ui.selectedLine, ui.researchFaction)

--~         local techClass = data.newTechnologies[ui.selectedTech].class
--~         for _, techBox in pairs(self.Techtree[techClass].techLines) do
--~           if techBox.boosted then
--~             techBox:Unboost()
--~           end
--~         end
--~         ui.selectedLine:Boost()
      end
    end
  })

  self.unfocusButton = self:AddWidget({
    type = "button",
    image = "button_default",
    position = {77, 492},
    text = "cancel",
    sfx = "click",
    on_click = function(button)
      if UnfocusTechnology(ui.researchFaction, ui.selectedTech) then
        self:Refresh()

        ui.researchTabPanel:Refresh()

        self:UpdateTechStats(ui.selectedTech, ui.selectedLine, ui.researchFaction)
      end
    end
  })

  self:AddWidget({
    name = "tech_status",
    type = "text",
    position = {135, 507},
    font = "hud12_font",
    align = "center",
    color = {174, 224, 255},
    text = "boosting",
    tooltip = "requirementsincomplete",
  }):Hide()

  self:AddWidget({
    type = "button",
    image = "button_default",
    position = {195, 492},
    text = "close",
    sfx = "click",
    on_click = function(button)
      hud:GetPanel("research_panel"):Hide()
      ui.hotkeysActive = 1
    end
  })

  self.tabImage = self:AddWidget({
    type = "image",
    position = {66, 315},
    image = "infotab1"
  })
  self:AddWidget({
    name = "stats_label",
    type = "label",
    position = {128, 330},
    align = "center",
    font = "hud12_font",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "statistics",
    sfx = "click",
    on_click = function(button)
      button.parent.details:Show()
      button.parent.informationPanel:Hide()
      button.parent.tabImage:SetImage("graphics/hud", "infotab1.png")
    end
  })
  self:AddWidget({
    name = "info_label",
    type = "label",
    position = {258, 330},
    align = "center",
    font = "hud12_font",
    normal   = {224, 220, 218},
    hilight  = {255, 255, 255},
    select   = {255, 255, 255},
    disabled = {224, 220, 218},
    text = "information",
    sfx = "click",
    on_click = function(button)
      button.parent.details:Hide()
      button.parent.informationPanel:Show()
      button.parent.tabImage:SetImage("graphics/hud", "infotab2.png")
    end
  })

  self:AddWidget({
    name = "tech_icon",
    type = "image",
    image = "tech_0_icon",
    position = {63, 127},
  })
  self:AddWidget({
    name = "tech_title",
    type = "text",
    font = "times16_font",
    position = {185, 289},
    align = "center",
    color = {67, 56, 47},
  })

  -- Add unit icons
  for i, unitType in ipairs(ui.unitTypes) do
    --for alliance = 1, 2 do
      self:AddWidget({
        name = "icon_" .. unitType .. "_" .. playerAlliance.id,
        type = "image",
        image = "../units/" .. unitType .. "_" .. playerAlliance.id .. "_50",
        position = {0, 0},
        tooltip = unitType
      }):Hide()
    --end
  end


  self:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {352, 27+456},
    align = "left",
    color = {241, 237, 233},
    text = "lab_cost"
  })
  self:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {352, 50+456},
    align = "left",
    color = {241, 237, 233},
    text = "lab_upkeep"
  })

  self:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {671, 27+456},
    align = "left",
    color = {241, 237, 233},
--~     text = "Lab Cost:"
    text = "focus_points"
  })
--~   self:AddWidget({
--~     type = "text",
--~     font = "hud14_font",
--~     position = {671, 45},
--~     align = "left",
--~     color = {241, 237, 233},
--~     text = "Focus Points:"
--~   })


  self.labCost = self:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {482, 27+456},
    align = "right",
    color = {241, 237, 233},
  })
  self:AddWidget({
    type = "image",
    position = {490, 26+456},
    image = "resource_pp_white",
    tooltip = "resourcePP"
  })
  self.labUpkeep = self:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {482, 50+456},
    align = "right",
    color = {241, 237, 233},
  })
  self:AddWidget({
    type = "image",
    position = {490, 50+456},
    image = "icon_upkeep_white",
    tooltip = "upkeepPP"
  })
  self.focusPoint = self:AddWidget({
    type = "text",
    font = "hud14_font",
    position = {801, 27+456},
    align = "right",
    color = {241, 237, 233},
  })
  self:AddWidget({
    type = "image",
    position = {807, 27+456},
    image = "resource_lab_white",
    tooltip = "focus_points"
  })

  --ui.selectedTech = 0

  self.Techtree = {}

  self.Techtree["ground"] = self:AdoptWidget(ResearchGroupPanel("ground", 0))
  self.Techtree["artillery"] = self:AdoptWidget(ResearchGroupPanel("artillery", 1))
  self.Techtree["naval"] = self:AdoptWidget(ResearchGroupPanel("naval", 2))
  self.Techtree["air"] = self:AdoptWidget(ResearchGroupPanel("air", 3))
  self.Techtree["armour"] = self:AdoptWidget(ResearchGroupPanel("armour", 4))

  self.unavailable = {}

  self.unavailable["ground"] = self:AdoptWidget(UnavailablePanel("ground", 0))
  self.unavailable["artillery"] = self:AdoptWidget(UnavailablePanel("artillery", 1))
  self.unavailable["naval"] = self:AdoptWidget(UnavailablePanel("naval", 2))
  self.unavailable["air"] = self:AdoptWidget(UnavailablePanel("air", 3))
  self.unavailable["armour"] = self:AdoptWidget(UnavailablePanel("armour", 4))

  self:Refresh()

end

research =
{
  name = "research_panel",
  type = "panel",
  position = {(engine.window.width)/2-437, (engine.window.height-200)/2-274},
  image = "new_tech_panel",
  visible = false,

  tooltip =
  {
    rect  = {10, 10, 0, 0},
    --color = (255 255 255),
    --bgcolor = (10 10 10),
    font  = "hud_font"
  },

  controls =
  {
    {
      name = "pp_title",
      type = "image",
      position = {204, 39},
      image = "resource_pp_white",
      tooltip = "resourcePP"
    },
    {
      name = "pp_value",
      type = "text",
      font = "hud14_font",
      position = {258, 48},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentPP"
    },
    {
      name = "mp_title",
      type = "image",
      position = {204, 64},
      image = "resource_mp_white",
      tooltip = "resourceMP"
    },
    {
      name = "mp_value",
      type = "text",
      font = "hud14_font",
      position = {258, 73},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentMP"
    },
    {
      name = "am_title",
      type = "image",
      position = {204, 89},
      image = "resource_am_white",
      tooltip = "resourceAM"
    },
    {
      name = "am_value",
      type = "text",
      font = "hud14_font",
      position = {258, 98},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "currentAM"
    },
    {
      name = "pp_income",
      type = "text",
      font = "hud12_font",
      position = {298, 48},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "incrementPP"
    },
--~     {
--~       name = "mp_income",
--~       type = "text",
--~       font = "hud12_font",
--~       position = {298, 73},
--~       align = "center",
--~       color   = {241, 237, 233},
--~       tooltip = "incrementMP"
--~     },
    {
      name = "am_income",
      type = "text",
      font = "hud12_font",
      position = {298, 98},
      align = "center",
      color   = {241, 237, 233},
      tooltip = "incrementAM"
    },
  }
}

function ResearchPanel:Refresh()

  -- After defeat
  if ui.researchFaction == nil then
    return
  end

  -- Production panel
  self:GetText("pp_value"):SetNumber(ui.researchFaction.pp)
  self:GetText("mp_value"):SetNumber(ui.researchFaction.mp)
  self:GetText("am_value"):SetNumber(ui.researchFaction.am)

  -- Set PP income colour & text
  local incomePP = GetIncomePP(ui.researchFaction) - GetUpkeep(ui.researchFaction) - GetResearchUpkeep(ui.researchFaction)
  if incomePP > 0 then
    self:GetText("pp_income"):SetText("+" .. incomePP)
    self:GetText("pp_income"):SetColour(192,204,111,255)
  elseif incomePP < 0 then
    self:GetText("pp_income"):SetNumber(incomePP)
    self:GetText("pp_income"):SetColour(254,83,30,255)
  else
    self:GetText("pp_income"):SetText("+" .. incomePP)
    self:GetText("pp_income"):SetColour(241, 237, 233, 255)
  end

  -- Set MP income colour & text
--~   local incomeMP = ui.researchFaction.incomeMP
--~   if incomeMP > 0 then
--~     self:GetText("mp_income"):SetText("+" .. incomeMP)
--~     self:GetText("mp_income"):SetColour(192,204,111,255)
--~   elseif incomeMP < 0 then
--~     self:GetText("mp_income"):SetNumber(incomeMP)
--~     self:GetText("mp_income"):SetColour(254,83,30,255)
--~   else
--~     self:GetText("mp_income"):SetText("+" .. incomeMP)
--~     self:GetText("mp_income"):SetColour(241, 237, 233, 255)
--~   end

  -- Set AM income colour & text
  local incomeAM = GetIncomeAM(ui.researchFaction)
  if incomeAM > 0 then
    self:GetText("am_income"):SetText("+" .. incomeAM)
    self:GetText("am_income"):SetColour(192,204,111,255)
  elseif incomeAM < 0 then
    self:GetText("am_income"):SetNumber(incomeAM)
    self:GetText("am_income"):SetColour(254,83,30,255)
  else
    self:GetText("am_income"):SetText("+" .. incomeAM)
    self:GetText("am_income"):SetColour(241, 237, 233, 255)
  end

  --ui.researchTabPanel:Refresh()
  self.focusPoint:SetNumber(ui.researchFaction.luaData.focusPoints)
  if ui.researchFaction.luaData.focusPoints == 0 then
    self.focusPoint:SetColour(254,83,30,255)
  else
    self.focusPoint:SetColour(241, 237, 233,255)
  end

  local cost = GetLabCost(ui.researchFaction)
  self.labCost:SetNumber(cost)
  if cost > ui.researchFaction.pp then
    self.labCost:SetColour(254,83,30,255)
  else
    self.labCost:SetColour(241, 237, 233,255)
  end
  self.labUpkeep:SetNumber(GetResearchUpkeep(ui.researchFaction))

  for techClassName, techClass in pairs(self.Techtree) do
    if IsTechCategoryAvailable(techClassName, ui.researchFaction) then
      techClass:Refresh()
      techClass:Show()
      self.unavailable[techClassName]:Hide()
    else
      techClass:Hide()
      self.unavailable[techClassName]:Show()
    end
  end
end

function ResearchPanel:OnShow()
  self:SelectFaction(ui.researchFaction)
  ui.hotkeysActive = 0
end

function ResearchPanel:AddFaction(faction, slot)

  --wow what a bad hack...
  if slot == nil then
    slot = 0
    for faction2 in playerAlliance.factions do
      if faction2.luaData.capitals > 0 or faction.id == 26 or faction.id == 27 then
        slot = slot + 1
      end
    end
  end

  if self.factionPanels[faction.id] == nil then
    self:FactionResearchFlag(faction, slot)
    self:FactionResearchPanel(faction, slot)
  else
    self:GetButton("flag" .. faction.id .. "_button"):SetPosition(19, 16 + (slot - 1) * 30)
    self:GetButton("flag" .. faction.id .. "_button"):Show()
    --self:GetImage("flag" .. faction.id .. "_disabled"):SetPosition(19, 16 + (slot - 1) * 30)
  end
end

function ResearchPanel:RemoveFaction(faction)
  -- If this faction is currently selected, select another
  if ui.researchFaction.id == faction.id then
    for otherFaction in playerAlliance.factions do
      if CanFactionProduce(otherFaction) then
        ui.researchFaction = otherFaction
        --SelectPanelFaction(otherFaction)
        break
      end
    end
  end

  -- Remove flag button
  self:GetButton("flag" .. faction.id .. "_button"):Hide()

  -- Shift other flags
  local slot = 1
  for otherFaction in playerAlliance.factions do
    if CanFactionProduce(otherFaction) then
      self:GetButton("flag" .. otherFaction.id .. "_button"):SetPosition(19, 16 + (slot - 1) * 30)
      slot = slot + 1
    end
  end
end

function ResearchPanel:FactionResearchFlag(faction, slot)

  local factionName = faction.name

  self:AddWidget({
    name = "flag" .. faction.id .. "_button",
    type = "button",
    image = "../flags/flag_" .. factionName .. "_32_button",
    position = {19, 16 + (slot - 1) * 30},
    sfx = "click",
    tooltip = factionName,
    on_click = function(button)
      self:SelectFaction(faction)
    end
  })

end



function ResearchPanel:SelectFaction(faction)

  self:GetPanel("factionResearch" .. self.previousFaction.id):Hide()

  ui.researchFaction = faction
  self.previousFaction = faction
  SelectPanelFaction(faction)

  self:GetPanel("factionResearch" .. faction.id):Show()

  if ui.selectedTech == nil or not IsTechAvailable(ui.selectedTech, ui.researchFaction) then
    local techsTable = GetAvailableTechs(ui.researchFaction)
    ui.selectedTech = techsTable[1]
    --ui.selectedLine = GetTechLine(techsTable[1])
  end

  self:UpdateTechStats(ui.selectedTech, ui.selectedLine, ui.researchFaction)

  self:Refresh()

end


function ResearchPanel:FactionResearchPanel(faction, slot)

  self.faction = faction

  factionResearch =
  {
    name = "factionResearch" .. faction.id,
    type = "panel",
    position = {60, 0},

    controls =
    {
      {
        name = "faction_name",
        type = "text",
        font = "hud14_font",
        position = {198, 24},
        align = "center",
        color   = {241, 237, 233},
        text = faction.name .. "_title"
      },
      {
        name = "faction_flag",
        type = "image",
        image = "../flags/flag_" .. faction.name .. "_128",
        position = {5, 16},
      },
    }
  }
  self.factionPanels[faction.id] = self:AddWidget(factionResearch)
  self.factionPanels[faction.id]:Hide()
end



function ResearchPanel:UpdateTechStats(techName, techLine, faction)

  ui.selectedTech = techName
  ui.selectedLine = techLine

if techName ~= nil then
	
  local i = 1
  local techsTable = GetAvailableTechs(faction, fakeTurn)

  if #techsTable ~= nil
    and #techsTable >0
	and data.newTechnologies[techName].stats ~= nil then
		for stat, value in pairs(data.newTechnologies[techName].stats) do
		  self.details:GetText("stat_number_" .. i):Show()
		  i = i + 1
		end
	
	else
	 LogUi("researchpanel")
	 --return false
	
  end
  for j = i, 4 do
    self.details:GetText("stat_number_" .. j):Hide()
  end

  self.informationPanel.content:SetLocalText("tech_" .. ui.selectedTech .. "_info")
  self.informationPanel.content.maxLines = 8
  self.informationPanel.pageCount = math.max(8, self.informationPanel.content.numLines)
  self.informationPanel.pagebar:SetSource(0, 0, 6, 80 * 8 / self.informationPanel.pageCount)
  self.informationPanel.pagebar:SetPosition(235+66, 63+315)


  self:GetImage("tech_icon"):SetImage("graphics/techs", techName .. ".png")
  self:GetText("tech_title"):SetLocalText("tech_" .. techName)
  --self.details:GetText("tech_turns"):SetNumber(GetTechTime(faction, techId))
  --self.details:GetText("tech_cost"):SetNumber(data.newTechnologies[techName].time)

  -- Check if already purchased => hide purchase button
  local techClass = data.newTechnologies[techName].class
  if faction.luaData.labs[techClass] > 0 and GetCategoryTechlineCount(ui.researchFaction, techClass) > 1 then
    if faction.luaData.currentTech[techClass] == techName then
      self.focusButton:Hide()
      if faction.luaData.focusPoints > 0 then
        self.unfocusButton:Show()
        self:GetText("tech_status"):Hide()
      else
        self.unfocusButton:Hide()
        self:GetText("tech_status"):Show()
        self:GetText("tech_status"):SetColour(254,83,30,255)
        self:GetText("tech_status"):SetLocalText("cancel")
        self:GetText("tech_status").tooltip = "insufficienct_focus_points"
      end
    else
      self.unfocusButton:Hide()
      if faction.luaData.researchComplete[techName] ~= 0 then
        self.focusButton:Hide()
        self:GetText("tech_status"):Show()
        self:GetText("tech_status"):SetColour(192,204,111,255)
        self:GetText("tech_status"):SetLocalText("completed")

      elseif not IsTechAvailable(techName, ui.researchFaction) then
        self.focusButton:Hide()
        self:GetText("tech_status"):Show()
        self:GetText("tech_status"):SetColour(254,83,30,255)
        self:GetText("tech_status"):SetLocalText("unavailable")
        self:GetText("tech_status").tooltip = "requirementsincomplete"
      else
        if faction.luaData.focusPoints > 0 then
          self.focusButton:Show()
          self:GetText("tech_status"):Hide()
        else
          self.focusButton:Hide()
          self:GetText("tech_status"):Show()
          self:GetText("tech_status"):SetColour(254,83,30,255)
          self:GetText("tech_status"):SetLocalText("focus")
        end
      end
    end
  else
    self.unfocusButton:Hide()
    self.focusButton:Hide()
    self:GetText("tech_status"):Show()
    self:GetText("tech_status"):SetColour(254,83,30,255)
    self:GetText("tech_status"):SetLocalText("unavailable")
    self:GetText("tech_status").tooltip = "cannot_focus_last_tech"
  end
--~   -- Check if requirements not met => hide purchase button
--~   if not IsTechAvailable(techId, ui.researchFaction) then
--~     self:GetButton("research_button"):Hide()
--~     self:GetText("tech_status"):Show()
--~     self:GetText("tech_status"):SetColour(254,83,30,255)
--~     self:GetText("tech_status"):SetLocalText("unavailable")
--~   end

  -- Next tech
  local nextTech = data.newTechnologies[techName].line[data.newTechnologies[techName].tier+1]
  if nextTech ~= nil then
    self.details.nextTech:SetImage("graphics/techs", nextTech .. "_small.png")
    self.details.nextTech.tooltip = "tech_" .. nextTech
  else
    self.details.nextTech:SetImage("graphics/hud", "tech_bg_empty.png")
    self.details.nextTech.tooltip = ""
  end

  -- Previous tech
  local prevTech = data.newTechnologies[techName].line[data.newTechnologies[techName].tier-1]
  if prevTech ~= nil then
    self.details.prevTech:SetImage("graphics/techs", prevTech .. "_small.png")
    self.details.prevTech.tooltip = "tech_" .. prevTech
  else
    self.details.prevTech:SetImage("graphics/hud", "tech_bg_empty.png")
    self.details.prevTech.tooltip = ""
  end

  local slot = 0
  for i, baseunitType in ipairs(ui.unitTypes) do
    self:GetImage("icon_" .. baseunitType .. "_" .. playerAlliance.id):Hide()
    for j, unitType in ipairs(data.newTechnologies[techName].unitTypes) do
      if baseunitType == unitType then
        self:GetImage("icon_" .. baseunitType .. "_" .. playerAlliance.id):SetPosition(71 + slot*30, 129)
        self:GetImage("icon_" .. baseunitType .. "_" .. playerAlliance.id):Show()
        slot = slot + 1
      end
    end
  end

  if data.newTechnologies[techName].stats ~= nil then

    self.details:GetImage("stat_unlock"):Hide()
    self.details:GetImage("stat_unlock_type"):Hide()

    slot = 0
    if data.newTechnologies[techName].stats.groundattack ~= nil then
      self.details:GetImage("stat_groundattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_groundattack"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.groundattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_groundattack"):Hide()
    end
    if data.newTechnologies[techName].stats.basedefense ~= nil then
      self.details:GetImage("stat_basedefense"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_basedefense"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.basedefense)
      slot = slot + 1
    else
      self.details:GetImage("stat_basedefense"):Hide()
    end
    if data.newTechnologies[techName].stats.airattack ~= nil then
      self.details:GetImage("stat_airattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_airattack"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.airattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_airattack"):Hide()
    end
    if data.newTechnologies[techName].stats.highdefense ~= nil then
      self.details:GetImage("stat_highdefense"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_highdefense"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.highdefense)
      slot = slot + 1
    else
      self.details:GetImage("stat_highdefense"):Hide()
    end
    if data.newTechnologies[techName].stats.shock ~= nil then
      self.details:GetImage("stat_shock"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_shock"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.shock)
      slot = slot + 1
    else
      self.details:GetImage("stat_shock"):Hide()
    end
    if data.newTechnologies[techName].stats.bombard ~= nil then
      self.details:GetImage("stat_bombard"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_bombard"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.bombard)
      slot = slot + 1
    else
      self.details:GetImage("stat_bombard"):Hide()
    end
    if data.newTechnologies[techName].stats.los ~= nil then
      self.details:GetImage("stat_los"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_los"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.los)
      slot = slot + 1
    else
      self.details:GetImage("stat_los"):Hide()
    end
    if data.newTechnologies[techName].stats.range ~= nil then
      self.details:GetImage("stat_range"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_range"):Show()
        self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.range)
      slot = slot + 1
    else
      self.details:GetImage("stat_range"):Hide()
    end
    if data.newTechnologies[techName].stats.assault ~= nil then
      self.details:GetImage("stat_assault"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_assault"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.assault)
      slot = slot + 1
    else
      self.details:GetImage("stat_assault"):Hide()
    end
    if data.newTechnologies[techName].stats.navalattack ~= nil then
      self.details:GetImage("stat_navalattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_navalattack"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.navalattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_navalattack"):Hide()
    end
    if data.newTechnologies[techName].stats.armourattack ~= nil then
      self.details:GetImage("stat_armourattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_armourattack"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.armourattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_armourattack"):Hide()
    end
    if data.newTechnologies[techName].stats.subattack ~= nil then
      self.details:GetImage("stat_subattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_subattack"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.subattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_subattack"):Hide()
    end
    if data.newTechnologies[techName].stats.entrenchment ~= nil then
      self.details:GetImage("stat_entrenchment"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_entrenchment"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.entrenchment)
      slot = slot + 1
    else
      self.details:GetImage("stat_entrenchment"):Hide()
    end
    if data.newTechnologies[techName].stats.counterattack ~= nil then
      self.details:GetImage("stat_counterattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_counterattack"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.counterattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_counterattack"):Hide()
    end
    if data.newTechnologies[techName].stats.gasEffect ~= nil then
      self.details:GetImage("stat_gas"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_gas"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.gasEffect)
      slot = slot + 1
    else
      self.details:GetImage("stat_gas"):Hide()
    end
    if data.newTechnologies[techName].stats.antigas ~= nil then
      self.details:GetImage("stat_gasmask"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_gasmask"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.antigas)
      slot = slot + 1
    else
      self.details:GetImage("stat_gasmask"):Hide()
    end
    if data.newTechnologies[techName].stats.stratattack ~= nil then
      self.details:GetImage("stat_stratattack"):SetPosition(30 + slot*55, 380)
      self.details:GetImage("stat_stratattack"):Show()
      self.details:GetText("stat_number_" .. slot + 1):SetNumber(data.newTechnologies[techName].stats.stratattack)
      slot = slot + 1
    else
      self.details:GetImage("stat_stratattack"):Hide()
    end
  else
    self.details:GetImage("stat_groundattack"):Hide()
    self.details:GetImage("stat_basedefense"):Hide()
    self.details:GetImage("stat_airattack"):Hide()
    self.details:GetImage("stat_highdefense"):Hide()
    self.details:GetImage("stat_shock"):Hide()
    self.details:GetImage("stat_bombard"):Hide()
    self.details:GetImage("stat_los"):Hide()
    self.details:GetImage("stat_range"):Hide()
    self.details:GetImage("stat_assault"):Hide()
    self.details:GetImage("stat_navalattack"):Hide()
    self.details:GetImage("stat_armourattack"):Hide()
    self.details:GetImage("stat_subattack"):Hide()
    self.details:GetImage("stat_entrenchment"):Hide()
    self.details:GetImage("stat_counterattack"):Hide()
    self.details:GetImage("stat_gas"):Hide()
    self.details:GetImage("stat_gasmask"):Hide()
    self.details:GetImage("stat_stratattack"):Hide()
    --self.details:GetImage("stat_unlock"):SetPosition(30, 427)
    self.details:GetImage("stat_unlock"):Show()
    self.details:GetImage("stat_unlock_type"):SetImage("graphics/units", data.newTechnologies[techName].unitTypes[1] .. "_" .. playerAlliance.id .. "_25.png")
    --self.details:GetImage("stat_unlock_type"):SetPosition(53, 431)
    self.details:GetImage("stat_unlock_type"):Show()
    self.details:GetImage("stat_unlock_type").tooltip = data.newTechnologies[techName].unitTypes[1]
  end

else
	PopupMessage("THIS NATION HAS RESEARCHED ALL AVAILABLE TECHNOLGIES!;REMOVE ALL LABS ASSIGNED THEN CLOSE THE WINDOW!")
	return false 
end

end

function ResearchPanel:GetTechCompletion(techId, faction)

  return faction.luaData.researchProgress[techId] * 100 / data.newTechnologies[techName].time

end


----------------------------------------------------------------------------


class 'ResearchDetailsPanel' (LuaPanel)

function ResearchDetailsPanel:__init(alliance)
  LuaPanel.__init(self)

  self:SetPosition(60, 0)

  self:AddWidget({
    type = "text",
    position = {25, 362},
    font = "hud12_font",
    align = "left",
    color = {241, 237, 233},
    text = "combat_effects"
  })

  self:AddWidget({
    type = "text",
    position = {73, 427},
    font = "hud12_font",
    align = "center",
    color = {241, 237, 233},
    text = "previous"
  })

  self:AddWidget({
    type = "text",
    position = {191, 427},
    font = "hud12_font",
    align = "center",
    color = {241, 237, 233},
    text = "next"
  })

  self:AddWidget({
    type = "image",
    image = "tech_bg_small",
    position = {50, 437},
  })

  self:AddWidget({
    type = "image",
    image = "tech_bg_small",
    position = {168, 437},
  })

  self.prevTech = self:AddWidget({
    type = "image",
    position = {54, 441},
    sfx = "click",
    on_click = function()
      local prevTech = data.newTechnologies[ui.selectedTech].line[data.newTechnologies[ui.selectedTech].tier-1]
      if prevTech ~= nil then
        self.parent:UpdateTechStats(prevTech, ui.selectedLine, ui.researchFaction)
      end
    end
  })

  self.nextTech = self:AddWidget({
    type = "image",
    position = {172, 441},
    sfx = "click",
    on_click = function()
      local nextTech = data.newTechnologies[ui.selectedTech].line[data.newTechnologies[ui.selectedTech].tier+1]
      if nextTech ~= nil then
        self.parent:UpdateTechStats(nextTech, ui.selectedLine, ui.researchFaction)
      end
    end
  })

--~   self:AddWidget({
--~     name = "progressbg",
--~     type = "image",
--~     image = "progress_black",
--~     position = {25, 480},
--~   })
--~   self:AddWidget({
--~     name = "progressbar",
--~     type = "image",
--~     image = "progress_green",
--~     position = {25, 480},
--~   })

  -- Stat icons
  self:AddWidget({
    name = "stat_basedefense",
    type = "image",
    image = "stat-basedefense",
    position = {80, 413},
    tooltip = "stat_basedefense"
  })
  self:AddWidget({
    name = "stat_highdefense",
    type = "image",
    image = "stat-highdefense",
    position = {190, 413},
    tooltip = "stat_highdefense"
  })
  self:AddWidget({
    name = "stat_groundattack",
    type = "image",
    image = "stat-groundattack",
    position = {25, 413},
    tooltip = "stat_groundattack"
  })
  self:AddWidget({
    name = "stat_airattack",
    type = "image",
    image = "stat-airattack",
    position = {135, 413},
    tooltip = "stat_airattack"
  })
  self:AddWidget({
    name = "stat_navalattack",
    type = "image",
    image = "stat-navalattack",
    position = {25, 413},
    tooltip = "stat_navalattack"
  })
  self:AddWidget({
    name = "stat_armourattack",
    type = "image",
    image = "stat-armourattack",
    position = {25, 413},
    tooltip = "stat_armourattack"
  })
  self:AddWidget({
    name = "stat_subattack",
    type = "image",
    image = "stat-subattack",
    position = {25, 413},
    tooltip = "stat_subattack"
  })
  self:AddWidget({
    name = "stat_shock",
    type = "image",
    image = "stat-shock",
    position = {190, 413},
    tooltip = "stat_shock"
  })
  self:AddWidget({
    name = "stat_bombard",
    type = "image",
    image = "stat-bombard",
    position = {190, 413},
    tooltip = "stat_bombard"
  })
  self:AddWidget({
    name = "stat_los",
    type = "image",
    image = "stat-los",
    position = {190, 413},
    tooltip = "stat_los"
  })
  self:AddWidget({
    name = "stat_range",
    type = "image",
    image = "stat-range",
    position = {190, 413},
    tooltip = "stat_range"
  })
  self:AddWidget({
    name = "stat_assault",
    type = "image",
    image = "stat-assault",
    position = {190, 413},
    tooltip = "stat_assault"
  })
  self:AddWidget({
    name = "stat_entrenchment",
    type = "image",
    image = "stat-entrench",
    position = {190, 413},
    tooltip = "stat_entrenchment_level"
  })
  self:AddWidget({
    name = "stat_counterattack",
    type = "image",
    image = "stat-counterattack",
    position = {190, 413},
    tooltip = "stat_counterattack"
  })
  self:AddWidget({
    name = "stat_gas",
    type = "image",
    image = "stat-gas",
    position = {190, 413},
    tooltip = "stat_gas"
  })
  self:AddWidget({
    name = "stat_gasmask",
    type = "image",
    image = "stat-gasmask",
    position = {190, 413},
    tooltip = "stat_gasmask"
  })
  self:AddWidget({
    name = "stat_stratattack",
    type = "image",
    image = "stat-stratattack",
    position = {190, 413},
    tooltip = "stat_stratattack"
  })
  self:AddWidget({
    name = "stat_unlock",
    type = "image",
    image = "stat-unlock",
    position = {30, 380},
    tooltip = "stat_unlock"
  })
  self:AddWidget({
    name = "stat_unlock_type",
    type = "image",
    position = {53, 385},
  })


  self:AddWidget({
    name = "stat_number_1",
    type = "text",
    position = {61, 393},
    font = "unit_font",
    align = "center",
    color = {31, 21, 6},
    text = "10"
  })
  self:AddWidget({
    name = "stat_number_2",
    type = "text",
    position = {116, 393},
    font = "unit_font",
    align = "center",
    color = {31, 21, 6},
    text = "10"
  })

  self:AddWidget({
    name = "stat_number_3",
    type = "text",
    position = {171, 393},
    font = "unit_font",
    align = "center",
    color = {31, 21, 6},
    text = "10"
  })

  self:AddWidget({
    name = "stat_number_4",
    type = "text",
    position = {226, 393},
    font = "unit_font",
    align = "center",
    color = {31, 21, 6},
    text = "10"
  })

--~  self:AddWidget({
--~     name = "tech_turns",
--~     type = "text",
--~     position = {108, 469},
--~     font = "hud12_font",
--~     align = "left",
--~     color = {241, 237, 233},
--~     text = "0"
--~   })

--~   self:AddWidget({
--~     type = "image",
--~     position = {82, 467},
--~     image = "turn_icon_white",
--~     tooltip = "turns"
 --~  })

--~   self:AddWidget({
--~     name = "tech_cost",
--~     type = "text",
--~     position = {50, 469},
--~     font = "hud12_font",
--~     align = "left",
--~     color = {241, 237, 233},
--~     text = "0"
--~   })

--~   self:AddWidget({
--~     type = "image",
--~     position = {20, 467},
--~     image = "resource_lab_white",
--~     tooltip = "resourceLab"
--~   })


end

----------------------------------------------------------------------------

class 'ResearchGroupPanel' (LuaPanel)

function ResearchGroupPanel:__init(techClass, slot)
  LuaPanel.__init(self)

  self.techClass = techClass

  self:SetPosition(340 + slot * 105, 10)

   self:AddWidget({
     type = "image",
     position = {30, 6},
     image = "class_" .. techClass .. "_white",
    tooltip = "tech_class_" .. techClass
   })

   self.labCount = self:AddWidget({
     type = "text",
     position = {42, 46},
    font = "hud18_font",
    align = "center",
    color = {241, 237, 233},
    text = "0",
   })

  self:AddWidget({
    name = "assign_lab_button",
    type = "button",
    image = "button_lab",
    position = {53, 31},
    tooltip = "build_lab",
    sfx = "click",
    on_click = function(button)
      if BuildLab(ui.researchFaction, techClass) then
        --local cost = GetLabCost(ui.researchFaction)
        ui.resourcesPanel:Refresh()
        button.parent.parent:Refresh()
        ui.researchTabPanel:Refresh()
        button.parent.parent:UpdateTechStats(ui.selectedTech, ui.selectedLine, ui.researchFaction)
      end
    end
  })

  self:AddWidget({
    name = "assign_lab_button",
    type = "button",
    image = "button_lab_sell",
    position = {0, 31},
    tooltip = "sell_lab",
    sfx = "click",
    on_click = function(button)
      if SellLab(ui.researchFaction, techClass) then
        --local cost = GetLabCost(ui.researchFaction)
        ui.resourcesPanel:Refresh()
        button.parent.parent:Refresh()
        ui.researchTabPanel:Refresh()
        button.parent.parent:UpdateTechStats(ui.selectedTech, ui.selectedLine, ui.researchFaction)
      end
    end
  })

  -- Create tech lines
  self.techLines = {}
  self.events = {}
  for i, techLine in pairs(data.techLines[techClass]) do

    -- Create tech item
    self.techLines[i] = self:AdoptWidget(TechLinePanel(i, techLine))

    -- Check if first element in techline is an event
    if techLine.event ~= nil then
      self.events[techLine.event] = self:AddWidget({
        type = "image",
        position = {3,  60 + (i - 1) * 82},
        image = "tech_locked_small",
        tooltip = "required_event_" .. techLine.event,
      })
    end
  end

--~   self:AddWidget({
--~     type = "image",
--~     position = {30 + (# data.techLines[techClass]) * 96, 0},
--~     image = "techline_end",
--~   })

  self.boost = self:AddWidget({
    type = "image",
    position = {33, 4},
    image = "boosted_tech",
  })

  self.info = self:AddWidget({
    type = "panel",
    position = {0, 58},
  })
  self.info:SetBackgroundImage("tech_category_info_vertical")
--~   self.info.text = self.info:AddWidget({
--~     type = "text",
--~      position = {242, 49},
--~     font = "hud12_font",
--~     align = "center",
--~     color = {31, 21, 6},
--~     text = "tech_class_unavailable_time",
--~   })

end

function ResearchGroupPanel:OnShow()
  self:Refresh()
end

function ResearchGroupPanel:Refresh()

  self.labCount:SetNumber(ui.researchFaction.luaData.labs[self.techClass])

  self.boost:Hide()

  if IsTechCategoryAvailable(self.techClass) and data.factions[ui.researchFaction.id+1].research[self.techClass] == 1 then
    for _, techLine in pairs(self.techLines) do
      techLine:Refresh()
      self.info:Hide()
    end
  else
    for _, techLine in pairs(self.techLines) do
      techLine:Hide()
      self.info:Show()
--~       if data.factions[ui.researchFaction.id+1].research[self.techClass] ~= 1 then
--~         self.info.text:SetLocalText("tech_class_unavailable_faction")
--~       else
--~         self.info.text:SetLocalText("tech_class_unavailable_time")
--~       end
    end
  end
end



----------------------------------------------------------------------------

class 'UnavailablePanel' (LuaPanel)

function UnavailablePanel:__init(techClass, slot)
  LuaPanel.__init(self)

  self.techClass = techClass

  self:SetPosition(340 + slot * 105, 10)

   self:AddWidget({
     type = "image",
     position = {30, 6},
     image = "class_" .. techClass .. "_white",
    tooltip = "tech_class_" .. techClass
   })

   self.turns = self:AddWidget({
     type = "text",
     position = {42, 46},
    font = "hud14_font",
    align = "center",
    color = {241, 237, 233},
    text = "0",
    tooltip = "research_available_turns",
   })

  self.turnIcon = self:AddWidget({
     type = "image",
     position = {50, 38},
     image = "turn_icon_white",
    tooltip = "research_available_turns",
  })

   self.unavailable = self:AddWidget({
     type = "image",
     position = {31, 34},
     image = "research_never_available",
    tooltip = "research_never_available",
   })


end

function UnavailablePanel:OnShow()
  if data.factions[ui.researchFaction.id+1].research[self.techClass] == 1 then
    self.turns:SetNumber(scenario.techCategoriesUnlocked[self.techClass])
    self.unavailable:Hide()
    self.turns:Show()
    self.turnIcon:Show()
  else
    self.unavailable:Show()
    self.turns:Hide()
    self.turnIcon:Hide()
  end
end

----------------------------------------------------------------------------

class 'TechLinePanel' (LuaPanel)

function TechLinePanel:__init(slot, techLine)
  LuaPanel.__init(self)

  self.techLine = techLine
  self.slot = slot

  self:SetPosition(3,  60 + (self.slot - 1) * 82)

  self:SetBackgroundImage("queue")

   self.icon = self:AddWidget({
     type = "image",
     position = {5, 6},
   })
--~    self.stat = self:AddWidget({
--~      type = "image",
--~      position = {72, 2},
--~    })
--~    self.unit = self:AddWidget({
--~      type = "image",
--~      position = {7, 8},
--~    })
   self.progressBg = self:AddWidget({
     type = "image",
     position = {8, 75},
    image = "tech_progress_bar_small_empty",
   })
   self.progress = self:AddWidget({
     type = "image",
     position = {8, 75},
    image = "tech_progress_bar_small_full",
   })
   self.levelCount = self:AddWidget({
     type = "text",
     position = {60, 12},
    font = "hud12_font",
    align = "center",
    color = {31, 21, 6},
    tooltip = "current_max_level"
   })
  self.turnCount = self:AddWidget({
      type = "text",
      position = {52, 63},
     font = "hud12_font",
     align = "center",
     color = {31, 21, 6},
     text = "?",
    })
    self:AddWidget({
      type = "image",
      position = {60, 56},
     image = "turn_icon",
    })

   self.hotspot = self:AddWidget({
     type = "image",
    image = "tech_bg_hotspot",
    position = {3, 4},
    sfx = "click",
    on_click = function(button)
      self.parent.parent:UpdateTechStats(self.techName, self, ui.researchFaction)
    end
   })

end

function TechLinePanel:Refresh()

  -- Find first uncompleted tech in the line
  self.techName = -1
  local level = 1
  local maxLevel = 1
  if IsTechLineAvailable(self.techLine) then
    if self.parent.events[self.techLine.event] ~= nil then
      self.parent.events[self.techLine.event]:Hide()
    end
    for k, techName in pairs(self.techLine) do
      maxLevel = # self.techLine
      if IsTechAvailable(techName, ui.researchFaction) then
        self.techName = techName
        level = k
        break
      end
    end
  else
    self.parent.events[self.techLine.event]:Show()
  end

  if self.techName ~= -1 then

    -- Show tech icon
    self.icon:SetImage("graphics/techs", self.techName .. "_queue.png")

--~     -- Show primary unit type
--~     local unit = data.newTechnologies[self.techName].unitTypes[1]
--~     self.unit:SetImage("graphics/units", unit .. "_" .. playerAlliance.id .. "_25.png")

--~     -- Show primary stat
--~     if data.newTechnologies[self.techName].stats ~= nil then
--~       for stat, _ in pairs(data.newTechnologies[self.techName].stats) do
--~         self.stat:SetImage("graphics/hud", "stat_" .. stat .. ".png")
--~         break
--~       end
--~     else
--~       self.stat:SetImage("graphics/hud", "stat_unlock.png")
--~     end

    -- Progress bar
    self.progress:SetSource(0, 0, 1 + 62 * ui.researchFaction.luaData.researchProgress[self.techName] / data.newTechnologies[self.techName].time, 6)
    self.hotspot.tooltip = "tech_" .. self.techName .. "_short"
    self:Show()

    self.levelCount:SetText(level .. "/" .. maxLevel)

    -- Timer
     local time = GetTechTime(ui.researchFaction, self.techName)
     if time ~= -1 then
       self.turnCount:SetNumber(time)
     else
       self.turnCount:SetText("?")
     end

--~     local techClass = data.newTechnologies[self.techName].class
--~     if ui.researchFaction.luaData.currentTech[techClass] == self.techName then
--~       self:Boost()
--~     end

    local techClass = data.newTechnologies[self.techName].class
    if self.boosted and ui.researchFaction.luaData.currentTech[techClass] ~= self.techName then
      self:Unboost()
    elseif not self.boosted and ui.researchFaction.luaData.currentTech[techClass] == self.techName then
      self:Boost()
    end

    if ui.selectedTech == self.techName then
      ui.selectedLine = self
    end
  else
    self:Hide()
  end
end

function TechLinePanel:Boost()
  self.boosted = true
  self:SetBackgroundImage("queue_boosted")
  self.progressBg:SetImage("graphics/hud", "tech_boosted_bar_small_empty.png")
  self.progress:SetImage("graphics/hud", "tech_boosted_bar_small_full.png")
  self.progress:SetSource(0, 0, 1 + 62 * ui.researchFaction.luaData.researchProgress[self.techName] / data.newTechnologies[self.techName].time, 6)
end

function TechLinePanel:Unboost()
  self.boosted = false
  self:SetBackgroundImage("queue")
  self.progressBg:SetImage("graphics/hud", "tech_progress_bar_small_empty.png")
  self.progress:SetImage("graphics/hud", "tech_progress_bar_small_full.png")
  self.progress:SetSource(0, 0, 1 + 62 * ui.researchFaction.luaData.researchProgress[self.techName] / data.newTechnologies[self.techName].time, 6)
end
